MODULE el_array

implicit none

!******************************************************************************

INTERFACE
  SUBROUTINE setup_ac_receiver(receiver_id,source_ix,receiver_ix,rec_num,srd,srd_diff,receiver_pos,receiver_dx,num_el,x,xmesh)


    implicit none

    double precision,dimension(:),intent(inout) :: srd,receiver_pos,receiver_dx
    double precision,dimension(:),intent(in) :: x,xmesh

    double precision srd_diff

    integer,dimension(:),intent(inout) :: receiver_ix,num_el
    integer, intent(inout) :: rec_num
    integer, intent(in) :: source_ix
    integer i,j

    integer receiver_id

  END SUBROUTINE

END INTERFACE


END MODULE el_array


!******************************************************************************
!******************************************************************************

SUBROUTINE setup_ac_receiver(receiver_id,source_ix,receiver_ix,rec_num,srd,srd_diff,receiver_pos,receiver_dx,num_el,x,xmesh)

!creates receiver

implicit none

double precision,dimension(:),intent(inout) :: srd,receiver_pos,receiver_dx
double precision,dimension(:),intent(in) :: x,xmesh

double precision srd_diff

integer,dimension(:),intent(inout) :: receiver_ix,num_el
integer, intent(inout) :: rec_num
integer, intent(in) :: source_ix
integer i,j, ng

integer receiver_id

ng=size(x)

if (receiver_id == 0) then

  receiver_pos(1) = 0
  receiver_pos(1) = x(source_ix) + srd(1)
  srd_diff = srd(1)

  do j=1,size(xmesh)-1
    if (receiver_pos(1) >= xmesh(j)) then
      num_el(1) = j
    endif
  enddo

  do i=1,rec_num
    do j=1,ng
      if (receiver_pos(i) >= x(j)) receiver_ix(i) = j
    enddo
    receiver_dx(i) = receiver_pos(i) - x(receiver_ix(i))
  enddo


else if (receiver_id == 1) then

  receiver_pos(1) = 0
  receiver_pos(1) = x(source_ix) + srd(1)
  receiver_ix(1) = idint(receiver_pos(1) * size(x) / (x(size(x))-x(1)))
  srd_diff = srd(1)

  srd = 0
  do j=1,rec_num
    srd(j) = x(receiver_ix(j))-x(source_ix)
  enddo

else

  stop 'incorrect value of receiver_id in parfile'

endif

END SUBROUTINE setup_ac_receiver

