
!-----------------------------------------------------------------------
!            Include file for GRPCKG
! Modifications:
!   29-Jan-1985 - add HP2648 (KS/TJP).
!   16-Sep-1985 - remove tabs (TJP).
!   30-Dec-1985 - add PS, VPS (TJP).
!   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP,
!                 HP7221, GRINL (TJP).
!    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP).
!   11-Jun-1987 - remove remaining built-in devices (TJP).
!    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT.
!   16-Aug-1987 - remove obsolete variables.
!    9-Sep-1989 - add SAVE statement.
!   26-Nov-1990 - remove GRCTYP.
!    5-Jan-1993 - add GRADJU.
!    1-Sep-1994 - add GRGCAP.
!   21-Dec-1995 - increase GRIMAX to 8.
!   30-Apr-1997 - remove GRC{XY}SP
!-----------------------------------------------------------------------
!
! Parameters:
!   GRIMAX : maximum number of concurrent devices
!   GRFNMX : maximum length of file names
!   GRCXSZ : default width of chars (pixels)
!   GRCYSZ : default height of chars (pixels)
!
  INTEGER   GRIMAX, GRFNMX
  REAL      GRCXSZ, GRCYSZ
  PARAMETER (GRIMAX = 8)
  PARAMETER (GRFNMX = 90)
  PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0)
!
! Common blocks:
!   GRCIDE : identifier of current plot
!   GRGTYP : device type of current plot
! The following are qualified by a plot id:
!   GRSTAT : 0 => workstation closed
!            1 => workstation open
!            2 => picture open
!   GRPLTD :
!   GRDASH : software dashing in effect?
!   GRUNIT : unit associated with id
!   GRFNLN : length of filename
!   GRTYPE : device type
!   GRXMXA : x size of plotting surface
!   GRYMXA : y size of plotting surface
!   GRXMIN : blc of plotting window
!   GRYMIN : ditto
!   GRXMAX : trc of plotting window
!   GRYMAX : ditto
!   GRSTYL : line style (integer code)
!   GRWIDT : line width (integer code)
!   GRCCOL : current color index (integer code)
!   GRMNCI : minimum color index on this device
!   GRMXCI : maximum color index on this device
!   GRCMRK : marker number
!   GRXPRE : previous (current) pen position (x)
!   GRYPRE : ditto (y)
!   GRXORG : transformation variables (GRTRAN)
!   GRYORG : ditto
!   GRXSCL : ditto
!   GRYSCL : ditto
!   GRCSCL : character scaling factor
!   GRCFAC :
!   GRCFNT : character font
!   GRFILE : file name (character)
!   GRGCAP : device capabilities (character)
!   GRPXPI : pixels per inch in x
!   GRPYPI : pixels per inch in y
!   GRADJU : TRUE if GRSETS (PGPAP) has been called
!
  INTEGER   GRCIDE, GRGTYP
  LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX)
  INTEGER   GRSTAT(GRIMAX)
  INTEGER   GRUNIT(GRIMAX), GRFNLN(GRIMAX), GRTYPE(GRIMAX), &
            GRXMXA(GRIMAX), GRYMXA(GRIMAX), &
                GRSTYL(GRIMAX), GRWIDT(GRIMAX), GRCCOL(GRIMAX), &
                GRCMRK(GRIMAX), GRIPAT(GRIMAX), GRCFNT(GRIMAX), &
                GRMNCI(GRIMAX), GRMXCI(GRIMAX)
  REAL      GRXMIN(GRIMAX), GRYMIN(GRIMAX), &
            GRXMAX(GRIMAX), GRYMAX(GRIMAX)
  REAL      GRXPRE(GRIMAX), GRYPRE(GRIMAX), GRXORG(GRIMAX), &
            GRYORG(GRIMAX), GRXSCL(GRIMAX), GRYSCL(GRIMAX), &
                GRCSCL(GRIMAX), GRCFAC(GRIMAX), GRPOFF(GRIMAX), &
                GRPATN(GRIMAX,8),GRPXPI(GRIMAX),GRPYPI(GRIMAX)
  COMMON /GRCM00/ GRCIDE, GRGTYP, GRSTAT, GRPLTD, GRUNIT, &
                  GRFNLN, GRTYPE, GRXMXA, GRYMXA, GRXMIN, GRYMIN, &
                      GRXMAX, GRYMAX, GRWIDT, GRCCOL, GRSTYL, &
                      GRXPRE, GRYPRE, GRXORG, GRYORG, GRXSCL, GRYSCL, &
                      GRCSCL, GRCFAC, GRDASH, GRPATN, GRPOFF, &
                      GRIPAT, GRCFNT, GRCMRK, GRPXPI, GRPYPI, GRADJU, &
                      GRMNCI, GRMXCI

  CHARACTER*(GRFNMX) GRFILE(GRIMAX)
  CHARACTER*11       GRGCAP(GRIMAX)
  COMMON /GRCM01/ GRFILE, GRGCAP
  SAVE /GRCM00/, /GRCM01/
!-----------------------------------------------------------------------
