MODULE jacobian_mod

INTERFACE
  SUBROUTINE calc_jacobian1D(Jacobi,Jacobian,Jacobi_inverse,shape1D,dershape1D,xmesh)

  implicit none

  double precision, dimension(:,:) :: Jacobi, Jacobian, Jacobi_inverse
  double precision, dimension(:,:) :: shape1D,dershape1D
  double precision, dimension(:) :: xmesh
  double precision xelm

  integer ispec, i,j,k, NGLLX, NGNOD, ne
  END SUBROUTINE
END INTERFACE

END MODULE


!_________________________________________________________________________________

SUBROUTINE calc_jacobian1D(Jacobi,Jacobian,Jacobi_inverse,shape1D,dershape1D,xmesh)

!subroutine calculates the Jacobi-Matrix, the Jacobian of the
!Mapping Function and the Jacobi-Matrix of the inverse Mapping
!Function for a 1-D SEM  (main program: elastic_1D)

implicit none

double precision, dimension(:,:) :: Jacobi
double precision, dimension(:,:) :: Jacobian
double precision, dimension(:,:) :: Jacobi_inverse

double precision, dimension(:,:) :: shape1D
double precision, dimension(:,:) :: dershape1D
double precision, dimension(:) :: xmesh
double precision xelm

integer ispec,i,j,NGLLX,NGNOD,ne

NGNOD=size(shape1D,1)
NGLLX=size(shape1D,2)

ne = size(Jacobi,2)

do ispec=1,ne
  do i=1,NGLLX
    do j=1,NGNOD
  xelm = xmesh(ispec-1+j)
  Jacobi(i,ispec) = Jacobi(i,ispec) + dershape1D(j,i)*xelm
  Jacobian(i,ispec) = Jacobi(i,ispec)
    enddo
  enddo
enddo

  if(minval(Jacobian) < 0.) stop 'negative jacobian, cannot be inverted'

  Jacobi_inverse = 1./Jacobian

END SUBROUTINE

