MODULE minmax

!******************************************************************

INTERFACE
  double precision FUNCTION max_matrix2d(matrix)

  implicit none

  double precision, dimension(:,:) :: matrix
  double precision, dimension(:), allocatable :: vec
  END FUNCTION

END INTERFACE

INTERFACE
  double precision FUNCTION max_matrix3d(matrix)

  implicit none

  double precision, dimension(:,:,:) :: matrix
  double precision, dimension(:), allocatable :: vec
  END FUNCTION

END INTERFACE

INTERFACE
  double precision FUNCTION min_matrix2d(matrix)

  implicit none

  double precision, dimension(:,:) :: matrix
  double precision, dimension(:), allocatable :: vec
  END FUNCTION

END INTERFACE

INTERFACE
  double precision FUNCTION min_matrix3d(matrix)

  implicit none

  double precision, dimension(:,:,:) :: matrix
  double precision, dimension(:), allocatable :: vec
  END FUNCTION

END INTERFACE

!******************************************************************


END MODULE


!******************************************************************

double precision FUNCTION max_matrix2d(matrix)

use minmax1d

implicit none

double precision, dimension(:,:) :: matrix
double precision, dimension(:), allocatable :: vec

allocate(vec(1:size(matrix)))
vec=reshape(matrix,(/size(matrix)/))
max_matrix2d=max_vector(vec)

END FUNCTION

!******************************************************************

double precision FUNCTION max_matrix3d(matrix)

use minmax1d

implicit none

double precision, dimension(:,:,:) :: matrix
double precision, dimension(:), allocatable :: vec

allocate(vec(1:size(matrix)))
vec=reshape(matrix,(/size(matrix)/))
max_matrix3d=max_vector(vec)

END FUNCTION

!******************************************************************

double precision FUNCTION min_matrix2d(matrix)

use minmax1d

implicit none

double precision, dimension(:,:) :: matrix
double precision, dimension(:), allocatable :: vec

allocate(vec(1:size(matrix)))
vec=reshape(matrix,(/size(matrix)/))
min_matrix2d=min_vector(vec)

END FUNCTION

!******************************************************************

double precision FUNCTION min_matrix3d(matrix)

use minmax1d

implicit none

double precision, dimension(:,:,:) :: matrix
double precision, dimension(:), allocatable :: vec

allocate(vec(1:size(matrix)))
vec=reshape(matrix,(/size(matrix)/))
min_matrix3d=min_vector(vec)

END FUNCTION

