
!! DK DK converted to Fortran90, Dimitri Komatitsch, February 2004

!! DK DK PGPLOT routine to pack the necessary fonts

      PROGRAM PACK

!-----------------------------------------------------------------------
! Convert unpacked (ASCII) representation of GRFONT into packed
! (binary) representation used by PGPLOT.
!
! This version ignores characters in the input file with Hershey
! numbers 1000-1999 ("indexical" fonts) and 3000-3999 ("triplex"
! and "gothic" fonts).
!
! The binary file contains one record, and is a direct copy of the
! internal data structure used in PGPLOT. The format of the internal
! data structure (and the binary file) are private to PGPLOT: i.e.,
! they may be changed in a future release.
!
! NC1 Integer*4   Smallest Hershey number defined in file (1)
! NC2 Integer*4   Largest Hershey number defined in file (3000)
! NC3 Integer*4   Number of words of buffer space used
! INDEX Integer*4 array (dimension 3000)
!                 Element NC of INDEX contains either 0 if
!                 NC is not a defined Hershey character, or the
!                 index in array BUFFER at which the digitization
!                       of character number NC begins
! BUFFER Integer*2 array (dimension 27000)
!                 Coordinate pairs defining each character are
!                 packed two to a word in this array.
!
! Note: the array sizes are fixed by dimension statements in PGPLOT.
! New characters cannot be added if they would increase the size of
! the arrays.  Array INDEX is not very efficiently used as only about
! 1000 of the possible 3000 characters are defined.
!-----------------------------------------------------------------------
      INTEGER MAXCHR, MAXBUF
      PARAMETER (MAXCHR=3000)
      PARAMETER (MAXBUF=27000)

      INTEGER   INDEX(MAXCHR)
      INTEGER(kind=2) BUFFER(MAXBUF)
      INTEGER   I, LENGTH, LOC, NC, NC1, NC2, NCHAR, XYGRID(400)
!-----------------------------------------------------------------------
 1000 FORMAT (7(2X,2I4))
 2000 FORMAT (' Characters defined: ', I5,' Array cells used:   ', I5)
 3000 FORMAT (' ++ERROR++ Buffer is too small: ',I7)
!-----------------------------------------------------------------------
!
! Initialize index.
!
      DO 1 I=1,MAXCHR
          INDEX(I) = 0
    1 CONTINUE
      LOC = 0
      NCHAR = 0
!
! Open stdin.
!
! Read input file.
!
   10 CONTINUE
!         -- read next character
          READ (*,1000,END=20) NC,LENGTH,(XYGRID(I),I=1,5)
          READ (*,1000) (XYGRID(I),I=6,LENGTH)
!         -- skip if Hershey number is outside required range
          IF (NC.LT.1 .OR. (NC.GT.999.AND.NC.LT.2000) .OR. NC.GT.2999) GOTO 10
!         -- store in index and buffer
          NCHAR = NCHAR+1
          LOC = LOC+1
          IF (LOC.GT.MAXBUF) GOTO 500
          INDEX(NC) = LOC
          BUFFER(LOC) = XYGRID(1)
          DO 15 I=2,LENGTH,2
              LOC = LOC + 1
              IF (LOC.GT.MAXBUF) GOTO 500
              BUFFER(LOC) = 128*(XYGRID(I)+64) + XYGRID(I+1) + 64
   15     CONTINUE
      GOTO 10
   20 CONTINUE
!
! Write output file.
!
      OPEN (UNIT=2, STATUS='NEW', FORM='UNFORMATTED', FILE='grfont.dat')
      NC1 = 1
      NC2 = 3000
      WRITE (2) NC1,NC2,LOC,INDEX,BUFFER
      CLOSE (UNIT=2)
!
! Write summary.
!
      WRITE (6,2000) NCHAR, LOC
      STOP 'Ended successfully'
!
! Error exit.
!
  500 WRITE (6,3000) MAXBUF

      END PROGRAM PACK

