
!! DK DK Dimitri Komatitsch February 2004
!! DK DK extracted what is needed from the PGPLOT library
!! DK DK ran a script to convert to Fortran90
!! DK DK cleaned a few obsolete statements
!! DK DK and emulated useless and non-portable system calls (below)

!! DK DK beginning of emulation of non-portable and useless system calls

!*
!**GRUSER -- get user name (POSIX)
!*+
  SUBROUTINE GRUSER(STRING, L)
  CHARACTER(len=*) STRING
  INTEGER L
!*
!* Return the name of the user running the program.
!*
!* Arguments:
!*  STRING : receives user name, truncated or extended with
!*           blanks as necessary.
!*  L      : receives the number of characters in VALUE, excluding
!*           trailing blanks.
!*--
!* 08-Nov-1994
!*-----------------------------------------------------------------------

  string = 'username'
  L = 8

  end subroutine GRUSER


!**GRDATE -- get date and time as character string (Cray)
!*+
  SUBROUTINE GRDATE(STRING, L)
  CHARACTER(len=*) STRING
  INTEGER L
!*
!* Return the current date and time, in format 'dd-Mmm-yyyy hh:mm'.
!* To receive the whole string, the STRING should be declared
!* CHARACTER*17.
!*
!* Arguments:
!*  STRING : receives date and time, truncated or extended with
!*           blanks as necessary.
!*  SLEN   : receives the number of characters in STRING, excluding
!*           trailing blanks. This will always be 17, unless the length
!*           of the string supplied is shorter.
!*--
!*-----------------------------------------------------------------------

  string = '01-Jan-2000 00:00'
  L = 17

  end subroutine GRDATE


!! DK DK end of emulation of non-portable and useless system calls


!*GREXEC -- PGPLOT device handler dispatch routine
!+
      SUBROUTINE GREXEC(IDEV,IFUNC,RBUF,NBUF,CHR,LCHR)
      INTEGER IDEV, IFUNC, NBUF, LCHR
      REAL    RBUF(*)
      CHARACTER*(*) CHR
!---
      INTEGER NDEV
      PARAMETER (NDEV=1)
      CHARACTER*10 MSG
!---
      GOTO(3,4,5,6,7,8,9) IDEV
      IF (IDEV.EQ.0) THEN
          RBUF(1) = NDEV
          NBUF = 1
      ELSE
          WRITE (MSG,'(I10)') IDEV
          CALL GRWARN('Unknown device code in GREXEC: '//MSG)
      END IF
      RETURN
!---
!! DK DK restricted output to Color Postscript only
!! DK DK suppressed XWindow, which is not portable

!! BS BS changed back to original version
!! BS BS !1     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,3)

!! BS BS gif output did not work at the moment
!1     CALL GIDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
!      RETURN
!2     CALL GIDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2)
!      RETURN
3     CALL NUDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      RETURN
4     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
      RETURN
5     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,2)
      RETURN
6     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,3)
      RETURN
7     CALL PSDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,4)
      RETURN
8     CALL XWDRIV(IFUNC,RBUF,NBUF,CHR,LCHR,1)
      RETURN
9     CALL TKDRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
      RETURN

      END SUBROUTINE GREXEC


!*GRAREA -- define a clipping window
!+
  SUBROUTINE GRAREA (IDENT,X0,Y0,XSIZE,YSIZE)
!
! GRPCKG: Define a rectangular window in the current plotting area. All
! graphics (except characters written with GRCHAR) will be blanked
! outside this window.  The default window is the full plotting area
! defined by default or by GRSETS.
!
! Arguments:
!
! IDENT (input, integer): the plot identifier, returned by GROPEN.
! X0, Y0 (input, real): the lower left corner of the window, in absolute
!       device coordinates.
! XSIZE, YSIZE (input, real): width and height of the window in absolute
!       coordinates; if either is negative, the window will be reset to
!       the full plotting area.
!--
!  1-Feb-1983 - [TJP].
! 25-Nov-1994 - use floating-point [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER IDENT
  REAL X0, Y0, XSIZE, YSIZE
!
  CALL GRSLCT(IDENT)
!
  IF ((XSIZE<=0.0) .OR. (YSIZE<=0.0)) THEN
    GRXMIN(IDENT) = 0
    GRXMAX(IDENT) = GRXMXA(IDENT)
    GRYMIN(IDENT) = 0
    GRYMAX(IDENT) = GRYMXA(IDENT)
  ELSE
    GRXMIN(IDENT) = MAX(X0,0.0)
    GRYMIN(IDENT) = MAX(Y0,0.0)
    GRXMAX(IDENT) = MIN(XSIZE+X0,REAL(GRXMXA(IDENT)))
    GRYMAX(IDENT) = MIN(YSIZE+Y0,REAL(GRYMXA(IDENT)))
  END IF
!
  END

!*GRBPIC -- begin picture
!+
  SUBROUTINE GRBPIC
!
! GRPCKG (internal routine). Send a "begin picture" command to the
! device driver, and send commands to set deferred attributes (color,
! line width, etc.)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL RBUF(2)
  INTEGER NBUF, LCHR
  CHARACTER*20 CHR
!
  GRPLTD(GRCIDE) = .TRUE.
  IF (GRGTYP>0) THEN
!         -- begin picture
    RBUF(1) = GRXMXA(GRCIDE)
    RBUF(2) = GRYMXA(GRCIDE)
    NBUF = 2
    CALL GREXEC(GRGTYP,11,RBUF,NBUF,CHR,LCHR)
!         -- set color index
    RBUF(1) = GRCCOL(GRCIDE)
    NBUF = 1
    CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR)
!         -- set line width
    IF (GRGCAP(GRCIDE)(5:5)=='T') THEN
        RBUF(1) = ABS(GRWIDT(GRCIDE))
        NBUF = 1
        CALL GREXEC(GRGTYP,22,RBUF,NBUF,CHR,LCHR)
    END IF
!         -- set hardware dashing
    IF (GRGCAP(GRCIDE)(3:3)=='D') THEN
        RBUF(1) = GRSTYL(GRCIDE)
        NBUF = 1
        CALL GREXEC(GRGTYP,19,RBUF,NBUF,CHR,LCHR)
    END IF
  END IF
!
  END


!*GRCHSZ -- inquire default character attributes
!+
  SUBROUTINE GRCHSZ (IDENT,XSIZE,YSIZE,XSPACE,YSPACE)
!
! GRPCKG: Obtain the default character attributes.
!
! Arguments:
!
! IDENT (input, integer): the plot identifier, returned by GROPEN.
! XSIZE, YSIZE (output, real): the default character size
!      (absolute device units).
! XSPACE, YSPACE (output, real): the default character spacing
!      (absolute units); XSPACE is the distance between the lower left
!      corners of adjacent characters in a plotted string; YSPACE
!      is the corresponding vertical spacing.
!--
! (1-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  IDENT
  REAL     FACTOR, XSIZE, YSIZE, XSPACE, YSPACE
!
  CALL GRSLCT(IDENT)
  FACTOR = GRCSCL(IDENT)
  XSIZE = GRCXSZ * FACTOR
  YSIZE = GRCYSZ * FACTOR
  XSPACE = 10.0 * FACTOR
  YSPACE = 13.0 * FACTOR
  END

!*GRCLIP -- clip a point against clipping rectangle
!+
  SUBROUTINE GRCLIP (X,Y,XMIN,XMAX,YMIN,YMAX,C)
  REAL X,Y
  REAL XMIN,XMAX,YMIN,YMAX
  INTEGER C
!
! GRPCKG (internal routine): support routine for the clipping algorithm;
! called from GRLIN0 only. C is a 4 bit code indicating the relationship
! between point (X,Y) and the window boundaries; 0 implies the point is
! within the window.
!
! Arguments:
!--
! (11-Feb-1983)
! Revised 20-Jun-1985 (TJP); use floating arithmetic
! Revised 12-Jun-1992 (TJP); clip exactly on the boundary
!-----------------------------------------------------------------------
!
  C = 0
  IF (X<XMIN) THEN
    C = 1
  ELSE IF (X>XMAX) THEN
    C = 2
  END IF
  IF (Y<YMIN) THEN
    C = C+4
  ELSE IF (Y>YMAX) THEN
    C = C+8
  END IF
  END

!*GRCLOS -- close graphics device
!+
  SUBROUTINE GRCLOS
!
! GRPCKG: Close the open plot on the current device. Any pending output
! is sent to the device, the device is released for other users or the
! disk file is closed, and no further plotting is allowed on the device
! without a new call to GROPEN.
!
! Arguments: none.
!--
!  1-Jun-1984 - [TJP].
! 17-Jul-1984 - ignore call if plot is not open [TJP].
!  1-Oct-1984 - reset color to default (1) and position text cursor
!               at bottom of VT screen [TJP].
! 19-Oct-1984 - add VV device [TJP].
! 22-Dec-1984 - use GRBUFL and GRIOTA parameters [TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 21-Feb-1987 - modify END_PICTURE sequence [AFT].
! 11-Jun-1987 - remove built-ins [TJP].
! 31-Aug-1987 - do not eject blank page [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL    RBUF(6)
  INTEGER NBUF,LCHR
  CHARACTER CHR
!
! Check a plot is open.
!
  IF (GRCIDE<1) RETURN
!
! Reset color to default (1). This is useful
! for VT240 terminals, which use the color tables for text.
!
  CALL GRSCI(1)
!
! Flush buffer.
!
  CALL GRTERM
!
! End picture.
!
  CALL GREPIC
!
! This plot identifier is no longer in use.
! Set state to "workstation closed".
!
  GRSTAT(GRCIDE) = 0
  GRCIDE = 0
!
! Close workstation.
!
  CALL GREXEC(GRGTYP,10,RBUF,NBUF,CHR,LCHR)
!
  END

!*GRCLPL -- clip line against clipping rectangle
!+
  SUBROUTINE GRCLPL (X0,Y0,X1,Y1,VIS)
!
! GRPCKG (internal routine): Change the end-points of the line (X0,Y0)
! (X1,Y1) to clip the line at the window boundary.  The algorithm is
! that of Cohen and Sutherland (ref: Newman & Sproull).
!
! Arguments:
!
! X0, Y0 (input/output, real): device coordinates of starting point
!       of line.
! X1, Y1 (input/output, real): device coordinates of end point of line.
! VIS (output, logical): .TRUE. if line lies wholly or partially
!       within the clipping rectangle; .FALSE. if it lies entirely
!       outside the rectangle.
!--
! 13-Jul-1984 - [TJP].
! 20-Jun-1985 - [TJP] - revise clipping algorithm.
! 28-Jun-1991 - [TJP] - use IAND().
! 12-Jun-1992 - [TJP] - clip exactly on the boundary.
!
! Caution: IAND is a non-standard intrinsic function to do bitwise AND
! of two integers. If it is not supported by your Fortran compiler, you
! will need to modify this routine or supply an IAND function.
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  LOGICAL  VIS
  INTEGER  C0,C1,C
  REAL     XMIN,XMAX,YMIN,YMAX
  REAL     X,Y, X0,Y0, X1,Y1
  INTEGER IAND
!
  XMIN = GRXMIN(GRCIDE)
  YMIN = GRYMIN(GRCIDE)
  XMAX = GRXMAX(GRCIDE)
  YMAX = GRYMAX(GRCIDE)
  CALL GRCLIP(X0,Y0,XMIN,XMAX,YMIN,YMAX,C0)
  CALL GRCLIP(X1,Y1,XMIN,XMAX,YMIN,YMAX,C1)
   10 IF (C0/=0 .OR. C1/=0) THEN
    IF (IAND(C0,C1)/=0) THEN
!             ! line is invisible
        VIS = .FALSE.
        RETURN
    END IF
    C = C0
    IF (C==0) C = C1
    IF (IAND(C,1)/=0) THEN
!             ! crosses XMIN
        Y = Y0 + (Y1-Y0)*(XMIN-X0)/(X1-X0)
        X = XMIN
    ELSE IF (IAND(C,2)/=0) THEN
!             ! crosses XMAX
        Y = Y0 + (Y1-Y0)*(XMAX-X0)/(X1-X0)
        X = XMAX
    ELSE IF (IAND(C,4)/=0) THEN
!             ! crosses YMIN
        X = X0 + (X1-X0)*(YMIN-Y0)/(Y1-Y0)
        Y = YMIN
    ELSE IF (IAND(C,8)/=0) THEN
!             ! crosses YMAX
        X = X0 + (X1-X0)*(YMAX-Y0)/(Y1-Y0)
        Y = YMAX
    END IF
    IF (C==C0) THEN
        X0 = X
        Y0 = Y
        CALL GRCLIP(X,Y,XMIN,XMAX,YMIN,YMAX,C0)
    ELSE
        X1 = X
        Y1 = Y
        CALL GRCLIP(X,Y,XMIN,XMAX,YMIN,YMAX,C1)
    END IF
  GOTO 10
  END IF
  VIS = .TRUE.
  END

!*GRCTOI -- convert character string to integer
!+
  INTEGER FUNCTION GRCTOI (S, I)
  CHARACTER*(*) S
  INTEGER I
!
! GRCTOI: attempt to read an integer from a character string, and return
! the result. No attempt is made to avoid integer overflow. A valid
! integer is any sequence of decimal digits.
!
! Returns:
!  GRCTOI           : the value of the integer; if the first character
!                    read is not a decimal digit, the value returned
!                    is zero.
! Arguments:
!  S      (input)  : character string to be parsed.
!  I      (in/out) : on input, I is the index of the first character
!                    in S to be examined; on output, either it points
!                    to the next character after a valid integer, or
!                    it is equal to LEN(S)+1.
!
!--
!  1985 Oct  8 - New routine, based on CTOI (T. J. Pearson).
!  1997 Jun  3 - allow leading + or - sign (TJP).
!-----------------------------------------------------------------------
  INTEGER K, SIGN, X
  CHARACTER*1 DIGITS(0:9)
  DATA  DIGITS/'0','1','2','3','4','5','6','7','8','9'/
!
  X = 0
  SIGN = +1
  IF (I>LEN(S)) GOTO 30
  IF (S(I:I)=='+') THEN
   I = I+1
  ELSE IF (S(I:I)=='-') THEN
   I = I+1
   SIGN = -1
  END IF
 10   IF (I>LEN(S)) GOTO 30
  DO 20 K=0,9
   IF (S(I:I)==DIGITS(K)) THEN
      X = X*10 + K
      I = I+1
      GOTO 10
   END IF
 20   CONTINUE
 30   GRCTOI = X*SIGN
  RETURN
  END

!*GRCURS -- read cursor position
!+
  INTEGER FUNCTION GRCURS (IDENT,IX,IY,IXREF,IYREF,MODE,POSN,CH)
  INTEGER IDENT, IX, IY, IXREF, IYREF, MODE, POSN
  CHARACTER*(*) CH
!
! GRPCKG: Read the cursor position and a character typed by the user.
! The position is returned in absolute device coordinates (pixels).
! GRCURS positions the cursor at the position specified, and
! allows the user to move the cursor using the joystick or
! arrow keys or whatever is available on the device. When he has
! positioned the cursor, the user types a single character on his
! keyboard; GRCURS then returns this character and the new cursor
! position.
!
! "Rubber band" feedback of cursor movement can be requested (although
! it may not be supported on some devices). If MODE=1, a line from
! the anchor point to the current cursor position is displayed as
! the cursor is moved. If MODE=2, a rectangle with vertical and
! horizontal sides and one vertex at the anchor point and the opposite
! vertex at the current cursor position is displayed as the cursor is
! moved.
!
! Returns:
!
! GRCURS (integer): 1 if the call was successful; 0 if the device
!      has no cursor or some other error occurs.
!
! Arguments:
!
! IDENT (integer, input):  GRPCKG plot identifier (from GROPEN).
! IX    (integer, in/out): the device x-coordinate of the cursor.
! IY    (integer, in/out): the device y-coordinate of the cursor.
! IXREF (integer, input):  x-coordinate of anchor point.
! IYREF (integer, input):  y-coordinate of anchor point.
! MODE  (integer, input):  type of rubber-band feedback.
! CH    (char,    output): the character typed by the user; if the device
!      has no cursor or if some other error occurs, the value CHAR(0)
!      [ASCII NUL character] is returned.
!--
!  1-Aug-1984 - extensively revised [TJP].
! 29-Jan-1985 - add ARGS and HP2648 devices (?) [KS/TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 11-Jun-1987 - remove built-ins [TJP].
! 15-Feb-1988 - remove test for batch jobs; leave this to the device
!               handler [TJP].
! 13-Dec-1990 - remove code to abort after 10 cursor errors [TJP].
!  7-Sep-1994 - add support for rubber-band modes [TJP].
! 17-Jan-1995 - start picture if necessary [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL           RBUF(6)
  INTEGER        NBUF, LCHR, ICURS, ERRCNT
  CHARACTER*16   CHR
  CHARACTER      C
  SAVE           ERRCNT
  DATA           ERRCNT/0/
!
! Validate identifier, and select device.
!
  CALL GRSLCT(IDENT)
  CALL GRTERM
!
! Begin picture if necessary.
!
  IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
!
! Make sure cursor is on view surface. (It does not
! have to be in the viewport.)
!
  IX = MAX(0,MIN(GRXMXA(GRCIDE),IX))
  IY = MAX(0,MIN(GRYMXA(GRCIDE),IY))
!
! Does the device have a cursor?
!
  C = GRGCAP(GRCIDE)(2:2)
  ICURS = 0
  IF (C=='C' .OR. C=='X') ICURS=1
!
! Device does have a cursor.
!
  IF (ICURS>0) THEN
!         -- initial position of cursor
    RBUF(1) = IX
    RBUF(2) = IY
!         -- reference point for rubber band
    RBUF(3) = IXREF
    RBUF(4) = IYREF
!         -- rubber band mode
    RBUF(5) = MODE
!         -- position cursor?
    RBUF(6) = POSN
    NBUF = 6
    LCHR = 0
    CALL GREXEC(GRGTYP,17,RBUF,NBUF,CHR,LCHR)
    IX = RBUF(1)
    IY = RBUF(2)
    CH = CHR(1:1)
    GRCURS = 1
!         -- error if driver returns NUL
    IF (ICHAR(CHR(1:1))==0) GRCURS = 0
!
! Other devices are illegal.
!
  ELSE
    CALL GREXEC(GRGTYP, 1,RBUF,NBUF,CHR,LCHR)
    LCHR = INDEX(CHR,' ')
    IF (ERRCNT<=10) CALL &
          GRWARN('output device has no cursor: '//CHR(:LCHR))
    CH = CHAR(0)
    GRCURS = 0
    ERRCNT = ERRCNT+1
  END IF
!
  END

!*GRDOT0 -- draw a dot
!+
  SUBROUTINE GRDOT0 (X,Y)
!
! GRPCKG (internal routine): Draw a single dot (pixel) at a specified
! location.
!
! Arguments:
!
! X, Y (real, input): absolute device coordinates of the dot (these
!       are rounded to the nearest integer by GRDOT0).
!--
! (1-Jun-1984)
! 22-Oct-1984 - rewrite [TJP].
! 29-Jan-1985 - add HP2648 device [KS/TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 21-Feb-1987 - If needed, calls begin picture [AFT].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  NBUF, LCHR
  REAL     X, Y, RBUF(6)
  CHARACTER CHR
!
! (X,Y) is the new current position.
!
  GRXPRE(GRCIDE) = X
  GRYPRE(GRCIDE) = Y
!
! Check window.
!
  IF (X < GRXMIN(GRCIDE)) RETURN
  IF (X > GRXMAX(GRCIDE)) RETURN
  IF (Y < GRYMIN(GRCIDE)) RETURN
  IF (Y > GRYMAX(GRCIDE)) RETURN
!
! Begin picture if necessary.
!
  IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
!
! If a "thick pen" is to be simulated, use the line-drawing routines
! instead.
!
  IF (GRWIDT(GRCIDE)>1) THEN
    CALL GRLIN3(X,Y,X,Y)
  ELSE
    RBUF(1)=X
    RBUF(2)=Y
    NBUF=2
    CALL GREXEC(GRGTYP,13,RBUF,NBUF,CHR,LCHR)
  END IF
  END

!*GRDOT1 -- draw dots
!+
  SUBROUTINE GRDOT1(POINTS, X, Y)
  INTEGER POINTS
  REAL X(POINTS), Y(POINTS)
!
! GRPCKG (internal routine): Draw a set of dots.
!
! Arguments:
!
! POINTS (input, integer): the number of coordinate pairs.
! X, Y (input, real arrays, dimensioned POINTS or greater): the
!       X and Y world coordinates of the points.
!--
! 14-Mar-1997 - new routine to optimize drawing many dots [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  I, NBUF, LCHR
  REAL     RBUF(2), XP, YP
  CHARACTER CHR
  EQUIVALENCE (XP, RBUF(1)), (YP, RBUF(2))
!
! Begin picture if necessary.
!
  IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
!
! Loop for points: driver support.
!
  IF (GRWIDT(GRCIDE)<=1) THEN
   NBUF = 2
   LCHR = 0
   DO 10 I=1,POINTS
!        -- Convert to device coordinates
      XP = X(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
      YP = Y(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
!           -- Clip against viewport
      IF (XP >= GRXMIN(GRCIDE) .AND. &
            XP <= GRXMAX(GRCIDE) .AND. &
            YP >= GRYMIN(GRCIDE) .AND. &
            YP <= GRYMAX(GRCIDE)) THEN
         CALL GREXEC(GRGTYP,13,RBUF,NBUF,CHR,LCHR)
      END IF
 10      CONTINUE
!
! Thick line emulation required.
!
  ELSE
   DO 20 I=1,POINTS
!        -- Convert to device coordinates
      XP = X(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
      YP = Y(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
!           -- Clip against viewport
      IF (XP >= GRXMIN(GRCIDE) .AND. &
            XP <= GRXMAX(GRCIDE) .AND. &
            YP >= GRYMIN(GRCIDE) .AND. &
            YP <= GRYMAX(GRCIDE)) THEN
         CALL GRLIN3(XP, YP, XP, YP)
      END IF
 20      CONTINUE
  END IF
!
! New pen position.
!
  GRXPRE(GRCIDE) = XP
  GRYPRE(GRCIDE) = YP
!
  END

!*GRDTYP -- decode graphics device type string
!+
  INTEGER FUNCTION GRDTYP (TEXT)
!
! GRPCKG (internal routine): determine graphics device type code from
! type name. It compares the argument with the table of known device
! types in common.
!
! Argument:
!
! TEXT (input, character): device type name, eg 'PRINTRONIX'; the name
!       may be abbreviated to uniqueness.
!
! Returns:
!
! GRDTYP (integer): the device type code, in the range 1 to
!       GRTMAX, zero if the type name is not recognised, or -1
!       if the type name is ambiguous.
!--
! 27-Dec-1984 - rewrite so that is doesn't have to be modified for
!               new devices [TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 10-Nov-1995 - ignore drivers that report no device type [TJP].
! 30-Aug-1996 - check for an exact match; indicate if type is
!               ambiguous [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  CHARACTER*(*) TEXT
  INTEGER  CODE, I, L, MATCH
  REAL     RBUF(6)
  INTEGER NDEV,NBUF,LCHR
  INTEGER GRTRIM
  CHARACTER*32 CHR
!
  GRDTYP = 0
  L = GRTRIM(TEXT)
  IF (L<1) RETURN
  MATCH = 0
  CODE = 0
  CALL GREXEC(0,0,RBUF,NBUF,CHR,LCHR)
  NDEV=NINT(RBUF(1))
  DO 30 I=1,NDEV
   CALL GREXEC(I, 1,RBUF,NBUF,CHR,LCHR)
   IF (LCHR>0) THEN
      IF(TEXT(1:L)==CHR(1:L)) THEN
         IF (CHR(L+1:L+1)==' ') THEN
!                 -- exact match
            GRDTYP = I
            GRGTYP = GRDTYP
            RETURN
         ELSE
            MATCH = MATCH+1
            CODE = I
         END IF
      END IF
   END IF
   30 CONTINUE
  IF (MATCH==0) THEN
!        -- no match
   GRDTYP = 0
  ELSE IF (MATCH==1) THEN
   GRDTYP = CODE
   GRGTYP = GRDTYP
  ELSE
   GRDTYP = -1
  END IF
!
  END

!*GREPIC -- end picture
!+
  SUBROUTINE GREPIC
!
! GRPCKG: End the current picture.
!
! Arguments: none.
!--
! 17-Nov-1994 - [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL    RBUF(6)
  INTEGER NBUF,LCHR
  CHARACTER CHR
!
! Check a plot is open.
!
  IF (GRCIDE<1) RETURN
!
! End picture.
!
  IF (GRPLTD(GRCIDE)) THEN
      RBUF(1) = 1.
      NBUF = 1
      CALL GREXEC(GRGTYP,14,RBUF,NBUF,CHR,LCHR)
  END IF
  GRPLTD(GRCIDE) = .FALSE.
!
  END

!*GRESC -- escape routine
!+
  SUBROUTINE GRESC (TEXT)
!
! GRPCKG: "Escape" routine. The specified text is sent directly to the
! selected graphics device, with no interpretation by GRPCKG. This
! routine must be used with care; e.g., the programmer needs to know
! the device type of the currently selected device, and the instructions
! that that device can accept.
!
! Arguments: none.
!  TEXT (input, character*(*)):  text to be sent to the device.
!
! 15-May-1985 - new routine [TJP].
! 26-May-1987 - add GREXEC support [TJP].
! 19-Dec-1988 - start new page if necessary [TJP].
!  4-Feb-1997 - RBUF should be an array, not a scalar [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  CHARACTER*(*) TEXT
  REAL RBUF(1)
  INTEGER NBUF
!
! If no device is currently selected, do nothing.
!
  IF (GRCIDE>0) THEN
    IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
    NBUF = 0
    CALL GREXEC(GRGTYP,23,RBUF,NBUF,TEXT,LEN(TEXT))
  END IF
  END


!*GRETXT -- erase text from graphics screen
!+
  SUBROUTINE GRETXT
!
! GRPCKG: Erase the text screen.  Some graphics devices have
! two superimposed view surfaces, of which one is used for graphics and
! the other for alphanumeric text.  This routine erases the text
! view surface without affecting the graphics view surface. It does
! nothing if there is no text view surface associated with the device.
!
! Arguments: none.
!--
! (1-Feb-1983)
! 16-Oct-1984 - add ID100 device [RSS/TJP].
! 29-Jan-1985 - add HP2648 device [KS/TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 11-Jun-1987 - remove built-in devices [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  CHARACTER*1   CHR
  REAL    RBUF(6)
  INTEGER NBUF,LCHR
!
  IF (GRCIDE>=1) THEN
    CALL GREXEC(GRGTYP,18,RBUF,NBUF,CHR,LCHR)
  END IF
!
  END

!*GRFA -- fill area (polygon)
!+
  SUBROUTINE GRFA (N,PX,PY)
  INTEGER N
  REAL PX(*), PY(*)
!
! GRPCKG: FILL AREA: fill a polygon with solid color.  The polygon
! is defined by the (x,y) world coordinates of its N vertices.  If
! this is not a function supported by the device, shading is
! accomplished by drawing horizontal lines spaced by 1 pixel.  By
! selecting color index 0, the interior of the polygon can be erased
! on devices which permit it.  The polygon need not be convex, but if
! it is re-entrant (i.e., edges intersect other than at the vertices),
! it may not be obvious which regions are "inside" the polygon.  The
! following rule is applied: for a given point, create a straight line
! starting at the point and going to infinity. If the number of
! intersections between the straight line and the polygon is odd, the
! point is within the polygon; otherwise it is outside. If the
! straight line passes a polygon vertex tangentially, the
! intersection  count is not affected. The only attribute which applies
! to FILL AREA is color index: line-width and line-style are ignored.
! There is a limitation on the complexity of the polygon: GFA will
! fail if any horizontal line intersects more than 32 edges of the
! polygon.
!
! Arguments:
!
! N (input, integer): the number of vertices of the polygon (at least
!       3).
! PX, PY (input, real arrays, dimension at least N): world coordinates
!       of the N vertices of the polygon.
!--
! 16-Jul-1984 - [TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 21-Feb-1987 - If needed, calls begin picture [AFT].
!  7-Sep-1994 - avoid driver call for capabilities [TJP].
!  1-May-1995 - fixed bug for re-entrant polygons, and optimized code
!               [A.F.Carman].
! 18-Oct-1995 - fixed bug: emulated fill failed for reversed y-axis
!               [S.C.Allendorf/TJP].
!  4-Dec-1995 - remove use of real variable as do-loop variable [TJP].
! 20-Mar-1996 - use another do loop 40 to avoid gaps between adjacent
!               polygons [RS]
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER MAXSEC
  PARAMETER (MAXSEC=32)
  INTEGER I, J, NSECT, LW, LS, NBUF, LCHR, LINE
  REAL    RBUF(6)
  CHARACTER*32 CHR
  REAL    X(MAXSEC), Y, YMIN, YMAX, DY, YD, TEMP, S1, S2, T1, T2
  LOGICAL FORWD
!
  IF (GRCIDE<1) RETURN
  IF (N<3) THEN
    CALL GRWARN('GRFA - polygon has < 3 vertices.')
    RETURN
  END IF
!
! Devices with polygon fill capability.
!
  IF(GRGCAP(GRCIDE)(4:4)=='A') THEN
   IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
   RBUF(1) = N
   CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
   DO 10 I=1,N
      RBUF(1) = PX(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
      RBUF(2) = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
      CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
 10      CONTINUE
   RETURN
  END IF
!
! For other devices fill area is simulated.
!
! Save attributes.
!
  CALL GRQLS(LS)
  CALL GRQLW(LW)
  CALL GRSLS(1)
  CALL GRSLW(1)
!
! Find range of raster-lines to be shaded.
!
  YMIN = PY(1)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
  YMAX = YMIN
  DO 20 I=2,N
   YD = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
   YMIN = MIN(YMIN,YD)
   YMAX = MAX(YMAX,YD)
 20   CONTINUE
  CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR)
  DY = ABS(RBUF(3))
!
! Find intersections of edges with current raster line.
!
  FORWD = .TRUE.
  S1 = PX(N)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
  T1 = PY(N)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
!
  DO 40 LINE = NINT(YMIN/DY),NINT(YMAX/DY)
   Y = LINE * DY
   NSECT = 0
   DO 30 I=1,N
      S2 = PX(I)*GRXSCL(GRCIDE) + GRXORG(GRCIDE)
      T2 = PY(I)*GRYSCL(GRCIDE) + GRYORG(GRCIDE)
      IF ((T1<Y .AND. Y<=T2).OR. &
            (T1>=Y .AND. Y>T2)) THEN
         NSECT = NSECT+1
         IF (NSECT>MAXSEC) THEN
            CALL GRWARN('GRFA - polygon is too complex.')
            RETURN
         END IF
         X(NSECT)=(S1+(S2-S1)*((Y-T1)/(T2-T1)))
      END IF
      S1 = S2
      T1 = T2
 30      CONTINUE
!
! Sort the intersections into increasing x order.
!
   DO 34 I=2,NSECT
      DO 32 J=1,I
         IF (X(J)>X(I)) THEN
            TEMP = X(J)
            X(J) = X(I)
            X(I) = TEMP
         END IF
 32         CONTINUE
 34      CONTINUE
!
! Draw the horizontal line-segments.
!
   GRYPRE(GRCIDE) = Y
   IF (FORWD) THEN
      DO 36 I=1,NSECT-1,2
         GRXPRE(GRCIDE) = X(I)
         CALL GRLIN0(X(I+1),Y)
 36         CONTINUE
      FORWD = .FALSE.
   ELSE
      DO 38 I=NSECT,2,-2
         GRXPRE(GRCIDE) = X(I)
         CALL GRLIN0(X(I-1),Y)
 38         CONTINUE
      FORWD = .TRUE.
   END IF
 40   CONTINUE
!
! Restore attributes.
!
  CALL GRSLS(LS)
  CALL GRSLW(LW)
  END

!*GRFAO - format character string containing integers
!+
  SUBROUTINE GRFAO (FORMAT, L, STR, V1, V2, V3, V4)
  CHARACTER*(*) FORMAT
  INTEGER L
  CHARACTER*(*) STR
  INTEGER V1, V2, V3, V4
!
! The input string FORMAT is copied to the output string STR with
! the first occurrence of '#' replaced by the value of V1, the second
! by the value of V2, etc.  The length of the resulting string is
! returned in L.
!-----------------------------------------------------------------------
  INTEGER I,Q,VAL,GRITOC
!
  L = 0
  Q = 0
  DO 10 I=1,LEN(FORMAT)
    IF (L>=LEN(STR)) RETURN
    IF (FORMAT(I:I)/='#') THEN
        L = L+1
        STR(L:L) = FORMAT(I:I)
    ELSE
        Q = Q+1
        VAL = 0
        IF (Q==1) VAL = V1
        IF (Q==2) VAL = V2
        IF (Q==3) VAL = V3
        IF (Q==4) VAL = V4
        L = L + GRITOC(VAL, STR(L+1:))
    END IF
   10 CONTINUE
!-----------------------------------------------------------------------
  END

!*GRFLUN -- free a Fortran logical unit number (Sun/Convex-UNIX)
!+
  SUBROUTINE GRFLUN(LUN)
  INTEGER LUN
!
! Free a Fortran logical unit number allocated by GRGLUN. [This version
! does nothing.]
!
! Arguments:
!  LUN    : the logical unit number to free.
!--
! 25-Nov-1988
!-----------------------------------------------------------------------
  RETURN
  END

!*GRGCOM -- read with prompt from user's terminal (Sun/Convex-UNIX)
!+
  INTEGER FUNCTION GRGCOM(STRING, PROMPT, L)
  CHARACTER*(*) STRING, PROMPT
  INTEGER L
!
! Issue prompt and read a line from the user's terminal; in VMS,
! this is equivalent to LIB$GET_COMMAND.
!
! Arguments:
!  STRING : (output) receives the string read from the terminal.
!  PROMPT : (input) prompt string.
!  L      : (output) length of STRING.
!
! Returns:
!  GRGCOM : 1 if successful, 0 if an error occurs (e.g., end of file).
!--
! 9-Feb-1988
! 10-Feb-1990 revised to always read from stdin (unit 5), but issue a
!             prompt only when device is a terminal.
!-----------------------------------------------------------------------
  INTEGER IER
!
  GRGCOM = 0
  L = 0
  IER = 0
  WRITE (*, '(1X,A,$)', IOSTAT=IER) PROMPT
  IF (IER==0) READ (*, '(A)', IOSTAT=IER) STRING
  IF (IER==0) GRGCOM = 1
  L = LEN(STRING)
   10 IF (STRING(L:L)/=' ') GOTO 20
    L = L-1
    GOTO 10
   20 CONTINUE
  END


!*GRGENV -- get value of PGPLOT environment parameter (Sun/Convex-UNIX)
!+
  SUBROUTINE GRGENV(NAME, VALUE, L)
  CHARACTER*(*) NAME, VALUE
  INTEGER L
!
! Return the value of a PGPLOT environment parameter. In Sun/Convex-UNIX,
! environment parameters are UNIX environment variables; e.g. parameter
! ENVOPT is environment variable PGPLOT_ENVOPT. Translation is not
! recursive and is case-sensitive.
!
! Arguments:
!  NAME   : (input) the name of the parameter to evaluate.
!  VALUE  : receives the value of the parameter, truncated or extended
!           with blanks as necessary. If the parameter is undefined,
!           a blank string is returned.
!  L      : receives the number of characters in VALUE, excluding
!           trailing blanks. If the parameter is undefined, zero is
!           returned.
!--
! 19-Jan-1988
!-----------------------------------------------------------------------
  INTEGER I, LIN
  CHARACTER*32 TEST
!
  TEST = 'PGPLOT_'//NAME
  LIN = INDEX(TEST, ' ')-1
  CALL GETENV(TEST(:LIN), VALUE)
  IF (VALUE==' ') THEN
    L = 0
  ELSE
    DO 10 I=LEN(VALUE),1,-1
        L = I
        IF (VALUE(I:I)/=' ') GOTO 20
   10     CONTINUE
    L = 0
   20     CONTINUE
  END IF
  END

!*GRGFIL -- find data file
!+
  SUBROUTINE GRGFIL(TYPE, NAME)
  CHARACTER*(*) TYPE, NAME
!
! This routine encsapsulates the algorithm for finding the PGPLOT
! run-time data files.
!
! 1. The binary font file: try the following in order:
!     file specified by PGPLOT_FONT
!     file "grfont.dat" in directory specified by PGPLOT_DIR
!                       (with or without '/' appended)
!     file "grfont.dat" in directory /usr/local/pgplot/
!
! 2. The color-name database: try the following in order:
!     file specified by PGPLOT_RGB
!     file "rgb.txt" in directory specified by PGPLOT_DIR
!                       (with or without '/' appended)
!     file "rgb.txt" in directory /usr/local/pgplot/
!
! Arguments:
!  TYPE (input)  : either 'FONT' or 'RGB' to request the corresponding
!                  file.
!  NAME (output) : receives the file name.
!--
!  2-Dec-1994 - new routine [TJP].
!-----------------------------------------------------------------------
  CHARACTER*(*) DEFDIR, DEFFNT, DEFRGB
  PARAMETER  (DEFDIR='/usr/local/pgplot/')
  PARAMETER  (DEFFNT='grfont.dat')
  PARAMETER  (DEFRGB='rgb.txt')
  CHARACTER*255 FF
  CHARACTER*16 DEFLT
  INTEGER I, L, LD
  LOGICAL TEST, DEBUG
!
! Is debug output requested?
!
  CALL GRGENV('DEBUG', FF, L)
  DEBUG = L>0
!
! Which file?
!
  IF (TYPE=='FONT') THEN
   DEFLT = DEFFNT
   LD = LEN(DEFFNT)
  ELSE IF (TYPE=='RGB') THEN
   DEFLT = DEFRGB
   LD = LEN(DEFRGB)
  ELSE
   CALL GRWARN('Internal error in routine GRGFIL')
  END IF
!
! Try each possibility in turn.
!
  DO 10 I=1,4
   IF (I==1) THEN
      CALL GRGENV(TYPE, FF, L)
   ELSE IF (I==2) THEN
      CALL GRGENV('DIR', FF, L)
      IF (L>0) THEN
         FF(L+1:) = DEFLT
         L = L+LD
      END IF
   ELSE IF (I==3) THEN
      CALL GRGENV('DIR', FF, L)
      IF (L>0) THEN
         FF(L+1:L+1) = '/'
         FF(L+2:) = DEFLT
         L = L+1+LD
      END IF
   ELSE IF (I==4) THEN
      FF = DEFDIR//DEFLT
      L = LEN(DEFDIR)+LD
   END IF
   IF (L>0) THEN
      IF (DEBUG) THEN
         CALL GRWARN('Looking for '//FF(:L))
      END IF
      INQUIRE (FILE=FF(:L), EXIST=TEST)
      IF (TEST) THEN
         NAME = FF(:L)
         RETURN
      ELSE IF (DEBUG) THEN
         CALL GRWARN('WARNING: file not found')
      END IF
   END IF
 10   CONTINUE
!
! Failed to find the file.
!
  NAME = DEFLT
!-----------------------------------------------------------------------
  END

!*GRGLUN -- get a Fortran logical unit number (Sun/Convex-UNIX)
!+
  SUBROUTINE GRGLUN(LUN)
  INTEGER LUN
!
! Get an unused Fortran logical unit number.
! Returns a Logical Unit Number that is not currently opened.
! After GRGLUN is called, the unit should be opened to reserve
! the unit number for future calls.  Once a unit is closed, it
! becomes free and another call to GRGLUN could return the same
! number.  Also, GRGLUN will not return a number in the range 1-9
! as older software will often use these units without warning.
!
! Arguments:
!  LUN    : receives the logical unit number, or -1 on error.
!--
! 12-Feb-1989 [AFT/TJP].
!-----------------------------------------------------------------------
  INTEGER I
  LOGICAL QOPEN
!---
  DO 10 I=99,10,-1
    INQUIRE (UNIT=I,  OPENED=QOPEN)
    IF (.NOT.QOPEN) THEN
        LUN = I
        RETURN
    END IF
   10 CONTINUE
  CALL GRWARN('GRGLUN: out of units.')
  LUN = -1
  RETURN
  END


!*GRGMSG -- print system message (Sun/Convex-UNIX)
!+
  SUBROUTINE GRGMSG (STATUS)
  INTEGER STATUS
!
! This routine obtains the text of the VMS system message corresponding
! to code STATUS, and displays it using routine GRWARN. On non-VMS
! systems, it just displays the error number.
!
! Argument:
!  STATUS (input): 32-bit system message code.
!--
! 18-Feb-1988
!-----------------------------------------------------------------------
  CHARACTER*10 BUFFER
!
  WRITE (BUFFER, '(I10)') STATUS
  CALL GRWARN('system message number: '//BUFFER)
  END

!*GRGRAY -- gray-scale map of a 2D data array
!+
  SUBROUTINE GRGRAY (A, IDIM, JDIM, I1, I2, J1, J2, &
                     FG, BG, PA, MININD, MAXIND, MODE)
  INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE
  REAL    A(IDIM,JDIM)
  REAL    FG, BG
  REAL    PA(6)
!
! This is a device-dependent support routine for PGGRAY.
!
! Draw gray-scale map of an array in current window. Array
! values between FG and BG are shaded in gray levels determined
! by linear interpolation. FG may be either less than or greater
! than BG.  Array values outside the range FG to BG are
! shaded black or white as appropriate.
!
! GRGRAY uses GRIMG0 on devices with enough color indices available.
! Note that it changes the color table to gray-scale.
! Otherwise in does a random dither with GRIMG3.
!
! Arguments:
!  A      (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  FG     (input)  : the array value which is to appear in
!                    foreground color.
!  BG     (input)  : the array value which is to appear in
!                    background color.
!  PA     (input)  : transformation matrix between array grid and
!                    device coordinates (see GRCONT).
!  MODE   (input)  : transfer function.
!--
! 12-Dec-1986 - Speed up plotting [J. Biretta].
!  3-Apr-1987 - Add special code for /PS, /VPS, /GR.
!  2-Sep-1987 - Adapted from PGGRAY [TJP].
!  1-Dec-1988 - Put random-number generator inline [TJP].
!  3-Apr-1989 - Use "line of pixels" primitive where available [TJP].
!  6-Sep-1989 - Changes for standard Fortran-77 [TJP].
! 19-Jan-1990 - Add special code for /CPS, /VCPS [DLM]
!  3-Sep-1992 - Add special code for NULL device [TJP].
! 25-Nov-1992 - Add special code for /NEXT [AFT].
! 17-Mar-1994 - Scale in device coordinates [TJP].
! 31-Aug-1994 - use GRIMG0 when appropriate [TJP].
!  7-Sep-1994 - speed up random dither [TJP].
!  8-Feb-1995 - use color ramp based on color indices 0 and 1 [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER I
  REAL    A0, A1, CR0, CG0, CB0, CR1, CG1, CB1
  INTRINSIC REAL
!-----------------------------------------------------------------------
!
! N.B. Arguments are assumed to be valid (checked by PGGRAY).
!
! Use GRIMG0 if this an appropriate device; first initialize the
! color table to a linear ramp between the colors assigned to color
! indices 0 and 1.
!
  IF (GRGCAP(GRCIDE)(7:7)/='N' .AND. MAXIND-MININD > 15) THEN
   CALL GRQCR(0, CR0, CG0, CB0)
   CALL GRQCR(1, CR1, CG1, CB1)
   DO 5 I=MININD,MAXIND
      A0 = REAL(I-MININD)/REAL(MAXIND-MININD)
      A1 = 1.0 - A0
      CALL GRSCR(I, A0*CR0+A1*CR1, A0*CG0+A1*CG1, A0*CB0+A1*CB1)
 5       CONTINUE
   CALL GRIMG0(A, IDIM, JDIM, I1, I2, J1, J2, &
                 FG, BG, PA, MININD, MAXIND, MODE)
   RETURN
!
! Otherwise use random dither in current color index.
!
  ELSE
   CALL GRIMG3(A, IDIM, JDIM, I1, I2, J1, J2, &
                 FG, BG, PA, MODE)
  END IF
!-----------------------------------------------------------------------
  END

!*GRIMG0 -- color image of a 2D data array
!+
  SUBROUTINE GRIMG0 (A, IDIM, JDIM, I1, I2, J1, J2, &
                     A1, A2, PA, MININD, MAXIND, MODE)
  INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE
  REAL    A(IDIM,JDIM), A1, A2, PA(6)
!
! This is a support routine for PGIMAG.
!
! Arguments:
!  A      (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  A1     (input)  : the array value which is to appear in color
!                    index MININD.
!  A2     (input)  : the array value which is to appear in color
!                    index MAXIND.
!  PA     (input)  : transformation matrix between array grid and
!                    device coordinates.
!  MININD (input)  : minimum color index to use.
!  MAXIND (input)  : maximum color index to use.
!  MODE   (input)  : =0 for linear, =1 for logarithmic, =2 for
!                    square-root mapping of array values to color
!                    indices.
!--
!  7-Sep-1994 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  CHARACTER C
!-----------------------------------------------------------------------
!
! Switch on type of device support.
!
  C = GRGCAP(GRCIDE)(7:7)
  IF (C=='Q') THEN
!         -- Image-primitive devices
    CALL GRIMG1(A, IDIM, JDIM, I1, I2, J1, J2, A1, A2, PA, &
                  MININD, MAXIND, MODE)
  ELSE IF (C=='P') THEN
!         -- Pixel-primitive devices
    CALL GRIMG2(A, IDIM, JDIM, I1, I2, J1, J2, A1, A2, PA, &
                  MININD, MAXIND, MODE)
  ELSE IF (C=='N') THEN
!         -- Other devices
    CALL GRWARN( &
       'images cannot be displayed on the selected device')
  ELSE
!         -- Unknown device code
    CALL GRWARN('unexpected error in routine GRIMG0')
  END IF
!-----------------------------------------------------------------------
  END

!*GRIMG1 -- image of a 2D data array (image-primitive devices)
!+
  SUBROUTINE GRIMG1 (A, IDIM, JDIM, I1, I2, J1, J2, &
                     A1, A2, PA, MININD, MAXIND, MODE)
  INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE
  REAL    A(IDIM,JDIM), A1, A2, PA(6)
!
! (This routine is called by GRIMG0.)
!--
! 7-Sep-1994  New routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER NBUF, LCHR
  REAL    RBUF(21), FAC, AV, SFAC, SFACL
  CHARACTER*1 CHR
  INTEGER  I, J, II, NXP, NYP, IV
  INTRINSIC NINT, LOG
  PARAMETER (SFAC=65000.0)
!-----------------------------------------------------------------------
! Size of image.
!
  NXP = I2 - I1 + 1
  NYP = J2 - J1 + 1
  RBUF(1) = 0.0
  RBUF(2) = NXP
  RBUF(3) = NYP
!
! Clipping rectangle.
!
  RBUF(4) = GRXMIN(GRCIDE)
  RBUF(5) = GRXMAX(GRCIDE)
  RBUF(6) = GRYMIN(GRCIDE)
  RBUF(7) = GRYMAX(GRCIDE)
!
! Image transformation matrix.
!
  FAC = PA(2)*PA(6) - PA(3)*PA(5)
  RBUF(8)  =  PA(6)/FAC
  RBUF(9)  = (-PA(5))/FAC
  RBUF(10) = (-PA(3))/FAC
  RBUF(11) =  PA(2)/FAC
  RBUF(12) = (PA(3)*PA(4) - PA(1)*PA(6))/FAC - (I1-0.5)
  RBUF(13) = (PA(5)*PA(1) - PA(4)*PA(2))/FAC - (J1-0.5)
!
! Send setup info to driver.
!
  IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
  CALL GRTERM
  NBUF = 13
  LCHR = 0
  CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
!
! Convert image array to color indices and send to driver.
!
  SFACL = LOG(1.0+SFAC)
  II = 0
  DO 20 J = J1,J2
    DO 10 I = I1,I2
        AV = A(I,J)
        IF (A2>A1) THEN
            AV = MIN(A2, MAX(A1,AV))
        ELSE
            AV = MIN(A1, MAX(A2,AV))
        END IF
        IF (MODE==0) THEN
          IV = NINT((MININD*(A2-AV) + MAXIND*(AV-A1))/(A2-A1))
        ELSE IF (MODE==1) THEN
          IV = MININD + NINT((MAXIND-MININD)* &
                 LOG(1.0+SFAC*ABS((AV-A1)/(A2-A1)))/SFACL)
        ELSE IF (MODE==2) THEN
          IV = MININD + NINT((MAXIND-MININD)* &
                               SQRT(ABS((AV-A1)/(A2-A1))))
        ELSE
          IV = MININD
        END IF
        II = II + 1
        RBUF(II+1) = IV
        IF (II==20) THEN
            NBUF = II + 1
            RBUF(1) = II
            CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
            II = 0
        END IF
   10     CONTINUE
   20 CONTINUE
  IF (II>0) THEN
    NBUF = II + 1
    RBUF(1) = II
    CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
    II = 0
  END IF
!
! Send termination code to driver.
!
  NBUF = 1
  RBUF(1) = -1
  CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
!-----------------------------------------------------------------------
  END

!*GRIMG2 -- image of a 2D data array (pixel-primitive devices)
!+
  SUBROUTINE GRIMG2 (A, IDIM, JDIM, I1, I2, J1, J2, &
                     A1, A2, PA, MININD, MAXIND, MODE)
  INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE
  REAL    A(IDIM,JDIM)
  REAL    A1, A2
  REAL    PA(6)
!
! (This routine is called by GRIMG0.)
!--
! 7-Sep-1994  New routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  I,IV,IX,IX1,IX2,IY,IY1,IY2,J, NPIX, LCHR
  REAL     DEN, AV, SFAC, SFACL
  REAL     XXAA,XXBB,YYAA,YYBB,XYAA,XYBB,YXAA,YXBB,XYAAIY,YXAAIY
  REAL     BUFFER(1026)
  CHARACTER*1 CHR
  INTRINSIC NINT, LOG
  PARAMETER (SFAC=65000.0)
!-----------------------------------------------------------------------
!
! Location of current window in device coordinates.
!
  IX1 = NINT(GRXMIN(GRCIDE))+1
  IX2 = NINT(GRXMAX(GRCIDE))-1
  IY1 = NINT(GRYMIN(GRCIDE))+1
  IY2 = NINT(GRYMAX(GRCIDE))-1
!
! Transformation from array coordinates to device coordinates.
!
  DEN = PA(2)*PA(6)-PA(3)*PA(5)
  XXAA = (-PA(6))*PA(1)/DEN
  XXBB = PA(6)/DEN
  XYAA = (-PA(3))*PA(4)/DEN
  XYBB = PA(3)/DEN
  YYAA = (-PA(2))*PA(4)/DEN
  YYBB = PA(2)/DEN
  YXAA = (-PA(5))*PA(1)/DEN
  YXBB = PA(5)/DEN
!
! Start a new page if necessary.
!
  IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
!
! Run through every device pixel (IX, IY) in the current window and
! determine which array pixel (I,J) it falls in.
!
  SFACL = LOG(1.0+SFAC)
  DO 120 IY=IY1,IY2
    XYAAIY = XXAA-XYAA-XYBB*IY
    YXAAIY = YYAA+YYBB*IY-YXAA
    NPIX = 0
    BUFFER(2) = IY
    DO 110 IX=IX1,IX2
      I = NINT(XYAAIY+XXBB*IX)
      IF (I<I1.OR.I>I2) GOTO 110
      J = NINT(YXAAIY-YXBB*IX)
      IF (J<J1.OR.J>J2) GOTO 110
!
!           -- determine color index IV of this pixel
!
      AV = A(I,J)
      IF (A2>A1) THEN
          AV = MIN(A2, MAX(A1,AV))
      ELSE
          AV = MIN(A1, MAX(A2,AV))
      END IF
      IF (MODE==0) THEN
          IV = NINT((MININD*(A2-AV) + MAXIND*(AV-A1))/(A2-A1))
      ELSE IF (MODE==1) THEN
          IV = MININD + NINT((MAXIND-MININD)* &
                 LOG(1.0+SFAC*ABS((AV-A1)/(A2-A1)))/SFACL)
      ELSE IF (MODE==2) THEN
          IV = MININD + NINT((MAXIND-MININD)* &
                               SQRT(ABS((AV-A1)/(A2-A1))))
      ELSE
          IV = MININD
      END IF
!
      IF (NPIX<=1024) THEN
!               -- drop pixels if buffer too small (to be fixed!)
          NPIX = NPIX+1
          IF (NPIX==1) BUFFER(1) = IX
          BUFFER(NPIX+2) = IV
      END IF
  110     CONTINUE
    IF (NPIX>0) CALL &
                     GREXEC(GRGTYP, 26, BUFFER, NPIX+2, CHR, LCHR)
  120 CONTINUE
!-----------------------------------------------------------------------
  END

!*GRIMG3 -- gray-scale map of a 2D data array, using dither
!+
  SUBROUTINE GRIMG3 (A, IDIM, JDIM, I1, I2, J1, J2, &
                     BLACK, WHITE, PA, MODE)
  INTEGER IDIM, JDIM, I1, I2, J1, J2, MODE
  REAL    A(IDIM,JDIM)
  REAL    BLACK, WHITE
  REAL    PA(6)
!--
! 2-Sep-1994 - moved from GRGRAY [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  I,IX,IX1,IX2,IY,IY1,IY2,J
  REAL     DEN,VALUE,BW
  REAL     XXAA,XXBB,YYAA,YYBB,XYAA,XYBB,YXAA,YXBB,XYAAIY,YXAAIY
  INTEGER  M, IAA, ICC, JRAN, ILAST, JLAST, IXSTEP, IYSTEP
  REAL     RAND, RM, FAC, FACL
  PARAMETER (M=714025, IAA=1366, ICC=150889, RM=1.0/M)
  PARAMETER (FAC=65000.0)
  INTRINSIC MOD, NINT, REAL, LOG
!-----------------------------------------------------------------------
!
  IF (MODE<0 .OR. MODE>2) RETURN
!
! Initialize random-number generator (based on RAN2 of Press et al.,
! Numerical Recipes)
!
  JRAN = 76773
!
  IX1 = NINT(GRXMIN(GRCIDE))+1
  IX2 = NINT(GRXMAX(GRCIDE))-1
  IY1 = NINT(GRYMIN(GRCIDE))+1
  IY2 = NINT(GRYMAX(GRCIDE))-1
  DEN = PA(2)*PA(6)-PA(3)*PA(5)
!
! Calculate constants.
!
  BW   = ABS(BLACK-WHITE)
  FACL = LOG(1.0+FAC)
  XXAA = (-PA(6))*PA(1)/DEN
  XXBB = PA(6)/DEN
  XYAA = (-PA(3))*PA(4)/DEN
  XYBB = PA(3)/DEN
  YYAA = (-PA(2))*PA(4)/DEN
  YYBB = PA(2)/DEN
  YXAA = (-PA(5))*PA(1)/DEN
  YXBB = PA(5)/DEN
!
! Choose step size: at least 1/200 inch, assuming the line-width
! unit is 1/200 inch.
!
  IXSTEP = MAX(1,NINT(GRWIDT(GRCIDE)*GRPXPI(GRCIDE)/200.0))
  IYSTEP = MAX(1,NINT(GRWIDT(GRCIDE)*GRPYPI(GRCIDE)/200.0))
!
! Draw dots.
!
  ILAST = 0
  JLAST = 0
  DO 120 IY=IY1,IY2,IYSTEP
    XYAAIY = XXAA-XYAA-XYBB*IY
    YXAAIY = YYAA+YYBB*IY-YXAA
    DO 110 IX=IX1,IX2,IXSTEP
        I = NINT(XYAAIY+XXBB*IX)
        IF (I<I1.OR.I>I2) GOTO 110
        J = NINT(YXAAIY-YXBB*IX)
        IF (J<J1.OR.J>J2) GOTO 110
        IF (I/=ILAST .OR. J/=JLAST) THEN
            ILAST = I
            JLAST = J
            VALUE = ABS(A(I,J)-WHITE)/BW
            IF (MODE==0) THEN
!                     -- "linear"
                CONTINUE
            ELSE IF (MODE==1) THEN
!                     -- "logarithmic"
                VALUE = LOG(1.0+FAC*VALUE)/FACL
            ELSE IF (MODE==2) THEN
!                     -- "square root"
                VALUE = SQRT(VALUE)
            END IF
        END IF
        JRAN = MOD(JRAN*IAA+ICC, M)
        RAND = JRAN*RM
        IF (VALUE>RAND) CALL GRDOT0(REAL(IX),REAL(IY))
  110     CONTINUE
  120  CONTINUE
!-----------------------------------------------------------------------
 END

!*GRINIT -- initialize GRPCKG
!+
  SUBROUTINE GRINIT
!
! Initialize GRPCKG and read font file. Called by GROPEN, but may be
! called explicitly if needed.
!--
! 29-Apr-1996 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER   I
  LOGICAL   INIT
  SAVE      INIT
  DATA      INIT / .TRUE. /
!
  IF (INIT) THEN
   DO 10 I=1,GRIMAX
      GRSTAT(I) = 0
 10      CONTINUE
   CALL GRSY00
   INIT = .FALSE.
  END IF
  RETURN
  END

!*GRITOC - convert integer to character string
!+
  INTEGER FUNCTION GRITOC(INT, STR)
  INTEGER INT
  CHARACTER*(*) STR
!
! Convert integer INT into (decimal) character string in STR.
!-----------------------------------------------------------------------
  CHARACTER*10 DIGITS
  INTEGER D, I, INTVAL, J, L
  CHARACTER K
  DATA DIGITS /'0123456789'/
!
  INTVAL = ABS(INT)
  I = 0
!
! Generate digits in reverse order.
!
  10  CONTINUE
    I = I+1
    D = 1 + MOD(INTVAL, 10)
    STR(I:I) = DIGITS(D:D)
    INTVAL = INTVAL/10
    IF (I<LEN(STR) .AND. INTVAL/=0) GOTO 10
!
! Add minus sign if necessary.
!
  IF (INT<0 .AND. I<LEN(STR)) THEN
    I = I+1
    STR(I:I) = '-'
  END IF
  GRITOC = I
!
! Reverse string in place.
!
  L = I/2
  DO 20 J=1,L
    K = STR(I:I)
    STR(I:I) = STR(J:J)
    STR(J:J) = K
    I = I-1
   20 CONTINUE
!-----------------------------------------------------------------------
  END

!*GRLEN -- inquire plotted length of character string
!+
  SUBROUTINE GRLEN (STRING, D)
!
! GRPCKG: length of text string (absolute units)
!--
! (3-Mar-1983)
! 19-Jan-1988 - remove unused label [TJP].
!  9-Sep-1989 - standardize [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  LOGICAL UNUSED
  INTEGER XYGRID(300)
  INTEGER LIST(256)
  CHARACTER*(*) STRING
  REAL FACTOR, COSA, SINA, DX, D, RATIO, FNTBAS, FNTFAC
  INTEGER I, IFNTLV, LX, NLIST
  INTRINSIC ABS, LEN
!
  D = 0.0
  IF (LEN(STRING)<=0) RETURN
!-----------------------------------------------------------------------
!               Compute scaling and orientation
!-----------------------------------------------------------------------
  FACTOR = GRCFAC(GRCIDE)/2.5
  RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE)
  COSA = FACTOR
  SINA = 0.0
  FNTBAS = 0.0
  FNTFAC = 1.0
  IFNTLV = 0
!
!               Convert string to symbol numbers:
!               \u and \d escape sequences are converted to -1,-2
!
  CALL GRSYDS(LIST,NLIST,STRING,GRCFNT(GRCIDE))
!
!               Plot the string of characters
!
  DO 380 I = 1,NLIST
    IF (LIST(I)<0) THEN
        IF (LIST(I)==-1) THEN
            IFNTLV = IFNTLV+1
            FNTBAS = FNTBAS + 16.0*FNTFAC
            FNTFAC = 0.6**ABS(IFNTLV)
        ELSE IF (LIST(I)==-2) THEN
            IFNTLV = IFNTLV-1
            FNTFAC = 0.6**ABS(IFNTLV)
            FNTBAS = FNTBAS - 16.0*FNTFAC
        END IF
        GOTO 380
    END IF
    CALL GRSYXD(LIST(I),XYGRID,UNUSED)
    LX = XYGRID(5)-XYGRID(4)
    DX = COSA*LX*RATIO
    D = D + DX*FNTFAC
  380 CONTINUE
!
  END

!*GRLGTR -- translate logical name (dummy version)
!+
  SUBROUTINE GRLGTR (NAME)
  CHARACTER*(*) NAME
!
! Recursive translation of a logical name.
! This is used in the parsing of device specifications in the
! VMS implementation of PGPLOT. In other implementations, it may
! be replaced by a null routine.
!
! Argument:
!  NAME (input/output): initially contains the name to be
!       inspected.  If an equivalence is found it will be replaced
!       with the new name. If not, the old name will be left there.
!--
! 19-Dec-1994
!-----------------------------------------------------------------------
  END

!*GRLIN0 -- draw a line
!+
  SUBROUTINE GRLIN0 (XP,YP)
!
! GRPCKG (internal routine): draw a line from the current position to a
! specified position, which becomes the new current position. This
! routine takes care of clipping at the viewport boundary, dashed and
! thick lines.
!
! Arguments:
!
! XP, YP (input, real): absolute device coordinates of the end-point of
!       the line.
!--
! 13-Jul-1984
!  7-May-1985 - add MIN/MAX kluge to prevent integer overflow [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  LOGICAL  VIS
  REAL     XP,YP, X0,Y0, X1,Y1
!
! End-points of line are (X0,Y0), (X1,Y1).
!
  X0 = GRXPRE(GRCIDE)
  Y0 = GRYPRE(GRCIDE)
  X1 = MIN(2E9,MAX(-2E9,XP))
  Y1 = MIN(2E9,MAX(-2E9,YP))
  GRXPRE(GRCIDE) = X1
  GRYPRE(GRCIDE) = Y1
!
! Change the end-points of the line (X0,Y0) - (X1,Y1)
! to clip the line at the window boundary.
!
  CALL GRCLPL(X0,Y0,X1,Y1,VIS)
  IF (.NOT.VIS) RETURN
!
! Draw the line in the appropriate style.
!
  IF (GRDASH(GRCIDE)) THEN
!         ! dashed line
   CALL GRLIN1(X0,Y0,X1,Y1,.FALSE.)
  ELSE IF (GRWIDT(GRCIDE)>1) THEN
!         ! heavy line
   CALL GRLIN3(X0,Y0,X1,Y1)
  ELSE
!         ! full line
   CALL GRLIN2(X0,Y0,X1,Y1)
  END IF
  END

!*GRLIN1 -- draw a dashed line
!+
  SUBROUTINE GRLIN1 (X0,Y0,X1,Y1,RESET)
!
! GRPCKG : dashed line. Generate a visible dashed line between points
! (X0,Y0) and (X1,Y1) according to the dash pattern stored in common.
! If RESET = .TRUE., the pattern will start from the beginning.
! Otherwise, it will continue from its last position.
!     DASHED LINE PATTERN ARRAY CONTAINING LENGTHS OF
!          MARKS AND SPACES IN UNIT CUBE: GRPATN(*)
!     OFFSET IN CURRENT PATTERN SEGMENT: GRPOFF
!     CURRENT PATTERN SEGMENT NUMBER: GRIPAT
!     NUMBER OF PATTERN SEGMENTS: 8
!--
! (1-Feb-1983)
!  6-Sep-1989 - Changes for standard Fortran-77 [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
!
  REAL ADJUST, ARG1, ARG2, ALFARG
  REAL SCALE, SEGLEN, X1, X0, Y1, Y0, DS, DSOLD
  REAL ALPHA1, ALPHA2, XP, YP, XQ, YQ
  LOGICAL RESET
  INTEGER THICK
  INTRINSIC ABS, MIN, MOD, REAL, SQRT
!
  ADJUST(ARG1,ARG2,ALFARG) = ALFARG*(ARG2 - ARG1) + ARG1
!
  THICK = GRWIDT(GRCIDE)
  SCALE = SQRT(REAL(ABS(THICK)))
  IF (RESET) THEN
    GRPOFF(GRCIDE) = 0.0
    GRIPAT(GRCIDE) = 1
  END IF
  SEGLEN = SQRT((X1-X0)**2 + (Y1-Y0)**2)
  IF (SEGLEN == 0.0) RETURN
  DS = 0.0
!
!       Repeat until (ALPHA2 .GE. 1.0)
!
!       Line segments matching the pattern segments are determined
!       by finding values (ALPHA1,ALPHA2) defining the start and end
!       of the segment in the parametric equation (1-ALPHA)*P1 + ALPHA*P2
!       defining the line.  DS measures the progress along the line
!       segment and defines the starting ALPHA1.  The ending ALPHA2
!       is computed from the end of the current pattern mark or space
!       or the segment end, whichever comes first.
!
   10 DSOLD = DS
  ALPHA1 = DS/SEGLEN
  ALPHA2 = MIN(1.0,(DS+SCALE*GRPATN(GRCIDE,GRIPAT(GRCIDE))- &
             GRPOFF(GRCIDE))/SEGLEN)
  IF (MOD(GRIPAT(GRCIDE),2) /= 0) THEN
    XP = ADJUST(X0,X1,ALPHA1)
    YP = ADJUST(Y0,Y1,ALPHA1)
    XQ = ADJUST(X0,X1,ALPHA2)
    YQ = ADJUST(Y0,Y1,ALPHA2)
    IF (THICK>1) THEN
        CALL GRLIN3(XP,YP,XQ,YQ)
    ELSE
        CALL GRLIN2(XP,YP,XQ,YQ)
    END IF
  END IF
  DS = ALPHA2*SEGLEN
  IF (ALPHA2 >= 1.0) THEN
    GRPOFF(GRCIDE) = GRPOFF(GRCIDE) + DS - DSOLD
    RETURN
  END IF
  GRIPAT(GRCIDE) = MOD(GRIPAT(GRCIDE),8) + 1
  GRPOFF(GRCIDE) = 0.0
  GO TO 10
  END

!*GRLIN2 -- draw a normal line
!+
  SUBROUTINE GRLIN2 (X0,Y0,X1,Y1)
!
! GRPCKG : plot a visible line segment in absolute coords from
! (X0,Y0) to (X1,Y1).  The endpoints of the line segment are rounded
! to the nearest integer and passed to the appropriate device-specific
! routine. It is assumed that the entire line-segment lies within the
! view surface, and that the physical device coordinates are
! non-negative.
!--
! (1-Jun-1984)
! 19-Oct-1984 - rewritten for speed [TJP].
! 29-Jan-1985 - add HP2648 device [KS/TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 21-Feb-1987 - If needed, calls begin picture [AFT].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL    X0,Y0,X1,Y1
  REAL    RBUF(6)
  INTEGER NBUF,LCHR
  CHARACTER CHR
!
!- If this is first thing plotted then set something plotted flag
!- and for a GREXEC device call BEGIN_PICTURE.
!
  IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
!---
  RBUF(1)=X0
  RBUF(2)=Y0
  RBUF(3)=X1
  RBUF(4)=Y1
  NBUF=4
!     WRITE(*,'(A,4F10.5)') 'GRLIN2',RBUF(1), RBUF(2), RBUF(3), RBUF(4)
  CALL GREXEC(GRGTYP,12,RBUF,NBUF,CHR,LCHR)
!
  END

!*GRLIN3 -- draw a thick line (multiple strokes)
!+
  SUBROUTINE GRLIN3 (X0,Y0,X1,Y1)
!
! GRPCKG: draw a heavy line from (X0,Y0) to (X1,Y1) by making multiple
! strokes.  In order to simulate a thick pen, the line drawn has
! circular, rather than square, end points.  If this is not done,
! thick letters and other figures have an abnormal and unpleasant
! appearance.
!
! Vocabulary:
!
! LINEWT: the number of strokes required to draw the line; if
!       this is odd, one stroke will lie along the requested vector.
!       The nominal line thickness is (LINEWT-1)*0.005 in.
! RSQURD: the square of the semi-line thickness.
! (DX,DY): the vector length of the line.
! (VX,VY): a vector of length 1 pixel in the direction of the line.
! (VY,-VX): a vector of length 1 pixel perpendicular to (VX,VY).
! OFF: the offset parallel to (VY,-VX) of the K'th stroke.
! (VXK,VYK): the vector increment of the K'th stroke to allow for the
!       semi-circular terminal on the line.
! (PXK,PYK): the vector offset of the K'th stroke perpendicular to the
!       line vector.
!--
! (1-Feb-1983)
! 23-Nov-1994 - change algorithm so that the unit of line-width is
!               0.005 inch instead of 1 pixel [TJP].
! March 1995 - added ABS to prevent domain error in SQRT (CTD)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  K,LINEWT
  REAL     DX,DY, HK, OFF, PXK,PYK, RSQURD, VLEN,VX,VY,VXK,VYK
  REAL     X0,X1,Y0,Y1
  REAL     XS0,XS1, YS0,YS1, SPIX,SPIY
  LOGICAL  VIS
!
! Determine number of strokes and line thickness.
!
  LINEWT = GRWIDT(GRCIDE)
  RSQURD = ((LINEWT-1)**2)*0.25
!
! Determine the vectors (VX,VY), (VY,-VX). If the line-length is zero,
! pretend it is a very short horizontal line.
!
  DX = X1 - X0
  DY = Y1 - Y0
  VLEN = SQRT(DX**2 + DY**2)
  SPIX = GRPXPI(GRCIDE)*0.005
  SPIY = GRPYPI(GRCIDE)*0.005
!
  IF (VLEN == 0.0) THEN
    VX = SPIX
    VY = 0.0
  ELSE
    VX = DX/VLEN*SPIX
    VY = DY/VLEN*SPIY
  END IF
!
! Draw LINEWT strokes. We have to clip again in case thickening the
! line has taken us outside the window.
!
  OFF = (LINEWT-1)*0.5
  DO 10 K=1,LINEWT
    PXK = VY*OFF
    PYK = -(VX*OFF)
    HK  = SQRT(ABS(RSQURD - OFF**2))
    VXK = VX*HK
    VYK = VY*HK
    XS1 = X1+PXK+VXK
    YS1 = Y1+PYK+VYK
    XS0 = X0+PXK-VXK
    YS0 = Y0+PYK-VYK
    CALL GRCLPL(XS1,YS1,XS0,YS0,VIS)
    IF (VIS) CALL GRLIN2(XS1, YS1, XS0, YS0)
    OFF = OFF - 1.0
   10 CONTINUE
  END

!*GRLINA -- draw a line (absolute, world coordinates)
!+
  SUBROUTINE GRLINA (X,Y)
!
! GRPCKG: draw line from current position to a specified position.
!
! Arguments:
!
! X, Y (real, input): world coordinates of the end-point of the line.
!--
! (1-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL     X,Y
!
  IF (GRCIDE>=1) THEN
!         WRITE (*,'(A,2F10.5)') 'GRLINA', X, Y
    CALL GRLIN0( X * GRXSCL(GRCIDE) + GRXORG(GRCIDE), &
                   Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE) )
  END IF
  END

  SUBROUTINE GRMCUR (ICH, ICX, ICY)
  INTEGER ICH, ICX, ICY
!
! Cursor movement:
! Input: ICH character code
! In/Out: ICX, ICY cursor position
!-----------------------------------------------------------------------
  INTEGER STEP
  SAVE STEP
  DATA STEP /4/
!
!     Up arrow or keypad 8:
  IF (ICH==-1 .OR. ICH==-28) THEN
    ICY = ICY+STEP
!     Down arrow or keypad 2:
  ELSE IF (ICH==-2 .OR. ICH==-22) THEN
    ICY = ICY-STEP
!     Right arrow or keypad 6:
  ELSE IF (ICH==-3 .OR. ICH==-26) THEN
    ICX = ICX+STEP
!     Left arrow or keypad 4:
  ELSE IF (ICH==-4 .OR. ICH==-24) THEN
    ICX = ICX-STEP
!     Keypad 7 (left and up):
  ELSE IF (ICH==-27) THEN
    ICX = ICX-STEP
    ICY = ICY+STEP
!     Keypad 9 (right and up):
  ELSE IF (ICH==-29) THEN
    ICX = ICX+STEP
    ICY = ICY+STEP
!     Keypad 3 (right and down):
  ELSE IF (ICH==-23) THEN
    ICX = ICX+STEP
    ICY = ICY-STEP
!     Keypad 1 (left and down):
  ELSE IF (ICH==-21) THEN
    ICX = ICX-STEP
    ICY = ICY-STEP
!     PF1:
  ELSE IF (ICH==-11) THEN
    STEP = 1
!     PF2:
  ELSE IF (ICH==-12) THEN
    STEP = 4
!     PF3:
  ELSE IF (ICH==-13) THEN
    STEP = 16
!     PF4:
  ELSE IF (ICH==-14) THEN
    STEP = 64
  END IF
  END

!*GRMKER -- draw graph markers
!+
  SUBROUTINE GRMKER (SYMBOL,ABSXY,N,X,Y)
!
! GRPCKG: Draw a graph marker at a set of points in the current
! window. Line attributes (color, intensity, and  thickness)
! apply to markers, but line-style is ignored. After the call to
! GRMKER, the current pen position will be the center of the last
! marker plotted.
!
! Arguments:
!
! SYMBOL (input, integer): the marker number to be drawn. Numbers
!       0-31 are special marker symbols; numbers 32-127 are the
!       corresponding ASCII characters (in the current font). If the
!       number is >127, it is taken to be a Hershey symbol number.
!       If -ve, a regular polygon is drawn.
! ABSXY (input, logical): if .TRUE., the input corrdinates (X,Y) are
!       taken to be absolute device coordinates; if .FALSE., they are
!       taken to be world coordinates.
! N (input, integer): the number of points to be plotted.
! X, Y (input, real arrays, dimensioned at least N): the (X,Y)
!       coordinates of the points to be plotted.
!--
! (19-Mar-1983)
! 20-Jun-1985 - revise to window markers whole [TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
!  1-Aug-1988 - add direct use of Hershey number [TJP].
! 15-Dec-1988 - standardize [TJP].
! 17-Dec-1990 - add polygons [PAH/TJP].
! 12-Jun-1992 - [TJP]
! 22-Sep-1992 - add support for hardware markers [TJP].
!  1-Sep-1994 - suppress driver call [TJP].
! 15-Feb-1994 - fix bug (expanding viewport!) [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  SYMBOL
  INTEGER  C
  LOGICAL  ABSXY, UNUSED, VISBLE
  INTEGER  I, K, LSTYLE, LX, LY, LXLAST, LYLAST, N, SYMNUM, NV
  INTEGER  XYGRID(300)
  REAL     ANGLE, COSA, SINA, FACTOR, RATIO, X(*), Y(*)
  REAL     XCUR, YCUR, XORG, YORG
  REAL     THETA, XOFF(40), YOFF(40), XP(40), YP(40)
  REAL     XMIN, XMAX, YMIN, YMAX
  REAL     XMINX, XMAXX, YMINX, YMAXX
  REAL     RBUF(4)
  INTEGER  NBUF,LCHR
  CHARACTER*32 CHR
!
! Check that there is something to be plotted.
!
  IF (N<=0) RETURN
!
! Check that a device is selected.
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRMKER - no graphics device is active.')
    RETURN
  END IF
!
  XMIN = GRXMIN(GRCIDE)
  XMAX = GRXMAX(GRCIDE)
  YMIN = GRYMIN(GRCIDE)
  YMAX = GRYMAX(GRCIDE)
  XMINX = XMIN-0.01
  XMAXX = XMAX+0.01
  YMINX = YMIN-0.01
  YMAXX = YMAX+0.01
!
! Does the device driver do markers (only markers 0-31 at present)?
!
  IF (GRGCAP(GRCIDE)(10:10)=='M' .AND. &
       SYMBOL>=0 .AND. SYMBOL<=31) THEN
    IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
!         -- symbol number
    RBUF(1) = SYMBOL
!          -- scale factor
    RBUF(4) = GRCFAC(GRCIDE)/2.5
    NBUF = 4
    LCHR = 0
    DO 10 K=1,N
!             -- convert to device coordinates
        CALL GRTXY0(ABSXY, X(K), Y(K), XORG, YORG)
!             -- is the marker visible?
        CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C)
        IF (C==0) THEN
            RBUF(2) = XORG
            RBUF(3) = YORG
            CALL GREXEC(GRGTYP,28,RBUF,NBUF,CHR,LCHR)
        END IF
   10     CONTINUE
    RETURN
  END IF
!
! Otherwise, draw the markers here.
!
! Save current line-style, and set style "normal".
!
  CALL GRQLS(LSTYLE)
  CALL GRSLS(1)
!
! Save current viewport, and open the viewport to include the full
! view surface.
!
  CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0)
!
! Compute scaling and orientation.
!
  ANGLE = 0.0
  FACTOR = GRCFAC(GRCIDE)/2.5
  RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE)
  COSA = FACTOR * COS(ANGLE)
  SINA = FACTOR * SIN(ANGLE)
!
! Convert the supplied marker number SYMBOL to a symbol number and
! obtain the digitization.
!
  IF (SYMBOL>=0) THEN
    IF (SYMBOL>127) THEN
        SYMNUM = SYMBOL
    ELSE
        CALL GRSYMK(SYMBOL,GRCFNT(GRCIDE),SYMNUM)
    END IF
    CALL GRSYXD(SYMNUM, XYGRID, UNUSED)
!
! Positive symbols.
!
  DO 380 I=1,N
    CALL GRTXY0(ABSXY, X(I), Y(I), XORG, YORG)
    CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C)
    IF (C/=0) GOTO 380
    VISBLE = .FALSE.
    K = 4
    LXLAST = -64
    LYLAST = -64
  320       K = K+2
      LX = XYGRID(K)
      LY = XYGRID(K+1)
      IF (LY==-64) GOTO 380
      IF (LX==-64) THEN
          VISBLE = .FALSE.
      ELSE
          IF ((LX/=LXLAST) .OR. (LY/=LYLAST)) THEN
              XCUR = XORG + (COSA*LX - SINA*LY)*RATIO
              YCUR = YORG + (SINA*LX + COSA*LY)
              IF (VISBLE) THEN
                  CALL GRLIN0(XCUR,YCUR)
              ELSE
                  GRXPRE(GRCIDE) = XCUR
                  GRYPRE(GRCIDE) = YCUR
              END IF
          END IF
          VISBLE = .TRUE.
          LXLAST = LX
          LYLAST = LY
      END IF
      GOTO 320
  380 CONTINUE
!
! Negative symbols.
!
  ELSE
!         ! negative symbol: filled polygon of radius 8
    NV = MIN(31,MAX(3,ABS(SYMBOL)))
    DO 400 I=1,NV
        THETA = 3.14159265359*(REAL(2*(I-1))/REAL(NV)+0.5) - ANGLE
        XOFF(I) = COS(THETA)*FACTOR*RATIO/GRXSCL(GRCIDE)*8.0
        YOFF(I) = SIN(THETA)*FACTOR/GRYSCL(GRCIDE)*8.0
  400     CONTINUE
    DO 420 K=1,N
        CALL GRTXY0(ABSXY, X(K), Y(K), XORG, YORG)
        CALL GRCLIP(XORG, YORG, XMINX, XMAXX, YMINX, YMAXX, C)
        IF (C==0) THEN
            DO 410 I=1,NV
                XP(I) = X(K)+XOFF(I)
                YP(I) = Y(K)+YOFF(I)
  410             CONTINUE
            CALL GRFA(NV, XP, YP)
        END IF
  420     CONTINUE
  END IF
!
! Set current pen position.
!
  GRXPRE(GRCIDE) = XORG
  GRYPRE(GRCIDE) = YORG
!
! Restore the viewport and line-style, and return.
!
  GRXMIN(GRCIDE) = XMIN
  GRXMAX(GRCIDE) = XMAX
  GRYMIN(GRCIDE) = YMIN
  GRYMAX(GRCIDE) = YMAX
  CALL GRSLS(LSTYLE)
!
  END

!*GRMOVA -- move pen (absolute, world coordinates)
!+
  SUBROUTINE GRMOVA (X,Y)
!
! GRPCKG: move the pen to a specified location.
!
! Arguments:
!
! X, Y (real, input): world coordinates of the new pen position.
!--
! (1-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL     X,Y
!
  IF (GRCIDE>=1) THEN
!         WRITE (*,'(A,2F10.5)') 'GRMOVA', X, Y
    GRXPRE(GRCIDE) = X * GRXSCL(GRCIDE) + GRXORG(GRCIDE)
    GRYPRE(GRCIDE) = Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE)
  END IF
  END

!*GRMSG -- issue message to user
!+
  SUBROUTINE GRMSG (TEXT)
  CHARACTER*(*) TEXT
!
! Display a message on standard output.
!
! Argument:
!  TEXT (input): text of message to be printed (the string
!      may not be blank).
!--
!  8-Nov-1994 [TJP].
!-----------------------------------------------------------------------
  INTEGER   GRTRIM
!
  IF (TEXT/=' ') THEN
    WRITE (*, '(1X,A)') TEXT(1:GRTRIM(TEXT))
  END IF
  END

!*GROPEN -- open device for graphics
!+
  INTEGER FUNCTION GROPEN (TYPE,DUMMY,FILE,IDENT)
  INTEGER   TYPE, DUMMY, IDENT
  CHARACTER*(*) FILE
!
! GRPCKG: assign a device and prepare for plotting.  GROPEN must be
! called before all other calls to GRPCKG routines.
!
! Returns:
!
! GROPEN (output, integer): 1 => success, any other value
!       indicates a failure (usually the value returned will
!       be a VMS error code). In the event of an error, a
!       message will be sent to the standard error unit.
!
! Arguments:
!
! TYPE (input, integer): default device type (integer code).
! DUMMY (input, integer): not used at present.
! FILE (input, character): plot specifier, of form 'device/type'.
! IDENT (output, integer): plot identifier to be used in later
!       calls to GRPCKG.
!
!  1-Jun-1984 - [TJP].
!  2-Jul-1984 - change to call GRSLCT [TJP].
! 13-Jul-1984 - add device initialization [TJP].
! 23-Jul-1984 - add /APPEND qualifier.
! 19-Oct-1984 - add VV device [TJP].
! 26-Dec-1984 - obtain default file name from common [TJP].
! 29-Jan-1985 - add HP2648 device [KS/TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 12-Oct-1986 - fix bug causing GREXEC to erase screen [AFT].
!  3-Jun-1987 - remove declaration of exit handler [TJP].
! 15-Dec-1988 - standardize [TJP].
! 25-Jun-1989 - remove code that removes spaces from the device name
!               [TJP].
! 26-Nov-1990 - [TJP].
!  5-Jan-1993 - [TJP].
!  1-Sep-1994 - store device capabilities in common for later use [TJP].
! 17-Apr-1995 - zero-length string fix [TJP].
!  6-Jun-1995 - explicitly initialize GRSTAT [TJP].
! 29-Apr-1996 - moved initialization into GRINIT [TJP].
! 12-Jul-1999 - fix bug [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER   IER, FTYPE, NBUF, LCHR
  INTEGER   GRPARS, GRTRIM
  REAL      RBUF(6)
  LOGICAL   APPEND
  CHARACTER*128 FFILE,CHR
!
! Initialize GRPCKG; read font file (if necessary).
!
  CALL GRINIT
!
! Allocate an identifier.
!
  IDENT = 1
   10 IF (GRSTAT(IDENT)/=0) THEN
    IDENT = IDENT+1
    IF (IDENT>GRIMAX) THEN
        CALL GRWARN('Too many active plots.')
        GROPEN = -1
        IDENT = 0
        RETURN
    END IF
  GOTO 10
  END IF
!
! Validate the device specification.
!
  IER = GRPARS(FILE,FFILE,FTYPE,APPEND)
  IF (IER/=1) THEN
    CHR = 'Invalid device specification: '
    CHR(31:) = FILE
    CALL GRWARN(CHR)
    GROPEN = -1
    RETURN
  END IF
  IF (FTYPE==0) FTYPE = TYPE
  IF (1<=FTYPE) THEN
    GRTYPE(IDENT) = FTYPE
  ELSE
    CHR = 'Device type omitted or invalid: '
    CHR(33:) = FILE
    CALL GRWARN(CHR)
    GROPEN = -1
    RETURN
  END IF
!
! Install the file name, or assign default.
!
  IF (FFILE==' ') THEN
    CALL GREXEC(GRTYPE(IDENT), 5,RBUF,NBUF,FFILE,LCHR)
  END IF
  GRFILE(IDENT) = FFILE
  GRFNLN(IDENT) = MAX(1,GRTRIM(GRFILE(IDENT)))
!
! Open workstation.
!
  RBUF(3)=0
  IF (APPEND) RBUF(3)=1
  NBUF=3
  CALL GREXEC(GRGTYP, 9,RBUF,NBUF, GRFILE(IDENT),GRFNLN(IDENT))
  GROPEN=RBUF(2)
  IF (GROPEN/=1) THEN
   IDENT = 0
   RETURN
  END IF
  GRGTYP = GRTYPE(IDENT)
  GRUNIT(IDENT)=RBUF(1)
  GRPLTD(IDENT) = .FALSE.
  GRSTAT(IDENT) = 1
  CALL GRSLCT(IDENT)
!
! Install the default plot parameters
!
!--- Inquire color-index range.
  CALL GREXEC(GRGTYP, 2,RBUF,NBUF,CHR,LCHR)
  GRMNCI(IDENT)=RBUF(5)
  GRMXCI(IDENT)=RBUF(6)
!--- Inquire resolution.
  CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR)
  GRPXPI(IDENT)=RBUF(1)
  GRPYPI(IDENT)=RBUF(2)
!--- Inquire default character size.
  CALL GREXEC(GRGTYP, 7,RBUF,NBUF,CHR,LCHR)
  GRCSCL(IDENT) = RBUF(1)
  GRCFAC(IDENT) = RBUF(1)
!--- Inquire default plot size.
  CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR)
  GRXMXA(IDENT) = RBUF(2)
  GRYMXA(IDENT) = RBUF(4)
  GRXMIN(IDENT) = RBUF(1)
  GRXMAX(IDENT) = RBUF(2)
  GRYMIN(IDENT) = RBUF(3)
  GRYMAX(IDENT) = RBUF(4)
!--- Inquire device capabilities.
  GRGCAP(IDENT) = 'NNNNNNNNNNN'
  CALL GREXEC(GRGTYP, 4,RBUF,NBUF,CHR,LCHR)
  IF (LCHR>LEN(GRGCAP(IDENT))) LCHR = LEN(GRGCAP(IDENT))
  GRGCAP(IDENT)(1:LCHR) = CHR(:LCHR)
!--- Current pen position.
  GRXPRE(IDENT) = 0.0
  GRYPRE(IDENT) = 0.0
!--- GRSETS has not been called.
  GRADJU(IDENT) = .FALSE.
!---Default scaling.
  CALL GRTRN0(0.0, 0.0, 1.0, 1.0)
!
! Default attributes.
!  text font (normal)
!  color (white)
!  line-style (full)
!  line-width (minimum)
!  marker number (dot)
!
  GRCFNT(IDENT) = 1
  GRCCOL(IDENT) = 1
  GRSTYL(IDENT) = 1
  GRWIDT(IDENT) = 1
  GRCMRK(IDENT) = 1
  GRDASH(IDENT) = .FALSE.
!
  GROPEN = 1
!
  END



!*GROPTX -- open input/output text file [Unix]
!+
  INTEGER FUNCTION GROPTX (UNIT, NAME, DEFNAM, MODE)
  INTEGER UNIT, MODE
  CHARACTER*(*) NAME, DEFNAM
!
! Input:
!  UNIT : Fortran unit number to use
!  NAME : name of file to create
!  DEFNAM : default file name (used to fill in missing fields for VMS)
!  MODE : 0 to open for reading, 1 to open for writing.
!
! Returns:
!  0 => success; any other value => error.
!-----------------------------------------------------------------------
  INTEGER IER
  IF (MODE==1) THEN
    OPEN (UNIT=UNIT, FILE=NAME, STATUS='UNKNOWN', IOSTAT=IER)
  ELSE
    OPEN (UNIT=UNIT, FILE=NAME, STATUS='OLD', IOSTAT=IER)
  END IF
  GROPTX = IER
!-----------------------------------------------------------------------
  END

!*GRPAGE -- end picture
!+
  SUBROUTINE GRPAGE
!
! GRPCKG: Advance the plotting area to a new page. For video devices,
! this amounts to erasing the screen; for hardcopy devices, the plot
! buffer is written to the output file followed by a form-feed to
! advance the paper to the start of the next page.
!
! Arguments: none.
!--
!  3-Jun-1983 - [TJP].
! 18-Feb-1984 - remove unnecessary 'T' initialization of VT125, and add
!               S(G1) for Rainbow REGIS [TJP].
!  1-Jun-1984 - add type GMFILE [TJP].
!  2-Jul-1984 - change initialization of VT125 for color [TJP].
! 13-Jul-1984 - move initialization of VT125 and Grinnell to GROPEN
!               [TJP].
! 19-Oct-1984 - add VV device [TJP].
! 29-Jan-1985 - add HP2648 terminal [KS/TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 21-Feb-1987 - fix GREXEC end picture sequence [AFT].
! 11-Jun-1987 - remove built-in devices [TJP].
! 11-Feb-1992 - update veiew surface size: it may have changed! [TJP].
!  5-Jan-1993 - but only if GRSETS has not been called! [TJP]
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
!
  INTEGER NBUF,LCHR
  REAL    RBUF(6)
!
  CHARACTER CHR
!
! Flush the buffer.
!
  CALL GRTERM
!
! Erase the text screen (if there is one).
!
  CALL GRETXT
!
! End picture.
!
  CALL GREPIC
!
! Update the view surface size: it may have changed (on windowing
! devices)
!
  IF (.NOT.GRADJU(GRCIDE)) THEN
    CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR)
    GRXMXA(GRCIDE) = RBUF(2)
    GRYMXA(GRCIDE) = RBUF(4)
  END IF
!
  END

!*GRPARS -- parse device specification string
!+
  INTEGER FUNCTION GRPARS (SPEC,DEV,TYPE,APPEND)
  CHARACTER*(*) SPEC, DEV
  INTEGER  TYPE
  LOGICAL  APPEND
!
! GRPCKG: decode a device-specification; called by GROPEN.
!
! Returns:
!  GRPARS (output): 1 if the device-specification is
!       acceptable; any other value indicates an error.
!
! Arguments:
!  SPEC (input): the device specification.
!  DEV  (output):  device name or file spec.
!  TYPE (output): device type (integer code); 0 if no device
!       type is specified.
!  APPEND (output): .TRUE. if /APPEND specified, .FALSE. otherwise.
!--
! 23-Jul-1984 - [TJP].
! 19-Feb-1988 - allow device part to be quoted [TJP].
! 30-Mar-1989 - remove logical translation of device and type [TJP].
! 17-Jun-1991 - ignore comments after ' (' [TJP].
! 19-Dec-1994 - rewritten to scan backwards [TJP].
!  6-Jun-1995 - correct a zero-length string problem [TJP].
!-----------------------------------------------------------------------
  CHARACTER*32  CTYPE, UPPER
  CHARACTER*6   APPSTR
  CHARACTER*256 DESCR
  INTEGER       GRDTYP, GRTRIM
  INTEGER       L, LC, LS
  DATA          APPSTR/'APPEND'/
!
! Default results.
!
  DEV = ' '
  TYPE = 0
  APPEND = .FALSE.
  GRPARS = 1
  CTYPE = ' '
!
! Null string is acceptable.
!
  IF (LEN(SPEC)<1) RETURN
  IF (SPEC==' ') RETURN
!
! On systems where it is possible, perform a "logical name" translation.
!
  DESCR = SPEC
  CALL GRLGTR(DESCR)
!
! Discard trailing blanks: L is length of remainder.
!
  L = GRTRIM(DESCR)
!
! Find last slash in string (position LS or 0).
!
  LS = L
 20   IF (DESCR(LS:LS)/='/') THEN
   LS = LS-1
   IF (LS>0) GOTO 20
  END IF
!
! Check for /APPEND qualifier; if present, look again for type.
!
  IF (LS>0) THEN
   CTYPE = DESCR(LS+1:L)
   CALL GRTOUP(UPPER,CTYPE)
   CTYPE = UPPER
   IF (CTYPE==APPSTR) THEN
      APPEND = .TRUE.
      L = LS-1
      LS = L
 30         IF (DESCR(LS:LS)/='/') THEN
         LS = LS-1
         IF (LS>0) GOTO 30
      END IF
   ELSE
      APPEND = .FALSE.
   END IF
  END IF
!
! If LS=0 there is no type field: use PGPLOT_TYPE.
!
  IF (LS==0) THEN
   CALL GRGENV('TYPE', CTYPE, LC)
  ELSE
   CTYPE = DESCR(LS+1:L)
   LC = L-LS
   L = LS-1
  END IF
!
! Check for allowed type.
!
  IF (LC>0) THEN
   CALL GRTOUP(UPPER,CTYPE)
   CTYPE = UPPER
   TYPE = GRDTYP(CTYPE)
   IF (TYPE==0) CALL GRWARN('Unrecognized device type')
   IF (TYPE==-1) CALL GRWARN('Device type is ambiguous')
  ELSE
   TYPE = 0
   CALL GRWARN('Device type omitted')
  END IF
  IF (TYPE==0) GRPARS = GRPARS+2
!
! Remove quotes from device if necessary.
!
  IF (L>=1) THEN
   IF (DESCR(1:1)=='"' .AND. DESCR(L:L)=='"') THEN
      DEV = DESCR(2:L-1)
      L = L-2
   ELSE
      DEV = DESCR(1:L)
   END IF
  END IF
!
!      write (*,*) 'Device = [', DEV(1:L), ']'
!      write (*,*) 'Type   = [', CTYPE, ']', TYPE
!      write (*,*) 'APPEND = ', APPEND
!
  END

!*GRPIXL -- solid-fill multiple rectangular areas
!+
  SUBROUTINE GRPIXL (IA, IDIM, JDIM, I1, I2, J1, J2, &
                     X1, X2, Y1, Y2)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  INTEGER IA(IDIM,JDIM)
  REAL    X1, X2, Y1, Y2
!
! Determine the size of each rectangular element. If it is equal
! to the device pen width and the device supports pixel primitives,
! use pixel primitives. Otherwise, if the size is smaller than the
! device pen width emulate pixel output by plotting points. If the
! size is larger than the device pen width, emulate by outputting
! solid-filled rectangles.
!
! Arguments:
!  IA     (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  X1, Y1 (input)  : world coordinates of one corner of the output
!                    region
!  X2, Y2 (input)  : world coordinates of the opposite corner of the
!                    output region
!--
! 18-Jan-1991 - [Ge van Geldorp]
! 31-Mar-1993 - Include color PostScript GRPXPS [Remko Scharroo]
!  4-Apr-1993 - New version of GRPXPS incorporated
!  4-Aug-1993 - Debugging
!  7-Sep-1994 - Revised for v5.0 [TJP].
! 24-Jan-1996 - GRXMIN etc changed to REAL as required in grpckg1.h [RS]
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL    RBUF(3)
  INTEGER NBUF, LCHR
  CHARACTER*32 CHR
  REAL    XLL, YLL, XUR, YUR
  REAL    XMIN, YMIN, XMAX, YMAX, XPIX, YPIX
  REAL    WIDTH, XSIZE, YSIZE
  INTEGER IL, IR, JB, JT
!
  IF (GRCIDE<1) RETURN
!
! Convert to device coordinates
!
  CALL GRTXY0(.FALSE., X1, Y1, XLL, YLL)
  CALL GRTXY0(.FALSE., X2, Y2, XUR, YUR)
  XMIN = MIN(XLL,XUR)
  XMAX = MAX(XLL,XUR)
  YMIN = MIN(YLL,YUR)
  YMAX = MAX(YLL,YUR)
!
! Check if completely outside clipping region
!
  IF (XMAX < GRXMIN(GRCIDE) .OR. GRXMAX(GRCIDE) < XMIN .OR. &
      YMAX < GRYMIN(GRCIDE) .OR. GRYMAX(GRCIDE) < YMIN) &
     RETURN
!
! Don't paint "pixels" completely before left clipping boundary
!
  XPIX = XMAX - XMIN
  YPIX = YMAX - YMIN
  IF (XMIN < GRXMIN(GRCIDE)) THEN
   IL = I1 + (GRXMIN(GRCIDE) - XMIN) * (I2 - I1 + 1) / XPIX
   XMIN = XMIN + (XPIX * (IL - I1)) / (I2 - I1 + 1)
  ELSE
   IL = I1
  ENDIF
!
! Don't paint "pixels" completely after right clipping boundary
!
  IF (GRXMAX(GRCIDE) < XMAX) THEN
   IR = I2 - (XMAX - GRXMAX(GRCIDE)) * (I2 - I1 + 1) / XPIX + 1
   XMAX = XMIN + (XPIX * (IR - I1 + 1)) / &
                   (I2 - I1 + 1)
  ELSE
   IR = I2
  ENDIF
!
! Don't paint "pixels" completely under bottom clipping boundary
!
  IF (YMIN < GRYMIN(GRCIDE)) THEN
   JB = J1 + (GRYMIN(GRCIDE) - YMIN) * (J2 - J1 + 1) / YPIX
   YMIN = YMIN + (YPIX * (JB - J1)) / (J2 - J1 + 1)
  ELSE
   JB = J1
  ENDIF
!
! Don't paint "pixels" completely above top clipping boundary
!
  IF (GRYMAX(GRCIDE) < YMAX) THEN
   JT = J2 - (YMAX - GRYMAX(GRCIDE)) * (J2 - J1 + 1) / YPIX + 1
   YMAX = YMIN + (YPIX * (JT - J1 + 1)) / &
                   (J2 - J1 + 1)
  ELSE
   JT = J2
  ENDIF
!
! If device accepts image primitives, use GRPXPS
!
  IF (GRGCAP(GRCIDE)(7:7)=='Q') THEN
   CALL GRPXPS(IA, IDIM, JDIM, IL, IR, JB, JT, &
                   XMIN,XMAX,YMIN,YMAX)
   RETURN
  ENDIF
!
! Check against pen width
!
  CALL GREXEC(GRGTYP, 3, RBUF, NBUF, CHR, LCHR)
  WIDTH = RBUF(3)
  XSIZE = (I2 - I1 + 1) * WIDTH
  YSIZE = (J2 - J1 + 1) * WIDTH
  XPIX = XMAX - XMIN + 1
  YPIX = YMAX - YMIN + 1
!
! Use rectangles if "pixel" is too large
!
  IF (XPIX > XSIZE + 0.5 * WIDTH .OR. &
      YPIX > YSIZE + 0.5 * WIDTH) THEN
  !     write (6,*) 'GRPXRE'
   CALL GRPXRE(IA, IDIM, JDIM, IL, IR, JB, JT, &
                   XMIN, XMAX, YMIN, YMAX)
!
! Use either pixel primitives or points
!
  ELSE
!
! Clip pixels lying more than 50% outside clipping boundaries
!
   IF (XMIN < GRXMIN(GRCIDE) - 0.5 * WIDTH) THEN
      XMIN = XMIN + XPIX / (IR - IL + 1)
      IL = IL + 1
   ENDIF
   IF (GRXMAX(GRCIDE) + 0.5 * WIDTH < XMAX) THEN
      XMAX = XMAX - XPIX / (IR - IL + 1)
      IR = IR - 1
   ENDIF
   IF (YMIN < GRYMIN(GRCIDE) - 0.5 * WIDTH) THEN
      YMIN = YMIN + YPIX / (JT - JB + 1)
      JB = JB + 1
   ENDIF
   IF (GRYMAX(GRCIDE) + 0.5 * WIDTH < YMAX) THEN
      YMAX = YMAX - YPIX / (JT - JB + 1)
      JT = JT - 1
   ENDIF
!
! Recalculate size
!
   XSIZE = (IR - IL + 1) * WIDTH
   YSIZE = (JT - JB + 1) * WIDTH
   XPIX = XMAX - XMIN + 1
   YPIX = YMAX - YMIN + 1
!
! Use pixel primitives if available and possible
!
   IF (GRGCAP(GRCIDE)(7:7) == 'P' .AND. &
         XSIZE - 0.5 * WIDTH <= XPIX .AND. &
         YSIZE - 0.5 * WIDTH <= YPIX) THEN
  !     write (6,*) 'GRPXPX'
      CALL GRPXPX(IA, IDIM, JDIM, IL, IR, JB, JT, XMIN, YMIN)
!
! Otherwise, use points
!
   ELSE
  !     write (6,*) 'GRPXPO'
      CALL GRPXPO(IA, IDIM, JDIM, IL, IR, JB, JT, &
                   XMIN, XMAX, YMIN, YMAX)
   ENDIF
  ENDIF
  END

!*GRPOCL -- polygon clip
!+
  SUBROUTINE GRPOCL (N,PX,PY, EDGE, VAL, MAXOUT, NOUT, QX, QY)
  INTEGER N, NOUT, EDGE, MAXOUT
  REAL    PX(*), PY(*), QX(*), QY(*)
  REAL    VAL
!
! Clip a polygon against a rectangle: Sutherland-Hodgman algorithm.
! this routine must be called four times to clip against each of the
! edges of the rectangle in turn.
!
! Arguments:
!
! N (input, integer): the number of vertices of the polygon (at least
!       3).
! PX, PY (input, real arrays, dimension at least N): world coordinates
!       of the N vertices of the input polygon.
! EDGE (input, integer):
!     1: clip against left edge,   X > XMIN=VAL
!     2: clip against right edge,  X < XMAX=VAL
!     3: clip against bottom edge, Y > YMIN=VAL
!     4: clip against top edge,    Y < YMIN=VAL
! VAL  (input, real): coordinate value of current edge.
! MAXOUT (input, integer): maximum number of vertices allowed in
!     output polygon (dimension of QX, QY).
! NOUT (output, integer): the number of vertices in the clipped polygon.
! QX, QY (output, real arrays, dimension at least MAXOUT): world
!       coordinates of the NOUT vertices of the output polygon.
!--
! 19-Sep-1994 - [TJP].
! 27-Feb-1996 - fix bug: overflow if coordinates are large [TJP].
! 11-Jul-1996 - fix bug: left and bottom edges disappeared when precisely
!               on edge [Remko Scharroo]
!-----------------------------------------------------------------------
  INTEGER I
  REAL FX, FY, SX, SY
!
  NOUT = 0
  DO 100 I=1,N
   IF (I==1) THEN
!           -- save first point
      FX = PX(I)
      FY = PY(I)
   ELSE IF ((EDGE==1 .OR.EDGE==2) .AND. &
              (SIGN(1.0,PX(I)-VAL)/=SIGN(1.0,SX-VAL))) THEN
!           -- SP intersects this edge: output vertex at intersection
      NOUT = NOUT+1
      IF (NOUT<=MAXOUT) THEN
         QX(NOUT) = VAL
         QY(NOUT) = SY + (PY(I)-SY)*((VAL-SX)/(PX(I)-SX))
      END IF
   ELSE IF ((EDGE==3 .OR.EDGE==4) .AND. &
              (SIGN(1.0,PY(I)-VAL)/=SIGN(1.0,SY-VAL))) THEN
!           -- SP intersects this edge: output vertex at intersection
      NOUT = NOUT+1
      IF (NOUT<=MAXOUT) THEN
         QX(NOUT) = SX + (PX(I)-SX)*((VAL-SY)/(PY(I)-SY))
         QY(NOUT) = VAL
      END IF
   END IF
   SX = PX(I)
   SY = PY(I)
   IF ((EDGE==1.AND.SX>=VAL) .OR. &
         (EDGE==2.AND.SX<=VAL) .OR. &
         (EDGE==3.AND.SY>=VAL) .OR. &
         (EDGE==4.AND.SY<=VAL)) THEN
!           -- output visible vertex S
      NOUT = NOUT + 1
      IF (NOUT<=MAXOUT) THEN
          QX(NOUT) = SX
          QY(NOUT) = SY
      END IF
   END IF
 100  CONTINUE
!      -- Does SF intersect edge?
  IF ((EDGE==1 .OR. EDGE==2) .AND. &
      (SIGN(1.0,SX-VAL)/=SIGN(1.0,FX-VAL))) THEN
   NOUT = NOUT+1
   IF (NOUT<=MAXOUT) THEN
      QX(NOUT) = VAL
      QY(NOUT) = SY + (FY-SY)*((VAL-SX)/(FX-SX))
   END IF
  ELSE IF ((EDGE==3 .OR. EDGE==4) .AND. &
           (SIGN(1.0,SY-VAL)/=SIGN(1.0,FY-VAL))) THEN
   NOUT = NOUT+1
   IF (NOUT<=MAXOUT) THEN
      QY(NOUT) = VAL
      QX(NOUT) = SX + (FX-SX)*((VAL-SY)/(FY-SY))
   END IF
  END IF
!
  END

!*GRPROM -- prompt user before clearing screen
!+
  SUBROUTINE GRPROM
!
! If the program is running under control of a terminal, display
! message and wait for the user to type <CR> before proceeding.
!
! Arguments:
!  none
!--
! 18-Aug-1994
!-----------------------------------------------------------------------
  INTEGER IER, L, GRGCOM
  CHARACTER*16 JUNK
!
  IER = GRGCOM(JUNK, 'Type <RETURN> for next page: ', L)
  END

!*GRPXPO -- Emulate pixel operations using points
!+
  SUBROUTINE GRPXPO (IA, IDIM, JDIM, I1, I2, J1, J2, &
                     X1, X2, Y1, Y2)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  INTEGER IA(IDIM,JDIM)
  REAL    X1, X2, Y1, Y2
!
! Arguments:
!  IA     (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  X1, X2 (input)  : the horizontal range of the output region
!  Y1, Y2 (input)  : the vertical range of the output region
!--
! 16-Jan-1991 - [GvG]
! 28-Jun-1991
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER LW
  INTEGER I, J
  INTEGER ICOL, LSTCOL
!
! Save attributes
!
  CALL GRQLW(LW)
  CALL GRQCI(ICOL)
  CALL GRSLW(1)
  LSTCOL = ICOL
  DO 20 J = J1, J2
   DO 10 I = I1, I2
!
! Color changed?
!
      IF (IA(I, J) /= LSTCOL) THEN
         CALL GRSCI(IA(I, J))
         LSTCOL = IA(I, J)
      ENDIF
!
! Output dot
!
      CALL GRDOT0(X1 + (X2 - X1) * (I - I1 + 0.5) / (I2 - I1 + 1), &
                    Y1 + (Y2 - Y1) * (J - J1 + 0.5) / (J2 - J1 + 1))
  10     CONTINUE
  20  CONTINUE
!
! Restore attributes
!
  CALL GRSCI(ICOL)
  CALL GRSLW(LW)
  END

!*GRPXPS -- pixel dump for color or grey PostScript.
!+
  SUBROUTINE GRPXPS (IA, IDIM, JDIM, I1, I2, J1, J2, &
                     XMIN, XMAX, YMIN, YMAX)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  INTEGER IA(IDIM,JDIM)
  REAL XMIN, XMAX, YMIN, YMAX
!
! This routine is called by GRPIXL.
!--
!  4-Apr-93 - Created from GRGRAY by Remko Scharroo - DUT/SSRT
!  8-Apr-93 - Bugs fixed.
!  6-Jul-94 - Aligned with PGPLOT V4.9H
!  7-Sep-94 - updated for V5.0 [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  I, J, NXP, NYP, NBUF, LCHR, II
  REAL     DX,DY,RBUF(32)
  CHARACTER*32 CHR
!-----------------------------------------------------------------------
  NXP = I2 - I1 + 1
  NYP = J2 - J1 + 1
!
! Build an image transformation matrix.
!
  DX = (XMAX-XMIN)/NXP
  DY = (YMAX-YMIN)/NYP
  RBUF(1) = 0
  RBUF(2) = NXP
  RBUF(3) = NYP
  RBUF(4) = GRXMIN(GRCIDE)
  RBUF(5) = GRXMAX(GRCIDE)
  RBUF(6) = GRYMIN(GRCIDE)
  RBUF(7) = GRYMAX(GRCIDE)
  RBUF(8) = 1.0/DX
  RBUF(9) = 0.0
  RBUF(10) = 0.0
  RBUF(11) = 1.0/DY
  RBUF(12) = (-XMIN)/DX
  RBUF(13) = (-YMIN)/DY
!
! Send setup info to driver.
!
  IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
  CALL GRTERM
  NBUF = 13
  LCHR = 0
  CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
!
! Send the array of color indices to the driver.
!
  II = 0
  DO 20 J=J1,J2
   DO 10 I=I1,I2
      II = II + 1
      RBUF(II+1) = IA(I,J)
      IF (II==20) THEN
         NBUF = II+1
         RBUF(1) = II
         CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
         II = 0
      END IF
 10      CONTINUE
 20   CONTINUE
  IF (II>0) THEN
   NBUF = II+1
   RBUF(1) = II
   CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
   II = 0
  END IF
!
! Send termination code to driver.
!
  NBUF = 1
  RBUF(1) = -1
  CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
!-----------------------------------------------------------------------
  END


!*GRPXPX -- Perform pixel operations using pixel primitive
!+
  SUBROUTINE GRPXPX (IA, IDIM, JDIM, I1, I2, J1, J2, X, Y)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  INTEGER IA(IDIM,JDIM)
  REAL    X, Y
!
! Arguments:
!  IA     (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  X, Y   (input)  : the lower left corner of the output region
!                    (device coordinates)
!--
! 16-Jan-1991 - [GvG]
  !  4-Aug-1993 - Debugged by Remko Scharroo
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER     NSIZE
  PARAMETER   (NSIZE = 1280)
  REAL        RBUF(NSIZE + 2)
  REAL        WIDTH
  INTEGER     IC1, IC2
  INTEGER     I, J, L
  INTEGER     NBUF, LCHR
  CHARACTER*1 CHR

  IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
!
! Get allowable color range and pixel width
!
  CALL GRQCOL(IC1, IC2)
  CALL GREXEC(GRGTYP, 3, RBUF, NBUF, CHR, LCHR)
  WIDTH = RBUF(3)
  DO 30 J = J1, J2
!
! Compute Y coordinate for this line
!
   RBUF(2) = Y + (J - J1) * WIDTH
   I = I1
  10        L = 1
!
! Compute left X coordinate for this line segment
!
      RBUF(1) = X + (I - I1) * WIDTH
!
! Check color index
!
  20           IF (IA(I, J) < IC1 .OR. IC2 < IA(I, J)) THEN
            RBUF(L + 2) = 1
         ELSE
            RBUF(L + 2) = IA(I, J)
         ENDIF
         L = L + 1
         I = I + 1
!
! Still room in segment and something left?
!
      IF (L <= NSIZE .AND. I <= I2) GOTO 20
!
! Output segment
!
  !           NBUF = L + 2 ! wrong ! should be: (RS)
      NBUF = L + 1
      CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR)
!
! Something left?
!
   IF (I <= I2) GOTO 10
  30  CONTINUE

  END

!*GRPXRE -- Emulate pixel operations using rectangles
!+
  SUBROUTINE GRPXRE (IA, IDIM, JDIM, I1, I2, J1, J2, &
                     X1, X2, Y1, Y2)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  INTEGER IA(IDIM,JDIM)
  REAL    X1, X2, Y1, Y2
!
! Arguments:
!  IA     (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  X1, X2 (input)  : the horizontal range of the output region
!  Y1, Y2 (input)  : the vertical range of the output region
!--
! 18-Jan-1991 - [GvG]
!-----------------------------------------------------------------------
  REAL YB, YT
  INTEGER I, J, ICOL, LSTCOL
!
! Save color attribute
!
  CALL GRQCI(ICOL)
  LSTCOL = ICOL
  DO 20 J = J1, J2
!
! Compute Y range for this index
!
   YB = Y1 + ((Y2 - Y1) * (J - J1)) / (J2 - J1 + 1)
   YT = Y1 + ((Y2 - Y1) * (J - J1 + 1)) / (J2 - J1 + 1)
   DO 10 I = I1, I2
!
! Need to change color?
!
      IF (IA(I, J) /= LSTCOL) THEN
         CALL GRSCI(IA(I, J))
         LSTCOL = IA(I, J)
      ENDIF
!
! Output rectangle
!
      CALL GRREC0(X1 + ((X2 - X1) * (I - I1)) / (I2 - I1 + 1), YB, &
                    X1 + ((X2 - X1) * (I - I1 + 1)) / (I2 - I1 + 1), &
                    YT)

  10     CONTINUE
  20  CONTINUE
!
! Restore color attribute
!
  CALL GRSCI(ICOL)
  END

!*GRQCAP -- inquire device capabilities
!+
  SUBROUTINE GRQCAP (STRING)
  CHARACTER*(*) STRING
!
! GRPCKG: obtain the "device capabilities" string from the device
! driver for the current device.
!
! Arguments:
!
! STRING (output, CHARACTER*(*)): receives the device capabilities
!       string.
!--
! 26-Nov-92: new routine [TJP].
!  1-Sep-94: get from common instead of driver [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRQCAP - no graphics device is active.')
    STRING = 'NNNNNNNNNN'
  ELSE
    STRING = GRGCAP(GRCIDE)
  END IF
!
  END

!*GRQCI -- inquire current color index
!+
  SUBROUTINE GRQCI (C)
!
! GRPCKG: obtain the color index of the current graphics device.
!
! Argument:
!
! C (integer, output): receives the current color index (0-255).
!--
! (1-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  C
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRQCI - no graphics device is active.')
    C = 1
  ELSE
    C = GRCCOL(GRCIDE)
  END IF
  END

!*GRQCOL -- inquire color capability
!+
  SUBROUTINE GRQCOL (CI1, CI2)
  INTEGER  CI1, CI2
!
! Query the range of color indices available on the current device.
!
! Argument:
!  CI1    (output) : the minimum available color index. This will be
!                    either 0 if the device can write in the
!                    background color, or 1 if not.
!  CI2    (output) : the maximum available color index. This will be
!                    1 if the device has no color capability, or a
!                    larger number (e.g., 3, 7, 15, 255).
!--
! 31-May-1989 - new routine [TJP].
!  1-Sep-1994 - avoid driver call [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
!
! Error if no workstation is open.
!
  IF (GRCIDE<1) THEN
    CI1 = 0
    CI2 = 0
  ELSE
    CI1 = GRMNCI(GRCIDE)
    CI2 = GRMXCI(GRCIDE)
  END IF
!
  END

!*GRQCR -- inquire color representation
!+
  SUBROUTINE GRQCR (CI, CR, CG, CB)
  INTEGER  CI
  REAL     CR, CG, CB
!
! Return the color representation (red, green, blue intensities)
! currently associated with the specified color index. This may be
! different from that requested on some devices.
!
! Arguments:
!
! CI (integer, input): color index.
! CR, CG, CB (real, output): red, green, and blue intensities,
!       in range 0.0 to 1.0.
!--
!  7-Sep-1994 - rewrite [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER   NBUF, LCHR, K
  REAL      RBUF(6)
  CHARACTER CHR
!
  CR = 1.0
  CG = 1.0
  CB = 1.0
  K  = CI
  IF (GRCIDE<1) THEN
!         -- no device open: return white
    CALL GRWARN('GRQCR: no plot device is open.')
  ELSE IF (GRGCAP(GRCIDE)(9:9)/='Y') THEN
!         -- devices that don't allow query color representation:
!            return black for ci 0, white for all others
    IF (K==0) THEN
       CR = 0.0
       CG = 0.0
       CB = 0.0
    END IF
  ELSE
!         -- query device driver; treat invalid ci as 1
    IF (K<GRMNCI(GRCIDE) .OR. CI>GRMXCI(GRCIDE)) THEN
       CALL GRWARN('GRQCR: invalid color index.')
       K = 1
    END IF
    RBUF(1) = K
    NBUF = 1
    LCHR = 0
    CALL GREXEC(GRGTYP,29,RBUF,NBUF,CHR,LCHR)
    IF (NBUF<4) THEN
       CALL GRWARN('GRSCR: device driver error')
    ELSE
        CR = RBUF(2)
        CG = RBUF(3)
        CB = RBUF(4)
    END IF
  END IF
!
  END


!*GRQDEV -- inquire current device
!+
  SUBROUTINE GRQDEV (DEVICE, L)
  CHARACTER*(*) DEVICE
  INTEGER L
!
! Obtain the name of the current graphics device or file.
!
! Argument:
!  DEVICE (output): receives the device name of the
!       currently active device.
!  L (output): number of characters in DEVICE, excluding trailing
!       blanks.
!--
! 19-Feb-1988
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
!
  IF (GRCIDE<1) THEN
    DEVICE = '?'
    L = 1
  ELSE
    DEVICE = GRFILE(GRCIDE)
    L = GRFNLN(GRCIDE)
    IF (L>LEN(DEVICE)) L = LEN(DEVICE)
  END IF
  END


!*GRQDT -- inquire current device and type
!+
  SUBROUTINE GRQDT (DEVICE)
!
! GRPCKG: obtain the name and type of the current graphics device.
!
! Argument:
!
! DEVICE (output, character): receives the device name and type of the
!       currently active device in the form 'device/type'; this is a
!       valid string for input to GROPEN.
!--
!  1-Feb-1983
! 19-Feb-1988 - add quotes if necessary.
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  CHARACTER*(*) DEVICE
  CHARACTER*14 TYPE
  LOGICAL   JUNK
  INTEGER   L
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRQDT - no graphics device is active.')
    DEVICE = '/NULL'
  ELSE
    CALL GRQTYP(TYPE,JUNK)
    L = GRFNLN(GRCIDE)
    IF (L<=0) THEN
        DEVICE = '/'//TYPE
    ELSE IF (INDEX(GRFILE(GRCIDE)(1:L), '/')==0) THEN
        DEVICE = GRFILE(GRCIDE)(1:L)//'/'//TYPE
    ELSE
        DEVICE = '"'//GRFILE(GRCIDE)(1:L)//'"/'//TYPE
    END IF
  END IF
  END

!*GRQFNT -- inquire current font
!+
  SUBROUTINE GRQFNT (IF)
!
! GRPCKG: obtain the font number of the current graphics device.
!
! Argument:
!
! IF (integer, output): receives the current font number (1-3).
!--
! (19-Mar-1983)
! 15-Dec-1988 - change name [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  IF
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRQFNT - no graphics device is active.')
    IF = 1
  ELSE
    IF = GRCFNT(GRCIDE)
  END IF
  END


!*GRQLS -- inquire current line-style
!+
  SUBROUTINE GRQLS (ISTYLE)
  INTEGER  ISTYLE
!
! GRPCKG: obtain the line-style of the current graphics device.
!
! Argument:
!  ISTYLE (output): receives the current line-style code.
!--
! (1-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRQLS - no graphics device is active.')
    ISTYLE = 1
  ELSE
    ISTYLE = GRSTYL(GRCIDE)
  END IF
  END

!*GRQLW -- inquire current line width
!+
  SUBROUTINE GRQLW (IWIDTH)
  INTEGER  IWIDTH
!
! GRPCKG: obtain the line-width of the current graphics device.
!
! Argument:
!  IWIDTH (output): receives the current line-width.
!--
! (1-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRQLW - no graphics device is active.')
    IWIDTH = 1
  ELSE
    IWIDTH = ABS(GRWIDT(GRCIDE))
  END IF
  END

!*GRQPOS -- return current pen position (absolute, world coordinates)
!+
  SUBROUTINE GRQPOS(X,Y)
!
! GRQPOS: returns the current pen position in absolute, world
! coordinates.
!
! Arguments:
!
! X, Y (real, output): world coordinates of the pen position.
!--
!  1-Mar-1991 - new routine  [JM].
!-----------------------------------------------------------------------
  REAL     X,Y
  INCLUDE 'grpckg1.h'
!
  IF (GRCIDE>=1) THEN
    X = (GRXPRE(GRCIDE) - GRXORG(GRCIDE)) / GRXSCL(GRCIDE)
    Y = (GRYPRE(GRCIDE) - GRYORG(GRCIDE)) / GRYSCL(GRCIDE)
  END IF
  END

!*GRQTXT -- get text bounding box
!+
  SUBROUTINE GRQTXT (ORIENT,X0,Y0,STRING, XBOX, YBOX)
!
! GRPCKG: get the bounding box of a string drawn by GRTEXT.
!--
! 12-Sep-1993 - [TJP].
!  8-Nov-1994 - return something even if string is blank [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  LOGICAL UNUSED, VISBLE, PLOT
  INTEGER XYGRID(300)
  INTEGER LIST(256)
  CHARACTER*(*) STRING
  REAL XBOX(4), YBOX(4)
  REAL ANGLE, FACTOR, FNTBAS, FNTFAC, COSA, SINA, DX, DY, XORG, YORG
  REAL ORIENT, RATIO, X0, Y0, RLX, RLY
  REAL XG, YG, XGMIN, XGMAX, YGMIN, YGMAX
  INTEGER I, IFNTLV,NLIST,LX,LY, K, LXLAST,LYLAST
  INTRINSIC ABS, COS, LEN, MAX, MIN, SIN
!
! Default return values.
!
  DO 10 I=1,4
   XBOX(I) = X0
   YBOX(I) = Y0
 10   CONTINUE
!
! Check that there is something to be plotted.
!
  IF (LEN(STRING)<=0) RETURN
!
! Check that a device is selected.
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRQTXT - no graphics device is active.')
    RETURN
  END IF
!
  XORG = GRXPRE(GRCIDE)
  YORG = GRYPRE(GRCIDE)
!
! Compute scaling and orientation.
!
  ANGLE = ORIENT*(3.14159265359/180.)
  FACTOR = GRCFAC(GRCIDE)/2.5
  RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE)
  COSA = FACTOR * COS(ANGLE)
  SINA = FACTOR * SIN(ANGLE)
  XORG = X0
  YORG = Y0
!
! Convert the string to a list of symbol numbers; to prevent overflow
! of array LIST, the length of STRING is limited to 256 characters.
!
  CALL GRSYDS(LIST,NLIST,STRING(1:MIN(256,LEN(STRING))), &
               GRCFNT(GRCIDE))
!
! Run through the string of characters, getting bounding box
! in character coordinates. (XG, YG) is the starting point
! of the current character. The x/y limits of the bbox are
! XGMIN...XGMAX, YGMIN...YGMAX.
!
  FNTBAS = 0.0
  FNTFAC = 1.0
  IFNTLV = 0
  DX = 0.0
  DY = 0.0
  XG = 0.0
  YG = 0.0
  XGMIN = 1E30
  XGMAX = -1E30
  YGMIN = 1E30
  YGMAX = -1E30
  PLOT  = .FALSE.
  DO 380 I=1,NLIST
    IF (LIST(I)<0) THEN
        IF (LIST(I)==-1) THEN
!                 ! up
            IFNTLV = IFNTLV+1
            FNTBAS = FNTBAS + 16.0*FNTFAC
            FNTFAC = 0.75**ABS(IFNTLV)
        ELSE IF (LIST(I)==-2) THEN
!                 ! down
            IFNTLV = IFNTLV-1
            FNTFAC = 0.75**ABS(IFNTLV)
            FNTBAS = FNTBAS - 16.0*FNTFAC
        ELSE IF (LIST(I)==-3) THEN
!                 ! backspace
            XG = XG - DX*FNTFAC
        END IF
        GOTO 380
    END IF
    CALL GRSYXD(LIST(I),XYGRID,UNUSED)
    VISBLE = .FALSE.
    DX = XYGRID(5)-XYGRID(4)
    K = 4
    LXLAST = -64
    LYLAST = -64
  320     K = K+2
    LX = XYGRID(K)
    LY = XYGRID(K+1)
    IF (LY==-64) GOTO 330
    IF (LX==-64) THEN
        VISBLE = .FALSE.
    ELSE
        RLX = (LX - XYGRID(4))*FNTFAC
        RLY = (LY - XYGRID(2))*FNTFAC + FNTBAS
        IF ((LX/=LXLAST) .OR. (LY/=LYLAST)) THEN
            XGMIN = MIN(XGMIN,XG+RLX)
            XGMAX = MAX(XGMAX,XG+RLX)
            YGMIN = MIN(YGMIN,RLY)
            YGMAX = MAX(YGMAX,RLY)
            PLOT = .TRUE.
        END IF
        VISBLE = .TRUE.
        LXLAST = LX
        LYLAST = LY
    END IF
    GOTO 320
  330     XG = XG + DX*FNTFAC
  380 CONTINUE
!
! Check whether anything was plotted.
!
  IF (.NOT.PLOT) RETURN
!
! Expand the box a bit to allow for line-width.
!
  XGMIN = XGMIN - 5.0
  XGMAX = XGMAX + 5.0
  YGMIN = YGMIN - 4.0
  YGMAX = YGMAX + 4.0
!
! Convert bounding box to device coordinates.
!
!     WRITE (*,*) XGMIN, XGMAX, YGMIN, YGMAX
  XBOX(1) = XORG + (COSA*XGMIN - SINA*YGMIN)*RATIO
  YBOX(1) = YORG + (SINA*XGMIN + COSA*YGMIN)
  XBOX(2) = XORG + (COSA*XGMIN - SINA*YGMAX)*RATIO
  YBOX(2) = YORG + (SINA*XGMIN + COSA*YGMAX)
  XBOX(3) = XORG + (COSA*XGMAX - SINA*YGMAX)*RATIO
  YBOX(3) = YORG + (SINA*XGMAX + COSA*YGMAX)
  XBOX(4) = XORG + (COSA*XGMAX - SINA*YGMIN)*RATIO
  YBOX(4) = YORG + (SINA*XGMAX + COSA*YGMIN)
!
  END

!*GRQTYP -- inquire current device type
!+
  SUBROUTINE GRQTYP (TYPE,INTER)
  CHARACTER*(*) TYPE
  LOGICAL INTER
!
! GRPCKG: obtain the device type of the currently selected graphics
! device, and determine whether or not it is an interactive device.
!
! Arguments:
!
! TYPE (output, CHARACTER*(*)): receives the device type, as a
!       character string, eg 'PRINTRONIX', 'TRILOG', 'VERSATEC',
!       'TEK4010', 'TEK4014', 'GRINNELL', or 'VT125'.  The character
!       string should have a length of at least 8 to ensure that the
!       type is unique.
! INTER (output, LOGICAL): receives the value .TRUE. if the device is
!       interactive, .FALSE. otherwise.
!--
! (23-May-1983)
!  5-Aug-1986 - add GREXEC support [AFT].
! 18-Jan-1993 - return type only, not description [TJP].
!  1-Sep-1994 - get capabilities from common [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL    RBUF(6)
  INTEGER NBUF,LCHR
  CHARACTER*32 CHR
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRQTYP - no graphics device is active.')
    TYPE = 'NULL'
    INTER = .FALSE.
  ELSE
    CALL GREXEC(GRGTYP, 1,RBUF,NBUF,CHR,LCHR)
    LCHR = INDEX(CHR,' ')
    TYPE = CHR(:LCHR)
    INTER = (GRGCAP(GRCIDE)(1:1)=='I')
  END IF
!
  END

!*GRQUIT -- report a fatal error and abort execution
!+
  SUBROUTINE GRQUIT (TEXT)
  CHARACTER*(*) TEXT
!
! Report a fatal error (via GRWARN) and exit program.
! This routine should be called in the event of an unrecoverable
! PGPLOT error.
!
! Argument:
!  TEXT (input): text of message to be sent to GRWARN.
!--
! 12-Nov-1994
!-----------------------------------------------------------------------
!
  CALL GRWARN(TEXT)
  CALL GRWARN('Fatal error in PGPLOT library: program terminating.')
  STOP
  END

!*GRREC0 -- fill a rectangle (device coordinates)
!+
  SUBROUTINE GRREC0 (X0,Y0,X1,Y1)
  REAL X0, Y0, X1, Y1
!
! GRPCKG: Fill a rectangle with solid color.  The rectangle
! is defined by the (x,y) device coordinates of its lower left and
! upper right corners; the edges are parallel to the coordinate axes.
! X0 is guaranteed to be <= X1 and Y0 <= Y1. The rectangle possible
! extends beyond the clipping boundaries
!
! Arguments:
!
! X0, Y0 (input, real): device coordinates of one corner of the
!       rectangle.
! X1, Y1 (input, real): device coordinates of the opposite corner of
!       the rectangle.
!--
! 23-Mar-1988 - [TJP].
! 18-Jan-1991 - Code moved from GRRECT to GRREC0 so that it can also be
!               used by GRPXRE.
!  1-Sep-1994 - suppress driver call [TJP].
!  4-Dec-1995 - avoid use of real variable as do-loop index [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL    RBUF(6)
  INTEGER NBUF,LCHR
  CHARACTER*32 CHR
  REAL    XMIN, YMIN, XMAX, YMAX, Y, DY
  INTEGER LS, LW, I, NLINES
!
! Clip
!
  XMIN = X0
  XMAX = X1
  YMIN = Y0
  YMAX = Y1
  IF (XMIN < GRXMIN(GRCIDE)) XMIN = GRXMIN(GRCIDE)
  IF (XMAX > GRXMAX(GRCIDE)) XMAX = GRXMAX(GRCIDE)
  IF (YMIN < GRYMIN(GRCIDE)) YMIN = GRYMIN(GRCIDE)
  IF (YMAX > GRYMAX(GRCIDE)) YMAX = GRYMAX(GRCIDE)
  IF (XMIN > XMAX) RETURN
  IF (YMIN > YMAX) RETURN
!
! Use hardware rectangle fill if available.
!
  IF (GRGCAP(GRCIDE)(6:6)=='R') THEN
    IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
    RBUF(1) = XMIN
    RBUF(2) = YMIN
    RBUF(3) = XMAX
    RBUF(4) = YMAX
    CALL GREXEC(GRGTYP,24,RBUF,NBUF,CHR,LCHR)
    RETURN
!
! Else use hardware polygon fill if available.
!
  ELSE IF (GRGCAP(GRCIDE)(4:4)=='A') THEN
    IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
    RBUF(1) = 4
    CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
    RBUF(1) = XMIN
    RBUF(2) = YMIN
    CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
    RBUF(1) = XMAX
    RBUF(2) = YMIN
    CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
    RBUF(1) = XMAX
    RBUF(2) = YMAX
    CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
    RBUF(1) = XMIN
    RBUF(2) = YMAX
    CALL GREXEC(GRGTYP,20,RBUF,NBUF,CHR,LCHR)
    RETURN
  END IF
!
! For other devices fill area is simulated.
!
! Save attributes.
!
  CALL GRQLS(LS)
  CALL GRQLW(LW)
  CALL GRSLS(1)
  CALL GRSLW(1)
  CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR)
  DY = RBUF(3)
!
! Draw horizontal raster lines.
!
  NLINES = ABS((YMAX-YMIN)/DY)
  Y = YMIN - DY/2.0
  DO 40 I=1,NLINES
   Y = Y + DY
   GRXPRE(GRCIDE) = XMIN
   GRYPRE(GRCIDE) = Y
   CALL GRLIN0(XMAX,Y)
   40 CONTINUE
!
! Restore attributes.
!
  CALL GRSLS(LS)
  CALL GRSLW(LW)
  END


!*GRRECT -- fill a rectangle
!+
  SUBROUTINE GRRECT (X0,Y0,X1,Y1)
  REAL X0, Y0, X1, Y1
!
! GRPCKG: Fill a rectangle with solid color.  The rectangle
! is defined by the (x,y) world coordinates of its lower left and upper
! right corners; the edges are parallel to the coordinate axes.
!
! Arguments:
!
! X0, Y0 (input, real): world coordinates of one corner of the
!       rectangle.
! X1, Y1 (input, real): world coordinates of the opposite corner of the
!       rectangle.
!--
! 23-Mar-1988 - [TJP].
! 18-Jan-1991 - Code moved from GRRECT to GRREC0 so that it can also be
!               used by GRPXRE
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL    XLL, YLL, XUR, YUR
  REAL    XMIN, YMIN, XMAX, YMAX
!
  IF (GRCIDE<1) RETURN
!
! Convert to device coordinates and clip.
!
  CALL GRTXY0(.FALSE.,X0,Y0,XLL,YLL)
  CALL GRTXY0(.FALSE.,X1,Y1,XUR,YUR)
  XMIN = MIN(XLL,XUR)
  XMAX = MAX(XLL,XUR)
  YMIN = MIN(YLL,YUR)
  YMAX = MAX(YLL,YUR)
!
! Do the real work
!
  CALL GRREC0(XMIN,YMIN,XMAX,YMAX)
  END

!*GRSCI -- set color index
!+
  SUBROUTINE GRSCI (IC)
!
! GRPCKG: Set the color index for subsequent plotting. Calls to GRSCI
! are ignored for monochrome devices. The default color index is 1,
! usually white on a black background for video displays or black on a
! white background for printer plots. The color index is an integer in
! the range 0 to a device-dependent maximum. Color index 0 corresponds
! to the background color; lines may be "erased" by overwriting them
! with color index 0.
!
! Color indices 0-7 are predefined as follows: 0 = black (background
! color), 1 = white (default), 2 = red, 3 = green, 4 = blue, 5 = cyan
! (blue + green), 6 = magenta (red + blue), 7 = yellow (red + green).
! The assignment of colors to color indices can be changed with
! subroutine GRSCR (set color representation).
!
! Argument:
!
! IC (integer, input): the color index to be used for subsequent
!       plotting on the current device (in range 0-255). If the
!       index exceeds the device-dependent maximum, the result is
!       device-dependent.
!--
! 11-Apr-1983 - [TJP].
!  3-Jun-1984 - add GMFILE device [TJP].
! 13-Jun-1984 - add code for TK4100 devices [TJP].
!  2-Jul-1984 - add code for RETRO and VT125 (REGIS) devices [TJP].
!  2-Oct-1984 - change REGIS to improve VT240 behavior [TJP].
! 22-Dec-1984 - add PRTX, TRILOG, VERS and VV devices [TJP].
! 29-Jan-1985 - add HP2648 device [KS/TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 21-Feb-1987 - delays setting color if picture not open [AFT].
! 11-Jun-1987 - remove built-in devices [TJP].
! 31-May-1989 - add check for valid color index [TJP].
!  1-Sep-1994 - use common data [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  IC, COLOR, IC1, IC2, NBUF,LCHR
  REAL     RBUF(6)
  CHARACTER*1 CHR
!
! Error if no workstation is open.
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRSCI - no graphics device is active.')
    RETURN
  END IF
!
! Use color index 1 if out of range.
!
  IC1 = GRMNCI(GRCIDE)
  IC2 = GRMXCI(GRCIDE)
  COLOR = IC
  IF (COLOR<IC1 .OR. COLOR>IC2) COLOR = 1
!
! If no change to color index is requested, take no action.
!
  IF (COLOR==GRCCOL(GRCIDE)) RETURN
!
! If the workstation is in "picture open" state, send command to
! driver.
!
  IF (GRPLTD(GRCIDE)) THEN
    RBUF(1) = COLOR
    CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR)
  END IF
!
! Set the current color index.
!
  GRCCOL(GRCIDE)=COLOR
!
  END

!*GRSCR -- set color representation
!+
  SUBROUTINE GRSCR (CI, CR, CG, CB)
  INTEGER  CI
  REAL     CR, CG, CB
!
! GRPCKG: SET COLOUR REPRESENTATION -- define the colour to be
! associated with a colour index.  Ignored for devices which do not
! support variable colour or intensity.  On monochrome output
! devices (e.g. VT125 terminals with monochrome monitors), the
! monochrome intensity is computed from the specified Red, Green, Blue
! intensities as 0.30*R + 0.59*G + 0.11*B, as in US color television
! systems, NTSC encoding.  Note that most devices do not have an
! infinite range of colours or monochrome intensities available;
! the nearest available colour is used.
!
! Arguments:
!
! CI (integer, input): colour index. If the colour index is outside the
!       range available on the device, the call is ignored. Colour
!       index 0 applies to the background colour.
! CR, CG, CB (real, input): red, green, and blue intensities,
!       in range 0.0 to 1.0.
!--
! 20-Feb-1984 - [TJP].
!  5-Jun-1984 - add GMFILE device [TJP].
!  2-Jul-1984 - add REGIS device [TJP].
!  2-Oct-1984 - change use of map tables in Regis [TJP].
! 11-Nov-1984 - add code for /TK [TJP].
!  1-Sep-1986 - add GREXEC support [AFT].
! 21-Feb-1987 - If needed, calls begin picture [AFT].
! 31-Aug-1994 - suppress call of begin picture [TJP].
!  1-Sep-1994 - use common data [TJP].
! 26-Jul-1995 - fix bug: some drivers would ignore a change to the
!               current color [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER   NBUF, LCHR
  REAL      RBUF(6)
  CHARACTER CHR
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRSCR - Specified workstation is not open.')
  ELSE IF (CR<0.0 .OR. CG<0.0 .OR. CB<0.0 .OR. &
      CR>1.0 .OR. CG>1.0 .OR. CB>1.0) THEN
    CALL GRWARN('GRSCR - Colour is outside range [0,1].')
  ELSE IF (CI>=GRMNCI(GRCIDE) .AND. CI<=GRMXCI(GRCIDE)) THEN
!         IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC
    RBUF(1)=CI
    RBUF(2)=CR
    RBUF(3)=CG
    RBUF(4)=CB
    NBUF=4
    CALL GREXEC(GRGTYP,21,RBUF,NBUF,CHR,LCHR)
!         -- If this is the current color, reselect it in the driver.
    IF (CI==GRCCOL(GRCIDE)) THEN
       RBUF(1) = CI
       CALL GREXEC(GRGTYP,15,RBUF,NBUF,CHR,LCHR)
    END IF
  END IF
!
  END

! GRSCRL -- scroll pixels in viewport
!+
  SUBROUTINE GRSCRL (DX, DY)
  INTEGER DX, DY
!
! Shift the pixels in the viewport by DX and DY in device coordinates.
!--
! 24-Feb-97: new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER NBUF, LCHR
  REAL RBUF(6)
  CHARACTER*8 CHR
!
! Do nothing if device is not open or not in appropriate state.
!
  IF (GRCIDE<1) RETURN
  IF (.NOT.GRPLTD(GRCIDE)) RETURN
!
! If device has scroll capability, use it. The arguments in
! RBUF are: (1..4) current viewport in device coordinates;
! (5..6) scroll displacement in world coordinates.
!
  IF (GRGCAP(GRCIDE)(11:11)=='S') THEN
   RBUF(1) = NINT(GRXMIN(GRCIDE))
   RBUF(2) = NINT(GRYMIN(GRCIDE))
   RBUF(3) = NINT(GRXMAX(GRCIDE))
   RBUF(4) = NINT(GRYMAX(GRCIDE))
   RBUF(5) = DX
   RBUF(6) = DY
   NBUF = 6
   LCHR = 0
   CALL GREXEC(GRGTYP,30,RBUF,NBUF,CHR,LCHR)
!
! Otherwise, report an error.
!
  ELSE
   CALL GRWARN('Device does not support scrolling')
  END IF
  END


!*GRSETC -- set character size
!+
  SUBROUTINE GRSETC (IDENT,XSIZE)
!
! GRPCKG : change the character size (user-callable routine).
!
! Input:   IDENT : plot identifier
!          XSIZE : the new character width. The character height
!                  and spacing will be scaled by the same factor.
!                  If XSIZE is negative or zero, the character size
!                  will be set to the default size.
!--
! (1-Feb-1983)
! 16-Sep-1985 - add code for metafile output (TJP).
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER IDENT
  REAL XSIZE
!
! Record the new size (GRCFAC).
!
  CALL GRSLCT(IDENT)
  IF (XSIZE<=0.0) THEN
    GRCFAC(IDENT) = 1.0
  ELSE
    GRCFAC(IDENT) = XSIZE / GRCXSZ
  END IF
!
  END

!*GRSETS -- change size of view surface
!+
  SUBROUTINE GRSETS (IDENT,XSIZE,YSIZE)
!
! GRPCKG : change size of plotting area. The requested dimensions
! will be reduced to the absolute maximum of the plot device if
! necessary.
!
! Arguments:
!
! IDENT (input, integer): plot identifier from GROPEN.
! XSIZE (input, real): new x dimension of plot area (absolute
!               units); if less than zero, the default dimension
!               will be used.
! YSIZE (input, real): new y dimension of plot area (absolute
!               units); if less than zero, the default dimension
!               will be used.
!--
! (1-Feb-1983)
!  5-Aug-1986 - add GREXEC support [AFT].
!  5-Jan-1993 - set GRADJU [TJP].
!------------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  I, IDENT, J, IX, IY, NBUF,LCHR
  REAL     RBUF(6)
  CHARACTER CHR
  REAL     XSIZE,YSIZE
!
  CALL GRSLCT(IDENT)
!     write (*,*) 'GRSETS: old size', GRXMXA(IDENT), GRYMXA(IDENT)
  CALL GRPAGE
  IF ((XSIZE < 0.0) .OR. (YSIZE < 0.0)) THEN
    CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR)
    GRXMXA(IDENT) = RBUF(2)
    GRYMXA(IDENT) = RBUF(4)
  ELSE
    I = NINT(XSIZE)
    J = NINT(YSIZE)
    CALL GREXEC(GRGTYP, 2,RBUF,NBUF,CHR,LCHR)
    IX=RBUF(2)
    IY=RBUF(4)
    IF (IX>0) I = MIN(I,IX)
    IF (IY>0) J = MIN(J,IY)
    GRXMXA(IDENT) = I
    GRYMXA(IDENT) = J
  END IF
!     write (*,*) 'GRSETS: new size', GRXMXA(IDENT), GRYMXA(IDENT)
  GRXMIN(IDENT) = 0
  GRXMAX(IDENT) = GRXMXA(IDENT)
  GRYMIN(IDENT) = 0
  GRYMAX(IDENT) = GRYMXA(IDENT)
  GRADJU(IDENT) = .TRUE.
!
  END

!*GRSFNT -- set text font
!+
  SUBROUTINE GRSFNT (IF)
  INTEGER IF
!
! GRPCKG: Set the font for subsequent text plotting.
! The default font is 1 ("Normal" font); others available are 2
! ("Roman"), 3 ("Italic"), and 4 ("Script").
!
! Argument:
!  IF (input): the font number to be used for subsequent
!       text plotting on the current device (in range 1-4).
!--
! 19-Mar-1983 - [TJP].
!  4-Jun-1984 - add code for GMFILE device [TJP].
! 15-Dec-1988 - change name [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER    I
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRSFNT - no graphics device is active.')
    RETURN
  END IF
!
! Set software font index.
!
  IF (IF<1 .OR. IF>4) THEN
    CALL GRWARN('Illegal font selected: font 1 used.')
    I = 1
  ELSE
    I = IF
  END IF
!
! Ignore request if no change is to be made.
!
  IF (IF==GRCFNT(GRCIDE)) RETURN
!
! Save font setting.
!
  GRCFNT(GRCIDE) = I
!
  END


!*GRSIZE -- inquire device size and resolution
!+
  SUBROUTINE GRSIZE (IDENT,XSZDEF,YSZDEF,XSZMAX,YSZMAX, &
                     XPERIN,YPERIN)
!
! GRPCKG : obtain device parameters (user-callable routine).
!--
! (1-Feb-1983)
!  5-Aug-1986 - add GREXEC support [AFT].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER IDENT
  REAL XSZDEF, YSZDEF, XSZMAX, YSZMAX, XPERIN, YPERIN
  INTEGER NBUF,LCHR
  REAL    RBUF(6)
  CHARACTER CHR
!
  CALL GRSLCT(IDENT)
  CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR)
  XSZDEF = RBUF(2)
  YSZDEF = RBUF(4)
  CALL GREXEC(GRGTYP, 2,RBUF,NBUF,CHR,LCHR)
  XSZMAX = RBUF(2)
  YSZMAX = RBUF(4)
  XPERIN = GRPXPI(GRCIDE)
  YPERIN = GRPYPI(GRCIDE)
!
  END

!*GRSKPB -- skip blanks in character string
!+
  SUBROUTINE GRSKPB (S, I)
  CHARACTER*(*) S
  INTEGER I
!
! GRSKPB: increment I so that it points to the next non-blank
! character in string S.  'Blank' characters are space and tab (ASCII
! character value 9).
!
! Arguments:
!  S      (input)  : character string to be parsed.
!  I      (in/out) : on input, I is the index of the first character
!                    in S to be examined; on output, either it points
!                    to the next non-blank character, or it is equal
!                    to LEN(S)+1 (if all the rest of the string is
!                    blank).
!--
!  1985 Oct 8 - New routine, based on SKIPBL (T. J. Pearson).
!-----------------------------------------------------------------------
!
   10 IF (I>LEN(S)) RETURN
  IF (S(I:I)/=' ' .AND. S(I:I)/=CHAR(9)) RETURN
  I = I+1
  GOTO 10
  END

!*GRSLCT -- select active output device
!+
  SUBROUTINE GRSLCT (IDENT)
!
! GRPCKG: Check that IDENT is a valid plot identifier, and select the
! corresponding plot as the current plot. All subsequent plotting will
! be directed to this device until the assignment is changed by another
! call to GRSLCT.
!
! Argument:
!
! IDENT (input, integer): the identifier of the plot to be selected, as
!       returned by GROPEN.
!--
! (1-Feb-1983)
!  5-Aug-1986 - add GREXEC support [AFT].
!  4-Jun-1987 - skip action if no change in ID [TJP].
! 26-Nov-1990 - [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL     RBUF(6)
  INTEGER  IDENT, NBUF,LCHR
  CHARACTER CHR
!
  IF ((IDENT<=0) .OR. (IDENT>GRIMAX) .OR. &
       (GRSTAT(IDENT)==0)) THEN
   CALL GRWARN('GRSLCT - invalid plot identifier.')
  ELSE IF (IDENT==GRCIDE) THEN
   GRGTYP = GRTYPE(IDENT)
   RETURN
  ELSE
   GRCIDE = IDENT
   GRGTYP = GRTYPE(IDENT)
   RBUF(1)= GRCIDE
   RBUF(2)= GRUNIT(GRCIDE)
   NBUF   = 2
   CALL GREXEC(GRGTYP, 8,RBUF,NBUF,CHR,LCHR)
  END IF
  END

!*GRSLS -- set line style
!+
  SUBROUTINE GRSLS (IS)
  INTEGER IS
!
! GRPCKG: Set the line style for subsequent plotting on the current
! device. The different line styles are generated in hardware on
! some devices and by GRPCKG software for the other devices. Five
! different line styles are available, with the following codes:
! 1 (full line), 2 (dashed), 3 (dot-dash-dot-dash), 4 (dotted),
! 5 (dash-dot-dot-dot). The default is 1 (normal full line). Line
! style is ignored when drawing characters, which are always drawn with
! a full line.
!
! Argument:
!
! IS (input, integer): the line-style code for subsequent plotting on
!       the current device (in range 1-5).
!--
!  9-Feb-1983 - [TJP].
!  3-Jun-1984 - add GMFILE device [TJP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 21-Feb-1987 - If needed, calls begin picture [AFT].
! 19-Jan-1987 - fix bug in GREXEC call [TJP].
! 16-May-1989 - fix bug for hardware line dash [TJP].
!  1-Sep-1994 - do not call driver to get size and capabilities [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER I, L, IDASH, NBUF,LCHR
  REAL    RBUF(6),TMP
  CHARACTER*10 CHR
  REAL PATERN(8,5)
!
  DATA PATERN/ 8*10.0, &
               8*10.0, &
               8.0, 6.0, 1.0, 6.0, 8.0, 6.0, 1.0, 6.0, &
               1.0, 6.0, 1.0, 6.0, 1.0, 6.0, 1.0, 6.0, &
               8.0, 6.0, 1.0, 6.0, 1.0, 6.0, 1.0, 6.0 /
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRSLS - no graphics device is active.')
    RETURN
  END IF
!
  I = IS
  IF (I<1 .OR. I>5) THEN
    CALL GRWARN('GRSLS - invalid line-style requested.')
    I = 1
  END IF
!
! Inquire if hardware dash is available.
!
  IDASH=0
  IF(GRGCAP(GRCIDE)(3:3)=='D') IDASH=1
!
! Set up for hardware dash.
!
  IF(IDASH/=0) THEN
    GRDASH(GRCIDE) = .FALSE.
    IF (GRPLTD(GRCIDE)) THEN
        RBUF(1)=I
        NBUF=1
        CALL GREXEC(GRGTYP,19,RBUF,NBUF,CHR,LCHR)
    END IF
!
! Set up for software dash.
!
  ELSE
    IF (I==1) THEN
        GRDASH(GRCIDE) = .FALSE.
    ELSE
        GRDASH(GRCIDE) = .TRUE.
        GRIPAT(GRCIDE) = 1
        GRPOFF(GRCIDE) = 0.0
        TMP = GRYMXA(GRCIDE)/1000.
        DO 10 L=1,8
            GRPATN(GRCIDE,L) = PATERN(L,I)*TMP
   10         CONTINUE
    END IF
  END IF
  GRSTYL(GRCIDE) = I
  END

!*GRSLW -- set line width
!+
  SUBROUTINE GRSLW (IW)
  INTEGER IW
!
! GRPCKG: Set the line width for subsequent plotting on the current
! device. If the hardware does not support thick lines, they are
! simulated by tracing each line with multiple strokes offset in the
! direction perpendicular to the line. The line width is specified by
! the number of strokes to be used, which must be in the range 1-201.
! The actual line width obtained depends on the device resolution.
! If the hardware does support thick lines, the width of the line
! is approximately 0.005 inches times the value of argument IW.
!
! Argument:
!
! IW (integer, input): the number of strokes to be used for subsequent
!       plotting on the current device (in range 1-201).
!--
!  1-Feb-1983 [TJP].
!  3-Jun-1984 [TJP] - add GMFILE device.
! 28-Aug-1984 [TJP] - correct bug in GMFILE: redundant SET_LINEWIDTH
!                     commands were not being filtered out.
! 26-May-1987 [TJP] - add GREXEC support.
! 11-Jun-1987 [TJP] - remove built-in devices.
! 31-May-1989 [TJP] - increase maximum width from 21 to 201.
!  1-Sep-1994 [TJP]
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER I, ITHICK
  REAL    RBUF(1)
  INTEGER NBUF,LCHR
  CHARACTER*32 CHR
!
! Check that graphics is active.
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRSLW - no graphics device is active.')
    RETURN
  END IF
!
! Check that requested line-width is valid.
!
  I = IW
  IF (I<1 .OR. I>201) THEN
    CALL GRWARN('GRSLW - invalid line-width requested.')
    I = 1
  END IF
!
! Ignore the request if the linewidth is unchanged.
!
  IF (I==ABS(GRWIDT(GRCIDE))) RETURN
!
! Inquire if hardware supports thick lines.
!
  ITHICK = 0
  IF (GRGCAP(GRCIDE)(5:5)=='T') ITHICK = 1
!
! For devices with hardware support of thick lines, send the
! appropriate commands to the device driver, and give the "current
! linewidth" parameter a negative value to suppress software linewidth
! emulation.
!
  IF (ITHICK==1 .AND. GRPLTD(GRCIDE)) THEN
    RBUF(1) = I
    CALL GREXEC(GRGTYP,22,RBUF,NBUF,CHR,LCHR)
  END IF
!
! Save the current linewidth.
!
  GRWIDT(GRCIDE) = I
  IF (ITHICK==1) GRWIDT(GRCIDE) = -I
!
  END

!*GRSY00 -- initialize font definition
!+
  SUBROUTINE GRSY00
!
! This routine must be called once in order to initialize the tables
! defining the symbol numbers to be used for ASCII characters in each
! font, and to read the character digitization from a file.
!
! Arguments: none.
!
! Implicit input:
!  The file with name specified in environment variable PGPLOT_FONT
!  is read, if it is available.
!  This is a binary file containing two arrays INDEX and BUFFER.
!  The digitization of each symbol occupies a number of words in
!  the INTEGER*2 array BUFFER; the start of the digitization
!  for symbol number N is in BUFFER(INDEX(N)), where INDEX is an
!  integer array of 3000 elements. Not all symbols 1...3000 have
!  a representation; if INDEX(N) = 0, the symbol is undefined.
!
  !  PGPLOT uses the Hershey symbols for two `primitive' operations:
  !  graph markers and text.  The Hershey symbol set includes several
  !  hundred different symbols in a digitized form that allows them to
  !  be drawn with a series of vectors (polylines).
  !
  !  The digital representation of all the symbols is stored in common
  !  block /GRSYMB/.  This is read from a disk file at run time. The
  !  name of the disk file is specified in environment variable
  !  PGPLOT_FONT.
  !
  ! Modules:
  !
  ! GRSY00 -- initialize font definition
  ! GRSYDS -- decode character string into list of symbol numbers
  ! GRSYMK -- convert marker number into symbol number
  ! GRSYXD -- obtain the polyline representation of a given symbol
  !
  ! PGPLOT calls these routines as follows:
  !
  ! Routine          Called by
  !
  ! GRSY00          GROPEN
  ! GRSYDS          GRTEXT, GRLEN
  ! GRSYMK          GRMKER,
  ! GRSYXD          GRTEXT, GRLEN, GRMKER
  !**********************************************************************
!--
! (2-Jan-1984)
! 22-Jul-1984 - revise to use DATA statements [TJP].
!  5-Jan-1985 - make missing font file non-fatal [TJP].
!  9-Feb-1988 - change default file name to Unix name; overridden
!               by environment variable PGPLOT_FONT [TJP].
! 29-Nov-1990 - move font assignment to GRSYMK.
!  7-Nov-1994 - look for font file in PGPLOT_DIR if PGPLOT_FONT is
!               undefined [TJP].
!-----------------------------------------------------------------------
  INTEGER*2  BUFFER(27000)
  INTEGER    FNTFIL, IER, INDEX(3000), NC1, NC2, NC3
  INTEGER    L, GRTRIM
  COMMON     /GRSYMB/ NC1, NC2, INDEX, BUFFER
  CHARACTER*128 FF
!
! Read the font file. If an I/O error occurs, it is ignored; the
! effect will be that all symbols will be undefined (treated as
! blank spaces).
!
  CALL GRGFIL('FONT', FF)
  L = GRTRIM(FF)
  IF (L<1) L = 1
  CALL GRGLUN(FNTFIL)
  OPEN (UNIT=FNTFIL, FILE=FF(1:L), FORM='UNFORMATTED', &
        STATUS='OLD', IOSTAT=IER)
  IF (IER==0) READ (UNIT=FNTFIL, IOSTAT=IER) &
              NC1,NC2,NC3,INDEX,BUFFER
  IF (IER==0) CLOSE (UNIT=FNTFIL, IOSTAT=IER)
  CALL GRFLUN(FNTFIL)
  IF (IER/=0) THEN
    CALL GRWARN('Unable to read font file: '//FF(:L))
    CALL GRWARN('Use environment variable PGPLOT_FONT to specify ' &
            //'the location of the PGPLOT grfont.dat file.')
  END IF
  RETURN
  END

!*GRSYDS -- decode character string into list of symbol numbers
!+
  SUBROUTINE GRSYDS (SYMBOL, NSYMBS, TEXT, FONT)
  INTEGER SYMBOL(*), NSYMBS, FONT
  CHARACTER*(*) TEXT
!
! Given a character string, this routine returns a list of symbol
! numbers to be used to plot it. It is responsible for interpreting
! all escape sequences.  Negative `symbol numbers' are inserted in the
! list to represent pen movement. The following escape sequences are
! defined (the letter following the \ may be either upper or lower
! case):
!
! \u       :      up one level (returns -1)
! \d       :      down one level (returns -2)
! \b       :      backspace (returns -3)
! \A       :      (upper case only) Angstrom symbol, roman font
! \x       :      multiplication sign
! \.       :      centered dot
! \\       :      \, returns the code for backslash
! \gx      :      greek letter corresponding to roman letter x
! \fn      :      switch to Normal font
! \fr      :      switch to Roman font
! \fi      :      switch to Italic font
! \fs      :      switch to Script font
! \mn or \mnn :   graph marker number n or nn (1 or 2 digits)
! \(nnn)   :      Hershey symbol number nnn (any number of digits)
!
! Arguments:
!  SYMBOL (output) : receives the list of symbol numers.
!  NSYMBS (output) : receives the actual number of symbols specified
!                    by the string; it is assumed that the dimension of
!                    SYMBOL is big enough (not less than LEN(TEXT)).
!  TEXT   (input)  : the text string to be decoded.
!  FONT   (input)  : the font number (1..4) to be used for decoding the
!                    string (this can be overridden by an escape
!                    sequence within the string).
!--
!  3-May-1983 - [TJP].
! 13-Jun-1984 - add \A [TJP].
! 15-Dec-1988 - standardize [TJP].
! 29-Nov-1990 - add \m escapes [TJP].
! 27-Nov-1991 - add \x escape [TJP].
! 27-Jul-1995 - extend for 256-character set [TJP]
!  7-Nov-1995 - add \. escape [TJP].
!-----------------------------------------------------------------------
  CHARACTER*8  FONTS
  CHARACTER*48 GREEK
  PARAMETER (FONTS = 'nrisNRIS')
  PARAMETER (GREEK = 'ABGDEZYHIKLMNCOPRSTUFXQW' // &
                     'abgdezyhiklmncoprstufxqw' )
  INTEGER  CH, IG, J, LENTXT, IFONT, MARK
!
! Initialize parameters.
!
  IFONT = FONT
  LENTXT = LEN(TEXT)
  NSYMBS = 0
  J = 0
!
! Get next character; treat non-printing characters as spaces.
!
  100 J = J+1
  IF (J>LENTXT) RETURN
  CH = ICHAR(TEXT(J:J))
  IF (CH<0)   CH = 32
  IF (CH>303) CH = 32
!
! Test for escape sequence (\)
!
  IF (CH==92) THEN
    IF ((LENTXT-J)>=1) THEN
      IF (TEXT(J+1:J+1)==CHAR(92)) THEN
          J = J+1
      ELSE IF (TEXT(J+1:J+1)=='u' .OR. &
                       TEXT(J+1:J+1)=='U') THEN
          NSYMBS = NSYMBS + 1
          SYMBOL(NSYMBS) = -1
          J = J+1
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='d' .OR. &
                       TEXT(J+1:J+1)=='D') THEN
          NSYMBS = NSYMBS + 1
          SYMBOL(NSYMBS) = -2
          J = J+1
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='b' .OR. &
                       TEXT(J+1:J+1)=='B') THEN
          NSYMBS = NSYMBS + 1
          SYMBOL(NSYMBS) = -3
          J = J+1
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='A') THEN
          NSYMBS = NSYMBS + 1
          SYMBOL(NSYMBS) = 2078
          J = J+1
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='x') THEN
          NSYMBS = NSYMBS + 1
          SYMBOL(NSYMBS) = 2235
          IF (IFONT==1) SYMBOL(NSYMBS) = 727
          J = J+1
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='.') THEN
          NSYMBS = NSYMBS + 1
          SYMBOL(NSYMBS) = 2236
          IF (IFONT==1) SYMBOL(NSYMBS) = 729
          J = J+1
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='(') THEN
          NSYMBS = NSYMBS + 1
          SYMBOL(NSYMBS) = 0
          J = J+2
!               -- DO WHILE ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9')
   90           IF ('0'<=TEXT(J:J).AND.TEXT(J:J)<='9') THEN
            SYMBOL(NSYMBS) = SYMBOL(NSYMBS)*10 + &
                        ICHAR(TEXT(J:J)) - ICHAR('0')
             J = J+1
          GOTO 90
          END IF
!               -- end DO WHILE
          IF (TEXT(J:J)/=')') J = J-1
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='m' .OR. &
                 TEXT(J+1:J+1)=='M') THEN
          MARK = 0
          J = J+2
          IF ('0'<=TEXT(J:J).AND.TEXT(J:J)<='9') THEN
              MARK = MARK*10 + ICHAR(TEXT(J:J)) - ICHAR('0')
              J = J+1
          END IF
          IF ('0'<=TEXT(J:J).AND.TEXT(J:J)<='9') THEN
              MARK = MARK*10 + ICHAR(TEXT(J:J)) - ICHAR('0')
              J = J+1
          END IF
          J = J-1
          NSYMBS = NSYMBS + 1
          CALL GRSYMK(MARK, IFONT, SYMBOL(NSYMBS))
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='f' .OR. &
                 TEXT(J+1:J+1)=='F') THEN
          IFONT = INDEX(FONTS, TEXT(J+2:J+2))
          IF (IFONT>4) IFONT = IFONT-4
          IF (IFONT==0) IFONT = 1
          J = J+2
          GOTO 100
      ELSE IF (TEXT(J+1:J+1)=='g' .OR. &
                 TEXT(J+1:J+1)=='G') THEN
          IG = INDEX(GREEK, TEXT(J+2:J+2))
          NSYMBS = NSYMBS + 1
          CALL GRSYMK(255+IG, IFONT, SYMBOL(NSYMBS))
          J = J+2
          GOTO 100
      END IF
    END IF
  END IF
!
! Decode character.
!
  NSYMBS = NSYMBS + 1
  CALL GRSYMK(CH, IFONT, SYMBOL(NSYMBS))
  GOTO 100
  END

!*GRSYMK -- convert character number into symbol number
!+
  SUBROUTINE GRSYMK (CODE, FONT, SYMBOL)
  INTEGER CODE, FONT, SYMBOL
!
! This routine returns the Hershey symbol number (SYMBOL) corresponding
! to ASCII code CODE in font FONT.
!
! Characters 0-31 are the same in all fonts, and are the standard
! graph markers. Characters 32-127 are standard representations of
! the ASCII codes. Characters 128-255 are reserved for the upper
! half of the ISO Latin-1 character set. Characters 256-303 are
! used for the greek alphabet.
!
! Arguments:
!  CODE   (input)  : the extended ASCII code number.
!  FONT   (input)  : the font to be used 31 (range 1-4).
!  SYMBOL (output) : the number of the symbol to be plotted.
!--
! 24-Apr-1986.
! 15-Dec-1988 - standardize [TJP].
! 29-Nov-1990 - eliminate common block [TJP].
! 27-Nov-1991 - correct code for backslash [TJP].
! 27-Jul-1995 - extend for 256-character set; add some defaults for
!               ISO Latin-1 (full glyph set not available) [TJP].
!-----------------------------------------------------------------------
  INTEGER   I, K, HERSH(0:303,4)
  SAVE      HERSH
!
! Special characters (graph markers).
!
  DATA (HERSH(  0,K),K=1,4) / 841, 841, 841, 841/
  DATA (HERSH(  1,K),K=1,4) / 899, 899, 899, 899/
  DATA (HERSH(  2,K),K=1,4) / 845, 845, 845, 845/
  DATA (HERSH(  3,K),K=1,4) / 847, 847, 847, 847/
  DATA (HERSH(  4,K),K=1,4) / 840, 840, 840, 840/
  DATA (HERSH(  5,K),K=1,4) / 846, 846, 846, 846/
  DATA (HERSH(  6,K),K=1,4) / 841, 841, 841, 841/
  DATA (HERSH(  7,K),K=1,4) / 842, 842, 842, 842/
  DATA (HERSH(  8,K),K=1,4) /2284,2284,2284,2284/
  DATA (HERSH(  9,K),K=1,4) /2281,2281,2281,2281/
  DATA (HERSH( 10,K),K=1,4) / 735, 735, 735, 735/
  DATA (HERSH( 11,K),K=1,4) / 843, 843, 843, 843/
  DATA (HERSH( 12,K),K=1,4) / 844, 844, 844, 844/
  DATA (HERSH( 13,K),K=1,4) / 852, 852, 852, 852/
  DATA (HERSH( 14,K),K=1,4) / 866, 866, 866, 866/
  DATA (HERSH( 15,K),K=1,4) / 868, 868, 868, 868/
  DATA (HERSH( 16,K),K=1,4) / 851, 851, 851, 851/
  DATA (HERSH( 17,K),K=1,4) / 850, 850, 850, 850/
  DATA (HERSH( 18,K),K=1,4) / 856, 856, 856, 856/
  DATA (HERSH( 19,K),K=1,4) / 254, 254, 254, 254/
  DATA (HERSH( 20,K),K=1,4) / 900, 900, 900, 900/
  DATA (HERSH( 21,K),K=1,4) / 901, 901, 901, 901/
  DATA (HERSH( 22,K),K=1,4) / 902, 902, 902, 902/
  DATA (HERSH( 23,K),K=1,4) / 903, 903, 903, 903/
  DATA (HERSH( 24,K),K=1,4) / 904, 904, 904, 904/
  DATA (HERSH( 25,K),K=1,4) / 905, 905, 905, 905/
  DATA (HERSH( 26,K),K=1,4) / 906, 906, 906, 906/
  DATA (HERSH( 27,K),K=1,4) / 907, 907, 907, 907/
  DATA (HERSH( 28,K),K=1,4) /2263,2263,2263,2263/
  DATA (HERSH( 29,K),K=1,4) /2261,2261,2261,2261/
  DATA (HERSH( 30,K),K=1,4) /2262,2262,2262,2262/
  DATA (HERSH( 31,K),K=1,4) /2264,2264,2264,2264/
!
! US-ASCII (ISO Latin-1 lower half).
!
!   32:39 space exclam quotdbl numbersign
!         dollar percent ampersand quoteright
  DATA (HERSH( 32,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH( 33,K),K=1,4) / 714,2214,2764,2764/
  DATA (HERSH( 34,K),K=1,4) / 717,2217,2778,2778/
  DATA (HERSH( 35,K),K=1,4) / 733,2275,2275,2275/
  DATA (HERSH( 36,K),K=1,4) / 719,2274,2769,2769/
  DATA (HERSH( 37,K),K=1,4) /2271,2271,2271,2271/
  DATA (HERSH( 38,K),K=1,4) / 734,2272,2768,2768/
  DATA (HERSH( 39,K),K=1,4) / 716,2216,2777,2777/
!   40:47 parenleft parenright asterisk plus
!         comma minus period slash
  DATA (HERSH( 40,K),K=1,4) / 721,2221,2771,2771/
  DATA (HERSH( 41,K),K=1,4) / 722,2222,2772,2772/
  DATA (HERSH( 42,K),K=1,4) / 728,2219,2773,2773/
  DATA (HERSH( 43,K),K=1,4) / 725,2232,2775,2775/
  DATA (HERSH( 44,K),K=1,4) / 711,2211,2761,2761/
  DATA (HERSH( 45,K),K=1,4) / 724,2231,2774,2774/
  DATA (HERSH( 46,K),K=1,4) / 710,2210,2760,2760/
  DATA (HERSH( 47,K),K=1,4) / 720,2220,2770,2770/
!   48:55 zero one two three four five six seven
  DATA (HERSH( 48,K),K=1,4) / 700,2200,2750,2750/
  DATA (HERSH( 49,K),K=1,4) / 701,2201,2751,2751/
  DATA (HERSH( 50,K),K=1,4) / 702,2202,2752,2752/
  DATA (HERSH( 51,K),K=1,4) / 703,2203,2753,2753/
  DATA (HERSH( 52,K),K=1,4) / 704,2204,2754,2754/
  DATA (HERSH( 53,K),K=1,4) / 705,2205,2755,2755/
  DATA (HERSH( 54,K),K=1,4) / 706,2206,2756,2756/
  DATA (HERSH( 55,K),K=1,4) / 707,2207,2757,2757/
!   56:63 eight nine colon semicolon less equal greater question
  DATA (HERSH( 56,K),K=1,4) / 708,2208,2758,2758/
  DATA (HERSH( 57,K),K=1,4) / 709,2209,2759,2759/
  DATA (HERSH( 58,K),K=1,4) / 712,2212,2762,2762/
  DATA (HERSH( 59,K),K=1,4) / 713,2213,2763,2763/
  DATA (HERSH( 60,K),K=1,4) /2241,2241,2241,2241/
  DATA (HERSH( 61,K),K=1,4) / 726,2238,2776,2776/
  DATA (HERSH( 62,K),K=1,4) /2242,2242,2242,2242/
  DATA (HERSH( 63,K),K=1,4) / 715,2215,2765,2765/
!   64:71 at A B C D E F G
  DATA (HERSH( 64,K),K=1,4) /2273,2273,2273,2273/
  DATA (HERSH( 65,K),K=1,4) / 501,2001,2051,2551/
  DATA (HERSH( 66,K),K=1,4) / 502,2002,2052,2552/
  DATA (HERSH( 67,K),K=1,4) / 503,2003,2053,2553/
  DATA (HERSH( 68,K),K=1,4) / 504,2004,2054,2554/
  DATA (HERSH( 69,K),K=1,4) / 505,2005,2055,2555/
  DATA (HERSH( 70,K),K=1,4) / 506,2006,2056,2556/
  DATA (HERSH( 71,K),K=1,4) / 507,2007,2057,2557/
!   72:79 H I J K L M N O
  DATA (HERSH( 72,K),K=1,4) / 508,2008,2058,2558/
  DATA (HERSH( 73,K),K=1,4) / 509,2009,2059,2559/
  DATA (HERSH( 74,K),K=1,4) / 510,2010,2060,2560/
  DATA (HERSH( 75,K),K=1,4) / 511,2011,2061,2561/
  DATA (HERSH( 76,K),K=1,4) / 512,2012,2062,2562/
  DATA (HERSH( 77,K),K=1,4) / 513,2013,2063,2563/
  DATA (HERSH( 78,K),K=1,4) / 514,2014,2064,2564/
  DATA (HERSH( 79,K),K=1,4) / 515,2015,2065,2565/
!   80:87 P Q R S T U V W
  DATA (HERSH( 80,K),K=1,4) / 516,2016,2066,2566/
  DATA (HERSH( 81,K),K=1,4) / 517,2017,2067,2567/
  DATA (HERSH( 82,K),K=1,4) / 518,2018,2068,2568/
  DATA (HERSH( 83,K),K=1,4) / 519,2019,2069,2569/
  DATA (HERSH( 84,K),K=1,4) / 520,2020,2070,2570/
  DATA (HERSH( 85,K),K=1,4) / 521,2021,2071,2571/
  DATA (HERSH( 86,K),K=1,4) / 522,2022,2072,2572/
  DATA (HERSH( 87,K),K=1,4) / 523,2023,2073,2573/
!   88:95 X Y Z bracketleft
!         backslash bracketright asciicircum underscore
  DATA (HERSH( 88,K),K=1,4) / 524,2024,2074,2574/
  DATA (HERSH( 89,K),K=1,4) / 525,2025,2075,2575/
  DATA (HERSH( 90,K),K=1,4) / 526,2026,2076,2576/
  DATA (HERSH( 91,K),K=1,4) /2223,2223,2223,2223/
  DATA (HERSH( 92,K),K=1,4) / 804, 804, 804, 804/
  DATA (HERSH( 93,K),K=1,4) /2224,2224,2224,2224/
  DATA (HERSH( 94,K),K=1,4) / 718,2218,2779,2779/
  DATA (HERSH( 95,K),K=1,4) / 590, 590, 590, 590/
!   96:103 quoteleft a b c d e f g
  DATA (HERSH( 96,K),K=1,4) /2249,2249,2249,2249/
  DATA (HERSH( 97,K),K=1,4) / 601,2101,2151,2651/
  DATA (HERSH( 98,K),K=1,4) / 602,2102,2152,2652/
  DATA (HERSH( 99,K),K=1,4) / 603,2103,2153,2653/
  DATA (HERSH(100,K),K=1,4) / 604,2104,2154,2654/
  DATA (HERSH(101,K),K=1,4) / 605,2105,2155,2655/
  DATA (HERSH(102,K),K=1,4) / 606,2106,2156,2656/
  DATA (HERSH(103,K),K=1,4) / 607,2107,2157,2657/
!  104:111 h i j k l m n o
  DATA (HERSH(104,K),K=1,4) / 608,2108,2158,2658/
  DATA (HERSH(105,K),K=1,4) / 609,2109,2159,2659/
  DATA (HERSH(106,K),K=1,4) / 610,2110,2160,2660/
  DATA (HERSH(107,K),K=1,4) / 611,2111,2161,2661/
  DATA (HERSH(108,K),K=1,4) / 612,2112,2162,2662/
  DATA (HERSH(109,K),K=1,4) / 613,2113,2163,2663/
  DATA (HERSH(110,K),K=1,4) / 614,2114,2164,2664/
  DATA (HERSH(111,K),K=1,4) / 615,2115,2165,2665/
!  112:119 p q r s t u v w
  DATA (HERSH(112,K),K=1,4) / 616,2116,2166,2666/
  DATA (HERSH(113,K),K=1,4) / 617,2117,2167,2667/
  DATA (HERSH(114,K),K=1,4) / 618,2118,2168,2668/
  DATA (HERSH(115,K),K=1,4) / 619,2119,2169,2669/
  DATA (HERSH(116,K),K=1,4) / 620,2120,2170,2670/
  DATA (HERSH(117,K),K=1,4) / 621,2121,2171,2671/
  DATA (HERSH(118,K),K=1,4) / 622,2122,2172,2672/
  DATA (HERSH(119,K),K=1,4) / 623,2123,2173,2673/
!  120:127 x y z braceleft bar braceright asciitilde -
  DATA (HERSH(120,K),K=1,4) / 624,2124,2174,2674/
  DATA (HERSH(121,K),K=1,4) / 625,2125,2175,2675/
  DATA (HERSH(122,K),K=1,4) / 626,2126,2176,2676/
  DATA (HERSH(123,K),K=1,4) /2225,2225,2225,2225/
  DATA (HERSH(124,K),K=1,4) / 723,2229,2229,2229/
  DATA (HERSH(125,K),K=1,4) /2226,2226,2226,2226/
  DATA (HERSH(126,K),K=1,4) /2246,2246,2246,2246/
  DATA (HERSH(127,K),K=1,4) / 699,2199,2199,2199/
!
! ISO Latin-1 upper half.
!
!  128:135 - - - - - - - -
  DATA (HERSH(128,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(129,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(130,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(131,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(132,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(133,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(134,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(135,K),K=1,4) / 699,2199,2199,2199/
!  136:143 - - - - - - - -
  DATA (HERSH(136,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(137,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(138,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(139,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(140,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(141,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(142,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(143,K),K=1,4) / 699,2199,2199,2199/
!   144:151 dotlessi grave acute circumflex tilde - breve dotaccent
  DATA (HERSH(144,K),K=1,4) / 699,2182,2196,2199/
  DATA (HERSH(145,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(146,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(147,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(148,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(149,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(150,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(151,K),K=1,4) / 699,2199,2199,2199/
!   152:159 dieresis - ring - - - - -
  DATA (HERSH(152,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(153,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(154,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(155,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(156,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(157,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(158,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(159,K),K=1,4) / 699,2199,2199,2199/
!   160:167 space exclamdown cent sterling currency yen brokenbar section
  DATA (HERSH(160,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(161,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(162,K),K=1,4) / 910, 910, 910, 910/
  DATA (HERSH(163,K),K=1,4) / 272, 272, 272, 272/
  DATA (HERSH(164,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(165,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(166,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(167,K),K=1,4) /2276,2276,2276,2276/
!   168:175 - copyright - - - - registered -
  DATA (HERSH(168,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(169,K),K=1,4) / 274, 274, 274, 274/
  DATA (HERSH(170,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(171,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(172,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(173,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(174,K),K=1,4) / 273, 273, 273, 273/
  DATA (HERSH(175,K),K=1,4) / 699,2199,2199,2199/
!   176:183 degree plusminus twosuperior threesuperior
!           acute mu paragraph periodcentered
  DATA (HERSH(176,K),K=1,4) / 718,2218,2779,2779/
  DATA (HERSH(177,K),K=1,4) /2233,2233,2233,2233/
  DATA (HERSH(178,K),K=1,4) / 702,2202,2752,2752/
  DATA (HERSH(179,K),K=1,4) / 703,2203,2753,2753/
  DATA (HERSH(180,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(181,K),K=1,4) / 638,2138,2138,2138/
  DATA (HERSH(182,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(183,K),K=1,4) / 729, 729, 729, 729/
!   184:191 cedilla onesuperior ordmasculine guillemotright
!           onequarter onehalf threequarters questiondown
  DATA (HERSH(184,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(185,K),K=1,4) / 701,2201,2751,2751/
  DATA (HERSH(186,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(187,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(188,K),K=1,4) / 270, 270, 270, 270/
  DATA (HERSH(189,K),K=1,4) / 261, 261, 261, 261/
  DATA (HERSH(190,K),K=1,4) / 271, 271, 271, 271/
  DATA (HERSH(191,K),K=1,4) / 699,2199,2199,2199/
!   192:199 Agrave Aacute Acircumflex Atilde Aring AE Ccedilla
  DATA (HERSH(192,K),K=1,4) / 501,2001,2051,2551/
  DATA (HERSH(193,K),K=1,4) / 501,2001,2051,2551/
  DATA (HERSH(194,K),K=1,4) / 501,2001,2051,2551/
  DATA (HERSH(195,K),K=1,4) / 501,2001,2051,2551/
  DATA (HERSH(196,K),K=1,4) / 501,2001,2051,2551/
  DATA (HERSH(197,K),K=1,4) / 501,2078,2051,2551/
  DATA (HERSH(198,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(199,K),K=1,4) / 503,2003,2053,2553/
!   200:207 Egrave Eacute Ecircumflex Edieresis
!           Igrave Iacute Icircumflex Idieresis
  DATA (HERSH(200,K),K=1,4) / 505,2005,2055,2555/
  DATA (HERSH(201,K),K=1,4) / 505,2005,2055,2555/
  DATA (HERSH(202,K),K=1,4) / 505,2005,2055,2555/
  DATA (HERSH(203,K),K=1,4) / 505,2005,2055,2555/
  DATA (HERSH(204,K),K=1,4) / 509,2009,2059,2559/
  DATA (HERSH(205,K),K=1,4) / 509,2009,2059,2559/
  DATA (HERSH(206,K),K=1,4) / 509,2009,2059,2559/
  DATA (HERSH(207,K),K=1,4) / 509,2009,2059,2559/
!   208:215 Eth Ntilde Ograve Oacute
!           Ocircumflex Otilde Odieresis multiply
  DATA (HERSH(208,K),K=1,4) / 504,2004,2054,2554/
  DATA (HERSH(209,K),K=1,4) / 514,2014,2064,2564/
  DATA (HERSH(210,K),K=1,4) / 515,2015,2065,2565/
  DATA (HERSH(211,K),K=1,4) / 515,2015,2065,2565/
  DATA (HERSH(212,K),K=1,4) / 515,2015,2065,2565/
  DATA (HERSH(213,K),K=1,4) / 515,2015,2065,2565/
  DATA (HERSH(214,K),K=1,4) / 515,2015,2065,2565/
  DATA (HERSH(215,K),K=1,4) /2235,2235,2235,2235/
!   216:223 Oslash Ugrave Uacute Ucircumflex
!           Udieresis Yacute Thorn germandbls
  DATA (HERSH(216,K),K=1,4) / 515,2015,2065,2565/
  DATA (HERSH(217,K),K=1,4) / 521,2021,2071,2571/
  DATA (HERSH(218,K),K=1,4) / 521,2021,2071,2571/
  DATA (HERSH(219,K),K=1,4) / 521,2021,2071,2571/
  DATA (HERSH(220,K),K=1,4) / 521,2021,2071,2571/
  DATA (HERSH(221,K),K=1,4) / 525,2025,2075,2575/
  DATA (HERSH(222,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(223,K),K=1,4) / 699,2199,2199,2199/
!   224:231 agrave aacute acircumflex atilde aring ae ccedilla
  DATA (HERSH(224,K),K=1,4) / 601,2101,2151,2651/
  DATA (HERSH(225,K),K=1,4) / 601,2101,2151,2651/
  DATA (HERSH(226,K),K=1,4) / 601,2101,2151,2651/
  DATA (HERSH(227,K),K=1,4) / 601,2101,2151,2651/
  DATA (HERSH(228,K),K=1,4) / 601,2101,2151,2651/
  DATA (HERSH(229,K),K=1,4) / 601,2101,2151,2651/
  DATA (HERSH(230,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(231,K),K=1,4) / 603,2103,2153,2653/
!   232:239 egrave eacute ecircumflex edieresis
!           igrave iacute icircumflex idieresis
  DATA (HERSH(232,K),K=1,4) / 605,2105,2155,2655/
  DATA (HERSH(233,K),K=1,4) / 605,2105,2155,2655/
  DATA (HERSH(234,K),K=1,4) / 605,2105,2155,2655/
  DATA (HERSH(235,K),K=1,4) / 605,2105,2155,2655/
  DATA (HERSH(236,K),K=1,4) / 609,2109,2159,2659/
  DATA (HERSH(237,K),K=1,4) / 609,2109,2159,2659/
  DATA (HERSH(238,K),K=1,4) / 609,2109,2159,2659/
  DATA (HERSH(239,K),K=1,4) / 609,2109,2159,2659/
!   240:247 eth ntilde ograve oacute
!           ocircumflex otilde odieresis divide
  DATA (HERSH(240,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(241,K),K=1,4) / 614,2114,2164,2664/
  DATA (HERSH(242,K),K=1,4) / 615,2115,2165,2665/
  DATA (HERSH(243,K),K=1,4) / 615,2115,2165,2665/
  DATA (HERSH(244,K),K=1,4) / 615,2115,2165,2665/
  DATA (HERSH(245,K),K=1,4) / 615,2115,2165,2665/
  DATA (HERSH(246,K),K=1,4) / 615,2115,2165,2665/
  DATA (HERSH(247,K),K=1,4) /2237,2237,2237,2237/
!   248:255 oslash ugrave uacute ucircumflex
!           udieresis yacute thorn ydieresis
  DATA (HERSH(248,K),K=1,4) / 615,2115,2165,2665/
  DATA (HERSH(249,K),K=1,4) / 621,2121,2171,2671/
  DATA (HERSH(250,K),K=1,4) / 621,2121,2171,2671/
  DATA (HERSH(251,K),K=1,4) / 621,2121,2171,2671/
  DATA (HERSH(252,K),K=1,4) / 621,2121,2171,2671/
  DATA (HERSH(253,K),K=1,4) / 625,2125,2175,2675/
  DATA (HERSH(254,K),K=1,4) / 699,2199,2199,2199/
  DATA (HERSH(255,K),K=1,4) / 625,2125,2175,2675/
!
! Greek alphabet.
!
  DATA (HERSH(256,K),K=1,4) / 527,2027,2027,2027/
  DATA (HERSH(257,K),K=1,4) / 528,2028,2028,2028/
  DATA (HERSH(258,K),K=1,4) / 529,2029,2029,2029/
  DATA (HERSH(259,K),K=1,4) / 530,2030,2030,2030/
  DATA (HERSH(260,K),K=1,4) / 531,2031,2031,2031/
  DATA (HERSH(261,K),K=1,4) / 532,2032,2032,2032/
  DATA (HERSH(262,K),K=1,4) / 533,2033,2033,2033/
  DATA (HERSH(263,K),K=1,4) / 534,2034,2034,2034/
  DATA (HERSH(264,K),K=1,4) / 535,2035,2035,2035/
  DATA (HERSH(265,K),K=1,4) / 536,2036,2036,2036/
  DATA (HERSH(266,K),K=1,4) / 537,2037,2037,2037/
  DATA (HERSH(267,K),K=1,4) / 538,2038,2038,2038/
  DATA (HERSH(268,K),K=1,4) / 539,2039,2039,2039/
  DATA (HERSH(269,K),K=1,4) / 540,2040,2040,2040/
  DATA (HERSH(270,K),K=1,4) / 541,2041,2041,2041/
  DATA (HERSH(271,K),K=1,4) / 542,2042,2042,2042/
  DATA (HERSH(272,K),K=1,4) / 543,2043,2043,2043/
  DATA (HERSH(273,K),K=1,4) / 544,2044,2044,2044/
  DATA (HERSH(274,K),K=1,4) / 545,2045,2045,2045/
  DATA (HERSH(275,K),K=1,4) / 546,2046,2046,2046/
  DATA (HERSH(276,K),K=1,4) / 547,2047,2047,2047/
  DATA (HERSH(277,K),K=1,4) / 548,2048,2048,2048/
  DATA (HERSH(278,K),K=1,4) / 549,2049,2049,2049/
  DATA (HERSH(279,K),K=1,4) / 550,2050,2050,2050/
  DATA (HERSH(280,K),K=1,4) / 627,2127,2127,2127/
  DATA (HERSH(281,K),K=1,4) / 628,2128,2128,2128/
  DATA (HERSH(282,K),K=1,4) / 629,2129,2129,2129/
  DATA (HERSH(283,K),K=1,4) / 630,2130,2130,2130/
  DATA (HERSH(284,K),K=1,4) / 684,2184,2184,2184/
  DATA (HERSH(285,K),K=1,4) / 632,2132,2132,2132/
  DATA (HERSH(286,K),K=1,4) / 633,2133,2133,2133/
  DATA (HERSH(287,K),K=1,4) / 685,2185,2185,2185/
  DATA (HERSH(288,K),K=1,4) / 635,2135,2135,2135/
  DATA (HERSH(289,K),K=1,4) / 636,2136,2136,2136/
  DATA (HERSH(290,K),K=1,4) / 637,2137,2137,2137/
  DATA (HERSH(291,K),K=1,4) / 638,2138,2138,2138/
  DATA (HERSH(292,K),K=1,4) / 639,2139,2139,2139/
  DATA (HERSH(293,K),K=1,4) / 640,2140,2140,2140/
  DATA (HERSH(294,K),K=1,4) / 641,2141,2141,2141/
  DATA (HERSH(295,K),K=1,4) / 642,2142,2142,2142/
  DATA (HERSH(296,K),K=1,4) / 643,2143,2143,2143/
  DATA (HERSH(297,K),K=1,4) / 644,2144,2144,2144/
  DATA (HERSH(298,K),K=1,4) / 645,2145,2145,2145/
  DATA (HERSH(299,K),K=1,4) / 646,2146,2146,2146/
  DATA (HERSH(300,K),K=1,4) / 686,2186,2186,2186/
  DATA (HERSH(301,K),K=1,4) / 648,2148,2148,2148/
  DATA (HERSH(302,K),K=1,4) / 649,2149,2149,2149/
  DATA (HERSH(303,K),K=1,4) / 650,2150,2150,2150/
!
  IF ((CODE<0) .OR. (CODE>303)) THEN
    I = 1
  ELSE
    I = CODE
  END IF
  SYMBOL = HERSH(I,FONT)
!
  END

!*GRSYXD -- obtain the polyline representation of a given symbol
!+
  SUBROUTINE GRSYXD (SYMBOL, XYGRID, UNUSED)
  INTEGER SYMBOL
  INTEGER XYGRID(300)
  LOGICAL UNUSED
!
! Return the digitization coordinates of a character. Each character is
! defined on a grid with X and Y coordinates in the range (-49,49),
! with the origin (0,0) at the center of the character.  The coordinate
! system is right-handed, with X positive to the right, and Y positive
! upward.
!
! Arguments:
!  SYMBOL (input)  : symbol number in range (1..3000).
!  XYGRID (output) : height range, width range, and pairs of (x,y)
!                    coordinates returned.  Height range = (XYGRID(1),
!                    XYGRID(3)).  Width range = (XYGRID(4),XYGRID(5)).
!                    (X,Y) = (XYGRID(K),XYGRID(K+1)) (K=6,8,...).
!  UNUSED (output) : receives .TRUE. if SYMBOL is an unused symbol
!                    number. A character of normal height and zero width
!                    is returned. Receives .FALSE. if SYMBOL is a
!                    valid symbol number.
!
! The height range consists of 3 values: (minimum Y, baseline Y,
! maximum Y).  The first is reached by descenders on lower-case g, p,
! q, and y.  The second is the bottom of upper-case letters.  The third
! is the top of upper-case letters.  A coordinate pair (-64,0) requests
! a pen raise, and a pair (-64,-64) terminates the coordinate list. It
! is assumed that movement to the first coordinate position will be
! done with the pen raised - no raise command is explicitly included to
! do this.
!--
!  7-Mar-1983.
! 15-Dec-1988 - standardize.
!-----------------------------------------------------------------------
  INTEGER*2    BUFFER(27000)
  INTEGER      INDEX(3000), IX, IY, K, L, LOCBUF
  INTEGER      NC1, NC2
  COMMON       /GRSYMB/ NC1, NC2, INDEX, BUFFER
!
! Extract digitization.
!
  IF (SYMBOL<NC1 .OR. SYMBOL>NC2) GOTO 3000
  L = SYMBOL - NC1 + 1
  LOCBUF = INDEX(L)
  IF (LOCBUF == 0) GOTO 3000
  XYGRID(1) = BUFFER(LOCBUF)
  LOCBUF = LOCBUF + 1
  K = 2
  IY = -1
!     -- DO WHILE (IY.NE.-64)
  100 IF (IY/=-64) THEN
    IX = BUFFER(LOCBUF)/128
    IY = BUFFER(LOCBUF) - 128*IX - 64
    XYGRID(K) = IX - 64
    XYGRID(K+1) = IY
    K = K + 2
    LOCBUF = LOCBUF + 1
  GOTO 100
  END IF
!     -- end DO WHILE
  UNUSED = .FALSE.
  RETURN
!
! Unimplemented character.
!
  3000  XYGRID(1) = -16
  XYGRID(2) =  -9
  XYGRID(3) = +12
  XYGRID(4) =   0
  XYGRID(5) =   0
  XYGRID(6) = -64
  XYGRID(7) = -64
  UNUSED = .TRUE.
  RETURN
  END


!*GRTERM -- flush buffer to output device
!+
  SUBROUTINE GRTERM
!
! GRPCKG: flush the buffer associated with the current plot. GRTERM
! should be called only when it is necessary to make sure that all the
! graphics created up to this point in the program are visible on the
! device, e.g., before beginning a dialog with the user. GRTERM has no
! effect on hardcopy devices.
!
! Arguments: none.
!--
!  6-Oct-1983
! 29-Jan-1985 - add HP2648 device [KS/TJP].
! 31-Dec-1985 - do not send CAN code to true Tek [TJP/PCP].
!  5-Aug-1986 - add GREXEC support [AFT].
! 11-Jun-1987 - remove built-in devices [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER NBUF,LCHR
  REAL    RBUF(6)
  CHARACTER CHR
!
  IF (GRCIDE>=1) THEN
    CALL GREXEC(GRGTYP,16,RBUF,NBUF,CHR,LCHR)
  END IF
  END

!*GRTEXT -- draw text
!+
  SUBROUTINE GRTEXT (CENTER,ORIENT,ABSXY,X0,Y0,STRING)
!
! GRPCKG: Write a text string using the high-quality character set.
! The text is NOT windowed in the current viewport, but may extend over
! the whole view surface.  Line attributes (color, intensity thickness)
! apply to text, but line-style is ignored.  The current pen position
! after a call to GRTEXT is undefined.
!
! Arguments:
!
! STRING (input, character): the character string to be plotted. This
!       may include standard escape-sequences to represent non-ASCII
!       characters and special commands. The number of characters in
!       STRING (i.e., LEN(STRING)) should not exceed 256.
!--
! (3-May-1983)
!  5-Aug-1986 - add GREXEC support [AFT].
!  6-Sep-1989 - standardize [TJP].
! 20-Apr-1995 - Verbose PS file support.  If PGPLOT_PS_VERBOSE_TEXT is
!               defined, text strings in PS files are preceded by a
!               comment with the text of the string plotted as vectors
!               [TJP after D.S.Briggs].
!  4-Feb-1997 - grexec requires an RBUF array, not a scalar [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  LOGICAL ABSXY,UNUSED,VISBLE,CENTER
  INTEGER XYGRID(300)
  INTEGER LIST(256)
  CHARACTER*(*) STRING
  REAL ANGLE, FACTOR, FNTBAS, FNTFAC, COSA, SINA, DX, DY, XORG, YORG
  REAL XCUR, YCUR, ORIENT, RATIO, X0, Y0, RLX, RLY
  REAL XMIN, XMAX, YMIN, YMAX
  REAL RBUF(6)
  INTEGER I, IFNTLV,NLIST,LX,LY, K, LXLAST,LYLAST, LSTYLE
  INTEGER SLEN, GRTRIM
  INTRINSIC ABS, COS, LEN, MIN, SIN
  CHARACTER DEVTYP*14, STEMP*258
  LOGICAL DEVINT, VTEXT
!
! Check that there is something to be plotted.
!
  IF (LEN(STRING)<=0) RETURN
!
! Check that a device is selected.
!
  IF (GRCIDE<1) THEN
    CALL GRWARN('GRTEXT - no graphics device is active.')
    RETURN
  END IF
!
! Save current line-style, and set style "normal".
!
  CALL GRQLS(LSTYLE)
  CALL GRSLS(1)
!
! Put device dependent code here or at end
!
  VTEXT = .FALSE.
  CALL GRQTYP (DEVTYP, DEVINT)
  IF ((DEVTYP=='PS').OR.(DEVTYP=='VPS').OR. &
      (DEVTYP=='CPS').OR.(DEVTYP=='VCPS')) THEN
   CALL GRGENV ('PS_VERBOSE_TEXT', STEMP, I)
   VTEXT = (I>0)
   IF (VTEXT) THEN
      SLEN = GRTRIM(STRING)
      STEMP = '% Start "' // STRING(1:SLEN) // '"'
      CALL GREXEC (GRGTYP, 23, RBUF, 0, STEMP, SLEN+10)
   END IF
  END IF
!
! Save current viewport, and open the viewport to include the full
! view surface.
!
  XORG = GRXPRE(GRCIDE)
  YORG = GRYPRE(GRCIDE)
  XMIN = GRXMIN(GRCIDE)
  XMAX = GRXMAX(GRCIDE)
  YMIN = GRYMIN(GRCIDE)
  YMAX = GRYMAX(GRCIDE)
  CALL GRAREA(GRCIDE, 0.0, 0.0, 0.0, 0.0)
!
! Compute scaling and orientation.
!
  ANGLE = ORIENT*(3.14159265359/180.)
  FACTOR = GRCFAC(GRCIDE)/2.5
  RATIO = GRPXPI(GRCIDE)/GRPYPI(GRCIDE)
  COSA = FACTOR * COS(ANGLE)
  SINA = FACTOR * SIN(ANGLE)
  CALL GRTXY0(ABSXY, X0, Y0, XORG, YORG)
  FNTBAS = 0.0
  FNTFAC = 1.0
  IFNTLV = 0
  DX = 0.0
  DY = 0.0
!
! Convert the string to a list of symbol numbers; to prevent overflow
! of array LIST, the length of STRING is limited to 256 characters.
!
  CALL GRSYDS(LIST,NLIST,STRING(1:MIN(256,LEN(STRING))), &
               GRCFNT(GRCIDE))
!
! Plot the string of characters
!
  DO 380 I = 1,NLIST
    IF (LIST(I)<0) THEN
        IF (LIST(I)==-1) THEN
!                 ! up
            IFNTLV = IFNTLV+1
            FNTBAS = FNTBAS + 16.0*FNTFAC
            FNTFAC = 0.75**ABS(IFNTLV)
        ELSE IF (LIST(I)==-2) THEN
!                 ! down
            IFNTLV = IFNTLV-1
            FNTFAC = 0.75**ABS(IFNTLV)
            FNTBAS = FNTBAS - 16.0*FNTFAC
        ELSE IF (LIST(I)==-3) THEN
!                 ! backspace
            XORG = XORG - DX*FNTFAC
            YORG = YORG - DY*FNTFAC
        END IF
        GOTO 380
    END IF
    CALL GRSYXD(LIST(I),XYGRID,UNUSED)
    VISBLE = .FALSE.
    LX = XYGRID(5)-XYGRID(4)
    DX = COSA*LX*RATIO
    DY = SINA*LX
    K = 4
    LXLAST = -64
    LYLAST = -64
  320     K = K+2
    LX = XYGRID(K)
    LY = XYGRID(K+1)
    IF (LY==-64) GOTO 330
    IF (LX==-64) THEN
        VISBLE = .FALSE.
    ELSE
        RLX = (LX - XYGRID(4))*FNTFAC
        RLY = (LY - XYGRID(2))*FNTFAC + FNTBAS
        IF ((LX/=LXLAST) .OR. (LY/=LYLAST)) THEN
            XCUR = XORG + (COSA*RLX - SINA*RLY)*RATIO
            YCUR = YORG + (SINA*RLX + COSA*RLY)
            IF (VISBLE) THEN
                CALL GRLIN0(XCUR,YCUR)
            ELSE
                GRXPRE(GRCIDE) = XCUR
                GRYPRE(GRCIDE) = YCUR
            END IF
        END IF
        VISBLE = .TRUE.
        LXLAST = LX
        LYLAST = LY
    END IF
    GOTO 320
  330     XORG = XORG + DX*FNTFAC
    YORG = YORG + DY*FNTFAC
  380 CONTINUE
!
! Set pen position ready for next character.
!
  GRXPRE(GRCIDE) = XORG
  GRYPRE(GRCIDE) = YORG
!
! Another possible device dependent section
!
  IF (VTEXT) THEN
   STEMP = '% End "' // STRING(1:SLEN) // '"'
   CALL GREXEC(GRGTYP, 23, RBUF, 0, STEMP, SLEN+8)
  END IF
!
! Restore the viewport and line-style, and return.
!
  GRXMIN(GRCIDE) = XMIN
  GRXMAX(GRCIDE) = XMAX
  GRYMIN(GRCIDE) = YMIN
  GRYMAX(GRCIDE) = YMAX
  CALL GRSLS(LSTYLE)
!
  END


!*GRTOUP -- convert character string to upper case
!+
  SUBROUTINE GRTOUP (DST, SRC)
  CHARACTER*(*) DST, SRC
!
! GRPCKG (internal routine): convert character string to upper case.
!
! Arguments:
!  DST    (output) : output string (upper case).
!  SRC    (input)  : input string to be converted.
!--
! 1988-Jan-18 (TJP)
!-----------------------------------------------------------------------
  INTEGER I, N, NCHI, NCHO, NCH
  NCHI = LEN(SRC)
  NCHO = LEN(DST)
  NCH = MIN(NCHI, NCHO)
  DO 10 I=1,NCH
    N = ICHAR(SRC(I:I))
    IF ((N >= 97) .AND. (N <= 122)) THEN
        DST(I:I) = CHAR(N - 32)
    ELSE
        DST(I:I) = CHAR(N)
    END IF
   10 CONTINUE
  IF (NCHO > NCHI) DST(NCHI+1:NCHO) = ' '
  END

!*GRTRIM -- length of string excluding trailing blanks
!+
  INTEGER FUNCTION GRTRIM(S)
  CHARACTER*(*) S
!
! Find the length of a character string excluding trailing blanks.
! A blank string returns a value of 0.
!
! Argument:
!  S      (input)  : character string.
!
! Returns:
!  GRTRIM          : number of characters in S, excluding trailing
!                    blanks, in range 0...LEN(S). A blank string
!                    returns a value of 0.
!
! Subroutines required:
!  None
!
! Fortran 77 extensions:
!  None
!
! History:
!  1987 Nov 12 - TJP.
!-----------------------------------------------------------------------
  INTEGER  I
!
  IF (S==' ') THEN
    GRTRIM = 0
  ELSE
    DO 10 I=LEN(S),1,-1
        GRTRIM = I
        IF (S(I:I)/=' ') GOTO 20
   10     CONTINUE
    GRTRIM = 0
   20     CONTINUE
  END IF
  END


!*GRTRML -- get name of user's terminal (UNIX)
!+
  SUBROUTINE GRTRML(STRING, L)
  CHARACTER*(*) STRING
  INTEGER L
!
! Return the device name of the user's terminal, if any. In Sun/Convex-UNIX,
! the name of the terminal is always /dev/tty.
!
! Arguments:
!  STRING : receives the terminal name, truncated or extended with
!           blanks as necessary.
!  L      : receives the number of characters in STRING, excluding
!           trailing blanks. If there is not attached terminal,
!           zero is returned.
!--
! 19-Jan-1988
!-----------------------------------------------------------------------
  STRING = '/dev/tty'
  L = MIN(LEN(STRING),8)
  END


!*GRTRN0 -- define scaling transformation
!+
  SUBROUTINE GRTRN0 (XORG,YORG,XSCALE,YSCALE)
!
! GRPCKG (internal routine): Define scaling transformation for current
! device (equivalent to GRTRAN without device selection).
!
! Arguments:
!
! XORG, YORG, XSCALE, YSCALE (input, real): parameters of the scaling
!       transformation. This is defined by:
!               XABS = XORG + XWORLD * XSCALE,
!               YABS = YORG + YWORLD * YSCALE,
!       where (XABS, YABS) are the absolute device coordinates
!       corresponding to world coordinates (XWORLD, YWORLD).
!--
!  1-Feb-83:
! 11-Feb-92: Add driver support (TJP).
!  1-Sep-94: Suppress driver call (TJP).
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  REAL     XORG, YORG, XSCALE, YSCALE
  REAL           RBUF(6)
  INTEGER        NBUF,LCHR
  CHARACTER*16   CHR
!
  GRXORG(GRCIDE) = XORG
  GRXSCL(GRCIDE) = XSCALE
  GRYORG(GRCIDE) = YORG
  GRYSCL(GRCIDE) = YSCALE
!
! Pass info to device driver?
!
  IF (GRGCAP(GRCIDE)(2:2)=='X') THEN
    RBUF(1) = XORG
    RBUF(2) = XSCALE
    RBUF(3) = YORG
    RBUF(4) = YSCALE
    NBUF = 4
    LCHR = 0
    CALL GREXEC(GRGTYP,27,RBUF,NBUF,CHR,LCHR)
  END IF
!
  END


!*GRTTER -- test whether device is user's terminal (Sun/Convex-UNIX)
!+
  SUBROUTINE GRTTER(STRING, SAME)
  CHARACTER*(*) STRING
  LOGICAL SAME
!
! Return a logical flag indicating whether the supplied device
! name is a name for the user's controlling terminal or not.
! (Some PGPLOT programs wish to take special action if they are
! plotting on the user's terminal.)
!
! Arguments:
!  STRING : (input) the device name to be tested.
!  SAME   : (output) .TRUE. is STRING contains a valid name for the
!           user's terminal; .FALSE. otherwise.
!--
! 18-Feb-1988
!-----------------------------------------------------------------------
  CHARACTER*64 T
  INTEGER L
!
  CALL GRTRML(T, L)
  SAME = (STRING==T(:L))
  END


!*GRTXY0 -- convert world coordinates to device coordinates
!+
  SUBROUTINE GRTXY0 (ABSXY,X,Y,XT,YT)
!
! GRPCKG (internal routine): Convert scaled position to absolute
! position.
!
! Arguments:
!
! ABSXY (input, logical): if FALSE, convert world coordinates to
!       absolute device coordinates; if TRUE, return the input
!       coordinates unchanged.
! X, Y (input, real): input coordinates (absolute or world, depending
!       on setting of ABSXY).
! XT, YT (output, real): output absolute device coordinates.
!--
! (1-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  LOGICAL  ABSXY
  REAL     X, Y, XT, YT
!
  IF (ABSXY) THEN
    XT = X
    YT = Y
  ELSE
    XT = X * GRXSCL(GRCIDE) + GRXORG(GRCIDE)
    YT = Y * GRYSCL(GRCIDE) + GRYORG(GRCIDE)
  END IF
!
  END


!*GRVCT0 -- draw line segments or dots
!+
  SUBROUTINE GRVCT0 (MODE,ABSXY,POINTS,X,Y)
!
! GRPCKG (internal routine): Draw a line or a set of dots. This
! is the same as GRVECT, but without device selection. It can be used to
! draw a single line-segment, a continuous series of line segments, or
! one or more single dots (pixels).
!
! Arguments:
!
! MODE (input, integer): if MODE=1, a series of line segments is drawn,
!       starting at the current position, moving to X(1),Y(1), ... and
!       ending at X(POINTS),Y(POINTS).
!       If MODE=2, the first vector is blanked, so the line starts at
!       X(1),Y(1).
!       If MODE=3, a single dot is placed at each coordinate pair, with
!       no connecting lines.
! ABSXY (input, logical): if TRUE, the coordinates are absolute device
!       coordinates; if FALSE, they are world coordinates and the
!       scaling transformation is applied.
! POINTS (input, integer): the number of coordinate pairs.
! X, Y (input, real arrays, dimensioned POINTS or greater): the
!       X and Y coordinates of the points.
!--
! (1-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'grpckg1.h'
  INTEGER  I, MODE, POINTS
  LOGICAL  ABSXY
  REAL     X(POINTS), Y(POINTS), XCUR, YCUR
!
  IF (MODE==1) THEN
    CALL GRTXY0(ABSXY, X(1), Y(1), XCUR, YCUR)
    CALL GRLIN0(XCUR, YCUR)
  ELSE IF (MODE==2) THEN
    CALL GRTXY0(ABSXY, X(1), Y(1), GRXPRE(GRCIDE), GRYPRE(GRCIDE))
  END IF
  IF (MODE==1 .OR. MODE==2) THEN
    DO 10 I=2,POINTS
        CALL GRTXY0(ABSXY, X(I), Y(I), XCUR, YCUR)
        CALL GRLIN0(XCUR, YCUR)
   10     CONTINUE
  ELSE IF (MODE==3) THEN
    DO 20 I=1,POINTS
        CALL GRTXY0(ABSXY, X(I), Y(I), XCUR, YCUR)
        CALL GRDOT0(XCUR, YCUR)
   20     CONTINUE
  END IF
!
  END

!*GRWARN -- issue warning message to user
!+
  SUBROUTINE GRWARN (TEXT)
  CHARACTER*(*) TEXT
!
! Report a warning message on standard output, with prefix "%PGPLOT, ".
!
! Argument:
!  TEXT (input): text of message to be printed (the string
!      may not be blank).
!--
!  8-Nov-1994 [TJP]
!-----------------------------------------------------------------------
  INTEGER   GRTRIM
!
  IF (TEXT/=' ') THEN
    WRITE (*, '(1X,2A)') '%PGPLOT, ', TEXT(1:GRTRIM(TEXT))
  END IF
  END

!*GRXHLS -- convert RGB color to HLS color
!+
  SUBROUTINE GRXHLS (R,G,B,H,L,S)
!
! GRPCKG: Convert a color specified in the RGB color model to one in
! the HLS model.  This is a support routine: no graphics I/O occurs.
! The inverse transformation is accomplished with routine GRXRGB.
! Reference: SIGGRAPH Status Report of the Graphic Standards Planning
! Committee, Computer Graphics, Vol.13, No.3, Association for
! Computing Machinery, New York, NY, 1979.
!
! Arguments:
!
! R,G,B (real, input): red, green, blue color coordinates, each in the
!       range 0.0 to 1.0. Input outside this range causes HLS = (0,1,0)
!       [white] to be returned.
! H,L,S (real, output): hue (0 to 360), lightness (0 to 1.0), and
!       saturation (0 to 1.0).
!--
!  2-Jul-1984 - new routine [TJP].
! 29-Sep-1994 - force H to be in rnage 0-360 [Remko Scharroo; TJP].
!-----------------------------------------------------------------------
  REAL     R,G,B, H,L,S, MA, MI, RR, GG, BB, D
!
  H = 0.0
  L = 1.0
  S = 0.0
  MA = MAX(R,G,B)
  MI = MIN(R,G,B)
  IF (MA>1.0 .OR. MI<0.0) RETURN
  RR = (MA-R)
  GG = (MA-G)
  BB = (MA-B)
!
! Lightness
!
  L = 0.5*(MA+MI)
!
! Achromatic case (R=G=B)
!
  IF (MA==MI) THEN
    S = 0.0
    H = 0.0
!
! Chromatic case
!
  ELSE
!         -- Saturation
    D = MA-MI
    IF (L<=0.5) THEN
        S = D/(MA+MI)
    ELSE
        S = D/(2.0-MA-MI)
    END IF
!         -- Hue
    IF (R==MA) THEN
!             -- yellow to magenta
        H = (2.0*D+BB-GG)
    ELSE IF (G==MA) THEN
        H = (4.0*D+RR-BB)
    ELSE
!             ! (B.EQ.MA)
        H = (6.0*D+GG-RR)
    END IF
    H = MOD(H*60.0/D,360.0)
    IF (H<0.0) H = H+360.0
  END IF
!
  END

!*GRXRGB -- convert HLS color to RGB color
!+
  SUBROUTINE GRXRGB (H,L,S,R,G,B)
!
! GRPCKG: Convert a color specified in the HLS color model to one in
! the RGB model.  This is a support routine: no graphics I/O occurs.
! The inverse transformation is accomplished with routine GRXHLS.
! Reference: SIGGRAPH Status Report of the Graphic Standards Planning
! Committee, Computer Graphics, Vol.13, No.3, Association for
! Computing Machinery, New York, NY, 1979.
!
! Arguments:
!
! H,L,S (real, input): hue (0 to 360), lightness (0 to 1.0), and
!       saturation (0 to 1.0).
! R,G,B (real, output): red, green, blue color coordinates, each in the
!       range 0.0 to 1.0.
!--
!  2-Jul-1984 - new routine [TJP].
! 29-Sep-1994 - take H module 360 [TJP].
! 26-Nov-1996 - force results to be in range (avoid rounding error
!               problems on some machines) [TJP].
!-----------------------------------------------------------------------
  REAL     H,L,S, R,G,B, MA, MI, HM
!
  HM = MOD(H, 360.0)
  IF (HM<0.0) HM = HM+360.0
  IF (L<=0.5) THEN
    MA = L*(1.0+S)
  ELSE
    MA = L + S - L*S
  END IF
  MI = 2.0*L-MA
!
! R component
!
  IF (HM<60.0) THEN
    R = MI + (MA-MI)*HM/60.0
  ELSE IF (HM<180.0) THEN
    R = MA
  ELSE IF (HM<240.0) THEN
    R = MI + (MA-MI)*(240.0-HM)/60.0
  ELSE
    R = MI
  END IF
!
! G component
!
  IF (HM<120.0) THEN
    G = MI
  ELSE IF (HM<180.0) THEN
    G = MI + (MA-MI)*(HM-120.0)/60.0
  ELSE IF (HM<300.0) THEN
    G = MA
  ELSE
    G = MI + (MA-MI)*(360.0-HM)/60.0
  END IF
!
! B component
!
  IF (HM<60.0 .OR. HM>=300.0) THEN
    B = MA
  ELSE IF (HM<120.0) THEN
    B = MI + (MA-MI)*(120.0-HM)/60.0
  ELSE IF (HM<240.0) THEN
    B = MI
  ELSE
    B = MI + (MA-MI)*(HM-240.0)/60.0
  END IF
!
  R = MIN(1.0, MAX(0.0,R))
  G = MIN(1.0, MAX(0.0,G))
  B = MIN(1.0, MAX(0.0,B))
!
  END

!*PGADVANCE -- non-standard alias for PGPAGE
!+
  SUBROUTINE PGADVANCE
!
! See description of PGPAGE.
!--
  CALL PGPAGE
  END

!*PGARRO -- draw an arrow
!%void cpgarro(float x1, float y1, float x2, float y2);
!+
  SUBROUTINE PGARRO (X1, Y1, X2, Y2)
  REAL X1, Y1, X2, Y2
!
! Draw an arrow from the point with world-coordinates (X1,Y1) to
! (X2,Y2). The size of the arrowhead at (X2,Y2) is determined by
! the current character size set by routine PGSCH. The default size
! is 1/40th of the smaller of the width or height of the view surface.
! The appearance of the arrowhead (shape and solid or open) is
! controlled by routine PGSAH.
!
! Arguments:
!  X1, Y1 (input)  : world coordinates of the tail of the arrow.
!  X2, Y2 (input)  : world coordinates of the head of the arrow.
!--
!  7-Feb-92 Keith Horne @ STScI / TJP.
! 13-Oct-92 - use arrowhead attributes; scale (TJP).
!-----------------------------------------------------------------------
  INTEGER AHFS, FS
  REAL DX, DY, XV1, XV2, YV1, YV2, XL, XR, YB, YT, DINDX, DINDY
  REAL XINCH, YINCH, RINCH, CA, SA, SO, CO, YP, XP, YM, XM, DHX, DHY
  REAL PX(4), PY(4)
  REAL AHANGL, AHVENT, SEMANG, CH, DH, XS1, XS2, YS1, YS2
!
  CALL PGBBUF
  CALL PGQAH(AHFS, AHANGL, AHVENT)
  CALL PGQFS(FS)
  CALL PGSFS(AHFS)
  DX = X2 - X1
  DY = Y2 - Y1
  CALL PGQCH(CH)
  CALL PGQVSZ(1, XS1, XS2, YS1, YS2)
!     -- length of arrowhead: 1 40th of the smaller of the height or
!        width of the view surface, scaled by character height.
  DH = CH*MIN(ABS(XS2-XS1),ABS(YS2-YS1))/40.0
  CALL PGMOVE(X2, Y2)
!     -- Is there to be an arrowhead ?
  IF (DH>0.) THEN
    IF (DX/=0. .OR. DY/=0.) THEN
!             -- Get x and y scales
        CALL PGQVP(1, XV1, XV2, YV1, YV2)
        CALL PGQWIN(XL, XR, YB, YT)
        IF (XR/=XL .AND. YT/=YB) THEN
            DINDX = (XV2 - XV1) / (XR - XL)
            DINDY = (YV2 - YV1) / (YT - YB)
            DHX = DH / DINDX
            DHY = DH / DINDY
!                 -- Unit vector in direction of the arrow
            XINCH = DX * DINDX
            YINCH = DY * DINDY
            RINCH = SQRT(XINCH*XINCH + YINCH*YINCH)
            CA = XINCH / RINCH
            SA = YINCH / RINCH
!                 -- Semiangle in radians
            SEMANG = AHANGL/2.0/57.296
            SO = SIN(SEMANG)
            CO = -COS(SEMANG)
!                 -- Vector back along one edge of the arrow
            XP = DHX * (CA*CO - SA*SO)
            YP = DHY * (SA*CO + CA*SO)
!                 -- Vector back along other edge of the arrow
            XM = DHX * (CA*CO + SA*SO)
            YM = DHY * (SA*CO - CA*SO)
!                 -- Draw the arrowhead
            PX(1) = X2
            PY(1) = Y2
            PX(2) = X2 + XP
            PY(2) = Y2 + YP
            PX(3) = X2 + 0.5*(XP+XM)*(1.0-AHVENT)
            PY(3) = Y2 + 0.5*(YP+YM)*(1.0-AHVENT)
            PX(4) = X2 + XM
            PY(4) = Y2 + YM
            CALL PGPOLY(4, PX, PY)
            CALL PGMOVE(PX(3), PY(3))
        END IF
    END IF
  END IF
  CALL PGDRAW(X1, Y1)
  CALL PGMOVE(X2,Y2)
  CALL PGSFS(FS)
  CALL PGEBUF
  RETURN
  END

!*PGASK -- control new page prompting
!%void cpgask(Logical flag);
!+
  SUBROUTINE PGASK (FLAG)
  LOGICAL FLAG
!
! Change the ``prompt state'' of PGPLOT. If the prompt state is
! ON, PGPAGE will type ``Type RETURN for next page:'' and will wait
! for the user to type a carriage-return before starting a new page.
! The initial prompt state (after the device has been opened) is ON
! for interactive devices. Prompt state is always OFF for
! non-interactive devices.
!
! Arguments:
!  FLAG   (input)  : if .TRUE., and if the device is an interactive
!                    device, the prompt state will be set to ON. If
!                    .FALSE., the prompt state will be set to OFF.
!--
!-----------------------------------------------------------------------
  INCLUDE     'pgplot.h'
  LOGICAL     PGNOTO
  CHARACTER*1 TYPE
!
  IF (PGNOTO('PGASK')) RETURN
!
  IF (FLAG) THEN
    CALL GRQTYP(TYPE,PGPRMP(PGID))
  ELSE
    PGPRMP(PGID) = .FALSE.
  END IF
  END

!*PGAXIS -- draw an axis
!%void cpgaxis(const char *opt, float x1, float y1, float x2, float y2, \
!%             float v1, float v2, float step, int nsub, float dmajl, \
!%             float dmajr, float fmin, float disp, float orient);
!+
  SUBROUTINE PGAXIS (OPT, X1, Y1, X2, Y2, V1, V2, STEP, NSUB, &
                     DMAJL, DMAJR, FMIN, DISP, ORIENT)
  CHARACTER*(*) OPT
  REAL X1, Y1, X2, Y2, V1, V2, STEP, DMAJL, DMAJR, FMIN, DISP
  REAL ORIENT
  INTEGER NSUB
!
! Draw a labelled graph axis from world-coordinate position (X1,Y1) to
! (X2,Y2).
!
! Normally, this routine draws a standard LINEAR axis with equal
! subdivisions.   The quantity described by the axis runs from V1 to V2;
! this may be, but need not be, the same as X or Y.
!
! If the 'L' option is specified, the routine draws a LOGARITHMIC axis.
! In this case, the quantity described by the axis runs from 10**V1 to
! 10**V2. A logarithmic axis always has major, labeled, tick marks
! spaced by one or more decades. If the major tick marks are spaced
! by one decade (as specified by the STEP argument), then minor
! tick marks are placed at 2, 3, .., 9 times each power of 10;
! otherwise minor tick marks are spaced by one decade. If the axis
! spans less than two decades, numeric labels are placed at 1, 2, and
! 5 times each power of ten.
!
! If the axis spans less than one decade, or if it spans many decades,
! it is preferable to use a linear axis labeled with the logarithm of
! the quantity of interest.
!
! Arguments:
!  OPT    (input)  : a string containing single-letter codes for
!                    various options. The options currently
!                    recognized are:
!                    L : draw a logarithmic axis
!                    N : write numeric labels
!                    1 : force decimal labelling, instead of automatic
!                        choice (see PGNUMB).
!                    2 : force exponential labelling, instead of
!                        automatic.
!  X1, Y1 (input)  : world coordinates of one endpoint of the axis.
!  X2, Y2 (input)  : world coordinates of the other endpoint of the axis.
!  V1     (input)  : axis value at first endpoint.
!  V2     (input)  : axis value at second endpoint.
!  STEP   (input)  : major tick marks are drawn at axis value 0.0 plus
!                    or minus integer multiples of STEP. If STEP=0.0,
!                    a value is chosen automatically.
!  NSUB   (input)  : minor tick marks are drawn to divide the major
!                    divisions into NSUB equal subdivisions (ignored if
!                    STEP=0.0). If NSUB <= 1, no minor tick marks are
!                    drawn. NSUB is ignored for a logarithmic axis.
!  DMAJL  (input)  : length of major tick marks drawn to left of axis
!                    (as seen looking from first endpoint to second), in
!                    units of the character height.
!  DMAJR  (input)  : length of major tick marks drawn to right of axis,
!                    in units of the character height.
!  FMIN   (input)  : length of minor tick marks, as fraction of major.
!  DISP   (input)  : displacement of baseline of tick labels to
!                    right of axis, in units of the character height.
!  ORIENT (input)  : orientation of label text, in degrees; angle between
!                    baseline of text and direction of axis (0-360).
!--
! 25-Mar-1997 - new routine [TJP].
!-----------------------------------------------------------------------
  REAL V, VMIN, VMAX, DVMAJ, DVMIN
  REAL PGRND
  INTEGER I, K, K1, K2, NSUBT, NV, NP, LLAB, CLIP, FORM
  LOGICAL OPTN, PGNOTO
  CHARACTER CH, LABEL*32
!
! Check arguments.
!
  IF (PGNOTO('PGAXIS')) RETURN
  IF (X1==X2 .AND. Y1==Y2) RETURN
  IF (V1==V2) RETURN
!
! Decode options.
!
  FORM = 0
  OPTN = .FALSE.
  DO 10 I=1,LEN(OPT)
   CH = OPT(I:I)
   CALL GRTOUP(CH, CH)
   IF (CH=='N') THEN
!           -- numeric labels requested
      OPTN = .TRUE.
   ELSE IF (CH=='L') THEN
!           -- logarithmic axis requested
      CALL PGAXLG(OPT, X1, Y1, X2, Y2, V1, V2, STEP, &
                    DMAJL, DMAJR, FMIN, DISP, ORIENT)
      RETURN
   ELSE IF (CH=='1') THEN
!           -- decimal labels requested
      FORM = 1
   ELSE IF (CH=='2') THEN
!           -- exponential labels requested
      FORM = 2
   END IF
 10   CONTINUE
!
! Choose major interval if defaulted. Requested interval = STEP,
! with NSUB subdivisions. We will use interval = DVMAJ with NSUBT
! subdivisions of size DVMIN. Note that DVMAJ is always positive.
!
  IF (STEP==0.0) THEN
    DVMAJ = PGRND(0.20*ABS(V1-V2),NSUBT)
  ELSE
    DVMAJ = ABS(STEP)
    NSUBT = MAX(NSUB,1)
  END IF
  DVMIN = DVMAJ/NSUBT
!
! For labelling, we need to express DVMIN as an integer times a
! power of 10, NV*(10**NP).
!
  NP = INT(LOG10(ABS(DVMIN)))-4
  NV = NINT(DVMIN/10.0**NP)
  DVMIN = REAL(NV)*(10.0**NP)
!
  CALL PGBBUF
  CALL PGQCLP(CLIP)
  CALL PGSCLP(0)
!
! Draw the axis.
!
  CALL PGMOVE(X1, Y1)
  CALL PGDRAW(X2, Y2)
!
! Draw the tick marks. Minor ticks are drawn at V = K*DVMIN,
! major (labelled) ticks where K is a multiple of NSUBT.
!
  VMIN = MIN(V1, V2)
  VMAX = MAX(V1, V2)
  K1 = INT(VMIN/DVMIN)
  IF (DVMIN*K1<VMIN) K1 = K1+1
  K2 = INT(VMAX/DVMIN)
  IF (DVMIN*K2>VMAX) K2 = K2-1
  DO 20 K=K1,K2
   V = (K*DVMIN-V1)/(V2-V1)
   IF (MOD(K,NSUBT)==0) THEN
!             -- major tick mark
      IF (OPTN) THEN
         CALL PGNUMB(K*NV, NP, FORM, LABEL, LLAB)
      ELSE
         LABEL = ' '
         LLAB = 1
      END IF
      CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL, DMAJR, &
                    DISP, ORIENT, LABEL(:LLAB))
   ELSE
!             -- minor tick mark
      CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL*FMIN, DMAJR*FMIN, &
                    0.0, ORIENT, ' ')
   END IF
 20   CONTINUE
!
  CALL PGSCLP(CLIP)
  CALL PGEBUF
  END

! PGAXLG -- draw a logarithmic axis [internal routine]
!
  SUBROUTINE PGAXLG (OPT, X1, Y1, X2, Y2, V1, V2, STEP, &
                     DMAJL, DMAJR, FMIN, DISP, ORIENT)
  CHARACTER*(*) OPT
  REAL X1, Y1, X2, Y2, V1, V2, STEP
  REAL DMAJL, DMAJR, FMIN, DISP, ORIENT
!
! Draw a labelled graph axis from world-coordinate position (X1,Y1)
!  to (X2,Y2). The quantity described by the axis runs from 10**V1 to
! 10**V2. A logarithmic axis always has major, labeled, tick marks
! spaced by one or more decades. If the major tick marks are spaced
! by one decade (as specified by the STEP argument), then minor
! tick marks are placed at 2, 3, .., 9 times each power of 10;
! otherwise minor tick marks are spaced by one decade. If the axis
! spans less than two decades, numeric labels are placed at 1, 2, and
! 5 times each power of ten.
!
! It is not advisable to use this routine if the axis spans less than
! one decade, or if it spans many decades. In these cases it is
! preferable to use a linear axis labeled with the logarithm of the
! quantity of interest.
!
! Arguments:
!  OPT    (input)  : a string containing single-letter codes for
!                    various options. The options currently
!                    recognized are:
!                    N : write numeric labels
!                    1 : force decimal labelling, instead of automatic
!                        choice (see PGNUMB).
!                    2 : force exponential labelling, instead of
!                        automatic.
!  X1, Y1 (input)  : world coordinates of one endpoint of the axis.
!  X2, Y2 (input)  : world coordinates of the other endpoint of the axis.
!  V1     (input)  : logarithm of axis value at first endpoint.
!  V2     (input)  : logarithm of axis value at second endpoint.
!  STEP   (input)  : the number of decades between major (labeled) tick
!                    marks.
!  DMAJL  (input)  : length of major tick marks drawn to left of axis
!                    (as seen looking from first endpoint to second), in
!                    units of the character height.
!  DMAJR  (input)  : length of major tick marks drawn to right of axis,
!                    in units of the character height.
!  FMIN   (input)  : length of minor tick marks, as fraction of major.
!  DISP   (input)  : displacement of baseline of tick labels to
!                    right of axis, in units of the character height.
!  ORIENT (input)  : orientation of text label relative to axis (see
!                    PGTICK).
!--
! 25-Mar-1997 - new routine [TJP].
!-----------------------------------------------------------------------
  REAL V, VMIN, VMAX, DVMAJ, DVMIN, PGRND
  INTEGER I, K, K1, K2, LLAB, NSUBT, CLIP, FORM
  LOGICAL XLAB, OPTN
  CHARACTER*32 LABEL
  REAL TAB(9)
!
! Table of logarithms 1..9
!
  DATA TAB / 0.00000, 0.30103, 0.47712, 0.60206, 0.69897, &
             0.77815, 0.84510, 0.90309, 0.95424 /
!
! Check arguments.
!
  IF (X1==X2 .AND. Y1==Y2) RETURN
  IF (V1==V2) RETURN
!
! Decode options.
!
  OPTN = INDEX(OPT,'N')/=0 .OR. INDEX(OPT,'n')/=0
  FORM =0
  IF (INDEX(OPT,'1')/=0) FORM = 1
  IF (INDEX(OPT,'2')/=0) FORM = 2
!
! Choose major interval (DVMAJ in the logarithm, with minimum value
! 1.0 = one decade). The minor interval is always 1.0.
!
  IF (STEP>0.5) THEN
   DVMAJ = NINT(STEP)
  ELSE
   DVMAJ = PGRND(0.20*ABS(V1-V2),NSUBT)
   IF (DVMAJ<1.0) DVMAJ = 1.0
  END IF
  DVMIN = 1.0
  NSUBT = DVMAJ/DVMIN
!
  CALL PGBBUF
  CALL PGQCLP(CLIP)
  CALL PGSCLP(0)
!
! Draw the axis.
!
  CALL PGMOVE(X1, Y1)
  CALL PGDRAW(X2, Y2)
!
! Draw the tick marks. Major ticks are drawn at V = K*DVMAJ.
!
  VMIN = MIN(V1, V2)
  VMAX = MAX(V1, V2)
  K1 = INT(VMIN/DVMIN)
  IF (DVMIN*K1<VMIN) K1 = K1+1
  K2 = INT(VMAX/DVMIN)
  IF (DVMIN*K2>VMAX) K2 = K2-1
  XLAB = (K2-K1) <= 2
  DO 20 K=K1,K2
   V = (K*DVMIN-V1)/(V2-V1)
   IF (MOD(K,NSUBT)==0) THEN
!             -- major tick mark
      IF (OPTN) THEN
         CALL PGNUMB(1, NINT(K*DVMIN), FORM, LABEL, LLAB)
      ELSE
         LABEL = ' '
         LLAB = 1
      END IF
      CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL, DMAJR, &
                    DISP, ORIENT, LABEL(:LLAB))
   ELSE
!             -- minor tick mark
      CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL*FMIN, DMAJR*FMIN, &
                    0.0, ORIENT, ' ')
   END IF
 20   CONTINUE
!
! Draw intermediate tick marks if required.
! Label them if axis spans less than 2 decades.
!
  IF (NSUBT==1) THEN
   DO 30 K=K1-1,K2+1
      DO 25 I=2,9
         V = (K*DVMIN + TAB(I) -V1)/(V2-V1)
         IF (V>=0.0 .AND. V<=1.0) THEN
            IF (OPTN.AND.(XLAB .AND.(I==2 .OR. I==5))) THEN
!                    -- labeled minor tick mark
               CALL PGNUMB(I, NINT(K*DVMIN), FORM, LABEL, LLAB)
            ELSE
!                    -- unlabeled minor tick mark
               LABEL = ' '
               LLAB = 1
            END IF
            CALL PGTICK(X1, Y1, X2, Y2, V, DMAJL*FMIN, DMAJR*FMIN, &
                          DISP, ORIENT, LABEL(:LLAB))
         END IF
 25         CONTINUE
 30      CONTINUE
  END IF
!
  CALL PGSCLP(CLIP)
  CALL PGEBUF
  END

!*PGBAND -- read cursor position, with anchor
!%int cpgband(int mode, int posn, float xref, float yref, float *x,\
!%            float *y, char *ch_scalar);
!+
  INTEGER FUNCTION PGBAND (MODE, POSN, XREF, YREF, X, Y, CH)
  INTEGER MODE, POSN
  REAL XREF, YREF, X, Y
  CHARACTER*(*) CH
!
! Read the cursor position and a character typed by the user.
! The position is returned in world coordinates.  PGBAND positions
! the cursor at the position specified (if POSN=1), allows the user to
! move the cursor using the mouse or arrow keys or whatever is available
! on the device. When he has positioned the cursor, the user types a
! single character on the keyboard; PGBAND then returns this
! character and the new cursor position (in world coordinates).
!
! Some interactive devices offer a selection of cursor types,
! implemented as thin lines that move with the cursor, but without
! erasing underlying graphics. Of these types, some extend between
! a stationary anchor-point at XREF,YREF, and the position of the
! cursor, while others simply follow the cursor without changing shape
! or size. The cursor type is specified with one of the following MODE
! values. Cursor types that are not supported by a given device, are
! treated as MODE=0.
!
! -- If MODE=0, the anchor point is ignored and the routine behaves
! like PGCURS.
! -- If MODE=1, a straight line is drawn joining the anchor point
! and the cursor position.
! -- If MODE=2, a hollow rectangle is extended as the cursor is moved,
! with one vertex at the anchor point and the opposite vertex at the
! current cursor position; the edges of the rectangle are horizontal
! and vertical.
! -- If MODE=3, two horizontal lines are extended across the width of
! the display, one drawn through the anchor point and the other
! through the moving cursor position. This could be used to select
! a Y-axis range when one end of the range is known.
! -- If MODE=4, two vertical lines are extended over the height of
! the display, one drawn through the anchor point and the other
! through the moving cursor position. This could be used to select an
! X-axis range when one end of the range is known.
! -- If MODE=5, a horizontal line is extended through the cursor
! position over the width of the display. This could be used to select
! an X-axis value such as the start of an X-axis range. The anchor point
! is ignored.
! -- If MODE=6, a vertical line is extended through the cursor
! position over the height of the display. This could be used to select
! a Y-axis value such as the start of a Y-axis range. The anchor point
! is ignored.
! -- If MODE=7, a cross-hair, centered on the cursor, is extended over
! the width and height of the display. The anchor point is ignored.
!
! Returns:
!  PGBAND          : 1 if the call was successful; 0 if the device
!                    has no cursor or some other error occurs.
! Arguments:
!  MODE   (input)  : display mode (0, 1, ..7: see above).
!  POSN   (input)  : if POSN=1, PGBAND attempts to place the cursor
!                    at point (X,Y); if POSN=0, it leaves the cursor
!                    at its current position. (On some devices this
!                    request may be ignored.)
!  XREF   (input)  : the world x-coordinate of the anchor point.
!  YREF   (input)  : the world y-coordinate of the anchor point.
!  X      (in/out) : the world x-coordinate of the cursor.
!  Y      (in/out) : the world y-coordinate of the cursor.
!  CH     (output) : the character typed by the user; if the device has
!                    no cursor or if some other error occurs, the value
!                    CHAR(0) [ASCII NUL character] is returned.
!
! Note: The cursor coordinates (X,Y) may be changed by PGBAND even if
! the device has no cursor or if the user does not move the cursor.
! Under these circumstances, the position returned in (X,Y) is that of
! the pixel nearest to the requested position.
!--
! 7-Sep-1994 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE      'pgplot.h'
  INTEGER      GRCURS, I, J, IREF, JREF
  LOGICAL      PGNOTO
!
  IF (PGNOTO('PGBAND')) THEN
    CH = CHAR(0)
    PGBAND = 0
    RETURN
  END IF
  IF (MODE<0 .OR. MODE>7) CALL GRWARN( &
       'Invalid MODE argument in PGBAND')
  IF (POSN<0 .OR. POSN>1) CALL GRWARN( &
       'Invalid POSN argument in PGBAND')
!
  I = NINT(PGXORG(PGID) + X*PGXSCL(PGID))
  J = NINT(PGYORG(PGID) + Y*PGYSCL(PGID))
  IREF = NINT(PGXORG(PGID) + XREF*PGXSCL(PGID))
  JREF = NINT(PGYORG(PGID) + YREF*PGYSCL(PGID))
  PGBAND = GRCURS(PGID,I,J,IREF,JREF,MODE,POSN,CH)
  X = (I - PGXORG(PGID))/PGXSCL(PGID)
  Y = (J - PGYORG(PGID))/PGYSCL(PGID)
  CALL GRTERM
  END

!*PGBBUF -- begin batch of output (buffer)
!%void cpgbbuf(void);
!+
  SUBROUTINE PGBBUF
!
! Begin saving graphical output commands in an internal buffer; the
! commands are held until a matching PGEBUF call (or until the buffer
! is emptied by PGUPDT). This can greatly improve the efficiency of
! PGPLOT.  PGBBUF increments an internal counter, while PGEBUF
! decrements this counter and flushes the buffer to the output
! device when the counter drops to zero.  PGBBUF and PGEBUF calls
! should always be paired.
!
! Arguments: none
!--
! 21-Nov-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (.NOT.PGNOTO('PGBBUF')) THEN
    PGBLEV(PGID) = PGBLEV(PGID) + 1
  END IF
  END

!*PGBEG -- open a graphics device
!%int cpgbeg(int unit, const char *file, int nxsub, int nysub);
!+
  INTEGER FUNCTION PGBEG (UNIT, FILE, NXSUB, NYSUB)
  INTEGER       UNIT
  CHARACTER*(*) FILE
  INTEGER       NXSUB, NYSUB
!
! Note: new programs should use PGOPEN rather than PGBEG. PGOPEN
! is retained for compatibility with existing programs. Unlike PGOPEN,
! PGBEG closes any graphics devices that are already open, so it
! cannot be used to open devices to be used in parallel.
!
! PGBEG opens a graphical device or file and prepares it for
! subsequent plotting. A device must be opened with PGBEG or PGOPEN
! before any other calls to PGPLOT subroutines for the device.
!
! If any device  is already open for PGPLOT output, it is closed before
! the new device is opened.
!
! Returns:
!  PGBEG         : a status return value. A value of 1 indicates
!                    successful completion, any other value indicates
!                    an error. In the event of error a message is
!                    written on the standard error unit.
!                    To test the return value, call
!                    PGBEG as a function, eg IER=PGBEG(...); note
!                    that PGBEG must be declared INTEGER in the
!                    calling program. Some Fortran compilers allow
!                    you to use CALL PGBEG(...) and discard the
!                    return value, but this is not standard Fortran.
! Arguments:
!  UNIT  (input)   : this argument is ignored by PGBEG (use zero).
!  FILE  (input)   : the "device specification" for the plot device.
!                    (For explanation, see description of PGOPEN.)
!  NXSUB  (input)  : the number of subdivisions of the view surface in
!                    X (>0 or <0).
!  NYSUB  (input)  : the number of subdivisions of the view surface in
!                    Y (>0).
!                    PGPLOT puts NXSUB x NYSUB graphs on each plot
!                    page or screen; when the view surface is sub-
!                    divided in this way, PGPAGE moves to the next
!                    panel, not the  next physical page. If
!                    NXSUB > 0, PGPLOT uses the panels in row
!                    order; if <0, PGPLOT uses them in column order.
!--
! 21-Dec-1995 [TJP] - changed for multiple devices; call PGOPEN.
! 27-Feb-1997 [TJP] - updated description.
!-----------------------------------------------------------------------
  INTEGER       IER
  INTEGER       PGOPEN
!
! Initialize PGPLOT if necessary.
!
  CALL PGINIT
!
! Close the plot-file if it is already open.
!
  CALL PGEND
!
! Call PGOPEN to open the device.
!
  IER = PGOPEN(FILE)
  IF (IER>0) THEN
   CALL PGSUBP(NXSUB, NYSUB)
   PGBEG = 1
  ELSE
   PGBEG = IER
  END IF
!
  RETURN
  END

!*PGBEGIN -- non-standard alias for PGBEG
!+
  INTEGER FUNCTION PGBEGIN (UNIT, FILE, NXSUB, NYSUB)
  INTEGER       UNIT
  CHARACTER*(*) FILE
  INTEGER       NXSUB, NYSUB
!
! See description of PGBEG.
!--
  INTEGER       PGBEG
  PGBEGIN = PGBEG (UNIT, FILE, NXSUB, NYSUB)
  END

!*PGBIN -- histogram of binned data
!%void cpgbin(int nbin, const float *x, const float *data, \
!% Logical center);
!+
  SUBROUTINE PGBIN (NBIN, X, DATA, CENTER)
  INTEGER NBIN
  REAL X(*), DATA(*)
  LOGICAL CENTER
!
! Plot a histogram of NBIN values with X(1..NBIN) values along
! the ordinate, and DATA(1...NBIN) along the abscissa. Bin width is
! spacing between X values.
!
! Arguments:
!  NBIN   (input)  : number of values.
!  X      (input)  : abscissae of bins.
!  DATA   (input)  : data values of bins.
!  CENTER (input)  : if .TRUE., the X values denote the center of the
!                    bin; if .FALSE., the X values denote the lower
!                    edge (in X) of the bin.
!--
! 19-Aug-92: change argument check (TJP).
!-----------------------------------------------------------------------
  LOGICAL  PGNOTO
  INTEGER  IBIN
  REAL     TX(4), TY(4)
!
! Check arguments.
!
  IF (NBIN<2) RETURN
  IF (PGNOTO('PGBIN')) RETURN
  CALL PGBBUF
!
! Draw Histogram. Centered an uncentered bins are treated separately.
!
  IF (CENTER) THEN
!         !set up initial point.
    TX(2) = (3.*X(1) - X(2))/2.
    TY(2) = DATA(1)
    TX(3) = (X(1) + X(2))/2.
    TY(3) = TY(2)
    CALL GRVCT0(2, .FALSE., 2, TX(2), TY(2))
!         !draw initial horizontal line
!         !now loop over bins
    DO 10 IBIN=2,NBIN-1
        TX(1) = TX(3)
        TX(2) = TX(1)
        TX(3) = ( X(IBIN) + X(IBIN+1) ) / 2.
        TY(1) = TY(3)
        TY(2) = DATA(IBIN)
        TY(3) = TY(2)
        CALL GRVCT0(2, .FALSE., 3, TX, TY)
   10     CONTINUE
!         !now draw last segment.
    TX(1) = TX(3)
    TX(2) = TX(1)
    TX(3) = (3.*X(NBIN) - X(NBIN-1) )/2.
    TY(1) = TY(3)
    TY(2) = DATA(NBIN)
    TY(3) = TY(2)
    CALL GRVCT0(2, .FALSE., 3, TX, TY)
!
!               Uncentered bins
!
  ELSE
!         !set up first line.
    TX(2) = X(1)
    TY(2) = DATA(1)
    TX(3) = X(2)
    TY(3) = TY(2)
    CALL GRVCT0(2, .FALSE., 2, TX(2), TY(2))
    DO 20 IBIN=2,NBIN
        TX(1) = TX(3)
        TX(2) = TX(1)
        IF (IBIN==NBIN) THEN
            TX(3) = 2.*X(NBIN) - X(NBIN-1)
        ELSE
            TX(3) = X(IBIN+1)
        END IF
        TY(1) = TY(3)
!             !get height for last segment.
        TY(2) = DATA(IBIN)
        TY(3) = TY(2)
        CALL GRVCT0(2, .FALSE., 3, TX, TY)
   20     CONTINUE
  END IF
!
  CALL PGEBUF
  END

! PGBOX1 -- support routine for PGBOX
!
  SUBROUTINE PGBOX1 (XA, XB, XD, I1, I2)
  REAL XA, XB, XD
  INTEGER I1, I2
!
! This routine is used to determine where to draw the tick marks on
! an axis. The input arguments XA and XB are the world-coordinate
! end points of the axis; XD is the tick interval. PGBOX1 returns
! two integers, I1 and I2, such that the required tick marks are
! to be placed at world-coordinates (I*XD), for I=I1,...,I2.
! Normally I2 is greater than or equal to I1, but if there are no
! values of I such that I*XD lies in the inclusive range (XA, XB),
! then I2 will be 1 less than I1.
!
! Arguments:
!  XA, XB (input)  : world-coordinate end points of the axis. XA must
!                    not be equal to XB; otherwise, there are no
!                    restrictions.
!  XD     (input)  : world-coordinate tick interval. XD may be positive
!                    or negative, but may not be zero.
!  I1, I2 (output) : tick marks should be drawn at world
!                    coordinates I*XD for I in the inclusive range
!                    I1...I2 (see above).
!
! 14-Jan-1986 - new routine [TJP].
! 13-Dec-1990 - remove rror check [TJP].
!-----------------------------------------------------------------------
  REAL XLO, XHI
!
  XLO = MIN(XA/XD, XB/XD)
  XHI = MAX(XA/XD, XB/XD)
  I1 = NINT(XLO)
  IF (I1<XLO) I1 = I1+1
  I2 = NINT(XHI)
  IF (I2>XHI) I2 = I2-1
  END

!*PGBOX -- draw labeled frame around viewport
!%void cpgbox(const char *xopt, float xtick, int nxsub, \
!% const char *yopt, float ytick, int nysub);
!+
  SUBROUTINE PGBOX (XOPT, XTICK, NXSUB, YOPT, YTICK, NYSUB)
  CHARACTER*(*) XOPT, YOPT
  REAL XTICK, YTICK
  INTEGER NXSUB, NYSUB
!
! Annotate the viewport with frame, axes, numeric labels, etc.
! PGBOX is called by on the user's behalf by PGENV, but may also be
! called explicitly.
!
! Arguments:
!  XOPT   (input)  : string of options for X (horizontal) axis of
!                    plot. Options are single letters, and may be in
!                    any order (see below).
!  XTICK  (input)  : world coordinate interval between major tick marks
!                    on X axis. If XTICK=0.0, the interval is chosen by
!                    PGBOX, so that there will be at least 3 major tick
!                    marks along the axis.
!  NXSUB  (input)  : the number of subintervals to divide the major
!                    coordinate interval into. If XTICK=0.0 or NXSUB=0,
!                    the number is chosen by PGBOX.
!  YOPT   (input)  : string of options for Y (vertical) axis of plot.
!                    Coding is the same as for XOPT.
!  YTICK  (input)  : like XTICK for the Y axis.
!  NYSUB  (input)  : like NXSUB for the Y axis.
!
! Options (for parameters XOPT and YOPT):
!  A : draw Axis (X axis is horizontal line Y=0, Y axis is vertical
!      line X=0).
!  B : draw bottom (X) or left (Y) edge of frame.
!  C : draw top (X) or right (Y) edge of frame.
!  G : draw Grid of vertical (X) or horizontal (Y) lines.
!  I : Invert the tick marks; ie draw them outside the viewport
!      instead of inside.
!  L : label axis Logarithmically (see below).
!  N : write Numeric labels in the conventional location below the
!      viewport (X) or to the left of the viewport (Y).
!  P : extend ("Project") major tick marks outside the box (ignored if
!      option I is specified).
!  M : write numeric labels in the unconventional location above the
!      viewport (X) or to the right of the viewport (Y).
!  T : draw major Tick marks at the major coordinate interval.
!  S : draw minor tick marks (Subticks).
!  V : orient numeric labels Vertically. This is only applicable to Y.
!      The default is to write Y-labels parallel to the axis.
!  1 : force decimal labelling, instead of automatic choice (see PGNUMB).
!  2 : force exponential labelling, instead of automatic.
!
! To get a complete frame, specify BC in both XOPT and YOPT.
! Tick marks, if requested, are drawn on the axes or frame
! or both, depending which are requested. If none of ABC is specified,
! tick marks will not be drawn. When PGENV calls PGBOX, it sets both
! XOPT and YOPT according to the value of its parameter AXIS:
! -1: 'BC', 0: 'BCNST', 1: 'ABCNST', 2: 'ABCGNST'.
!
! For a logarithmic axis, the major tick interval is always 1.0. The
! numeric label is 10**(x) where x is the world coordinate at the
! tick mark. If subticks are requested, 8 subticks are drawn between
! each major tick at equal logarithmic intervals.
!
! To label an axis with time (days, hours, minutes, seconds) or
! angle (degrees, arcmin, arcsec), use routine PGTBOX.
!--
! 19-Oct-1983
! 23-Sep-1984 - fix bug in labelling reversed logarithmic axes.
!  6-May-1985 - improve behavior for pen plotters [TJP].
! 23-Nov-1985 - add 'P' option [TJP].
! 14-Jan-1986 - use new routine PGBOX1 to fix problem of missing
!               labels at end of axis [TJP].
!  8-Apr-1987 - improve automatic choice of tick interval; improve
!               erroneous rounding of tick interval to 1 digit [TJP].
! 23-Apr-1987 - fix bug: limit max number of ticks to ~10 [TJP].
!  7-Nov-1987 - yet another change to algorithm for choosing tick
!               interval; maximum tick interval is now 0.2*range of
!               axis, which may round up to 0.5 [TJP].
! 15-Dec-1988 - correct declaration of MAJOR [TJP].
!  6-Sep-1989 - use Fortran generic intrinsic functions [TJP].
! 18-Oct-1990 - correctly initialize UTAB(1) [AFT].
! 19-Oct-1990 - do all plotting in world coordinates [TJP].
!  6-Nov-1991 - label logarithmic subticks when necessary [TJP].
!  4-Jul-1994 - add '1' and '2' options [TJP].
! 20-Apr-1995 - adjust position of labels slightly, and move out
!               when ticks are inverted [TJP].
! 26-Feb-1997 - use new routine pgclp [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  CHARACTER*20  CLBL
  CHARACTER*64  OPT
  LOGICAL  XOPTA, XOPTB, XOPTC, XOPTG, XOPTN, XOPTM, XOPTT, XOPTS
  LOGICAL  YOPTA, YOPTB, YOPTC, YOPTG, YOPTN, YOPTM, YOPTT, YOPTS
  LOGICAL  XOPTI, YOPTI, YOPTV, XOPTL, YOPTL, XOPTP, YOPTP, RANGE
  LOGICAL  IRANGE, MAJOR, XOPTLS, YOPTLS, PGNOTO
  REAL     TAB(9), UTAB(9)
  INTEGER  I, I1, I2, J, NC, NP, NV, KI, CLIP
  INTEGER  NSUBX, NSUBY, JMAX, XNFORM, YNFORM
  REAL     TIKL, TIKL1, TIKL2, XC, YC
  REAL     XINT, XINT2, XVAL, YINT, YINT2, YVAL
  REAL     PGRND
  REAL     A, B, C
  REAL     XNDSP, XMDSP, YNDSP, YMDSP, YNVDSP, YMVDSP
  REAL     XBLC, XTRC, YBLC, YTRC
  INTRINSIC ABS, INDEX, INT, LOG10, MAX, MIN, MOD, NINT, SIGN, REAL

!
! Table of logarithms 1..9
!
  DATA TAB / 0.00000, 0.30103, 0.47712, 0.60206, 0.69897, &
             0.77815, 0.84510, 0.90309, 0.95424 /
!
  RANGE(A,B,C) = (A<B.AND.B<C) .OR. (C<B.AND.B<A)
  IRANGE(A,B,C) = (A<=B.AND.B<=C) .OR. (C<=B.AND.B<=A)
!
  IF (PGNOTO('PGBOX')) RETURN
  CALL PGBBUF
  CALL PGQWIN(XBLC, XTRC, YBLC, YTRC)
!
! Decode options.
!
  CALL GRTOUP(OPT,XOPT)
  XOPTA = INDEX(OPT,'A')/=0 .AND. RANGE(YBLC,0.0,YTRC)
  XOPTB = INDEX(OPT,'B')/=0
  XOPTC = INDEX(OPT,'C')/=0
  XOPTG = INDEX(OPT,'G')/=0
  XOPTI = INDEX(OPT,'I')/=0
  XOPTL = INDEX(OPT,'L')/=0
  XOPTM = INDEX(OPT,'M')/=0
  XOPTN = INDEX(OPT,'N')/=0
  XOPTS = INDEX(OPT,'S')/=0
  XOPTT = INDEX(OPT,'T')/=0
  XOPTP = INDEX(OPT,'P')/=0 .AND. (.NOT.XOPTI)
  XNFORM = 0
  IF (INDEX(OPT,'1')/=0) XNFORM = 1
  IF (INDEX(OPT,'2')/=0) XNFORM = 2
  CALL GRTOUP(OPT,YOPT)
  YOPTA = INDEX(OPT,'A')/=0 .AND. RANGE(XBLC,0.0,XTRC)
  YOPTB = INDEX(OPT,'B')/=0
  YOPTC = INDEX(OPT,'C')/=0
  YOPTG = INDEX(OPT,'G')/=0
  YOPTI = INDEX(OPT,'I')/=0
  YOPTL = INDEX(OPT,'L')/=0
  YOPTN = INDEX(OPT,'N')/=0
  YOPTM = INDEX(OPT,'M')/=0
  YOPTS = INDEX(OPT,'S')/=0
  YOPTT = INDEX(OPT,'T')/=0
  YOPTV = INDEX(OPT,'V')/=0
  YOPTP = INDEX(OPT,'P')/=0 .AND. (.NOT.YOPTI)
  YNFORM = 0
  IF (INDEX(OPT,'1')/=0) YNFORM = 1
  IF (INDEX(OPT,'2')/=0) YNFORM = 2
!
! Displacement of labels from edge of box
! (for X bottom/top, Y left/right, and Y left/right with V option).
!
  XNDSP = 1.2
  XMDSP = 0.7
  YNDSP = 0.7
  YMDSP = 1.2
  YNVDSP = 0.7
  YMVDSP = 0.7
  IF (XOPTI) THEN
   XNDSP = XNDSP + 0.3
   XMDSP = XMDSP + 0.3
  END IF
  IF (YOPTI) THEN
   YNDSP = YNDSP + 0.3
   YMDSP = YMDSP + 0.3
   YNVDSP = YNVDSP + 0.3
   YMVDSP = YMVDSP + 0.3
  END IF
!
! Disable clipping.
!
  CALL PGQCLP(CLIP)
  CALL PGSCLP(0)
!
! Draw box.
!
  IF (XOPTB) THEN
    CALL GRMOVA(XBLC, YBLC)
    CALL GRLINA(XTRC, YBLC)
  END IF
  IF (YOPTC) THEN
    CALL GRMOVA(XTRC, YBLC)
    CALL GRLINA(XTRC, YTRC)
  END IF
  IF (XOPTC) THEN
    CALL GRMOVA(XTRC, YTRC)
    CALL GRLINA(XBLC, YTRC)
  END IF
  IF (YOPTB) THEN
    CALL GRMOVA(XBLC, YTRC)
    CALL GRLINA(XBLC, YBLC)
  END IF
!
! Draw axes if required.
!
  IF (XOPTA.AND..NOT.XOPTG) THEN
    CALL GRMOVA(XBLC, 0.0)
    CALL GRLINA(XTRC, 0.0)
  END IF
  IF (YOPTA.AND..NOT.YOPTG) THEN
    CALL GRMOVA(0.0, YBLC)
    CALL GRLINA(0.0, YTRC)
  END IF
!
! Length of X tick marks.
!
  TIKL1 = PGXSP(PGID)*0.6*(YTRC-YBLC)/PGYLEN(PGID)
  IF (XOPTI) TIKL1 = -TIKL1
  TIKL2 = TIKL1*0.5
!
! Choose X tick intervals. Major interval = XINT,
! minor interval = XINT2 = XINT/NSUBX.
!
  UTAB(1) = 0.0
  IF (XOPTL) THEN
    XINT = SIGN(1.0,XTRC-XBLC)
    NSUBX = 1
    DO 10 J=2,9
        UTAB(J) = TAB(J)
        IF (XINT<0.0) UTAB(J) = 1.0-TAB(J)
   10     CONTINUE
  ELSE IF (XTICK==0.0) THEN
    XINT = MAX(0.05, MIN(7.0*PGXSP(PGID)/PGXLEN(PGID), 0.20)) &
             *(XTRC-XBLC)
    XINT = PGRND(XINT,NSUBX)
  ELSE
    XINT = SIGN(XTICK,XTRC-XBLC)
    NSUBX = MAX(NXSUB,1)
  END IF
  IF (.NOT.XOPTS) NSUBX = 1
  NP = INT(LOG10(ABS(XINT)))-4
  NV = NINT(XINT/10.**NP)
  XINT2 = XINT/NSUBX
  XOPTLS = XOPTL .AND. XOPTS .AND. (ABS(XTRC-XBLC)<2.0)
!
! Draw X grid.
!
  IF (XOPTG) THEN
    CALL PGBOX1(XBLC, XTRC, XINT, I1, I2)
    DO 20 I=I1,I2
        CALL GRMOVA(REAL(I)*XINT, YBLC)
        CALL GRLINA(REAL(I)*XINT, YTRC)
   20     CONTINUE
  END IF
!
! Draw X ticks.
!
  IF (XOPTT.OR.XOPTS) THEN
    CALL PGBOX1(XBLC, XTRC, XINT2, I1, I2)
    JMAX = 1
    IF (XOPTL.AND.XOPTS) JMAX=9
!
!         Bottom ticks.
!
    IF (XOPTB) THEN
      DO 40 I=I1-1,I2
      DO 30 J=1,JMAX
          MAJOR = (MOD(I,NSUBX)==0).AND.XOPTT.AND.J==1
          TIKL = TIKL2
          IF (MAJOR) TIKL = TIKL1
          XVAL = (I+UTAB(J))*XINT2
          IF (IRANGE(XBLC,XVAL,XTRC)) THEN
              IF (XOPTP.AND.MAJOR) THEN
                  CALL GRMOVA(XVAL, YBLC-TIKL2)
              ELSE
                  CALL GRMOVA(XVAL, YBLC)
              END IF
              CALL GRLINA(XVAL, YBLC+TIKL)
          END IF
   30        CONTINUE
   40       CONTINUE
    END IF
!
!         Axis ticks.
!
    IF (XOPTA) THEN
      DO 60 I=I1-1,I2
      DO 50 J=1,JMAX
          MAJOR = (MOD(I,NSUBX)==0).AND.XOPTT.AND.J==1
          TIKL = TIKL2
          IF (MAJOR) TIKL = TIKL1
          XVAL = (I+UTAB(J))*XINT2
          IF (IRANGE(XBLC,XVAL,XTRC)) THEN
              CALL GRMOVA(XVAL, -TIKL)
              CALL GRLINA(XVAL, TIKL)
          END IF
   50       CONTINUE
   60       CONTINUE
    END IF
!
!         Top ticks.
!
    IF (XOPTC) THEN
      DO 80 I=I1-1,I2
      DO 70 J=1,JMAX
          MAJOR = (MOD(I,NSUBX)==0).AND.XOPTT.AND.J==1
          TIKL = TIKL2
          IF (MAJOR) TIKL = TIKL1
          XVAL = (I+UTAB(J))*XINT2
          IF (IRANGE(XBLC,XVAL,XTRC)) THEN
              CALL GRMOVA(XVAL, YTRC-TIKL)
              CALL GRLINA(XVAL, YTRC)
          END IF
   70       CONTINUE
   80       CONTINUE
    END IF
  END IF
!
! Write X labels.
!
  IF (XOPTN .OR. XOPTM) THEN
    CALL PGBOX1(XBLC, XTRC, XINT, I1, I2)
    DO 90 I=I1,I2
        XC = (I*XINT-XBLC)/(XTRC-XBLC)
        IF (XOPTL) THEN
            CALL PGNUMB(1,NINT(I*XINT),XNFORM,CLBL,NC)
        ELSE
            CALL PGNUMB(I*NV,NP,XNFORM,CLBL,NC)
        END IF
        IF (XOPTN) CALL PGMTXT('B', XNDSP, XC, 0.5, CLBL(1:NC))
        IF (XOPTM) CALL PGMTXT('T', XMDSP, XC, 0.5, CLBL(1:NC))
   90     CONTINUE
  END IF
!
! Extra X labels for log axes.
!
  IF (XOPTLS) THEN
    CALL PGBOX1(XBLC, XTRC, XINT2, I1, I2)
    DO 401 I=I1-1,I2
       DO 301 J=2,5,3
          XVAL = (I+UTAB(J))*XINT2
          XC = (XVAL-XBLC)/(XTRC-XBLC)
          KI = I
          IF (XTRC<XBLC) KI = KI+1
          IF (IRANGE(XBLC,XVAL,XTRC)) THEN
              CALL PGNUMB(J,NINT(KI*XINT2),XNFORM,CLBL,NC)
              IF (XOPTN) &
                  CALL PGMTXT('B', XNDSP, XC, 0.5, CLBL(1:NC))
              IF (XOPTM) &
                  CALL PGMTXT('T', XMDSP, XC, 0.5, CLBL(1:NC))
          END IF
  301       CONTINUE
  401     CONTINUE
  END IF
!
! Length of Y tick marks.
!
  TIKL1 = PGXSP(PGID)*0.6*(XTRC-XBLC)/PGXLEN(PGID)
  IF (YOPTI) TIKL1 = -TIKL1
  TIKL2 = TIKL1*0.5
!
! Choose Y tick intervals. Major interval = YINT,
! minor interval = YINT2 = YINT/NSUBY.
!
  UTAB(1) = 0.0
  IF (YOPTL) THEN
    YINT = SIGN(1.0,YTRC-YBLC)
    NSUBY = 1
    DO 100 J=2,9
        UTAB(J) = TAB(J)
        IF (YINT<0.0) UTAB(J) = 1.0-TAB(J)
  100     CONTINUE
  ELSE IF (YTICK==0.0) THEN
    YINT = MAX(0.05, MIN(7.0*PGXSP(PGID)/PGYLEN(PGID), 0.20)) &
             *(YTRC-YBLC)
    YINT = PGRND(YINT,NSUBY)
  ELSE
    YINT  = SIGN(YTICK,YTRC-YBLC)
    NSUBY = MAX(NYSUB,1)
  END IF
  IF (.NOT.YOPTS) NSUBY = 1
  NP = INT(LOG10(ABS(YINT)))-4
  NV = NINT(YINT/10.**NP)
  YINT2 = YINT/NSUBY
  YOPTLS = YOPTL .AND. YOPTS .AND. (ABS(YTRC-YBLC)<2.0)
!
! Draw Y grid.
!
  IF (YOPTG) THEN
    CALL PGBOX1(YBLC, YTRC, YINT, I1, I2)
    DO 110 I=I1,I2
        CALL GRMOVA(XBLC, REAL(I)*YINT)
        CALL GRLINA(XTRC, REAL(I)*YINT)
  110     CONTINUE
  END IF
!
! Draw Y ticks.
!
  IF (YOPTT.OR.YOPTS) THEN
    CALL PGBOX1(YBLC, YTRC, YINT2, I1, I2)
    JMAX = 1
    IF (YOPTL.AND.YOPTS) JMAX = 9
!
!               Left ticks.
!
      IF (YOPTB) THEN
      DO 130 I=I1-1,I2
      DO 120 J=1,JMAX
          MAJOR = (MOD(I,NSUBY)==0).AND.YOPTT.AND.J==1
          TIKL = TIKL2
          IF (MAJOR) TIKL = TIKL1
          YVAL = (I+UTAB(J))*YINT2
          IF (IRANGE(YBLC,YVAL,YTRC)) THEN
              IF (YOPTP.AND.MAJOR) THEN
                  CALL GRMOVA(XBLC-TIKL2, YVAL)
              ELSE
                  CALL GRMOVA(XBLC, YVAL)
              END IF
              CALL GRLINA(XBLC+TIKL, YVAL)
          END IF
  120       CONTINUE
  130       CONTINUE
      END IF
!
!               Axis ticks.
!
      IF (YOPTA) THEN
      DO 150 I=I1-1,I2
      DO 140 J=1,JMAX
          MAJOR = (MOD(I,NSUBY)==0).AND.YOPTT.AND.J==1
          TIKL = TIKL2
          IF (MAJOR) TIKL = TIKL1
          YVAL = (I+UTAB(J))*YINT2
          IF (IRANGE(YBLC,YVAL,YTRC)) THEN
              CALL GRMOVA(-TIKL, YVAL)
              CALL GRLINA(TIKL, YVAL)
          END IF
  140       CONTINUE
  150       CONTINUE
      END IF
!
!               Right ticks.
!
      IF (YOPTC) THEN
      DO 170 I=I1-1,I2
      DO 160 J=1,JMAX
          MAJOR = (MOD(I,NSUBY)==0).AND.YOPTT.AND.J==1
          TIKL = TIKL2
          IF (MAJOR) TIKL = TIKL1
          YVAL = (I+UTAB(J))*YINT2
          IF (IRANGE(YBLC,YVAL,YTRC)) THEN
              CALL GRMOVA(XTRC-TIKL, YVAL)
              CALL GRLINA(XTRC, YVAL)
          END IF
  160       CONTINUE
  170       CONTINUE
      END IF
  END IF
!
! Write Y labels.
!
  IF (YOPTN.OR.YOPTM) THEN
    CALL PGBOX1(YBLC, YTRC, YINT, I1, I2)
    DO 180 I=I1,I2
        YC = (I*YINT-YBLC)/(YTRC-YBLC)
        IF (YOPTL) THEN
            CALL PGNUMB(1,NINT(I*YINT),YNFORM,CLBL,NC)
        ELSE
            CALL PGNUMB(I*NV,NP,YNFORM,CLBL,NC)
        END IF
        IF (YOPTV) THEN
            IF (YOPTN) CALL PGMTXT('LV',YNVDSP,YC,1.0,CLBL(1:NC))
            IF (YOPTM) CALL PGMTXT('RV',YMVDSP,YC,0.0,CLBL(1:NC))
        ELSE
            IF (YOPTN) CALL PGMTXT('L',YNDSP,YC,0.5,CLBL(1:NC))
            IF (YOPTM) CALL PGMTXT('R',YMDSP,YC,0.5,CLBL(1:NC))
        END IF
  180     CONTINUE
  END IF
!
! Extra Y labels for log axes.
!
  IF (YOPTLS) THEN
    CALL PGBOX1(YBLC, YTRC, YINT2, I1, I2)
    DO 402 I=I1-1,I2
      DO 302 J=2,5,3
          YVAL = (I+UTAB(J))*YINT2
          YC = (YVAL-YBLC)/(YTRC-YBLC)
          KI = I
          IF (YBLC>YTRC) KI = KI+1
          IF (IRANGE(YBLC,YVAL,YTRC)) THEN
              CALL PGNUMB(J,NINT(KI*YINT2),YNFORM,CLBL,NC)
              IF (YOPTV) THEN
              IF (YOPTN) &
                  CALL PGMTXT('LV', YNVDSP, YC, 1.0, CLBL(1:NC))
              IF (YOPTM) &
                  CALL PGMTXT('RV', YMVDSP, YC, 0.0, CLBL(1:NC))
              ELSE
              IF (YOPTN) &
                  CALL PGMTXT('L', YNDSP, YC, 0.5, CLBL(1:NC))
              IF (YOPTM) &
                  CALL PGMTXT('R', YMDSP, YC, 0.5, CLBL(1:NC))
              END IF
          END IF
  302       CONTINUE
  402     CONTINUE
  END IF
!
! Enable clipping.
!
  CALL PGSCLP(CLIP)
!
  CALL PGEBUF
  END

!*PGCIRC -- draw a circle, using fill-area attributes
!%void cpgcirc(float xcent, float ycent, float radius);
!+
  SUBROUTINE PGCIRC (XCENT, YCENT, RADIUS)
  REAL XCENT, YCENT, RADIUS
!
! Draw a circle. The action of this routine depends
! on the setting of the Fill-Area Style attribute. If Fill-Area Style
! is SOLID (the default), the interior of the circle is solid-filled
! using the current Color Index. If Fill-Area Style is HOLLOW, the
! outline of the circle is drawn using the current line attributes
! (color index, line-style, and line-width).
!
! Arguments:
!  XCENT  (input)  : world x-coordinate of the center of the circle.
!  YCENT  (input)  : world y-coordinate of the center of the circle.
!  RADIUS (input)  : radius of circle (world coordinates).
!--
! 26-Nov-1992 - [TJP].
! 20-Sep-1994 - adjust number of points according to size [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  INTEGER MAXPTS
  PARAMETER (MAXPTS=72)
!
  INTEGER NPTS,I,RADPIX
  REAL ANGLE
  REAL X(MAXPTS),Y(MAXPTS)
!
  RADPIX = NINT(RADIUS*MAX(PGXSCL(PGID), PGYSCL(PGID)))
  NPTS = MAX(8, MIN(MAXPTS, RADPIX))
  DO 10 I=1,NPTS
   ANGLE = I*360.0/REAL(NPTS)/57.3
   X(I) = XCENT + RADIUS*COS(ANGLE)
   Y(I) = YCENT + RADIUS*SIN(ANGLE)
   10 CONTINUE
  CALL PGPOLY (NPTS,X,Y)
!     write (*,*) 'PGCIRC', NPTS
!-----------------------------------------------------------------------
  END

!
  SUBROUTINE PGCL (K, X, Y, Z)
  INTEGER K
  REAL X, Y, Z
!
! PGPLOT (internal routine): Label one contour segment (for use by
! PGCONX).
!
! Arguments:
!
! K (input, integer): if K=0, move the pen to (X,Y); if K=1, draw
!       a line from the current position to (X,Y); otherwise
!       do nothing.
! X (input, real): X world-coordinate of end point.
! Y (input, real): Y world-coordinate of end point.
! Z (input, real): the value of the contour level, not used by PGCL.
!--
!  5-May-1994 - new routine [TJP]
!  7-Mar-1995 - correct error in angle; do not draw labels outside
!               window [TJP].
! 28-Aug-1995 - check arguments of atan2 [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  REAL     XX, YY, XC, YC, XV1, XV2, YV1, YV2, XL, XR, YB, YT
  REAL     XN, YN
  REAL     ANGLE, XO, YO, XP, YP, DINDX, DINDY, XBOX(4), YBOX(4)
  INTEGER  I, TB
  SAVE     I
  DATA     I /0/
!
!     -- transform to world coordinates
  XX = TRANS(1) + TRANS(2)*X + TRANS(3)*Y
  YY = TRANS(4) + TRANS(5)*X + TRANS(6)*Y
!
  IF (K==0) THEN
!        -- start of contour: reset segment counter
   I = 0
  ELSE
!        -- increment segment counter and check whether this
!           segment should be labelled
   I = MOD(I+1,PGCINT)
   IF (I==PGCMIN) THEN
!           -- find center of this segment (XC, YC)
      CALL PGQPOS(XP, YP)
      XC = (XX+XP)*0.5
      YC = (YY+YP)*0.5
!            -- find slope of this segment (ANGLE)
      CALL PGQVP(1, XV1, XV2, YV1, YV2)
      CALL PGQWIN(XL, XR, YB, YT)
      ANGLE = 0.0
      IF (XR/=XL .AND. YT/=YB) THEN
         DINDX = (XV2 - XV1) / (XR - XL)
         DINDY = (YV2 - YV1) / (YT - YB)
         IF (YY-YP/=0.0 .OR. XX-XP/=0.0) &
             ANGLE = 57.3*ATAN2((YY-YP)*DINDY, (XX-XP)*DINDX)
      END IF
!           -- check whether point is in window
      XN = (XC-XL)/(XR-XL)
      YN = (YC-YB)/(YT-YB)
      IF (XN>=0.0 .AND. XN<=1.0 .AND. &
            YN>=0.0 .AND. YN<=1.0) THEN
!              -- save current text background and set to erase
         CALL PGQTBG(TB)
         CALL PGSTBG(0)
!              -- find bounding box of label
         CALL PGQTXT(XC, YC, ANGLE, 0.5, PGCLAB, XBOX, YBOX)
         XO = 0.5*(XBOX(1)+XBOX(3))
         YO = 0.5*(YBOX(1)+YBOX(3))
!              -- plot label with bounding box centered at (XC, YC)
         CALL PGPTXT(2.0*XC-XO, 2.0*YC-YO, ANGLE, 0.5, PGCLAB)
!              -- restore text background
         CALL PGSTBG(TB)
      END IF
   END IF
  END IF
  CALL PGMOVE(XX,YY)
  END

!*PGCLOS -- close the selected graphics device
!%void cpgclos(void);
!+
  SUBROUTINE PGCLOS
!
! Close the currently selected graphics device. After the device has
! been closed, either another open device must be selected with PGSLCT
! or another device must be opened with PGOPEN before any further
! plotting can be done. If the call to PGCLOS is omitted, some or all
! of the plot may be lost.
!
! [This routine was added to PGPLOT in Version 5.1.0. Older programs
! use PGEND instead.]
!
! Arguments: none
!--
! 22-Dec-1995 - new routine, derived from the old PGEND.
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  CHARACTER*16 DEFSTR
  LOGICAL PGNOTO
!
  IF (.NOT.PGNOTO('PGCLOS')) THEN
   CALL GRTERM
   IF (PGPRMP(PGID)) THEN
      CALL GRQCAP(DEFSTR)
      IF (DEFSTR(8:8)=='V') CALL GRPROM
   END IF
   CALL GRCLOS
   PGDEVS(PGID) = 0
   PGID = 0
  END IF
!     WRITE (*,*) 'PGCLOS', PGID, ':', PGDEVS
  END

  SUBROUTINE PGCN01(Z, MX, MY, IA, IB, JA, JB, Z0, PLOT, &
                    FLAGS, IS, JS, SDIR)
!
! Support routine for PGCNSC. This routine draws a continuous contour,
! starting at the specified point, until it either crosses the edge of
! the array or closes on itself.
!-----------------------------------------------------------------------
  INTEGER UP, DOWN, LEFT, RIGHT
  PARAMETER (UP=1, DOWN=2, LEFT=3, RIGHT=4)
  INTEGER  MAXEMX, MAXEMY
  PARAMETER (MAXEMX=100, MAXEMY=100)
  LOGICAL FLAGS(MAXEMX,MAXEMY,2)
  INTEGER MX, MY, IA, IB, JA, JB, IS, JS, I, J, II, JJ, DIR, SDIR
  REAL Z(MX,*)
  REAL Z0, X, Y, STARTX, STARTY
  EXTERNAL PLOT
!
  I = IS
  J = JS
  DIR = SDIR
  II = 1+I-IA
  JJ = 1+J-JA
  IF (DIR==UP .OR. DIR==DOWN) THEN
    X = REAL(I) + (Z0-Z(I,J))/(Z(I+1,J)-Z(I,J))
    Y = REAL(J)
  ELSE
    X = REAL(I)
    Y = REAL(J) + (Z0-Z(I,J))/(Z(I,J+1)-Z(I,J))
  END IF
!D    WRITE (*,*) 'SEGMENT'
!
! Move to start of contour and record starting point.
!
  CALL PLOT(0, X, Y, Z0)
  STARTX = X
  STARTY = Y
!
! We have reached grid-point (I,J) going in direction DIR (UP, DOWN,
! LEFT, or RIGHT). Look at the other three sides of the cell we are
! entering to decide where to go next. It is important to look to the
! two sides before looking straight ahead, in order to avoid self-
! intersecting contours. If all 3 sides have unused crossing-points,
! the cell is "degenerate" and we have to decide which of two possible
! pairs of contour segments to draw; at present we make an arbitrary
! choice. If we have reached the edge of the array, we have
! finished drawing an unclosed contour. If none of the other three
! sides of the cell have an unused crossing-point, we must have
! completed a closed contour, which requires a final segment back to
! the starting point.
!
  100 CONTINUE
!D    WRITE (*,*) I,J,DIR
  II = 1 + I - IA
  JJ = 1 + J - JA
  GOTO (110, 120, 130, 140), DIR
!
! DIR = UP
!
  110 CONTINUE
  FLAGS(II,JJ,1) = .FALSE.
  IF (J==JB) THEN
    RETURN
  ELSE IF (FLAGS(II,JJ,2)) THEN
    DIR = LEFT
    GOTO 200
  ELSE IF (FLAGS(II+1,JJ,2)) THEN
    DIR = RIGHT
    I = I+1
    GOTO 200
  ELSE IF (FLAGS(II,JJ+1,1)) THEN
!!        DIR = UP
    J = J+1
    GOTO 250
  ELSE
    GOTO 300
  END IF
!
! DIR = DOWN
!
  120 CONTINUE
  FLAGS(II,JJ,1) = .FALSE.
  IF (J==JA) THEN
    RETURN
  ELSE IF (FLAGS(II+1,JJ-1,2)) THEN
    DIR = RIGHT
    I = I+1
    J = J-1
    GOTO 200
  ELSE IF (FLAGS(II,JJ-1,2)) THEN
    DIR = LEFT
    J = J-1
    GOTO 200
  ELSE IF (FLAGS(II,JJ-1,1)) THEN
!!        DIR = DOWN
    J = J-1
    GOTO 250
  ELSE
    GOTO 300
  END IF
!
! DIR = LEFT
!
  130 CONTINUE
  FLAGS(II,JJ,2) = .FALSE.
  IF (I==IA) THEN
    RETURN
  ELSE IF (FLAGS(II-1,JJ,1)) THEN
    DIR = DOWN
    I = I-1
    GOTO 250
  ELSE IF (FLAGS(II-1,JJ+1,1)) THEN
    DIR = UP
    I = I-1
    J = J+1
    GOTO 250
  ELSE IF (FLAGS(II-1,JJ,2)) THEN
!!        DIR = LEFT
    I = I-1
    GOTO 200
  ELSE
    GOTO 300
  END IF
!
! DIR = RIGHT
!
  140 CONTINUE
  FLAGS(II,JJ,2) = .FALSE.
  IF (I==IB) THEN
    RETURN
  ELSE IF (FLAGS(II,JJ+1,1)) THEN
    DIR = UP
    J = J+1
    GOTO 250
  ELSE IF (FLAGS(II,JJ,1)) THEN
    DIR = DOWN
    GOTO 250
  ELSE IF (FLAGS(II+1,JJ,2)) THEN
!!        DIR = RIGHT
    I = I+1
    GOTO 200
  ELSE
    GOTO 300
  END IF
!
! Draw a segment of the contour.
!
  200 X = REAL(I)
  Y = REAL(J) + (Z0-Z(I,J))/(Z(I,J+1)-Z(I,J))
  CALL PLOT(1,X,Y,Z0)
  GOTO 100
  250 X = REAL(I) + (Z0-Z(I,J))/(Z(I+1,J)-Z(I,J))
  Y = REAL(J)
  CALL PLOT(1,X,Y,Z0)
  GOTO 100
!
! Close the contour and go look for another one.
!
  300 CALL PLOT(1,STARTX,STARTY,Z0)
  RETURN
!
  END

  SUBROUTINE PGCNSC (Z, MX, MY, IA, IB, JA, JB, Z0, PLOT)
  INTEGER MX, MY, IA, IB, JA, JB
  REAL Z(MX,*)
  REAL Z0
  EXTERNAL PLOT
!
! PGPLOT (internal routine): Draw a single contour.  This routine is
! called by PGCONT, but may be called directly by the user.
!
! Arguments:
!
! Z (real array dimension MX,MY, input): the array of function values.
! MX,MY (integer, input): actual declared dimension of Z(*,*).
! IA,IB (integer, input): inclusive range of the first index of Z to be
!       contoured.
! JA,JB (integer, input): inclusive range of the second index of Z to
!       be contoured.
! Z0 (real, input): the contour level sought.
! PLOT (the name of a subroutine declared EXTERNAL in the calling
!       routine): this routine is called by PGCNSC to do all graphical
!       output. The calling sequence is CALL PLOT(K,X,Y,Z) where Z is
!       the contour level, (X,Y) are the coordinates of a point (in the
!       inclusive range I1<X<I2, J1<Y<J2, and if K is 0, the routine is
!       to move then pen to (X,Y); if K is 1, it is to draw a line from
!       the current position to (X,Y).
!
! NOTE:  the intervals (IA,IB) and (JA,JB) must not exceed the
! dimensions of an internal array. These are currently set at 100.
!--
! 17-Sep-1989 - Completely rewritten [TJP]. The algorithm is my own,
!               but it is probably not original. It could probably be
!               coded more briefly, if not as clearly.
!  1-May-1994 - Modified to draw contours anticlockwise about maxima,
!               to prevent contours at different levels from
!               crossing in degenerate cells [TJP].
!-----------------------------------------------------------------------
  INTEGER UP, DOWN, LEFT, RIGHT
  PARAMETER (UP=1, DOWN=2, LEFT=3, RIGHT=4)
  INTEGER  MAXEMX, MAXEMY
  PARAMETER (MAXEMX=100, MAXEMY=100)
!
  LOGICAL FLAGS(MAXEMX,MAXEMY,2), RANGE
  INTEGER I, J, II, JJ, DIR
  REAL Z1, Z2, Z3, P, P1, P2

!
! The statement function RANGE decides whether a contour at level P
! crosses the line between two gridpoints with values P1 and P2. It is
! important that a contour cannot cross a line with equal endpoints.
!
  RANGE (P,P1,P2) = (P>MIN(P1,P2)) .AND. (P<=MAX(P1,P2)) &
                    .AND. (P1/=P2)
!
! Check for errors.
!
  IF ( (IB-IA+1) > MAXEMX .OR.  (JB-JA+1) > MAXEMY ) THEN
    CALL GRWARN('PGCNSC - array index range exceeds'// &
                  ' built-in limit of 100')
    RETURN
  END IF
!
! Initialize the flags. The first flag for a gridpoint is set if
! the contour crosses the line segment to the right of the gridpoint
! (joining [I,J] to [I+1,J]); the second flag is set if if it crosses
! the line segment above the gridpoint (joining [I,J] to [I,J+1]).
! The top and right edges require special treatment. (For purposes
! of description only, we assume I increases horizontally to the right
! and J increases vertically upwards.)
!
  DO 20 I=IA,IB
    II = I-IA+1
    DO 10 J=JA,JB
        JJ = J-JA+1
        Z1 = Z(I,J)
        FLAGS(II,JJ,1) = .FALSE.
        FLAGS(II,JJ,2) = .FALSE.
        IF (I<IB) THEN
          Z2 = Z(I+1,J)
          IF (RANGE(Z0,Z1,Z2)) FLAGS(II,JJ,1) = .TRUE.
        END IF
        IF (J<JB) THEN
          Z3 = Z(I,J+1)
          IF (RANGE(Z0,Z1,Z3)) FLAGS(II,JJ,2) = .TRUE.
        END IF
   10     CONTINUE
   20 CONTINUE
!
! Search the edges of the array for the start of an unclosed contour.
! Note that (if the algorithm is implemented correctly) all unclosed
! contours must begin and end at the edge of the array. When one is
! found, call PGCN01 to draw the contour, telling it the correct
! starting direction so that it follows the contour into the array
! instead of out of it. A contour is only started if the higher
! ground lies to the left: this is to enforce the direction convention
! that contours are drawn anticlockwise around maxima. If the high
! ground lies to the right, we will find the other end of the contour
! and start there.
!
! Bottom edge.
!
  J = JA
  JJ = J-JA+1
  DO 26 I=IA,IB-1
    II = I-IA+1
    IF (FLAGS(II,JJ,1) .AND. (Z(I,J)>Z(I+1,J))) &
            CALL PGCN01(Z, MX, MY, IA, IB, JA, JB, &
                        Z0, PLOT, FLAGS, I, J, UP)
   26 CONTINUE
!
! Right edge.
!
  I = IB
  II = I-IA+1
  DO 27 J=JA,JB-1
    JJ = J-JA+1
    IF (FLAGS(II,JJ,2) .AND. (Z(I,J)>Z(I,J+1))) &
            CALL PGCN01(Z, MX, MY, IA, IB, JA, JB, &
                        Z0, PLOT, FLAGS, I, J, LEFT)
   27 CONTINUE
!
! Top edge.
!
  J = JB
  JJ = J-JA+1
  DO 28 I=IB-1,IA,-1
    II = I-IA+1
    IF (FLAGS(II,JJ,1) .AND. (Z(I+1,J)>Z(I,J))) &
            CALL PGCN01(Z, MX, MY, IA, IB, JA, JB, &
                        Z0, PLOT, FLAGS, I, J, DOWN)
   28 CONTINUE
!
! Left edge.
!
  I = IA
  II = I-IA+1
  DO 29 J=JB-1,JA,-1
    JJ = J-JA+1
    IF (FLAGS(II,JJ,2)  .AND. (Z(I,J+1)>Z(I,J))) &
            CALL PGCN01(Z, MX, MY, IA, IB, JA, JB, &
                        Z0, PLOT, FLAGS, I, J, RIGHT)
   29 CONTINUE
!
! Now search the interior of the array for a crossing point, which will
! lie on a closed contour (because all unclosed contours have been
! eliminated). It is sufficient to search just the horizontal crossings
! (or the vertical ones); any closed contour must cross a horizontal
! and a vertical gridline. PGCN01 assumes that when it cannot proceed
! any further, it has reached the end of a closed contour. Thus all
! unclosed contours must be eliminated first.
!
  DO 40 I=IA+1,IB-1
    II = I-IA+1
    DO 30 J=JA+1,JB-1
        JJ = J-JA+1
        IF (FLAGS(II,JJ,1)) THEN
            DIR = UP
            IF (Z(I+1,J)> Z(I,J)) DIR = DOWN
            CALL PGCN01(Z, MX, MY, IA, IB, JA, JB, &
                          Z0, PLOT, FLAGS, I, J, DIR)

        END IF
   30     CONTINUE
   40 CONTINUE
!
! We didn't find any more crossing points: we're finished.
!
  RETURN
  END

!*PGCONB -- contour map of a 2D data array, with blanking
!%void cpgconb(const float *a, int idim, int jdim, int i1, int i2, \
!% int j1, int j2, const float *c, int nc, const float *tr, \
!% float blank);
!+
  SUBROUTINE PGCONB (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, TR, &
                     BLANK)
  INTEGER IDIM, JDIM, I1, I2, J1, J2, NC
  REAL    A(IDIM,JDIM), C(*), TR(6), BLANK
!
! Draw a contour map of an array. This routine is the same as PGCONS,
! except that array elements that have the "magic value" defined by
! argument BLANK are ignored, making gaps in the contour map. The
! routine may be useful for data measured on most but not all of the
! points of a grid.
!
! Arguments:
!  A      (input)  : data array.
!  IDIM   (input)  : first dimension of A.
!  JDIM   (input)  : second dimension of A.
!  I1,I2  (input)  : range of first index to be contoured (inclusive).
!  J1,J2  (input)  : range of second index to be contoured (inclusive).
!  C      (input)  : array of contour levels (in the same units as the
!                    data in array A); dimension at least NC.
!  NC     (input)  : number of contour levels (less than or equal to
!                    dimension of C). The absolute value of this
!                    argument is used (for compatibility with PGCONT,
!                    where the sign of NC is significant).
!  TR     (input)  : array defining a transformation between the I,J
!                    grid of the array and the world coordinates. The
!                    world coordinates of the array point A(I,J) are
!                    given by:
!                      X = TR(1) + TR(2)*I + TR(3)*J
!                      Y = TR(4) + TR(5)*I + TR(6)*J
!                    Usually TR(3) and TR(5) are zero - unless the
!                    coordinate transformation involves a rotation
!                    or shear.
!  BLANK   (input) : elements of array A that are exactly equal to
!                    this value are ignored (blanked).
!--
! 21-Sep-1989 - Derived from PGCONS [TJP].
!-----------------------------------------------------------------------
  INTEGER  I, IC, ICORN, IDELT(6), J, K, NPT
  INTEGER  IOFF(8), JOFF(8), IENC, ITMP, JTMP, ILO, ITOT
  LOGICAL  PGNOTO
  REAL     CTR, DELTA, DVAL(5), XX, YY, X(4), Y(4)
  INTRINSIC ABS
  DATA     IDELT/0,-1,-1,0,0,-1/
  DATA     IOFF/-2,-2,-1,-1, 0, 0, 1, 1/
  DATA     JOFF/ 0,-1,-2, 1,-2, 1,-1, 0/
!
! Check arguments.
!
  IF (PGNOTO('PGCONB')) RETURN
  IF (I1<1 .OR. I2>IDIM .OR. I1>=I2 .OR. &
      J1<1 .OR. J2>JDIM .OR. J1>=J2) RETURN
  IF (NC==0) RETURN
  CALL PGBBUF
!
  DO 130 J=J1+1,J2
  DO 130 I=I1+1,I2
    DVAL(1) = A(I-1,J)
    DVAL(2) = A(I-1,J-1)
    DVAL(3) = A(I,J-1)
    DVAL(4) = A(I,J)
    DVAL(5) = DVAL(1)
    IF (DVAL(1)==BLANK .OR. DVAL(2)==BLANK .OR. &
          DVAL(3)==BLANK .OR. DVAL(4)==BLANK) GOTO 130
  DO 110 IC=1,ABS(NC)
    CTR = C(IC)
    NPT = 0
    DO 120 ICORN=1,4
    IF( (DVAL(ICORN)<CTR .AND. DVAL(ICORN+1)<CTR) &
      .OR.(DVAL(ICORN)>=CTR .AND. DVAL(ICORN+1)>=CTR) ) GOTO 120
      NPT=NPT+1
      DELTA = (CTR-DVAL(ICORN))/(DVAL(ICORN+1)-DVAL(ICORN))
      GOTO (60,70,60,70), ICORN
!
   60       XX = I+IDELT(ICORN+1)
      YY = REAL(J+IDELT(ICORN)) + &
             DELTA*REAL(IDELT(ICORN+1)-IDELT(ICORN))
      GOTO 80
!
   70       XX = REAL(I+IDELT(ICORN+1)) + &
             DELTA*REAL(IDELT(ICORN+2)-IDELT(ICORN+1))
      YY  = J+IDELT(ICORN)
!
   80       X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY
      Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY
!
  120     CONTINUE
    IF (NPT==2) THEN
!             -- Contour crosses two sides of cell. Draw line-segment.
        CALL PGMOVE(X(1),Y(1))
        CALL PGDRAW(X(2),Y(2))
    ELSE IF (NPT==4) THEN
!             -- The 'ambiguous' case.  The routine must draw two line
!             segments here and there are two ways to do so.  The
!             following 4 lines would implement the original PGPLOT
!             method:
!            CALL PGCP(0,X(1),Y(1),CTR)
!            CALL PGCP(1,X(2),Y(2),CTR)
!            CALL PGCP(0,X(3),Y(3),CTR)
!            CALL PGCP(1,X(4),Y(4),CTR)
!            -- Choose between \\ and // based on the 8 points just
!            outside the current box.  If half or more of these points
!            lie below the contour level, then draw the lines such that
!            the high corners lie between the lines, otherwise, draw
!            the lines such that the low corners are enclosed.  Care is
!            taken to avoid going off the edge.
      ITOT=0
      ILO=0
      DO 140 K=1,8
         ITMP=I+IOFF(K)
         JTMP=J+JOFF(K)
         IF(ITMP<I1 .OR. ITMP>I2) GOTO 140
         IF(JTMP<J1 .OR. JTMP>J2) GOTO 140
         IF(A(ITMP,JTMP)==BLANK) GOTO 140
         ITOT=ITOT+1
         IF(A(ITMP,JTMP)<CTR) ILO=ILO+1
  140       CONTINUE
      IENC=+1
      IF(ILO<ITOT/2) IENC=-1
      IF(IENC<0 .AND. DVAL(1)<CTR .OR. &
           IENC>0 .AND. DVAL(1)>=CTR) THEN
         CALL PGMOVE(X(1),Y(1))
         CALL PGDRAW(X(2),Y(2))
         CALL PGMOVE(X(3),Y(3))
         CALL PGDRAW(X(4),Y(4))
      ELSE
         CALL PGMOVE(X(1),Y(1))
         CALL PGDRAW(X(4),Y(4))
         CALL PGMOVE(X(3),Y(3))
         CALL PGDRAW(X(2),Y(2))
      END IF
    END IF
  110     CONTINUE
  130 CONTINUE
!
  CALL PGEBUF
  END

!*PGCONF -- fill between two contours
!%void cpgconf(const float *a, int idim, int jdim, int i1, int i2, \
!% int j1, int j2, float c1, float c2, const float *tr);
!+
  SUBROUTINE PGCONF (A, IDIM, JDIM, I1, I2, J1, J2, C1, C2, TR)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  REAL    A(IDIM,JDIM), C1, C2, TR(6)
!
! Shade the region between two contour levels of a function defined on
! the nodes of a rectangular grid. The routine uses the current fill
! attributes, hatching style (if appropriate), and color index.
!
! If you want to both shade between contours and draw the contour
! lines, call this routine first (once for each pair of levels) and
! then CALL PGCONT (or PGCONS) to draw the contour lines on top of the
! shading.
!
! Note 1: This routine is not very efficient: it generates a polygon
! fill command for each cell of the mesh that intersects the desired
! area, rather than consolidating adjacent cells into a single polygon.
!
! Note 2: If both contours intersect all four edges of a particular
! mesh cell, the program behaves badly and may consider some parts
! of the cell to lie in more than one contour range.
!
! Note 3: If a contour crosses all four edges of a cell, this
! routine may not generate the same contours as PGCONT or PGCONS
! (these two routines may not agree either). Such cases are always
! ambiguous and the routines use different approaches to resolving
! the ambiguity.
!
! Arguments:
!  A      (input)  : data array.
!  IDIM   (input)  : first dimension of A.
!  JDIM   (input)  : second dimension of A.
!  I1,I2  (input)  : range of first index to be contoured (inclusive).
!  J1,J2  (input)  : range of second index to be contoured (inclusive).
!  C1, C2 (input)  : contour levels; note that C1 must be less than C2.
!  TR     (input)  : array defining a transformation between the I,J
!                    grid of the array and the world coordinates. The
!                    world coordinates of the array point A(I,J) are
!                    given by:
!                      X = TR(1) + TR(2)*I + TR(3)*J
!                      Y = TR(4) + TR(5)*I + TR(6)*J
!                    Usually TR(3) and TR(5) are zero - unless the
!                    coordinate transformation involves a rotation
!                    or shear.
!--
! 03-Oct-1996 - new routine [TJP].
!-----------------------------------------------------------------------
  INTEGER  I, J, IC, NPT, LEV
  LOGICAL  PGNOTO
  REAL     DVAL(5), X(8), Y(8), DELTA, XX, YY, C, R
  INTEGER  IDELT(6)
  DATA     IDELT/0,-1,-1,0,0,-1/
!
! Check arguments.
!
  IF (PGNOTO('PGCONF')) RETURN
  IF (I1<1 .OR. I2>IDIM .OR. I1>=I2 .OR. &
      J1<1 .OR. J2>JDIM .OR. J1>=J2) RETURN
  IF (C1>=C2) RETURN
  CALL PGBBUF
!
  DO 140 J=J1+1,J2
   DO 130 I=I1+1,I2
      DVAL(1) = A(I-1,J)
      DVAL(2) = A(I-1,J-1)
      DVAL(3) = A(I,J-1)
      DVAL(4) = A(I,J)
      DVAL(5) = DVAL(1)
!
      NPT = 0
      DO 120 IC=1,4
         IF (DVAL(IC)>=C1 .AND. DVAL(IC)<C2) THEN
            NPT = NPT+1
            XX = I+IDELT(IC+1)
            YY = J+IDELT(IC)
            X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY
            Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY
         END IF
         R = DVAL(IC+1)-DVAL(IC)
         IF (R==0.0) GOTO 120
         DO 110 LEV=1,2
            IF (R>0.0) THEN
               C = C1
               IF (LEV==2) C = C2
            ELSE
               C = C2
               IF (LEV==2) C = C1
            END IF
            DELTA = (C-DVAL(IC))/R
            IF (DELTA>0.0 .AND. DELTA<1.0) THEN
               IF (IC==1 .OR. IC==3) THEN
                  XX = I+IDELT(IC+1)
                  YY = REAL(J+IDELT(IC)) + &
                         DELTA*REAL(IDELT(IC+1)-IDELT(IC))
               ELSE
                  XX = REAL(I+IDELT(IC+1)) + &
                         DELTA*REAL(IDELT(IC+2)-IDELT(IC+1))
                  YY = J+IDELT(IC)
               END IF
               NPT = NPT+1
               X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY
               Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY
            END IF
 110           CONTINUE
 120        CONTINUE
      IF (NPT>=3) CALL PGPOLY(NPT, X, Y)
 130     CONTINUE
 140  CONTINUE
  CALL PGEBUF
  END

!*PGCONL -- label contour map of a 2D data array
!%void cpgconl(const float *a, int idim, int jdim, int i1, int i2, \
!% int j1, int j2, float c, const float *tr, const char *label, \
!% int intval, int minint);
!+
  SUBROUTINE PGCONL (A, IDIM, JDIM, I1, I2, J1, J2, C, TR, &
                     LABEL, INTVAL, MININT)
  INTEGER IDIM, JDIM, I1, J1, I2, J2, INTVAL, MININT
  REAL A(IDIM,JDIM), C, TR(6)
  CHARACTER*(*) LABEL
!
! Label a contour map drawn with routine PGCONT. Routine PGCONT should
! be called first to draw the contour lines, then this routine should be
! called to add the labels. Labels are written at intervals along the
! contour lines, centered on the contour lines with lettering aligned
! in the up-hill direction. Labels are opaque, so a part of the under-
! lying contour line is obscured by the label. Labels use the current
! attributes (character height, line width, color index, character
! font).
!
! The first 9 arguments are the same as those supplied to PGCONT, and
! should normally be identical to those used with PGCONT. Note that
! only one contour level can be specified; tolabel more contours, call
! PGCONL for each level.
!
! The Label is supplied as a character string in argument LABEL.
!
! The spacing of labels along the contour is specified by parameters
! INTVAL and MININT. The routine follows the contour through the
! array, counting the number of cells that the contour crosses. The
! first label will be written in the MININT'th cell, and additional
! labels will be written every INTVAL cells thereafter. A contour
! that crosses less than MININT cells will not be labelled. Some
! experimentation may be needed to get satisfactory results; a good
! place to start is INTVAL=20, MININT=10.
!
! Arguments:
!  A      (input) : data array.
!  IDIM   (input) : first dimension of A.
!  JDIM   (input) : second dimension of A.
!  I1, I2 (input) : range of first index to be contoured (inclusive).
!  J1, J2 (input) : range of second index to be contoured (inclusive).
!  C      (input) : the level of the contour to be labelled (one of the
!                   values given to PGCONT).
!  TR     (input) : array defining a transformation between the I,J
!                   grid of the array and the world coordinates.
!                   The world coordinates of the array point A(I,J)
!                   are given by:
!                     X = TR(1) + TR(2)*I + TR(3)*J
!                     Y = TR(4) + TR(5)*I + TR(6)*J
!                   Usually TR(3) and TR(5) are zero - unless the
!                   coordinate transformation involves a rotation or
!                   shear.
!  LABEL  (input) : character strings to be used to label the specified
!                   contour. Leading and trailing blank spaces are
!                   ignored.
!  INTVAL (input) : spacing along the contour between labels, in
!                   grid cells.
!  MININT (input) : contours that cross less than MININT cells
!                   will not be labelled.
!--
!  5-May-1994 - New routine; this routine is virtually identical to
!               PGCONT, but calls PGCONX with a different external
!               routine [TJP].
!  4-Feb-1997 - PGCONX requires an array argument, not scalar [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  INTEGER  I
  LOGICAL  PGNOTO
  REAL     CL(1)
  EXTERNAL PGCL
!
  IF (PGNOTO('PGCONL')) RETURN
!
! Save TRANS matrix and other parameters.
!
  DO 10 I=1,6
    TRANS(I) = TR(I)
   10 CONTINUE
  PGCINT = INTVAL
  PGCMIN = MININT
  PGCLAB = LABEL
!
! Use PGCONX with external function PGCL.
!
  CL(1) = C
  CALL PGCONX (A, IDIM, JDIM, I1, I2, J1, J2, CL, 1, PGCL)
!
  END

!*PGCONS -- contour map of a 2D data array (fast algorithm)
!%void cpgcons(const float *a, int idim, int jdim, int i1, int i2, \
!% int j1, int j2, const float *c, int nc, const float *tr);
!+
  SUBROUTINE PGCONS (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, TR)
  INTEGER IDIM, JDIM, I1, I2, J1, J2, NC
  REAL    A(IDIM,JDIM), C(*), TR(6)
!
! Draw a contour map of an array. The map is truncated if
! necessary at the boundaries of the viewport.  Each contour line is
! drawn with the current line attributes (color index, style, and
! width).  This routine, unlike PGCONT, does not draw each contour as a
! continuous line, but draws the straight line segments composing each
! contour in a random order.  It is thus not suitable for use on pen
! plotters, and it usually gives unsatisfactory results with dashed or
! dotted lines.  It is, however, faster than PGCONT, especially if
! several contour levels are drawn with one call of PGCONS.
!
! Arguments:
!  A      (input)  : data array.
!  IDIM   (input)  : first dimension of A.
!  JDIM   (input)  : second dimension of A.
!  I1,I2  (input)  : range of first index to be contoured (inclusive).
!  J1,J2  (input)  : range of second index to be contoured (inclusive).
!  C      (input)  : array of contour levels (in the same units as the
!                    data in array A); dimension at least NC.
!  NC     (input)  : number of contour levels (less than or equal to
!                    dimension of C). The absolute value of this
!                    argument is used (for compatibility with PGCONT,
!                    where the sign of NC is significant).
!  TR     (input)  : array defining a transformation between the I,J
!                    grid of the array and the world coordinates. The
!                    world coordinates of the array point A(I,J) are
!                    given by:
!                      X = TR(1) + TR(2)*I + TR(3)*J
!                      Y = TR(4) + TR(5)*I + TR(6)*J
!                    Usually TR(3) and TR(5) are zero - unless the
!                    coordinate transformation involves a rotation
!                    or shear.
!--
! 27-Aug-1984 - [TJP].
! 21-Sep-1989 - Better treatment of the 'ambiguous' case [A. Tennant];
!               compute world coordinates internally and eliminate
!               dependence on common block [TJP].
!-----------------------------------------------------------------------
  INTEGER  I, IC, ICORN, IDELT(6), J, K, NPT
  INTEGER  IOFF(8), JOFF(8), IENC, ITMP, JTMP, ILO, ITOT
  LOGICAL  PGNOTO
  REAL     CTR, DELTA, DVAL(5), XX, YY, X(4), Y(4)
  INTRINSIC ABS
  DATA     IDELT/0,-1,-1,0,0,-1/
  DATA     IOFF/-2,-2,-1,-1, 0, 0, 1, 1/
  DATA     JOFF/ 0,-1,-2, 1,-2, 1,-1, 0/
!
! Check arguments.
!
  IF (PGNOTO('PGCONS')) RETURN
  IF (I1<1 .OR. I2>IDIM .OR. I1>=I2 .OR. &
      J1<1 .OR. J2>JDIM .OR. J1>=J2) RETURN
  IF (NC==0) RETURN
  CALL PGBBUF
!
  DO 130 J=J1+1,J2
  DO 130 I=I1+1,I2
    DVAL(1) = A(I-1,J)
    DVAL(2) = A(I-1,J-1)
    DVAL(3) = A(I,J-1)
    DVAL(4) = A(I,J)
    DVAL(5) = DVAL(1)
  DO 110 IC=1,ABS(NC)
    CTR = C(IC)
    NPT = 0
    DO 120 ICORN=1,4
    IF( (DVAL(ICORN)<CTR .AND. DVAL(ICORN+1)<CTR) &
      .OR.(DVAL(ICORN)>=CTR .AND. DVAL(ICORN+1)>=CTR) ) GOTO 120
      NPT=NPT+1
      DELTA = (CTR-DVAL(ICORN))/(DVAL(ICORN+1)-DVAL(ICORN))
      GOTO (60,70,60,70), ICORN
!
   60       XX = I+IDELT(ICORN+1)
      YY = REAL(J+IDELT(ICORN)) + &
             DELTA*REAL(IDELT(ICORN+1)-IDELT(ICORN))
      GOTO 80
!
   70       XX = REAL(I+IDELT(ICORN+1)) + &
             DELTA*REAL(IDELT(ICORN+2)-IDELT(ICORN+1))
      YY  = J+IDELT(ICORN)
!
   80       X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY
      Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY
!
  120     CONTINUE
    IF (NPT==2) THEN
!             -- Contour crosses two sides of cell. Draw line-segment.
        CALL PGMOVE(X(1),Y(1))
        CALL PGDRAW(X(2),Y(2))
    ELSE IF (NPT==4) THEN
!             -- The 'ambiguous' case.  The routine must draw two line
!             segments here and there are two ways to do so.  The
!             following 4 lines would implement the original PGPLOT
!             method:
!            CALL PGCP(0,X(1),Y(1),CTR)
!            CALL PGCP(1,X(2),Y(2),CTR)
!            CALL PGCP(0,X(3),Y(3),CTR)
!            CALL PGCP(1,X(4),Y(4),CTR)
!            -- Choose between \\ and // based on the 8 points just
!            outside the current box.  If half or more of these points
!            lie below the contour level, then draw the lines such that
!            the high corners lie between the lines, otherwise, draw
!            the lines such that the low corners are enclosed.  Care is
!            taken to avoid going off the edge.
      ITOT=0
      ILO=0
      DO 140 K=1,8
         ITMP=I+IOFF(K)
         JTMP=J+JOFF(K)
         IF(ITMP<I1 .OR. ITMP>I2) GOTO 140
         IF(JTMP<J1 .OR. JTMP>J2) GOTO 140
         ITOT=ITOT+1
         IF(A(ITMP,JTMP)<CTR) ILO=ILO+1
  140       CONTINUE
      IENC=+1
      IF(ILO<ITOT/2) IENC=-1
      IF(IENC<0 .AND. DVAL(1)<CTR .OR. &
           IENC>0 .AND. DVAL(1)>=CTR) THEN
         CALL PGMOVE(X(1),Y(1))
         CALL PGDRAW(X(2),Y(2))
         CALL PGMOVE(X(3),Y(3))
         CALL PGDRAW(X(4),Y(4))
      ELSE
         CALL PGMOVE(X(1),Y(1))
         CALL PGDRAW(X(4),Y(4))
         CALL PGMOVE(X(3),Y(3))
         CALL PGDRAW(X(2),Y(2))
      END IF
    END IF
  110     CONTINUE
  130 CONTINUE
!
  CALL PGEBUF
  END

!*PGCONT -- contour map of a 2D data array (contour-following)
!%void cpgcont(const float *a, int idim, int jdim, int i1, int i2, \
!% int j1, int j2, const float *c, int nc, const float *tr);
!+
  SUBROUTINE PGCONT (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, TR)
  INTEGER IDIM, JDIM, I1, J1, I2, J2, NC
  REAL A(IDIM,JDIM), C(*), TR(6)
!
! Draw a contour map of an array.  The map is truncated if
! necessary at the boundaries of the viewport.  Each contour line
! is drawn with the current line attributes (color index, style, and
! width); except that if argument NC is positive (see below), the line
! style is set by PGCONT to 1 (solid) for positive contours or 2
! (dashed) for negative contours.
!
! Arguments:
!  A      (input) : data array.
!  IDIM   (input) : first dimension of A.
!  JDIM   (input) : second dimension of A.
!  I1, I2 (input) : range of first index to be contoured (inclusive).
!  J1, J2 (input) : range of second index to be contoured (inclusive).
!  C      (input) : array of NC contour levels; dimension at least NC.
!  NC     (input) : +/- number of contour levels (less than or equal
!                   to dimension of C). If NC is positive, it is the
!                   number of contour levels, and the line-style is
!                   chosen automatically as described above. If NC is
!                   negative, it is minus the number of contour
!                   levels, and the current setting of line-style is
!                   used for all the contours.
!  TR     (input) : array defining a transformation between the I,J
!                   grid of the array and the world coordinates.
!                   The world coordinates of the array point A(I,J)
!                   are given by:
!                     X = TR(1) + TR(2)*I + TR(3)*J
!                     Y = TR(4) + TR(5)*I + TR(6)*J
!                   Usually TR(3) and TR(5) are zero - unless the
!                   coordinate transformation involves a rotation or
!                   shear.
!--
! (7-Feb-1983)
! (24-Aug-1984) Revised to add the option of not automatically
!       setting the line-style. Sorry about the ugly way this is
!       done (negative NC); this is the least incompatible way of doing
!       it (TJP).
! (21-Sep-1989) Changed to call PGCONX instead of duplicating the code
!       [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  INTEGER  I
  LOGICAL  PGNOTO
  EXTERNAL PGCP
!
  IF (PGNOTO('PGCONT')) RETURN
!
! Save TRANS matrix.
!
  DO 10 I=1,6
    TRANS(I) = TR(I)
   10 CONTINUE
!
! Use PGCONX with external function PGCP, which applies the TRANS
! scaling.
!
  CALL PGCONX (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, PGCP)
!
  END

!*PGCONX -- contour map of a 2D data array (non rectangular)
!+
  SUBROUTINE PGCONX (A, IDIM, JDIM, I1, I2, J1, J2, C, NC, PLOT)
  INTEGER  IDIM, JDIM, I1, J1, I2, J2, NC
  REAL     A(IDIM,JDIM), C(*)
  EXTERNAL PLOT
!
! Draw a contour map of an array using a user-supplied plotting
! routine.  This routine should be used instead of PGCONT when the
! data are defined on a non-rectangular grid.  PGCONT permits only
! a linear transformation between the (I,J) grid of the array
! and the world coordinate system (x,y), but PGCONX permits any
! transformation to be used, the transformation being defined by a
! user-supplied subroutine. The nature of the contouring algorithm,
! however, dictates that the transformation should maintain the
! rectangular topology of the grid, although grid-points may be
! allowed to coalesce.  As an example of a deformed rectangular
! grid, consider data given on the polar grid theta=0.1n(pi/2),
! for n=0,1,...,10, and r=0.25m, for m=0,1,..,4. This grid
! contains 55 points, of which 11 are coincident at the origin.
! The input array for PGCONX should be dimensioned (11,5), and
! data values should be provided for all 55 elements.  PGCONX can
! also be used for special applications in which the height of the
! contour affects its appearance, e.g., stereoscopic views.
!
! The map is truncated if necessary at the boundaries of the viewport.
! Each contour line is drawn with the current line attributes (color
! index, style, and width); except that if argument NC is positive
! (see below), the line style is set by PGCONX to 1 (solid) for
! positive contours or 2 (dashed) for negative contours. Attributes
! for the contour lines can also be set in the user-supplied
! subroutine, if desired.
!
! Arguments:
!  A      (input) : data array.
!  IDIM   (input) : first dimension of A.
!  JDIM   (input) : second dimension of A.
!  I1, I2 (input) : range of first index to be contoured (inclusive).
!  J1, J2 (input) : range of second index to be contoured (inclusive).
!  C      (input) : array of NC contour levels; dimension at least NC.
!  NC     (input) : +/- number of contour levels (less than or equal
!                   to dimension of C). If NC is positive, it is the
!                   number of contour levels, and the line-style is
!                   chosen automatically as described above. If NC is
!                   negative, it is minus the number of contour
!                   levels, and the current setting of line-style is
!                   used for all the contours.
!  PLOT   (input) : the address (name) of a subroutine supplied by
!                   the user, which will be called by PGCONX to do
!                   the actual plotting. This must be declared
!                   EXTERNAL in the program unit calling PGCONX.
!
! The subroutine PLOT will be called with four arguments:
!      CALL PLOT(VISBLE,X,Y,Z)
! where X,Y (input) are real variables corresponding to
! I,J indices of the array A. If  VISBLE (input, integer) is 1,
! PLOT should draw a visible line from the current pen
! position to the world coordinate point corresponding to (X,Y);
! if it is 0, it should move the pen to (X,Y). Z is the value
! of the current contour level, and may be used by PLOT if desired.
! Example:
!       SUBROUTINE PLOT (VISBLE,X,Y,Z)
!       REAL X, Y, Z, XWORLD, YWORLD
!       INTEGER VISBLE
!       XWORLD = X*COS(Y) ! this is the user-defined
!       YWORLD = X*SIN(Y) ! transformation
!       IF (VISBLE.EQ.0) THEN
!           CALL PGMOVE (XWORLD, YWORLD)
!       ELSE
!           CALL PGDRAW (XWORLD, YWORLD)
!       END IF
!       END
!--
! 14-Nov-1985 - new routine [TJP].
! 12-Sep-1989 - correct documentation error [TJP].
! 22-Apr-1990 - corrected bug in panelling algorithm [TJP].
! 13-Dec-1990 - make errors non-fatal [TJP].
!-----------------------------------------------------------------------
  INTEGER  MAXEMX,MAXEMY
  PARAMETER (MAXEMX=100)
  PARAMETER (MAXEMY=100)
  INTEGER  I
  INTEGER  NNX,NNY, KX,KY, KI,KJ, IA,IB, JA,JB, LS, PX, PY
  LOGICAL  STYLE, PGNOTO
!
! Check arguments.
!
  IF (PGNOTO('PGCONX')) RETURN
  IF (I1<1 .OR. I2>IDIM .OR. I1>=I2 .OR. &
      J1<1 .OR. J2>JDIM .OR. J1>=J2) THEN
    CALL GRWARN('PGCONX: invalid range I1:I2, J1:J2')
    RETURN
  END IF
  IF (NC==0) RETURN
  STYLE = NC>0
  CALL PGQLS(LS)
  CALL PGBBUF
!
! Divide arrays into panels not exceeding MAXEMX by MAXEMY for
! contouring by PGCNSC.
!
!D    write (*,*) 'PGCONX window:',i1,i2,j1,j2
  NNX = I2-I1+1
  NNY = J2-J1+1
  KX = MAX(1,(NNX+MAXEMX-2)/(MAXEMX-1))
  KY = MAX(1,(NNY+MAXEMY-2)/(MAXEMY-1))
  PX = (NNX+KX-1)/KX
  PY = (NNY+KY-1)/KY
  DO 60 KI=1,KX
    IA = I1 + (KI-1)*PX
    IB = MIN(I2, IA + PX)
    DO 50 KJ=1,KY
        JA = J1 + (KJ-1)*PY
        JB = MIN(J2, JA + PY)
!
!             Draw the contours in one panel.
!
!D            write (*,*) 'PGCONX panel:',ia,ib,ja,jb
        IF (STYLE) CALL PGSLS(1)
        DO 40 I=1,ABS(NC)
            IF (STYLE.AND.(C(I)<0.0)) CALL PGSLS(2)
            CALL PGCNSC(A,IDIM,JDIM,IA,IB,JA,JB,C(I),PLOT)
            IF (STYLE) CALL PGSLS(1)
   40         CONTINUE
   50     CONTINUE
   60 CONTINUE
!
  CALL PGSLS(LS)
  CALL PGEBUF
  END

!
  SUBROUTINE PGCP (K, X, Y, Z)
!
! PGPLOT (internal routine): Draw one contour segment (for use by
! PGCNSC).
!
! Arguments:
!
! K (input, integer): if K=0, move the pen to (X,Y); if K=1, draw
!       a line from the current position to (X,Y); otherwise
!       do nothing.
! X (input, real): X world-coordinate of end point.
! Y (input, real): Y world-coordinate of end point.
! Z (input, real): the value of the contour level, not used by PGCP at
!       the moment.
!
! (7-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  INTEGER  K
  REAL     X,XX,Y,YY,Z
!
  XX = TRANS(1) + TRANS(2)*X + TRANS(3)*Y
  YY = TRANS(4) + TRANS(5)*X + TRANS(6)*Y
  IF (K==1) THEN
    CALL GRLINA(XX,YY)
  ELSE IF (K==0) THEN
    CALL GRMOVA(XX,YY)
  END IF
  END

!*PGCTAB -- install the color table to be used by PGIMAG
!%void cpgctab(const float *l, const float *r, const float *g, \
!% const float *b, int nc, float contra, float bright);
!+
  SUBROUTINE PGCTAB(L, R, G, B, NC, CONTRA, BRIGHT)
  INTEGER NC
  REAL    L(NC), R(NC), G(NC), B(NC), CONTRA, BRIGHT
!
! Use the given color table to change the color representations of
! all color indexes marked for use by PGIMAG. To change which
! color indexes are thus marked, call PGSCIR before calling PGCTAB
! or PGIMAG. On devices that can change the color representations
! of previously plotted graphics, PGCTAB will also change the colors
! of existing graphics that were plotted with the marked color
! indexes. This feature can then be combined with PGBAND to
! interactively manipulate the displayed colors of data previously
! plotted with PGIMAG.
!
! Limitations:
!  1. Some devices do not propagate color representation changes
!     to previously drawn graphics.
!  2. Some devices ignore requests to change color representations.
!  3. The appearance of specific color representations on grey-scale
!     devices is device-dependent.
!
! Notes:
!  To reverse the sense of a color table, change the chosen contrast
!  and brightness to -CONTRA and 1-BRIGHT.
!
!  In the following, the term 'color table' refers to the input
!  L,R,G,B arrays, whereas 'color ramp' refers to the resulting
!  ramp of colors that would be seen with PGWEDG.
!
! Arguments:
!  L      (input)  : An array of NC normalized ramp-intensity levels
!                    corresponding to the RGB primary color intensities
!                    in R(),G(),B(). Colors on the ramp are linearly
!                    interpolated from neighbouring levels.
!                    Levels must be sorted in increasing order.
!                     0.0 places a color at the beginning of the ramp.
!                     1.0 places a color at the end of the ramp.
!                    Colors outside these limits are legal, but will
!                    not be visible if CONTRA=1.0 and BRIGHT=0.5.
!  R      (input)  : An array of NC normalized red intensities.
!  G      (input)  : An array of NC normalized green intensities.
!  B      (input)  : An array of NC normalized blue intensities.
!  NC     (input)  : The number of color table entries.
!  CONTRA (input)  : The contrast of the color ramp (normally 1.0).
!                    Negative values reverse the direction of the ramp.
!  BRIGHT (input)  : The brightness of the color ramp. This is normally
!                    0.5, but can sensibly hold any value between 0.0
!                    and 1.0. Values at or beyond the latter two
!                    extremes, saturate the color ramp with the colors
!                    of the respective end of the color table.
!--
!  17-Sep-1994 - New routine [MCS].
!  14-Apr-1997 - Modified to implement a more conventional
!                interpretation of contrast and brightness [MCS].
!-----------------------------------------------------------------------
  INTEGER MININD, MAXIND, CI
  INTEGER NTOTAL, NSPAN
  INTEGER BELOW, ABOVE
  LOGICAL FORWRD
  REAL CA, CB, CIFRAC, SPAN
  REAL LEVEL
  REAL LDIFF, LFRAC
  REAL RED, GREEN, BLUE
!
! Set the minimum absolute contrast - this prevents a divide by zero.
!
  REAL MINCTR
  PARAMETER (MINCTR = 1.0/256)
!
! No colormap entries?
!
  IF(NC == 0) RETURN
!
! Determine the range of color indexes to be used.
!
  CALL PGQCIR(MININD, MAXIND)
!
! Count the total number of color indexes to be processed.
!
  NTOTAL = MAXIND - MININD + 1
!
! No definable colors?
!
  IF(NTOTAL < 1 .OR. MININD < 0) RETURN
!
! Prevent a divide by zero later by ensuring that CONTRA >= ABS(MINCTR).
!
  IF(ABS(CONTRA) < MINCTR) THEN
  CONTRA = SIGN(MINCTR, CONTRA)
  END IF
!
! Convert contrast to the normalized stretch of the
! color table across the available color index range.
!
  SPAN = 1.0 / ABS(CONTRA)
!
! Translate from brightness and contrast to the normalized color index
! coordinates, CA and CB, at which to place the start and end of the
! color table.
!
  IF(CONTRA >= 0.0) THEN
  CA = 1.0 - BRIGHT * (1.0 + SPAN)
  CB = CA + SPAN
  ELSE
  CA = BRIGHT * (1.0 + SPAN)
  CB = CA - SPAN
  END IF
!
! Determine the number of color indexes spanned by the color table.
!
  NSPAN = INT(SPAN * NTOTAL)
!
! Determine the direction in which the color table should be traversed.
!
  FORWRD = CA <= CB
!
! Initialize the indexes at which to start searching the color table.
!
! Set the start index for traversing the table from NC to 1.
!
  BELOW = NC
!
! Set the start index for traversing the table from 1 to NC.
!
  ABOVE = 1
!
! Buffer PGPLOT commands until the color map has been completely
! installed.
!
  CALL PGBBUF
!
! Linearly interpolate the color table RGB values onto each color index.
!
  DO 1 CI=MININD, MAXIND
!
! Turn the color index into a fraction of the range MININD..MAXIND.
!
  CIFRAC = REAL(CI-MININD) / REAL(MAXIND-MININD)
!
! Determine the color table position that corresponds to color index,
! CI.
!
  IF(NSPAN > 0) THEN
    LEVEL = (CIFRAC-CA) / (CB-CA)
  ELSE
    IF(CIFRAC <= CA) THEN
      LEVEL = 0.0
    ELSE
      LEVEL = 1.0
    END IF
  END IF
!
! Search for the indexes of the two color table entries that straddle
! LEVEL. The search algorithm assumes that values in L() are
! arranged in increasing order. This allows us to search the color table
! from the point at which the last search left off, rather than having
! to search the whole color table each time.
!
  IF(FORWRD) THEN
 2        IF(ABOVE<=NC .AND. L(ABOVE)<LEVEL) THEN
      ABOVE = ABOVE + 1
      GOTO 2
    END IF
    BELOW = ABOVE - 1
  ELSE
 3        IF(BELOW>=1 .AND. L(BELOW)>LEVEL) THEN
      BELOW = BELOW - 1
      GOTO 3
    END IF
    ABOVE = BELOW + 1
  END IF
!
! If the indexes lie outside the table, substitute the index of the
! nearest edge of the table.
!
  IF(BELOW < 1) THEN
    LEVEL = 0.0
    BELOW = 1
    ABOVE = 1
  ELSE IF(ABOVE > NC) THEN
    LEVEL = 1.0
    BELOW = NC
    ABOVE = NC
  END IF
!
! Linearly interpolate the primary color intensities from color table
! entries, BELOW and ABOVE.
!
  LDIFF = L(ABOVE) - L(BELOW)
  IF(LDIFF > MINCTR) THEN
    LFRAC = (LEVEL - L(BELOW)) / LDIFF
  ELSE
    LFRAC = 0.0
  END IF
  RED   = R(BELOW) + (R(ABOVE) - R(BELOW)) * LFRAC
  GREEN = G(BELOW) + (G(ABOVE) - G(BELOW)) * LFRAC
  BLUE  = B(BELOW) + (B(ABOVE) - B(BELOW)) * LFRAC
!
! Intensities are only defined between 0 and 1.
!
  IF(RED   < 0.0)   RED = 0.0
  IF(RED   > 1.0)   RED = 1.0
  IF(GREEN < 0.0) GREEN = 0.0
  IF(GREEN > 1.0) GREEN = 1.0
  IF(BLUE  < 0.0)  BLUE = 0.0
  IF(BLUE  > 1.0)  BLUE = 1.0
!
! Install the new color representation.
!
  CALL PGSCR(CI, RED, GREEN, BLUE)
 1    CONTINUE
!
! Reveal the changed color map.
!
  CALL PGEBUF
  RETURN
  END

!*PGCURSE -- non-standard alias for PGCURS
!+
  INTEGER FUNCTION PGCURSE (X, Y, CH)
  REAL X, Y
  CHARACTER*1 CH
!
! See description of PGCURS.
!--
  INTEGER PGCURS
  PGCURSE = PGCURS (X, Y, CH)
  END

!*PGCURS -- read cursor position
!%int cpgcurs(float *x, float *y, char *ch_scalar);
!+
  INTEGER FUNCTION PGCURS (X, Y, CH)
  REAL X, Y
  CHARACTER*(*) CH
!
! Read the cursor position and a character typed by the user.
! The position is returned in world coordinates.  PGCURS positions
! the cursor at the position specified, allows the user to move the
! cursor using the joystick or arrow keys or whatever is available on
! the device. When he has positioned the cursor, the user types a
! single character on the keyboard; PGCURS then returns this
! character and the new cursor position (in world coordinates).
!
! Returns:
!  PGCURS         : 1 if the call was successful; 0 if the device
!                    has no cursor or some other error occurs.
! Arguments:
!  X      (in/out) : the world x-coordinate of the cursor.
!  Y      (in/out) : the world y-coordinate of the cursor.
!  CH     (output) : the character typed by the user; if the device has
!                    no cursor or if some other error occurs, the value
!                    CHAR(0) [ASCII NUL character] is returned.
!
! Note: The cursor coordinates (X,Y) may be changed by PGCURS even if
! the device has no cursor or if the user does not move the cursor.
! Under these circumstances, the position returned in (X,Y) is that of
! the pixel nearest to the requested position.
!--
!  7-Sep-1994 - changed to use PGBAND [TJP].
!-----------------------------------------------------------------------
  INTEGER PGBAND
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGCURS')) THEN
   CH = CHAR(0)
   PGCURS = 0
  ELSE
   PGCURS = PGBAND(0, 1, 0.0, 0.0, X, Y, CH)
  END IF
  END

!*PGDRAW -- draw a line from the current pen position to a point
!%void cpgdraw(float x, float y);
!+
  SUBROUTINE PGDRAW (X, Y)
  REAL X, Y
!
! Draw a line from the current pen position to the point
! with world-coordinates (X,Y). The line is clipped at the edge of the
! current window. The new pen position is (X,Y) in world coordinates.
!
! Arguments:
!  X      (input)  : world x-coordinate of the end point of the line.
!  Y      (input)  : world y-coordinate of the end point of the line.
!--
! 27-Nov-1986
!-----------------------------------------------------------------------
  CALL PGBBUF
  CALL GRLINA(X,Y)
  CALL PGEBUF
  END

!*PGEBUF -- end batch of output (buffer)
!%void cpgebuf(void);
!+
  SUBROUTINE PGEBUF
!
! A call to PGEBUF marks the end of a batch of graphical output begun
! with the last call of PGBBUF.  PGBBUF and PGEBUF calls should always
! be paired. Each call to PGBBUF increments a counter, while each call
! to PGEBUF decrements the counter. When the counter reaches 0, the
! batch of output is written on the output device.
!
! Arguments: none
!--
! 21-Nov-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (.NOT.PGNOTO('PGEBUF')) THEN
    PGBLEV(PGID) = MAX(0, PGBLEV(PGID) - 1)
    IF (PGBLEV(PGID)==0) CALL GRTERM
  END IF
  END

!*PGEND -- close all open graphics devices
!%void cpgend(void);
!+
  SUBROUTINE PGEND
!
! Close and release any open graphics devices. All devices must be
! closed by calling either PGCLOS (for each device) or PGEND before
! the program terminates. If a device is not closed properly, some
! or all of the graphical output may be lost.
!
! Arguments: none
!--
! 22-Dec-1995 [TJP] - revised to call PGCLOS for each open device.
! 25-Feb-1997 [TJP] - revised description.
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  INTEGER I
!
  DO 10 I=1,PGMAXD
   IF (PGDEVS(I)==1) THEN
      CALL PGSLCT(I)
      CALL PGCLOS
   END IF
 10   CONTINUE
  END

!*PGENV -- set window and viewport and draw labeled frame
!%void cpgenv(float xmin, float xmax, float ymin, float ymax, \
!% int just, int axis);
!+
  SUBROUTINE PGENV (XMIN, XMAX, YMIN, YMAX, JUST, AXIS)
  REAL XMIN, XMAX, YMIN, YMAX
  INTEGER JUST, AXIS
!
! Set PGPLOT "Plotter Environment".  PGENV establishes the scaling
! for subsequent calls to PGPT, PGLINE, etc.  The plotter is
! advanced to a new page or panel, clearing the screen if necessary.
! If the "prompt state" is ON (see PGASK), confirmation
! is requested from the user before clearing the screen.
! If requested, a box, axes, labels, etc. are drawn according to
! the setting of argument AXIS.
!
! Arguments:
!  XMIN   (input)  : the world x-coordinate at the bottom left corner
!                    of the viewport.
!  XMAX   (input)  : the world x-coordinate at the top right corner
!                    of the viewport (note XMAX may be less than XMIN).
!  YMIN   (input)  : the world y-coordinate at the bottom left corner
!                    of the viewport.
!  YMAX   (input)  : the world y-coordinate at the top right corner
!                    of the viewport (note YMAX may be less than YMIN).
!  JUST   (input)  : if JUST=1, the scales of the x and y axes (in
!                    world coordinates per inch) will be equal,
!                    otherwise they will be scaled independently.
!  AXIS   (input)  : controls the plotting of axes, tick marks, etc:
!      AXIS = -2 : draw no box, axes or labels;
!      AXIS = -1 : draw box only;
!      AXIS =  0 : draw box and label it with coordinates;
!      AXIS =  1 : same as AXIS=0, but also draw the
!                  coordinate axes (X=0, Y=0);
!      AXIS =  2 : same as AXIS=1, but also draw grid lines
!                  at major increments of the coordinates;
!      AXIS = 10 : draw box and label X-axis logarithmically;
!      AXIS = 20 : draw box and label Y-axis logarithmically;
!      AXIS = 30 : draw box and label both axes logarithmically.
!
! For other axis options, use routine PGBOX. PGENV can be persuaded to
! call PGBOX with additional axis options by defining an environment
! parameter PGPLOT_ENVOPT containing the required option codes.
! Examples:
!   PGPLOT_ENVOPT=P      ! draw Projecting tick marks
!   PGPLOT_ENVOPT=I      ! Invert the tick marks
!   PGPLOT_ENVOPT=IV     ! Invert tick marks and label y Vertically
!--
!  1-May-1983
! 25-Sep-1985 [TJP] - change to use PGWNAD.
! 23-Nov-1985 [TJP] - add PGPLOT_ENVOPT option.
! 31-Dec-1985 [TJP] - remove automatic PGBEG call.
! 29-Aug-1989 [TJP] - remove common block; no longer needed.
!-----------------------------------------------------------------------
  INTEGER      L
  LOGICAL      PGNOTO
  CHARACTER*10 XOPTS, YOPTS, ENVOPT, TEMP
!
  IF (PGNOTO('PGENV')) RETURN
!
! Start a new picture: move to a new panel or page as necessary.
!
  CALL PGPAGE
!
! Redefine the standard viewport.
!
  CALL PGVSTD
!
! If invalid arguments are specified, issue warning and leave window
! unchanged.
!
  IF (XMIN==XMAX) THEN
    CALL GRWARN('invalid x limits in PGENV: XMIN = XMAX.')
    RETURN
  ELSE IF (YMIN==YMAX) THEN
    CALL GRWARN('invalid y limits in PGENV: YMIN = YMAX.')
    RETURN
  END IF
!
! Call PGSWIN to define the window.
! If equal-scales requested, adjust viewport.
!
  IF (JUST==1) THEN
    CALL PGWNAD(XMIN,XMAX,YMIN,YMAX)
  ELSE
    CALL PGSWIN(XMIN,XMAX,YMIN,YMAX)
  END IF
!
! Call PGBOX to draw and label frame around viewport.
!
  YOPTS = '*'
  IF (AXIS==-2) THEN
    XOPTS = ' '
  ELSE IF (AXIS==-1) THEN
    XOPTS = 'BC'
  ELSE IF (AXIS==0) THEN
    XOPTS = 'BCNST'
  ELSE IF (AXIS==1) THEN
    XOPTS = 'ABCNST'
  ELSE IF (AXIS==2) THEN
    XOPTS = 'ABCGNST'
  ELSE IF (AXIS==10) THEN
    XOPTS = 'BCNSTL'
    YOPTS = 'BCNST'
  ELSE IF (AXIS==20) THEN
    XOPTS = 'BCNST'
    YOPTS = 'BCNSTL'
  ELSE IF (AXIS==30) THEN
    XOPTS = 'BCNSTL'
    YOPTS = 'BCNSTL'
  ELSE
    CALL GRWARN('PGENV: illegal AXIS argument.')
    XOPTS = 'BCNST'
  END IF
  IF (YOPTS=='*') YOPTS = XOPTS
!
! Additional PGBOX options from PGPLOT_ENVOPT.
!
  CALL GRGENV('ENVOPT', ENVOPT, L)
  IF (L>0 .AND. AXIS>=0) THEN
    TEMP = XOPTS
    XOPTS = ENVOPT(1:L)//TEMP
    TEMP = YOPTS
    YOPTS = ENVOPT(1:L)//TEMP
  END IF
  CALL PGBOX(XOPTS, 0.0, 0, YOPTS, 0.0, 0)
!
  END

!*PGERAS -- erase all graphics from current page
!%void cpgeras(void);
!+
  SUBROUTINE PGERAS
!
! Erase all graphics from the current page (or current panel, if
! the view surface has been divided into panels with PGSUBP).
!
! Arguments: none
!--
! 24-Jun-1994
!-----------------------------------------------------------------------
  INTEGER CI, FS
  REAL XV1, XV2, YV1, YV2, XW1, XW2, YW1, YW2
  CALL PGBBUF
  CALL PGQCI(CI)
  CALL PGQFS(FS)
  CALL PGSCI(0)
  CALL PGSFS(1)
  CALL PGQWIN(XW1, XW2, YW1, YW2)
  CALL PGQVP(0, XV1, XV2, YV1, YV2)
  CALL PGSVP(0.0, 1.0, 0.0, 1.0)
  CALL PGRECT(XW1, XW2, YW1, YW2)
  CALL PGSVP(XV1, XV2, YV1, YV2)
  CALL PGSCI(CI)
  CALL PGSFS(FS)
  CALL PGEBUF
  END

!*PGERR1 -- horizontal or vertical error bar
!%void cpgerr1(int dir, float x, float y, float e, float t);
!+
  SUBROUTINE PGERR1 (DIR, X, Y, E, T)
  INTEGER DIR
  REAL X, Y, E
  REAL T
!
! Plot a single error bar in the direction specified by DIR.
! This routine draws an error bar only; to mark the data point at
! the start of the error bar, an additional call to PGPT is required.
! To plot many error bars, use PGERRB.
!
! Arguments:
!  DIR    (input)  : direction to plot the error bar relative to
!                    the data point.
!                    One-sided error bar:
!                      DIR is 1 for +X (X to X+E);
!                             2 for +Y (Y to Y+E);
!                             3 for -X (X to X-E);
!                             4 for -Y (Y to Y-E).
!                    Two-sided error bar:
!                      DIR is 5 for +/-X (X-E to X+E);
!                             6 for +/-Y (Y-E to Y+E).
!  X      (input)  : world x-coordinate of the data.
!  Y      (input)  : world y-coordinate of the data.
!  E      (input)  : value of error bar distance to be added to the
!                    data position in world coordinates.
!  T      (input)  : length of terminals to be drawn at the ends
!                    of the error bar, as a multiple of the default
!                    length; if T = 0.0, no terminals will be drawn.
!--
! 31-Mar-1997 - new routine [TJP].
!-----------------------------------------------------------------------
  LOGICAL  PGNOTO
  REAL     XTIK, YTIK, XX, YY
!
  IF (PGNOTO('PGERR1')) RETURN
  IF (DIR<1 .OR. DIR>6) RETURN
  CALL PGBBUF
!
! Determine terminal length.
!
  CALL PGTIKL(T, XTIK, YTIK)
!
! Draw terminal at starting point if required.
!
  IF (DIR==5) THEN
   XX = X-E
   YY = Y
  ELSE IF (DIR==6) THEN
   XX = X
   YY = Y-E
  ELSE
   XX = X
   YY = Y
  END IF
  IF (T/=0.0) THEN
   IF (DIR==5) THEN
      CALL GRMOVA(XX,YY-YTIK)
      CALL GRLINA(XX,YY+YTIK)
   ELSE IF (DIR==6) THEN
      CALL GRMOVA(XX-XTIK,YY)
      CALL GRLINA(XX+XTIK,YY)
   END IF
  END IF
!
! Draw the error bar itself.
!
  CALL GRMOVA(XX,YY)
  IF (DIR==1 .OR. DIR==5) THEN
   XX = X+E
   YY = Y
  ELSE IF (DIR==2 .OR. DIR==6) THEN
   XX = X
   YY = Y+E
  ELSE IF (DIR==3) THEN
   XX = X-E
   YY = Y
  ELSE IF (DIR==4) THEN
   XX = X
   YY = Y-E
  END IF
  CALL GRLINA(XX,YY)
!
! Draw terminal at end point.
!
  IF (T/=0.0) THEN
   IF (MOD(DIR,2)==1) THEN
      CALL GRMOVA(XX,YY-YTIK)
      CALL GRLINA(XX,YY+YTIK)
   ELSE
      CALL GRMOVA(XX-XTIK,YY)
      CALL GRLINA(XX+XTIK,YY)
   END IF
  END IF
!
  CALL PGEBUF
  END

!*PGERRB -- horizontal or vertical error bar
!%void cpgerrb(int dir, int n, const float *x, const float *y, \
!% const float *e, float t);
!+
  SUBROUTINE PGERRB (DIR, N, X, Y, E, T)
  INTEGER DIR, N
  REAL X(*), Y(*), E(*)
  REAL T
!
! Plot error bars in the direction specified by DIR.
! This routine draws an error bar only; to mark the data point at
! the start of the error bar, an additional call to PGPT is required.
!
! Arguments:
!  DIR    (input)  : direction to plot the error bar relative to
!                    the data point.
!                    One-sided error bar:
!                      DIR is 1 for +X (X to X+E);
!                             2 for +Y (Y to Y+E);
!                             3 for -X (X to X-E);
!                             4 for -Y (Y to Y-E).
!                    Two-sided error bar:
!                      DIR is 5 for +/-X (X-E to X+E);
!                             6 for +/-Y (Y-E to Y+E).
!  N      (input)  : number of error bars to plot.
!  X      (input)  : world x-coordinates of the data.
!  Y      (input)  : world y-coordinates of the data.
!  E      (input)  : value of error bar distance to be added to the
!                    data position in world coordinates.
!  T      (input)  : length of terminals to be drawn at the ends
!                    of the error bar, as a multiple of the default
!                    length; if T = 0.0, no terminals will be drawn.
!
! Note: the dimension of arrays X, Y, and E must be greater
! than or equal to N. If N is 1, X, Y, and E may be scalar
! variables, or expressions.
!--
!  1-Mar-1991 - new routine [JM].
! 20-Apr-1992 - correct bug [ALF, TJP].
! 28-Mar-1995 - add options DIR = 5 or 6 [TJP].
! 31-Mar-1997 - use pgtikl [TJP].
!-----------------------------------------------------------------------
  INTEGER  I
  LOGICAL  PGNOTO
  REAL     XTIK, YTIK, XX, YY
!
  IF (PGNOTO('PGERRB')) RETURN
  IF (N<1) RETURN
  IF (DIR<1 .OR. DIR>6) RETURN
  CALL PGBBUF
!
! Determine terminal length.
!
  CALL PGTIKL(T, XTIK, YTIK)
!
! Loop through points.
!
  DO 10 I=1,N
!
! Draw terminal at starting point if required.
!
   IF (DIR==5) THEN
      XX = X(I)-E(I)
      YY = Y(I)
   ELSE IF (DIR==6) THEN
      XX = X(I)
      YY = Y(I)-E(I)
   ELSE
      XX = X(I)
      YY = Y(I)
   END IF
   IF (T/=0.0) THEN
      IF (DIR==5) THEN
         CALL GRMOVA(XX,YY-YTIK)
         CALL GRLINA(XX,YY+YTIK)
      ELSE IF (DIR==6) THEN
         CALL GRMOVA(XX-XTIK,YY)
         CALL GRLINA(XX+XTIK,YY)
      END IF
   END IF
!
! Draw the error bar itself.
!
   CALL GRMOVA(XX,YY)
   IF (DIR==1 .OR. DIR==5) THEN
      XX = X(I)+E(I)
      YY = Y(I)
   ELSE IF (DIR==2 .OR. DIR==6) THEN
      XX = X(I)
      YY = Y(I)+E(I)
   ELSE IF (DIR==3) THEN
      XX = X(I)-E(I)
      YY = Y(I)
   ELSE IF (DIR==4) THEN
      XX = X(I)
      YY = Y(I)-E(I)
   END IF
   CALL GRLINA(XX,YY)
!
! Draw terminal at end point.
!
   IF (T/=0.0) THEN
      IF (MOD(DIR,2)==1) THEN
         CALL GRMOVA(XX,YY-YTIK)
         CALL GRLINA(XX,YY+YTIK)
      ELSE
         CALL GRMOVA(XX-XTIK,YY)
         CALL GRLINA(XX+XTIK,YY)
      END IF
   END IF
!
 10   CONTINUE
  CALL PGEBUF
  END

!*PGERRX -- horizontal error bar
!%void cpgerrx(int n, const float *x1, const float *x2, \
!% const float *y, float t);
!+
  SUBROUTINE PGERRX (N, X1, X2, Y, T)
  INTEGER N
  REAL X1(*), X2(*), Y(*)
  REAL T
!
! Plot horizontal error bars.
! This routine draws an error bar only; to mark the data point in
! the middle of the error bar, an additional call to PGPT or
! PGERRY is required.
!
! Arguments:
!  N      (input)  : number of error bars to plot.
!  X1     (input)  : world x-coordinates of lower end of the
!                    error bars.
!  X2     (input)  : world x-coordinates of upper end of the
!                    error bars.
!  Y      (input)  : world y-coordinates of the data.
!  T      (input)  : length of terminals to be drawn at the ends
!                    of the error bar, as a multiple of the default
!                    length; if T = 0.0, no terminals will be drawn.
!
! Note: the dimension of arrays X1, X2, and Y must be greater
! than or equal to N. If N is 1, X1, X2, and Y may be scalar
! variables, or expressions, eg:
!       CALL PGERRX(1,X-SIGMA,X+SIGMA,Y)
!--
! (6-Oct-1983)
! 31-Mar-1997 - use pgtikl [TJP[.
!-----------------------------------------------------------------------
  INTEGER  I
  LOGICAL  PGNOTO
  REAL     XTIK, YTIK
!
  IF (PGNOTO('PGERRX')) RETURN
  IF (N<1) RETURN
  CALL PGBBUF
!
  CALL PGTIKL(T, XTIK, YTIK)
  DO 10 I=1,N
    IF (T/=0.0) THEN
        CALL GRMOVA(X1(I),Y(I)-YTIK)
        CALL GRLINA(X1(I),Y(I)+YTIK)
    END IF
    CALL GRMOVA(X1(I),Y(I))
    CALL GRLINA(X2(I),Y(I))
    IF (T/=0.0) THEN
        CALL GRMOVA(X2(I),Y(I)-YTIK)
        CALL GRLINA(X2(I),Y(I)+YTIK)
    END IF
   10 CONTINUE
  CALL PGEBUF
  END

!*PGERRY -- vertical error bar
!%void cpgerry(int n, const float *x, const float *y1, \
!% const float *y2, float t);
!+
  SUBROUTINE PGERRY (N, X, Y1, Y2, T)
  INTEGER N
  REAL X(*), Y1(*), Y2(*)
  REAL T
!
! Plot vertical error bars.
! This routine draws an error bar only; to mark the data point in
! the middle of the error bar, an additional call to PGPT or
! PGERRX is required.
!
! Arguments:
!  N      (input)  : number of error bars to plot.
!  X      (input)  : world x-coordinates of the data.
!  Y1     (input)  : world y-coordinates of top end of the
!                    error bars.
!  Y2     (input)  : world y-coordinates of bottom end of the
!                    error bars.
!  T      (input)  : length of terminals to be drawn at the ends
!                    of the error bar, as a multiple of the default
!                    length; if T = 0.0, no terminals will be drawn.
!
! Note: the dimension of arrays X, Y1, and Y2 must be greater
! than or equal to N. If N is 1, X, Y1, and Y2 may be scalar
! variables or expressions, eg:
!       CALL PGERRY(1,X,Y+SIGMA,Y-SIGMA)
!--
! (6-Oct-1983)
! 31-Mar-1997 - use pgtikl [TJP].
!-----------------------------------------------------------------------
  INTEGER  I
  LOGICAL  PGNOTO
  REAL     XTIK, YTIK
!
  IF (PGNOTO('PGERRY')) RETURN
  IF (N<1) RETURN
  CALL PGBBUF
!
  CALL PGTIKL(T, XTIK, YTIK)
  DO 10 I=1,N
    IF (T/=0.0) THEN
        CALL GRMOVA(X(I)-XTIK,Y1(I))
        CALL GRLINA(X(I)+XTIK,Y1(I))
    END IF
    CALL GRMOVA(X(I),Y1(I))
    CALL GRLINA(X(I),Y2(I))
    IF (T/=0.0) THEN
        CALL GRMOVA(X(I)-XTIK,Y2(I))
        CALL GRLINA(X(I)+XTIK,Y2(I))
    END IF
   10 CONTINUE
  CALL PGEBUF
  END

!*PGETXT -- erase text from graphics display
!%void cpgetxt(void);
!+
  SUBROUTINE PGETXT
!
! Some graphics terminals display text (the normal interactive dialog)
! on the same screen as graphics. This routine erases the text from the
! view surface without affecting the graphics. It does nothing on
! devices which do not display text on the graphics screen, and on
! devices which do not have this capability.
!
! Arguments:
!  None
!--
! 18-Feb-1988
!-----------------------------------------------------------------------
  CALL GRETXT
  END

!*PGFUNT -- function defined by X = F(T), Y = G(T)
!+
  SUBROUTINE PGFUNT (FX, FY, N, TMIN, TMAX, PGFLAG)
  REAL FX, FY
  EXTERNAL FX, FY
  INTEGER N
  REAL TMIN, TMAX
  INTEGER PGFLAG
!
! Draw a curve defined by parametric equations X = FX(T), Y = FY(T).
!
! Arguments:
!  FX     (external real function): supplied by the user, evaluates
!                    X-coordinate.
!  FY     (external real function): supplied by the user, evaluates
!                    Y-coordinate.
!  N      (input)  : the number of points required to define the
!                    curve. The functions FX and FY will each be
!                    called N+1 times.
!  TMIN   (input)  : the minimum value for the parameter T.
!  TMAX   (input)  : the maximum value for the parameter T.
!  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the
!                    current window and viewport; if PGFLAG = 0,
!                    PGENV is called automatically by PGFUNT to
!                    start a new plot with automatic scaling.
!
! Note: The functions FX and FY must be declared EXTERNAL in the
! Fortran program unit that calls PGFUNT.
!--
!  5-Oct-1983
! 11-May-1990 - remove unnecessary include [TJP].
! 13-Dec-1990 - make errors non-fatal [TJP].
!-----------------------------------------------------------------------
  INTEGER MAXP
  PARAMETER (MAXP=1000)
  INTEGER  I
  REAL     X(0:MAXP), Y(0:MAXP), DT
  REAL     XMIN, XMAX, YMIN, YMAX
!
  IF (N<1 .OR. N>MAXP) THEN
    CALL GRWARN('PGFUNT: invalid arguments')
    RETURN
  END IF
  CALL PGBBUF
!
! Evaluate function.
!
  DT = (TMAX-TMIN)/N
  X(0) = FX(TMIN)
  Y(0) = FY(TMIN)
  XMIN = X(0)
  XMAX = X(0)
  YMIN = Y(0)
  YMAX = Y(0)
  DO 10 I=1,N
    X(I) = FX(TMIN+DT*I)
    Y(I) = FY(TMIN+DT*I)
    XMIN = MIN(XMIN,X(I))
    XMAX = MAX(XMAX,X(I))
    YMIN = MIN(YMIN,Y(I))
    YMAX = MAX(YMAX,Y(I))
   10 CONTINUE
  DT = 0.05*(XMAX-XMIN)
  IF (DT==0.0) THEN
    XMIN = XMIN - 1.0
    XMAX = XMAX + 1.0
  ELSE
    XMIN = XMIN - DT
    XMAX = XMAX + DT
  END IF
  DT = 0.05*(YMAX-YMIN)
  IF (DT==0.0) THEN
    YMIN = YMIN - 1.0
    YMAX = YMAX + 1.0
  ELSE
    YMIN = YMIN - DT
    YMAX = YMAX + DT
  END IF
!
! Define environment if necessary.
!
  IF (PGFLAG==0) CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0)
!
! Draw curve.
!
  CALL PGMOVE(X(0),Y(0))
  DO 20 I=1,N
    CALL PGDRAW(X(I),Y(I))
   20 CONTINUE
!
  CALL PGEBUF
  END

!*PGFUNX -- function defined by Y = F(X)
!+
  SUBROUTINE PGFUNX (FY, N, XMIN, XMAX, PGFLAG)
  REAL FY
  EXTERNAL FY
  INTEGER N
  REAL XMIN, XMAX
  INTEGER PGFLAG
!
! Draw a curve defined by the equation Y = FY(X), where FY is a
! user-supplied subroutine.
!
! Arguments:
!  FY     (external real function): supplied by the user, evaluates
!                    Y value at a given X-coordinate.
!  N      (input)  : the number of points required to define the
!                    curve. The function FY will be called N+1 times.
!                    If PGFLAG=0 and N is greater than 1000, 1000
!                    will be used instead.  If N is less than 1,
!                    nothing will be drawn.
!  XMIN   (input)  : the minimum value of X.
!  XMAX   (input)  : the maximum value of X.
!  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the
!                    current window and viewport; if PGFLAG = 0,
!                    PGENV is called automatically by PGFUNX to
!                    start a new plot with X limits (XMIN, XMAX)
!                    and automatic scaling in Y.
!
! Note: The function FY must be declared EXTERNAL in the Fortran
! program unit that calls PGFUNX.  It has one argument, the
! x-coordinate at which the y value is required, e.g.
!   REAL FUNCTION FY(X)
!   REAL X
!   FY = .....
!   END
!--
!  6-Oct-1983 - TJP.
!  6-May-1985 - fix Y(0) bug - TJP.
! 11-May-1990 - remove unnecessary include - TJP.
!-----------------------------------------------------------------------
  INTEGER MAXP
  PARAMETER (MAXP=1000)
  INTEGER  I, NN
  REAL     Y(0:MAXP), DT, DY
  REAL     YMIN, YMAX
!
! Check N > 1, and find parameter increment.
!
  IF (N<1) RETURN
  DT = (XMAX-XMIN)/N
  CALL PGBBUF
!
! Case 1: we do not have to find limits.
!
  IF (PGFLAG/=0) THEN
    CALL PGMOVE(XMIN,FY(XMIN))
    DO 10 I=1,N
        CALL PGDRAW(XMIN+I*DT,FY(XMIN+I*DT))
   10     CONTINUE
!
! Case 2: find limits and scale plot; function values must be stored
! in an array.
!
  ELSE
    NN = MIN(N,MAXP)
    Y(0) = FY(XMIN)
    YMIN = Y(0)
    YMAX = Y(0)
    DO 20 I=1,NN
        Y(I) = FY(XMIN+DT*I)
        YMIN = MIN(YMIN,Y(I))
        YMAX = MAX(YMAX,Y(I))
   20     CONTINUE
    DY = 0.05*(YMAX-YMIN)
    IF (DY==0.0) THEN
        YMIN = YMIN - 1.0
        YMAX = YMAX + 1.0
    ELSE
        YMIN = YMIN - DY
        YMAX = YMAX + DY
    END IF
    CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0)
    CALL PGMOVE(XMIN,Y(0))
    DO 30 I=1,NN
        CALL PGDRAW(XMIN+DT*I,Y(I))
   30     CONTINUE
  END IF
!
  CALL PGEBUF
  END

!*PGFUNY -- function defined by X = F(Y)
!+
  SUBROUTINE PGFUNY (FX, N, YMIN, YMAX, PGFLAG)
  REAL    FX
  EXTERNAL FX
  INTEGER N
  REAL    YMIN, YMAX
  INTEGER PGFLAG
!
! Draw a curve defined by the equation X = FX(Y), where FY is a
! user-supplied subroutine.
!
! Arguments:
!  FX     (external real function): supplied by the user, evaluates
!                    X value at a given Y-coordinate.
!  N      (input)  : the number of points required to define the
!                    curve. The function FX will be called N+1 times.
!                    If PGFLAG=0 and N is greater than 1000, 1000
!                    will be used instead.  If N is less than 1,
!                    nothing will be drawn.
!  YMIN   (input)  : the minimum value of Y.
!  YMAX   (input)  : the maximum value of Y.
!  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the
!                    current window and viewport; if PGFLAG = 0,
!                    PGENV is called automatically by PGFUNY to
!                    start a new plot with Y limits (YMIN, YMAX)
!                    and automatic scaling in X.
!
! Note: The function FX must be declared EXTERNAL in the Fortran
! program unit that calls PGFUNY.  It has one argument, the
! y-coordinate at which the x value is required, e.g.
!   REAL FUNCTION FX(Y)
!   REAL Y
!   FX = .....
!   END
!--
!  5-Oct-1983
! 11-May-1990 - remove unnecessary include [TJP].
! 13-DEc-1990 - make errors non-fatal [TJP].
!-----------------------------------------------------------------------
  INTEGER MAXP
  PARAMETER (MAXP=1000)
  INTEGER  I
  REAL     X(0:MAXP), Y(0:MAXP), DT
  REAL     XMIN, XMAX
!
  IF (N<1 .OR. N>MAXP) THEN
    CALL GRWARN('PGFUNY: invalid arguments')
    RETURN
  END IF
  CALL PGBBUF
!
! Evaluate function.
!
  DT = (YMAX-YMIN)/N
  X(0) = FX(YMIN)
  Y(0) = YMIN
  XMIN = X(0)
  XMAX = X(0)
  DO 10 I=1,N
    X(I) = FX(YMIN+DT*I)
    Y(I) = YMIN + DT*I
    XMIN = MIN(XMIN,X(I))
    XMAX = MAX(XMAX,X(I))
   10 CONTINUE
  DT = 0.05*(XMAX-XMIN)
  IF (DT==0.0) THEN
    XMIN = XMIN - 1.0
    XMAX = XMAX + 1.0
  ELSE
    XMIN = XMIN - DT
    XMAX = XMAX + DT
  END IF
!
! Define environment if necessary.
!
  IF (PGFLAG==0) CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0)
!
! Draw curve.
!
  CALL PGMOVE(X(0),Y(0))
  DO 20 I=1,N
    CALL PGDRAW(X(I),Y(I))
   20 CONTINUE
!
  CALL PGEBUF
  END

!*PGGRAY -- gray-scale map of a 2D data array
!%void cpggray(const float *a, int idim, int jdim, int i1, int i2, \
!% int j1, int j2, float fg, float bg, const float *tr);
!+
  SUBROUTINE PGGRAY (A, IDIM, JDIM, I1, I2, J1, J2, &
                     FG, BG, TR)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  REAL    A(IDIM,JDIM), FG, BG, TR(6)
!
! Draw gray-scale map of an array in current window. The subsection
! of the array A defined by indices (I1:I2, J1:J2) is mapped onto
! the view surface world-coordinate system by the transformation
! matrix TR. The resulting quadrilateral region is clipped at the edge
! of the window and shaded with the shade at each point determined
! by the corresponding array value.  The shade is a number in the
! range 0 to 1 obtained by linear interpolation between the background
! level (BG) and the foreground level (FG), i.e.,
!
!   shade = [A(i,j) - BG] / [FG - BG]
!
! The background level BG can be either less than or greater than the
! foreground level FG.  Points in the array that are outside the range
! BG to FG are assigned shade 0 or 1 as appropriate.
!
! PGGRAY uses two different algorithms, depending how many color
! indices are available in the color index range specified for images.
! (This range is set with routine PGSCIR, and the current or default
! range can be queried by calling routine PGQCIR).
!
! If 16 or more color indices are available, PGGRAY first assigns
! color representations to these color indices to give a linear ramp
! between the background color (color index 0) and the foreground color
! (color index 1), and then calls PGIMAG to draw the image using these
! color indices. In this mode, the shaded region is "opaque": every
! pixel is assigned a color.
!
! If less than 16 color indices are available, PGGRAY uses only
! color index 1, and uses  a "dithering" algorithm to fill in pixels,
! with the shade (computed as above) determining the faction of pixels
! that are filled. In this mode the shaded region is "transparent" and
! allows previously-drawn graphics to show through.
!
! The transformation matrix TR is used to calculate the world
! coordinates of the center of the "cell" that represents each
! array element. The world coordinates of the center of the cell
! corresponding to array element A(I,J) are given by:
!
!          X = TR(1) + TR(2)*I + TR(3)*J
!          Y = TR(4) + TR(5)*I + TR(6)*J
!
! Usually TR(3) and TR(5) are zero -- unless the coordinate
! transformation involves a rotation or shear.  The corners of the
! quadrilateral region that is shaded by PGGRAY are given by
! applying this transformation to (I1-0.5,J1-0.5), (I2+0.5, J2+0.5).
!
! Arguments:
!  A      (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  FG     (input)  : the array value which is to appear with the
!                    foreground color (corresponding to color index 1).
!  BG     (input)  : the array value which is to appear with the
!                    background color (corresponding to color index 0).
!  TR     (input)  : transformation matrix between array grid and
!                    world coordinates.
!--
!  2-Sep-1987: remove device-dependent code to routine GRGRAY (TJP).
!  7-Jun-1988: change documentation and argument names (TJP).
! 31-May-1989: allow 1-pixel wide arrays to be plotted (TJP).
! 17-Mar-1994: pass PG scaling info to lower routines (TJP).
! 15-Sep-1994: use PGITF attribute (TJP).
!  8-Feb-1995: use color ramp based on current foreground and background
!              colors (TJP).
!  6-May-1996: allow multiple devives (TJP).
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  REAL PA(6)
  LOGICAL PGNOTO
!
! Check inputs.
!
  IF (PGNOTO('PGGRAY')) RETURN
  IF (I1<1 .OR. I2>IDIM .OR. I1>I2 .OR. &
      J1<1 .OR. J2>JDIM .OR. J1>J2) THEN
    CALL GRWARN('PGGRAY: invalid range I1:I2, J1:J2')
  ELSE IF (FG==BG) THEN
    CALL GRWARN('PGGRAY: foreground level = background level')
  ELSE
!
! Call lower-level routine to do the work.
!
    CALL PGBBUF
    CALL PGSAVE
    CALL PGSCI(1)
    PA(1) = TR(1)*PGXSCL(PGID) + PGXORG(PGID)
    PA(2) = TR(2)*PGXSCL(PGID)
    PA(3) = TR(3)*PGXSCL(PGID)
    PA(4) = TR(4)*PGYSCL(PGID) + PGYORG(PGID)
    PA(5) = TR(5)*PGYSCL(PGID)
    PA(6) = TR(6)*PGYSCL(PGID)
    CALL GRGRAY(A, IDIM, JDIM, I1, I2, J1, J2, FG, BG, PA, &
                  PGMNCI(PGID), PGMXCI(PGID), PGITF(PGID))
    CALL PGEBUF
    CALL PGUNSA
  END IF
!-----------------------------------------------------------------------
  END


!*PGHI2D -- cross-sections through a 2D data array
!%void cpghi2d(const float *data, int nxv, int nyv, int ix1, \
!% int ix2, int iy1, int iy2, const float *x, int ioff, float bias, \
!% Logical center, float *ylims);
!+
  SUBROUTINE PGHI2D (DATA, NXV, NYV, IX1, IX2, IY1, IY2, X, IOFF, &
                     BIAS, CENTER, YLIMS)
  INTEGER NXV, NYV, IX1, IX2, IY1, IY2
  REAL    DATA(NXV,NYV)
  REAL    X(IX2-IX1+1), YLIMS(IX2-IX1+1)
  INTEGER IOFF
  REAL    BIAS
  LOGICAL CENTER
!
! Plot a series of cross-sections through a 2D data array.
! Each cross-section is plotted as a hidden line histogram.  The plot
! can be slanted to give a pseudo-3D effect - if this is done, the
! call to PGENV may have to be changed to allow for the increased X
! range that will be needed.
!
! Arguments:
!  DATA   (input)  : the data array to be plotted.
!  NXV    (input)  : the first dimension of DATA.
!  NYV    (input)  : the second dimension of DATA.
!  IX1    (input)
!  IX2    (input)
!  IY1    (input)
!  IY2    (input)  : PGHI2D plots a subset of the input array DATA.
!                    This subset is delimited in the first (x)
!                    dimension by IX1 and IX2 and the 2nd (y) by IY1
!                    and IY2, inclusively. Note: IY2 < IY1 is
!                    permitted, resulting in a plot with the
!                    cross-sections plotted in reverse Y order.
!                    However, IX2 must be => IX1.
!  X      (input)  : the abscissae of the bins to be plotted. That is,
!                    X(1) should be the X value for DATA(IX1,IY1), and
!                    X should have (IX2-IX1+1) elements.  The program
!                    has to assume that the X value for DATA(x,y) is
!                    the same for all y.
!  IOFF   (input)  : an offset in array elements applied to successive
!                    cross-sections to produce a slanted effect.  A
!                    plot with IOFF > 0 slants to the right, one with
!                    IOFF < 0 slants left.
!  BIAS   (input)  : a bias value applied to each successive cross-
!                    section in order to raise it above the previous
!                    cross-section.  This is in the same units as the
!                    data.
!  CENTER (input)  : if .true., the X values denote the center of the
!                    bins; if .false. the X values denote the lower
!                    edges (in X) of the bins.
!  YLIMS  (input)  : workspace.  Should be an array of at least
!                    (IX2-IX1+1) elements.
!--
! 21-Feb-1984 - Keith Shortridge.
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL FIRST,PENDOW,HPLOT,VPLOT
  INTEGER IY,INC,IX,NELMX,IXPT,NOFF
  REAL CBIAS,YNWAS,XNWAS,YN,XN,VTO,VFROM,YLIMWS,YLIM
  REAL PGHIS1
  LOGICAL PGNOTO
!
! Check arguments.
!
  IF (IX1>IX2) RETURN
  IF (PGNOTO('PGHI2D')) RETURN
  CALL PGBBUF
!
! Check Y order.
!
  IF (IY1>IY2) THEN
   INC = -1
  ELSE
   INC = 1
  END IF
!
! Clear limits array.
!
  NELMX = IX2 - IX1 + 1
  DO 10 IX=1,NELMX
   YLIMS(IX) = PGYBLC(PGID)
 10   CONTINUE
!
! Loop through Y values.
!
  NOFF = 0
  CBIAS = 0.
  DO 200 IY=IY1,IY2,INC
   YNWAS = CBIAS
   YLIMWS = YNWAS
   XNWAS = PGHIS1(X,NELMX,CENTER,1+NOFF)
   PENDOW = .FALSE.
   FIRST = .TRUE.
   IXPT = 1
!
! Draw histogram for this Y value.
!
   DO 100 IX=IX1,IX2
      YN = DATA(IX,IY) + CBIAS
      XN = PGHIS1(X,NELMX,CENTER,IXPT+NOFF+1)
      YLIM = YLIMS(IXPT)
!
! Given X and Y old and new values, and limits, see which parts of the
! lines are to be drawn.
!
      IF (YN>YLIM) THEN
         YLIMS(IXPT) = YN
         HPLOT = .TRUE.
         VPLOT = .TRUE.
         VTO = YN
         VFROM = YLIM
         IF (YNWAS>YLIMWS) VFROM = YNWAS
      ELSE
         HPLOT = .FALSE.
         IF (YNWAS>YLIMWS) THEN
            VPLOT = .TRUE.
            VFROM = YNWAS
            VTO = YLIM
         ELSE
            VPLOT = .FALSE.
         END IF
      END IF
!
! Plot the bin.
!
      IF (VPLOT) THEN
         IF (.NOT.PENDOW) THEN
            IF (FIRST) THEN
               CALL GRMOVA(XNWAS,MAX(VTO,CBIAS))
               FIRST = .FALSE.
            ELSE
               CALL GRMOVA(XNWAS,VFROM)
            END IF
         END IF
         CALL GRLINA(XNWAS,VTO)
         IF (HPLOT) THEN
            CALL GRLINA(XN,YN)
         END IF
      END IF
      PENDOW = HPLOT
      YLIMWS = YLIM
      YNWAS = YN
      XNWAS = XN
      IXPT = IXPT + 1
 100     CONTINUE
   IF (PENDOW) CALL GRLINA(XN,MAX(YLIM,CBIAS))
!
! If any offset in operation, shift limits array to compensate for it.
!
   IF (IOFF>0) THEN
      DO 110 IX=1,NELMX-IOFF
         YLIMS(IX) = YLIMS(IX+IOFF)
 110        CONTINUE
      DO 120 IX=NELMX-IOFF+1,NELMX
         YLIMS(IX) = PGYBLC(PGID)
 120        CONTINUE
   ELSE IF (IOFF<0) THEN
      DO 130 IX=NELMX,1-IOFF,-1
         YLIMS(IX) = YLIMS(IX+IOFF)
 130        CONTINUE
      DO 140 IX=1,-IOFF
         YLIMS(IX) = PGYBLC(PGID)
 140        CONTINUE
   END IF
   CBIAS = CBIAS + BIAS
   NOFF = NOFF + IOFF
 200  CONTINUE
!
  CALL PGEBUF
  END

  REAL FUNCTION PGHIS1 (X, NELMX, CENTER, IXV)
  LOGICAL CENTER
  INTEGER NELMX, IXV
  REAL X(NELMX)
!
! PGPLOT Internal routine used by PGHI2D.  Calculates the X-value for
! the left hand edge of a given element of the array being plotted.
!
! Arguments -
!
! X (input, real array): abscissae of bins
! NELMX (input, integer): number of bins
! CENTER (Input, logical): if .true., X values denote the center of
!       the bin; if .false., the X values denote the lower edge (in X)
!       of the bin.
! IXV (input, integer): the bin number in question.  Note IXV may be
!       outside the range 1..NELMX, in which case an interpolated
!       value is returned.
!
! 21-Feb-1984 - Keith Shortridge.
!  6-Sep-1989 - Changes for standard Fortran-77 [TJP].
!-----------------------------------------------------------------------
  REAL XN
  INTRINSIC REAL
!
  IF (CENTER) THEN
    IF ((IXV>1).AND.(IXV<=NELMX)) THEN
      XN = ( X(IXV-1) + X(IXV) ) * .5
    ELSE IF (IXV<=1) THEN
      XN = X(1) - .5 * (X(2) - X(1)) * REAL(3 - 2 * IXV)
    ELSE IF (IXV>NELMX) THEN
      XN = X(NELMX) +.5*(X(NELMX)-X(NELMX-1))* &
             REAL((IXV-NELMX)*2-1)
    END IF
  ELSE
    IF ((IXV>=1).AND.(IXV<=NELMX)) THEN
      XN = X(IXV)
    ELSE IF (IXV<1) THEN
      XN = X(1) - ( X(2) - X(1) ) * REAL( 1 - IXV )
    ELSE IF (IXV>NELMX) THEN
      XN = X(NELMX) + ( X(NELMX) - X(NELMX-1)) * &
             REAL(IXV - NELMX)
    END IF
  END IF
!
  PGHIS1 = XN
  END

!*PGHIST -- histogram of unbinned data
!%void cpghist(int n, const float *data, float datmin, float datmax, \
!% int nbin, int pgflag);
!+
  SUBROUTINE PGHIST(N, DATA, DATMIN, DATMAX, NBIN, PGFLAG)
  INTEGER N
  REAL    DATA(*)
  REAL    DATMIN, DATMAX
  INTEGER NBIN, PGFLAG
!
! Draw a histogram of N values of a variable in array
! DATA(1...N) in the range DATMIN to DATMAX using NBIN bins.  Note
! that array elements which fall exactly on the boundary between
! two bins will be counted in the higher bin rather than the
! lower one; and array elements whose value is less than DATMIN or
! greater than or equal to DATMAX will not be counted at all.
!
! Arguments:
!  N      (input)  : the number of data values.
!  DATA   (input)  : the data values. Note: the dimension of array
!                    DATA must be greater than or equal to N. The
!                    first N elements of the array are used.
!  DATMIN (input)  : the minimum data value for the histogram.
!  DATMAX (input)  : the maximum data value for the histogram.
!  NBIN   (input)  : the number of bins to use: the range DATMIN to
!                    DATMAX is divided into NBIN equal bins and
!                    the number of DATA values in each bin is
!                    determined by PGHIST.  NBIN may not exceed 200.
!  PGFLAG (input)  : if PGFLAG = 1, the histogram is plotted in the
!                    current window and viewport; if PGFLAG = 0,
!                    PGENV is called automatically by PGHIST to start
!                    a new plot (the x-limits of the window will be
!                    DATMIN and DATMAX; the y-limits will be chosen
!                    automatically.
!                    IF PGFLAG = 2,3 the histogram will be in the same
!                    window and viewport but with a filled area style.
!                    If pgflag=4,5 as for pgflag = 0,1, but simple
!                    line drawn as for PGBIN
!
!--
! Side effects:
!
! The pen position is changed to (DATMAX,0.0) in world coordinates.
!--
!  6-Sep-83:
! 11-Feb-92: fill options added.
!-----------------------------------------------------------------------
  INTEGER  MAXBIN
  PARAMETER (MAXBIN=200)
  INTEGER  I, IBIN, NUM(MAXBIN), NUMMAX, JUNK
  REAL     BINSIZ, PGRND
  REAL     CUR, PREV, XLO, XHI, YLO, YHI
  LOGICAL  PGNOTO
!
  IF (N<1 .OR. DATMAX<=DATMIN .OR. NBIN<1 .OR. &
      NBIN>MAXBIN) THEN
    CALL GRWARN('PGHIST: invalid arguments')
    RETURN
  END IF
  IF (PGNOTO('PGHIST')) RETURN
  CALL PGBBUF
!
! How many values in each bin?
!
  DO 10 IBIN=1,NBIN
    NUM(IBIN) = 0
   10 CONTINUE
  DO 20 I=1,N
    IBIN = (DATA(I)-DATMIN)/(DATMAX-DATMIN)*NBIN+1
    IF (IBIN>=1 .AND. IBIN<=NBIN) NUM(IBIN) = NUM(IBIN)+1
   20 CONTINUE
  NUMMAX = 0
  DO 30 IBIN=1,NBIN
    NUMMAX = MAX(NUMMAX,NUM(IBIN))
   30 CONTINUE
  BINSIZ = (DATMAX-DATMIN)/NBIN
!
! Boundaries of plot.
!
  XLO = DATMIN
  XHI = DATMAX
  YLO = 0.0
  YHI = PGRND(1.01*NUMMAX,JUNK)
!
! Define environment if necessary.
!
  IF (MOD(PGFLAG,2)==0) THEN
   CALL PGENV(XLO,XHI,YLO,YHI,0,0)
  END IF
!
! Draw Histogram.
!
  IF (PGFLAG/2==0) THEN
   PREV = 0.0
   XHI=DATMIN
   CALL GRMOVA(DATMIN,0.0)
   DO 40 IBIN=1,NBIN
      CUR = NUM(IBIN)
      XLO=XHI
      XHI = DATMIN + IBIN*BINSIZ
      IF (CUR==0.0) THEN
         CONTINUE
      ELSE IF (CUR<=PREV) THEN
         CALL GRMOVA(XLO,CUR)
         CALL GRLINA(XHI,CUR)
      ELSE
         CALL GRMOVA(XLO,PREV)
         CALL GRLINA(XLO,CUR)
         CALL GRLINA(XHI,CUR)
      END IF
      CALL GRLINA(XHI,0.0)
      PREV = CUR
 40      CONTINUE
  ELSE IF (PGFLAG/2==1) THEN
   PREV = 0.0
   XHI = DATMIN
   DO 50 IBIN=1,NBIN
      CUR = NUM(IBIN)
      XLO=XHI
      XHI = DATMIN + IBIN*BINSIZ
      IF (CUR==0.0) THEN
         CONTINUE
      ELSE
         CALL PGRECT(XLO,XHI,0.0,CUR)
      END IF
 50      CONTINUE
  ELSE IF (PGFLAG/2==2) THEN
   PREV = 0.0
   CALL GRMOVA(DATMIN,0.0)
   XHI=DATMIN
   DO 60 IBIN=1,NBIN
      CUR = NUM(IBIN)
      XLO = XHI
      XHI = DATMIN + IBIN*BINSIZ
      IF (CUR==0.0 .AND. PREV==0.0) THEN
         CALL GRMOVA(XHI,0.0)
      ELSE
         CALL GRLINA(XLO,CUR)
         IF(CUR/=0.0) THEN
            CALL GRLINA(XHI,CUR)
         ELSE
            CALL GRMOVA(XHI,CUR)
         ENDIF
      END IF
      PREV = CUR
 60      CONTINUE
  END IF
!
  CALL PGEBUF
  END

!.PGHTCH -- hatch a polygonal area (internal routine)
!.
  SUBROUTINE PGHTCH(N, X, Y, DA)
  INTEGER N
  REAL X(*), Y(*), DA
!
! Hatch a polygonal area using equi-spaced parallel lines. The lines
! are drawn using the current line attributes: line style, line width,
! and color index. Cross-hatching can be achieved by calling this
! routine twice.
!
! Limitations: the hatching will not be done correctly if the
! polygon is so complex that a hatch line intersects more than
! 32 of its sides.
!
! Arguments:
!  N      (input)  : the number of vertices of the polygonal.
!  X,Y    (input)  : the (x,y) world-coordinates of the vertices
!                    (in order).
!  DA      (input) : 0.0 for normal hatching, 90.0 for perpendicular
!                    hatching.
!--
! Reference: I.O. Angel and G. Griffith "High-resolution computer
! graphics using Fortran 77", Halsted Press, 1987.
!
! 18-Feb-1995 [TJP].
!-----------------------------------------------------------------------
!
! MAXP is the maximum number of intersections any hatch line may make
! with the sides of the polygon.
!
  INTEGER MAXP
  PARAMETER (MAXP=32)
  INTEGER NP(MAXP), I,J, II,JJ, NMIN,NMAX, NX, NI, NNP
  REAL ANGLE, SEPN, PHASE
  REAL RMU(MAXP), DX,DY, C, CMID,CMIN,CMAX, SX,SY, EX,EY, DELTA
  REAL QX,QY, R, RMU1, RMU2, XI,YI, BX,BY
  REAL DH, XS1, XS2, YS1, YS2, XL, XR, YT, YB, DINDX, DINDY
!
! Check arguments.
!
  IF (N<3) RETURN
  CALL PGQHS(ANGLE, SEPN, PHASE)
  ANGLE = ANGLE + DA
  IF (SEPN==0.0) RETURN
!
! The unit spacing is 1 percent of the smaller of the height or
! width of the view surface. The line-spacing (DH), in inches, is
! obtained by multiplying this by argument SEPN.
!
  CALL PGQVSZ(1, XS1, XS2, YS1, YS2)
  DH = SEPN*MIN(ABS(XS2-XS1),ABS(YS2-YS1))/100.0
!
! DINDX and DINDY are the scales in inches per world-coordinate unit.
!
  CALL PGQVP(1, XS1, XS2, YS1, YS2)
  CALL PGQWIN(XL, XR, YB, YT)
  IF (XR/=XL .AND. YT/=YB) THEN
   DINDX = (XS2 - XS1) / (XR - XL)
   DINDY = (YS2 - YS1) / (YT - YB)
  ELSE
   RETURN
  END IF
!
! Initialize.
!
  CALL PGBBUF
!
! The vector (SX,SY) is a vector length DH perpendicular to
! the hatching lines, which have vector (DX,DY).
!
  DX = COS(ANGLE/57.29578)
  DY = SIN(ANGLE/57.29578)
  SX = (-DH)*DY
  SY = DH*DX
!
! The hatch lines are labelled by a parameter C, the distance from
! the coordinate origin. Calculate CMID, the C-value of the line
! that passes through the hatching reference point (BX,BY), and
! CMIN and CMAX, the range of C-values spanned by lines that intersect
! the polygon.
!
  BX = PHASE*SX
  BY = PHASE*SY
  CMID = DX*BY - DY*BX
  CMIN = DX*Y(1)*DINDY - DY*X(1)*DINDX
  CMAX = CMIN
  DO 10 I=2,N
   C = DX*Y(I)*DINDY - DY*X(I)*DINDX
   CMIN = MIN(C,CMIN)
   CMAX = MAX(C,CMAX)
 10   CONTINUE
!
! Compute integer labels for the hatch lines; N=0 is the line
! which passes through the reference point; NMIN and NMAX define
! the range of labels for lines that intersect the polygon.
! [Note that INT truncates towards zero; we need FLOOR and CEIL
! functions.]
!
  CMIN = (CMIN-CMID)/DH
  CMAX = (CMAX-CMID)/DH
  NMIN = INT(CMIN)
  IF (REAL(NMIN)<CMIN) NMIN = NMIN+1
  NMAX = INT(CMAX)
  IF (REAL(NMAX)>CMAX) NMAX = NMAX-1
!
! Each iteration of the following loop draws one hatch line.
!
  DO 60 J=NMIN,NMAX
!
! The parametric representation of this hatch line is
! (X,Y) = (QX,QY) + RMU*(DX,DY).
!
   QX = BX + REAL(J)*SX
   QY = BY + REAL(J)*SY
!
! Find the NX intersections of this line with the edges of the polygon.
!
   NX = 0
   NI = N
   DO 20 I=1,N
      EX = (X(I) - X(NI))*DINDX
      EY = (Y(I) - Y(NI))*DINDY
      DELTA = EX*DY - EY*DX
      IF (ABS(DELTA)<1E-5) THEN
!                 -- lines are parallel
      ELSE
!                 -- lines intersect in (XI,YI)
         R = ((QX-X(NI)*DINDX)*DY - (QY-Y(NI)*DINDY)*DX)/DELTA
         IF (R>0.0 .AND. R<=1.0) THEN
            IF (NX<MAXP) NX = NX+1
            NP(NX) = NX
            IF (ABS(DX)>0.5) THEN
               XI = X(NI)*DINDX + R*EX
               RMU(NX) = (XI-QX)/DX
            ELSE
               YI = Y(NI)*DINDY + R*EY
               RMU(NX) = (YI-QY)/DY
            END IF
         END IF
      END IF
      NI = I
 20      CONTINUE
!
! The RMU array now contains the intersections. Sort them into order.
!
   DO 40 II=1,NX-1
      DO 30 JJ=II+1,NX
         IF (RMU(NP(II))<RMU(NP(JJ))) THEN
            NNP = NP(II)
            NP(II) = NP(JJ)
            NP(JJ) = NNP
         END IF
 30         CONTINUE
 40      CONTINUE
!
! Join the intersections in pairs.
!
   NI = 1
!         -- do while NI < NX
 50      IF (NI < NX) THEN
      RMU1 = RMU(NP(NI))
      RMU2 = RMU(NP(NI+1))
      CALL PGMOVE((QX+RMU1*DX)/DINDX, (QY+RMU1*DY)/DINDY)
      CALL PGDRAW((QX+RMU2*DX)/DINDX, (QY+RMU2*DY)/DINDY)
      NI = NI+2
      GOTO 50
   END IF
 60   CONTINUE
!
! Tidy up.
!
  CALL PGEBUF
!
  END

!*PGIDEN -- write username, date, and time at bottom of plot
!%void cpgiden(void);
!+
  SUBROUTINE PGIDEN
!
! Write username, date, and time at bottom of plot.
!
! Arguments: none.
!--
!  9-Feb-1988
! 10-Sep-1990 : adjust position of text [TJP]
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  INTEGER L, M, CF, CI, LW
  CHARACTER*64 TEXT
  REAL D, CH
!
  CALL PGBBUF
!
! Get information for annotation.
!
  CALL GRUSER(TEXT, L)
  TEXT(L+1:) = ' '
  CALL GRDATE(TEXT(L+2:), M)
  L = L+1+M
!
! Save current attributes.
!
  CALL PGQCF(CF)
  CALL PGQCI(CI)
  CALL PGQLW(LW)
  CALL PGQCH(CH)
!
! Change attributes and write text.
!
  CALL PGSCF(1)
  CALL PGSCI(1)
  CALL PGSLW(1)
  CALL PGSCH(0.6)
  CALL GRLEN(TEXT(1:L),D)
  CALL GRTEXT(.FALSE., 0.0, .TRUE., PGXSZ(PGID)-D-2.0, &
              2.0+PGYSZ(PGID)/130.0, TEXT(1:L))
!
! Restore attributes.
!
  CALL PGSCF(CF)
  CALL PGSCI(CI)
  CALL PGSLW(LW)
  CALL PGSCH(CH)
  CALL PGEBUF
!
  END

!*PGIMAG -- color image from a 2D data array
!%void cpgimag(const float *a, int idim, int jdim, int i1, int i2, \
!% int j1, int j2, float a1, float a2, const float *tr);
!+
  SUBROUTINE PGIMAG (A, IDIM, JDIM, I1, I2, J1, J2, &
                     A1, A2, TR)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  REAL    A(IDIM,JDIM), A1, A2, TR(6)
!
! Draw a color image of an array in current window. The subsection
! of the array A defined by indices (I1:I2, J1:J2) is mapped onto
! the view surface world-coordinate system by the transformation
! matrix TR. The resulting quadrilateral region is clipped at the edge
! of the window. Each element of the array is represented in the image
! by a small quadrilateral, which is filled with a color specified by
! the corresponding array value.
!
! The subroutine uses color indices in the range C1 to C2, which can
! be specified by calling PGSCIR before PGIMAG. The default values
! for C1 and C2 are device-dependent; these values can be determined by
! calling PGQCIR. Note that color representations should be assigned to
! color indices C1 to C2 by calling PGSCR before calling PGIMAG. On some
! devices (but not all), the color representation can be changed after
! the call to PGIMAG by calling PGSCR again.
!
! Array values in the range A1 to A2 are mapped on to the range of
! color indices C1 to C2, with array values <= A1 being given color
! index C1 and values >= A2 being given color index C2. The mapping
! function for intermediate array values can be specified by
! calling routine PGSITF before PGIMAG; the default is linear.
!
! On devices which have no available color indices (C1 > C2),
! PGIMAG will return without doing anything. On devices with only
! one color index (C1=C2), all array values map to the same color
! which is rather uninteresting. An image is always "opaque",
! i.e., it obscures all graphical elements previously drawn in
! the region.
!
! The transformation matrix TR is used to calculate the world
! coordinates of the center of the "cell" that represents each
! array element. The world coordinates of the center of the cell
! corresponding to array element A(I,J) are given by:
!
!          X = TR(1) + TR(2)*I + TR(3)*J
!          Y = TR(4) + TR(5)*I + TR(6)*J
!
! Usually TR(3) and TR(5) are zero -- unless the coordinate
! transformation involves a rotation or shear.  The corners of the
! quadrilateral region that is shaded by PGIMAG are given by
! applying this transformation to (I1-0.5,J1-0.5), (I2+0.5, J2+0.5).
!
! Arguments:
!  A      (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  A1     (input)  : the array value which is to appear with shade C1.
!  A2     (input)  : the array value which is to appear with shade C2.
!  TR     (input)  : transformation matrix between array grid and
!                    world coordinates.
!--
! 15-Sep-1994: new routine [TJP].
! 21-Jun-1995: minor change to header comments [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  REAL PA(6)
  LOGICAL PGNOTO
!
! Check inputs.
!
  IF (PGNOTO('PGIMAG')) RETURN
  IF (I1<1 .OR. I2>IDIM .OR. I1>I2 .OR. &
      J1<1 .OR. J2>JDIM .OR. J1>J2) THEN
    CALL GRWARN('PGIMAG: invalid range I1:I2, J1:J2')
  ELSE IF (A1==A2) THEN
    CALL GRWARN('PGIMAG: foreground level = background level')
  ELSE IF (PGMNCI(PGID)>PGMXCI(PGID)) THEN
    CALL GRWARN('PGIMAG: not enough colors available')
  ELSE
!
! Call lower-level routine to do the work.
!
    CALL PGBBUF
    PA(1) = TR(1)*PGXSCL(PGID) + PGXORG(PGID)
    PA(2) = TR(2)*PGXSCL(PGID)
    PA(3) = TR(3)*PGXSCL(PGID)
    PA(4) = TR(4)*PGYSCL(PGID) + PGYORG(PGID)
    PA(5) = TR(5)*PGYSCL(PGID)
    PA(6) = TR(6)*PGYSCL(PGID)
    CALL GRIMG0(A, IDIM, JDIM, I1, I2, J1, J2, A1, A2, PA, &
                  PGMNCI(PGID), PGMXCI(PGID), PGITF(PGID))
    CALL PGEBUF
  END IF
!-----------------------------------------------------------------------
  END

! PGINIT -- initialize PGPLOT (internal routine)
!
  SUBROUTINE PGINIT
!
! Initialize PGPLOT. This routine should be called once during program
! execution, before any other PGPLOT routines.
!--
! Last modified: 1996 Apr 30 [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  INTEGER CALLED, I
  SAVE CALLED
  DATA CALLED /0/
!
  IF (CALLED==0) THEN
   PGID = 0
   DO 10 I=1,PGMAXD
      PGDEVS(I) = 0
 10      CONTINUE
   CALL GRINIT
   CALLED = 1
  END IF
!
  RETURN
  END

!*PGLABEL -- non-standard alias for PGLAB
!+
  SUBROUTINE PGLABEL (XLBL, YLBL, TOPLBL)
  CHARACTER*(*) XLBL, YLBL, TOPLBL
!
! See description of PGLAB.
!--
  CALL PGLAB (XLBL, YLBL, TOPLBL)
  END

!*PGLAB -- write labels for x-axis, y-axis, and top of plot
!%void cpglab(const char *xlbl, const char *ylbl, const char *toplbl);
!+
  SUBROUTINE PGLAB (XLBL, YLBL, TOPLBL)
  CHARACTER*(*) XLBL, YLBL, TOPLBL
!
! Write labels outside the viewport. This routine is a simple
! interface to PGMTXT, which should be used if PGLAB is inadequate.
!
! Arguments:
!  XLBL   (input) : a label for the x-axis (centered below the
!                   viewport).
!  YLBL   (input) : a label for the y-axis (centered to the left
!                   of the viewport, drawn vertically).
!  TOPLBL (input) : a label for the entire plot (centered above the
!                   viewport).
!--
! 11-May-1990 - remove unnecessary include - TJP.
!-----------------------------------------------------------------------
  CALL PGBBUF
  CALL PGMTXT('T', 2.0, 0.5, 0.5, TOPLBL)
  CALL PGMTXT('B', 3.2, 0.5, 0.5, XLBL)
  CALL PGMTXT('L', 2.2, 0.5, 0.5, YLBL)
  CALL PGEBUF
  END

!*PGLCUR -- draw a line using the cursor
!%void cpglcur(int maxpt, int *npt, float *x, float *y);
!+
  SUBROUTINE PGLCUR (MAXPT, NPT, X, Y)
  INTEGER MAXPT, NPT
  REAL    X(*), Y(*)
!
! Interactive routine for user to enter a polyline by use of
! the cursor.  Routine allows user to Add and Delete vertices;
! vertices are joined by straight-line segments.
!
! Arguments:
!  MAXPT  (input)  : maximum number of points that may be accepted.
!  NPT    (in/out) : number of points entered; should be zero on
!                    first call.
!  X      (in/out) : array of x-coordinates (dimension at least MAXPT).
!  Y      (in/out) : array of y-coordinates (dimension at least MAXPT).
!
! Notes:
!
! (1) On return from the program, cursor points are returned in
! the order they were entered. Routine may be (re-)called with points
! already defined in X,Y (# in NPT), and they will be plotted
! first, before editing.
!
! (2) User commands: the user types single-character commands
! after positioning the cursor: the following are accepted:
!   A (Add)    - add point at current cursor location.
!   D (Delete) - delete last-entered point.
!   X (eXit)   - leave subroutine.
!--
!  5-Aug-1984 - new routine [TJP].
! 16-Jul-1988 - correct error in delete operation [TJP].
! 13-Dec-1990 - change warnings to messages [TJP].
!  3-Sep-1992 - fixed erase first point bug under Add option [JM/TJP].
!  7-Sep-1994 - use PGBAND [TJP].
!  2-Aug-1995 - remove dependence on common block [TJP].
!-----------------------------------------------------------------------
  LOGICAL  PGNOTO
  CHARACTER*1 LETTER
  INTEGER  PGBAND, I, SAVCOL, MODE
  REAL     XP, YP, XREF, YREF
  REAL     XBLC, XTRC, YBLC, YTRC
!
! Check that PGPLOT is in the correct state.
!
  IF (PGNOTO('PGLCUR')) RETURN
!
! Save current color.
!
  CALL GRQCI(SAVCOL)
!
! Put current line-segments on screen.
!
  IF (NPT==1) THEN
    CALL PGPT(1,X(1),Y(1),1)
  END IF
  IF (NPT>0) THEN
    CALL GRMOVA(X(1),Y(1))
    DO 10 I=2,NPT
        CALL GRLINA(X(I),Y(I))
   10     CONTINUE
  END IF
!
! Start with the cursor in the middle of the box,
! unless lines have already been drawn.
!
  CALL PGQWIN(XBLC, XTRC, YBLC, YTRC)
  IF (NPT>0) THEN
    XP = X(NPT)
    YP = Y(NPT)
  ELSE
    XP = 0.5*(XBLC+XTRC)
    YP = 0.5*(YBLC+YTRC)
  END IF
!
! Loop over cursor inputs.
!
  MODE = 0
  100 XREF = XP
  YREF = YP
  IF (PGBAND(MODE,1,XREF,YREF,XP,YP,LETTER)/=1) RETURN
  CALL GRTOUP(LETTER,LETTER)
  MODE = 1
!
! A (ADD) command:
!
  IF (LETTER == 'A') THEN
    IF (NPT>=MAXPT) THEN
      CALL GRMSG('ADD ignored (too many points).')
        GOTO 100
    END IF
    NPT = NPT+1
    X(NPT) = XP
    Y(NPT) = YP
    IF (NPT==1) THEN
!           -- first point: draw a dot
      CALL GRMOVA(X(NPT),Y(NPT))
      CALL PGPT(1,X(NPT),Y(NPT),1)
    ELSE
!           -- nth point: draw from (n-1) to (n)
      CALL GRLINA(X(NPT),Y(NPT))
    END IF
    CALL GRTERM
!
! D (DELETE) command:
!
  ELSE IF (LETTER=='D') THEN
    IF (NPT<=0) THEN
      CALL GRMSG('DELETE ignored (there are no points left).')
      GOTO 100
    END IF
    IF (NPT>1) THEN
!           -- delete nth point: erase from (n-1) to (n)
      CALL GRMOVA(X(NPT-1),Y(NPT-1))
      CALL GRSCI(0)
      CALL GRLINA(X(NPT),Y(NPT))
      CALL GRSCI(SAVCOL)
      CALL GRMOVA(X(NPT-1),Y(NPT-1))
      CALL GRTERM
    ELSE IF (NPT==1) THEN
!           -- delete first point: erase dot
      CALL GRSCI(0)
      CALL PGPT(1,X(NPT),Y(NPT),1)
      CALL GRSCI(SAVCOL)
    END IF
    NPT = NPT-1
    IF (NPT==0) THEN
      XP = 0.5*(XBLC+XTRC)
      YP = 0.5*(YBLC+YTRC)
    ELSE
      XP = X(NPT)
      YP = Y(NPT)
    END IF
    IF (NPT==1) THEN
!           -- delete 2nd point: redraw dot at first point
      CALL PGPT(1,X(1),Y(1),1)
    END IF
!
! X (EXIT) command:
!
  ELSE IF (LETTER=='X') THEN
    CALL GRETXT
    RETURN
!
! Illegal command:
!
  ELSE
    CALL GRMSG('Commands are A (add), D (delete), X (exit).')
  END IF
!
  GOTO 100
  END

!*PGLDEV -- list available device types on standard output
!%void cpgldev(void);
!+
  SUBROUTINE PGLDEV
!
! Writes (to standard output) a list of all device types available in
! the current PGPLOT installation.
!
! Arguments: none.
!--
! 5-Aug-1986 - [AFT].
! 1-Aug-1988 - add version number [TJP].
! 24-Apr-1989 - add copyright notice [TJP].
! 13-Dec-1990 - changed warnings to messages [TJP].
! 26-Feb-1997 - revised description [TJP].
! 18-Mar-1997 - revised [TJP].
!-----------------------------------------------------------------------
  CHARACTER*16 GVER
  INTEGER L
  CHARACTER*10 T
  CHARACTER*64 D
  INTEGER I, N, TLEN, DLEN, INTER
!
! Initialize PGPLOT if necessary.
!
  CALL PGINIT
!
! Report version and copyright.
!
  CALL PGQINF('VERSION', GVER, L)
  CALL GRMSG('PGPLOT '//GVER(:L)// &
             ' Copyright 1997 California Institute of Technology')
!
! Find number of device types.
!
  CALL PGQNDT(N)
!
! Loop through device-type list (twice).

  CALL GRMSG('Interactive devices:')
  DO 10 I=1,N
   CALL PGQDT(I, T, TLEN, D, DLEN, INTER)
   IF (TLEN>0 .AND. INTER==1) &
          CALL GRMSG('   '//T//' '//D(1:DLEN))
 10   CONTINUE
  CALL GRMSG('Non-interactive file formats:')
  DO 20 I=1,N
   CALL PGQDT(I, T, TLEN, D, DLEN, INTER)
   IF (TLEN>0 .AND. INTER==0) &
          CALL GRMSG('   '//T//' '//D(1:DLEN))
 20   CONTINUE
!
  END

!*PGLEN -- find length of a string in a variety of units
!%void cpglen(int units, const char *string, float *xl, float *yl);
!+
  SUBROUTINE PGLEN (UNITS, STRING, XL, YL)
  REAL XL, YL
  INTEGER UNITS
  CHARACTER*(*) STRING
!
! Work out length of a string in x and y directions
!
! Input
!  UNITS    :  0 => answer in normalized device coordinates
!              1 => answer in inches
!              2 => answer in mm
!              3 => answer in absolute device coordinates (dots)
!              4 => answer in world coordinates
!              5 => answer as a fraction of the current viewport size
!
!  STRING   :  String of interest
! Output
!  XL       :  Length of string in x direction
!  YL       :  Length of string in y direction
!
!--
! 15-Sep-1989 - new routine (Neil Killeen)
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
  REAL    D
!
  IF (PGNOTO('PGLEN')) RETURN
!
!   Work out length of a string in absolute device coordinates (dots)
!   and then convert
!
  CALL GRLEN (STRING, D)
!
  IF (UNITS==0) THEN
  XL = D / PGXSZ(PGID)
  YL = D / PGYSZ(PGID)
  ELSE IF (UNITS==1) THEN
  XL = D / PGXPIN(PGID)
  YL = D / PGYPIN(PGID)
  ELSE IF (UNITS==2) THEN
  XL = 25.4 * D / PGXPIN(PGID)
  YL = 25.4 * D / PGYPIN(PGID)
  ELSE IF (UNITS==3) THEN
  XL = D
  YL = D
  ELSE IF (UNITS==4) THEN
  XL = D / ABS(PGXSCL(PGID))
  YL = D / ABS(PGYSCL(PGID))
  ELSE IF (UNITS==5) THEN
  XL = D / PGXLEN(PGID)
  YL = D / PGYLEN(PGID)
  ELSE
  CALL GRWARN('Illegal value for UNITS in routine PGLEN')
  END IF
!
  RETURN
  END

!*PGLINE -- draw a polyline (curve defined by line-segments)
!%void cpgline(int n, const float *xpts, const float *ypts);
!+
  SUBROUTINE PGLINE (N, XPTS, YPTS)
  INTEGER  N
  REAL     XPTS(*), YPTS(*)
!
! Primitive routine to draw a Polyline. A polyline is one or more
! connected straight-line segments.  The polyline is drawn using
! the current setting of attributes color-index, line-style, and
! line-width. The polyline is clipped at the edge of the window.
!
! Arguments:
!  N      (input)  : number of points defining the line; the line
!                    consists of (N-1) straight-line segments.
!                    N should be greater than 1 (if it is 1 or less,
!                    nothing will be drawn).
!  XPTS   (input)  : world x-coordinates of the points.
!  YPTS   (input)  : world y-coordinates of the points.
!
! The dimension of arrays X and Y must be greater than or equal to N.
! The "pen position" is changed to (X(N),Y(N)) in world coordinates
! (if N > 1).
!--
! 27-Nov-1986
!-----------------------------------------------------------------------
  INTEGER  I
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGLINE')) RETURN
  IF (N<2) RETURN
!
  CALL PGBBUF
  CALL GRMOVA(XPTS(1),YPTS(1))
  DO 10 I=2,N
   CALL GRLINA(XPTS(I),YPTS(I))
 10   CONTINUE
  CALL PGEBUF
  END

!*PGMOVE -- move pen (change current pen position)
!%void cpgmove(float x, float y);
!+
  SUBROUTINE PGMOVE (X, Y)
  REAL X, Y
!
! Primitive routine to move the "pen" to the point with world
! coordinates (X,Y). No line is drawn.
!
! Arguments:
!  X      (input)  : world x-coordinate of the new pen position.
!  Y      (input)  : world y-coordinate of the new pen position.
!--
! (29-Dec-1983)
!-----------------------------------------------------------------------
  CALL GRMOVA(X,Y)
  END

!*PGMTEXT -- non-standard alias for PGMTXT
!+
  SUBROUTINE PGMTEXT (SIDE, DISP, COORD, FJUST, TEXT)
  CHARACTER*(*) SIDE, TEXT
  REAL DISP, COORD, FJUST
!
! See description of PGMTXT.
!--
  CALL PGMTXT (SIDE, DISP, COORD, FJUST, TEXT)
  END

!*PGMTXT -- write text at position relative to viewport
!%void cpgmtxt(const char *side, float disp, float coord, \
!% float fjust, const char *text);
!+
  SUBROUTINE PGMTXT (SIDE, DISP, COORD, FJUST, TEXT)
  CHARACTER*(*) SIDE, TEXT
  REAL DISP, COORD, FJUST
!
! Write text at a position specified relative to the viewport (outside
! or inside).  This routine is useful for annotating graphs. It is used
! by routine PGLAB.  The text is written using the current values of
! attributes color-index, line-width, character-height, and
! character-font.
!
! Arguments:
!  SIDE   (input)  : must include one of the characters 'B', 'L', 'T',
!                    or 'R' signifying the Bottom, Left, Top, or Right
!                    margin of the viewport. If it includes 'LV' or
!                    'RV', the string is written perpendicular to the
!                    frame rather than parallel to it.
!  DISP   (input)  : the displacement of the character string from the
!                    specified edge of the viewport, measured outwards
!                    from the viewport in units of the character
!                    height. Use a negative value to write inside the
!                    viewport, a positive value to write outside.
!  COORD  (input)  : the location of the character string along the
!                    specified edge of the viewport, as a fraction of
!                    the length of the edge.
!  FJUST  (input)  : controls justification of the string parallel to
!                    the specified edge of the viewport. If
!                    FJUST = 0.0, the left-hand end of the string will
!                    be placed at COORD; if JUST = 0.5, the center of
!                    the string will be placed at COORD; if JUST = 1.0,
!                    the right-hand end of the string will be placed at
!                    at COORD. Other values between 0 and 1 give inter-
!                    mediate placing, but they are not very useful.
!  TEXT   (input) :  the text string to be plotted. Trailing spaces are
!                    ignored when justifying the string, but leading
!                    spaces are significant.
!
!--
! 18-Apr-1983
! 15-Aug-1987 - fix BBUF/EBUF error.
! 27-Aug-1987 - fix justification error if XPERIN.ne.YPERIN.
! 05-Sep-1989 - change so that DISP has some effect for 'RV' and
!               'LV' options [nebk]
! 16-Oct-1993 - erase background of opaque text.
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
  REAL ANGLE, D, X, Y, RATIO, XBOX(4), YBOX(4)
  INTEGER CI, I, L, GRTRIM
  CHARACTER*20 TEST
!
  IF (PGNOTO('PGMTXT')) RETURN
!
  L = GRTRIM(TEXT)
  IF (L<1) RETURN
  D = 0.0
  IF (FJUST/=0.0) CALL GRLEN(TEXT(1:L),D)
  D = D*FJUST
  RATIO = PGYPIN(PGID)/PGXPIN(PGID)
  CALL GRTOUP(TEST,SIDE)
  IF (INDEX(TEST,'B')/=0) THEN
    ANGLE = 0.0
    X = PGXOFF(PGID) + COORD*PGXLEN(PGID) - D
    Y = PGYOFF(PGID) - PGYSP(PGID)*DISP
  ELSE IF (INDEX(TEST,'LV')/=0) THEN
    ANGLE = 0.0
    X = PGXOFF(PGID) - PGYSP(PGID)*DISP - D
    Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - 0.3*PGYSP(PGID)
  ELSE IF (INDEX(TEST,'L')/=0) THEN
    ANGLE = 90.0
    X = PGXOFF(PGID) - PGYSP(PGID)*DISP
    Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - D*RATIO
  ELSE IF (INDEX(TEST,'T')/=0) THEN
    ANGLE = 0.0
    X = PGXOFF(PGID) + COORD*PGXLEN(PGID) - D
    Y = PGYOFF(PGID) + PGYLEN(PGID) + PGYSP(PGID)*DISP
  ELSE IF (INDEX(TEST,'RV')/=0) THEN
    ANGLE = 0.0
    X = PGXOFF(PGID) + PGXLEN(PGID) + PGYSP(PGID)*DISP - D
    Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - 0.3*PGYSP(PGID)
  ELSE IF (INDEX(TEST,'R')/=0) THEN
    ANGLE = 90.0
    X = PGXOFF(PGID) + PGXLEN(PGID) + PGYSP(PGID)*DISP
    Y = PGYOFF(PGID) + COORD*PGYLEN(PGID) - D*RATIO
  ELSE
    CALL GRWARN('Invalid "SIDE" argument in PGMTXT.')
    RETURN
  END IF
  CALL PGBBUF
  IF (PGTBCI(PGID)>=0) THEN
    CALL GRQTXT (ANGLE, X, Y, TEXT(1:L), XBOX, YBOX)
    DO 25 I=1,4
        XBOX(I) = (XBOX(I)-PGXORG(PGID))/PGXSCL(PGID)
        YBOX(I) = (YBOX(I)-PGYORG(PGID))/PGYSCL(PGID)
   25     CONTINUE
    CALL PGQCI(CI)
    CALL PGSCI(PGTBCI(PGID))
    CALL GRFA(4, XBOX, YBOX)
    CALL PGSCI(CI)
  END IF
  CALL GRTEXT(.FALSE.,ANGLE,.TRUE., X, Y, TEXT(1:L))
  CALL PGEBUF
  END

!*PGNCUR -- mark a set of points using the cursor
!%void cpgncur(int maxpt, int *npt, float *x, float *y, int symbol);
!+
  SUBROUTINE PGNCUR (MAXPT, NPT, X, Y, SYMBOL)
  INTEGER MAXPT, NPT
  REAL    X(*), Y(*)
  INTEGER SYMBOL
!
! Interactive routine for user to enter data points by use of
! the cursor.  Routine allows user to Add and Delete points.  The
! points are returned in order of increasing x-coordinate, not in the
! order they were entered.
!
! Arguments:
!  MAXPT  (input)  : maximum number of points that may be accepted.
!  NPT    (in/out) : number of points entered; should be zero on
!                    first call.
!  X      (in/out) : array of x-coordinates.
!  Y      (in/out) : array of y-coordinates.
!  SYMBOL (input)  : code number of symbol to use for marking
!                    entered points (see PGPT).
!
! Note (1): The dimension of arrays X and Y must be greater than or
! equal to MAXPT.
!
! Note (2): On return from the program, cursor points are returned in
! increasing order of X. Routine may be (re-)called with points
! already defined in X,Y (number in NPT), and they will be plotted
! first, before editing.
!
! Note (3): User commands: the user types single-character commands
! after positioning the cursor: the following are accepted:
! A (Add)    - add point at current cursor location.
! D (Delete) - delete nearest point to cursor.
! X (eXit)   - leave subroutine.
!--
! 27-Nov-1983
!  9-Jul-1983 - modified to use GRSCI instead of GRSETLI [TJP].
! 13-Dec-1990 - changed warnings to messages [TJP].
!  2-Aug-1995 - [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  CHARACTER*1 LETTER
  LOGICAL  PGNOTO
  INTEGER  PGCURS, I, J, SAVCOL
  REAL     DELTA, XP, YP, XPHYS, YPHYS
  REAL     XMIN, XIP, YIP
  REAL     XBLC, XTRC, YBLC, YTRC
!
! Check that PGPLOT is in the correct state.
!
  IF (PGNOTO('PGNCUR')) RETURN
!
! Save current color.
!
  CALL GRQCI(SAVCOL)
!
! Put current points on screen.
!
  IF (NPT/=0) CALL PGPT(NPT,X,Y,SYMBOL)
!
! Start with the cursor in the middle of the viewport.
!
  CALL PGQWIN(XBLC, XTRC, YBLC, YTRC)
  XP = 0.5*(XBLC+XTRC)
  YP = 0.5*(YBLC+YTRC)
!
! Loop over cursor inputs.
!
  100 IF (PGCURS(XP,YP,LETTER)/=1) RETURN
  IF (LETTER==CHAR(0)) RETURN
  CALL GRTOUP(LETTER,LETTER)
!
! A (ADD) command:
!
  IF (LETTER == 'A') THEN
    IF (NPT>=MAXPT) THEN
        CALL GRMSG('ADD ignored (too many points).')
        GOTO 100
    END IF
!         ! Find what current points new point is between.
    DO 120 J=1,NPT
        IF (XP<X(J)) GOTO 122
  120     CONTINUE
    J = NPT + 1
!         ! New point is beyond last current
  122     CONTINUE
!         ! J is vector location where new point should be included.
    DO 140 I=NPT,J,-1
        X(I+1) = X(I)
        Y(I+1) = Y(I)
  140     CONTINUE
    NPT = NPT + 1
!         ! Add new point to point array.
    X(J) = XP
    Y(J) = YP
    CALL PGPT(1,X(J),Y(J),SYMBOL)
    CALL GRTERM
!
! D (DELETE) command:
!
  ELSE IF (LETTER=='D') THEN
    IF (NPT<=0) THEN
        CALL GRMSG('DELETE ignored (there are no points left).')
        GOTO 100
    END IF
    XMIN = 1.E+08
!         ! Look for point closest in radius.
!         ! Convert cursor points to physical.
    XPHYS = PGXORG(PGID) + XP*PGXSCL(PGID)
    YPHYS = PGYORG(PGID) + YP*PGYSCL(PGID)
    DO 220 I=1,NPT
!             ! Convert array points to physical.
        XIP = PGXORG(PGID) + X(I)*PGXSCL(PGID)
        YIP = PGYORG(PGID) + Y(I)*PGYSCL(PGID)
        DELTA = SQRT( (XIP-XPHYS)**2 + (YIP-YPHYS)**2 )
        IF (DELTA<XMIN) THEN
           XMIN = DELTA
           J = I
        END IF
  220     CONTINUE
!         ! Remove point from screen by writing in background color.
    CALL GRSCI(0)
    CALL PGPT(1,X(J),Y(J),SYMBOL)
    CALL GRSCI(SAVCOL)
    CALL GRTERM
!         ! Remove point from cursor array.
    NPT = NPT-1
    DO 240 I=J,NPT
        X(I) = X(I+1)
        Y(I) = Y(I+1)
  240     CONTINUE
!
! X (EXIT) command:
!
  ELSE IF (LETTER=='X') THEN
    CALL GRETXT
    RETURN
!
! Illegal command:
!
  ELSE
    CALL GRMSG('Commands are A (add), D (delete), X (exit).')
  END IF
!
  GOTO 100
  END

!*PGNCURSE -- non-standard alias for PGNCUR
!+
  SUBROUTINE PGNCURSE (MAXPT, NPT, X, Y, SYMBOL)
  INTEGER MAXPT, NPT
  REAL    X(*), Y(*)
  INTEGER SYMBOL
!
! See description of PGNCUR.
!--
  CALL PGNCUR (MAXPT, NPT, X, Y, SYMBOL)
  END

!
  LOGICAL FUNCTION PGNOTO (RTN)
  CHARACTER*(*) RTN
!
! PGPLOT (internal routine): Test whether a PGPLOT device is open and
! print a message if not. Usage:
!     LOGICAL PGNOTO
!     IF (PGNOTO('routine')) RETURN
!
! Arguments:
!
! RTN (input, character): routine name to be include in message.
!
! Returns:
!     .TRUE. if PGPLOT is not open.
!--
! 11-Nov-1994
! 21-Dec-1995 - revised for multiple devices.
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  CHARACTER*80 TEXT
!
  CALL PGINIT
  PGNOTO = .FALSE.
  IF (PGID<1 .OR. PGID>PGMAXD) THEN
   PGNOTO = .TRUE.
   TEXT = RTN//': no graphics device has been selected'
   CALL GRWARN(TEXT)
  ELSE IF (PGDEVS(PGID)/=1) THEN
   PGNOTO = .TRUE.
   TEXT = RTN//': selected graphics device is not open'
   CALL GRWARN(TEXT)
  END IF
  RETURN
  END


!
!.PGNPL -- Work out how many numerals there are in an integer
!.
  SUBROUTINE PGNPL (NMAX, N, NPL)
!
  INTEGER NMAX, N, NPL
!
!     Work out how many numerals there are in an integer for use with
!     format statements.
!     e.g.  N=280 => NPL=3,   N=-3 => NPL=2
!
!     Input:
!       NMAX   :   If > 0, issue a warning that N is going to
!                  exceed the format statement field size if NPL
!                  exceeds NMAX
!       N      :   Integer of interest
!     Output:
!       NPL    :   Number of numerals
!
!-
!  20-Apr-1991 -- new routine (Neil Killeen)
!-------------------------------------------------------------------------
  IF (N==0) THEN
  NPL = 1
  ELSE
  NPL = INT(LOG10(REAL(ABS(N)))) + 1
  END IF
  IF (N<0) NPL = NPL + 1
!
  IF (NMAX>0 .AND. NPL>NMAX) &
    CALL GRWARN ('PGNPL: output conversion error likely; ' &
                 //'number too big for format')
!
  RETURN
  END

!*PGNUMB -- convert a number into a plottable character string
!%void cpgnumb(int mm, int pp, int form, char *string, \
!% int *string_length);
!+
  SUBROUTINE PGNUMB (MM, PP, FORM, STRING, NC)
  INTEGER MM, PP, FORM
  CHARACTER*(*) STRING
  INTEGER NC
!
! This routine converts a number into a decimal character
! representation. To avoid problems of floating-point roundoff, the
! number must be provided as an integer (MM) multiplied by a power of 10
! (10**PP).  The output string retains only significant digits of MM,
! and will be in either integer format (123), decimal format (0.0123),
! or exponential format (1.23x10**5). Standard escape sequences \u, \d
! raise the exponent and \x is used for the multiplication sign.
! This routine is used by PGBOX to create numeric labels for a plot.
!
! Formatting rules:
!   (a) Decimal notation (FORM=1):
!       - Trailing zeros to the right of the decimal sign are
!         omitted
!       - The decimal sign is omitted if there are no digits
!         to the right of it
!       - When the decimal sign is placed before the first digit
!         of the number, a zero is placed before the decimal sign
!       - The decimal sign is a period (.)
!       - No spaces are placed between digits (ie digits are not
!         grouped in threes as they should be)
!       - A leading minus (-) is added if the number is negative
!   (b) Exponential notation (FORM=2):
!       - The exponent is adjusted to put just one (non-zero)
!         digit before the decimal sign
!       - The mantissa is formatted as in (a), unless its value is
!         1 in which case it and the multiplication sign are omitted
!       - If the power of 10 is not zero and the mantissa is not
!         zero, an exponent of the form \x10\u[-]nnn is appended,
!         where \x is a multiplication sign (cross), \u is an escape
!         sequence to raise the exponent, and as many digits nnn
!         are used as needed
!   (c) Automatic choice (FORM=0):
!         Decimal notation is used if the absolute value of the
!         number is less than 10000 or greater than or equal to
!         0.01. Otherwise exponential notation is used.
!
! Arguments:
!  MM     (input)
!  PP     (input)  : the value to be formatted is MM*10**PP.
!  FORM   (input)  : controls how the number is formatted:
!                    FORM = 0 -- use either decimal or exponential
!                    FORM = 1 -- use decimal notation
!                    FORM = 2 -- use exponential notation
!  STRING (output) : the formatted character string, left justified.
!                    If the length of STRING is insufficient, a single
!                    asterisk is returned, and NC=1.
!  NC     (output) : the number of characters used in STRING:
!                    the string to be printed is STRING(1:NC).
!--
! 23-Nov-1983
!  9-Feb-1988 [TJP] - Use temporary variable to avoid illegal character
!                     assignments; remove non-standard DO loops.
! 15-Dec-1988 [TJP] - More corrections of the same sort.
! 27-Nov-1991 [TJP] - Change code for multiplication sign.
! 23-Jun-1994 [TJP] - Partial implementation of FORM=1 and 2.
!-----------------------------------------------------------------------
  CHARACTER*1 BSLASH
  CHARACTER*2 TIMES, UP, DOWN
  CHARACTER*20 WORK, WEXP, TEMP
  INTEGER M, P, ND, I, J, K, NBP
  LOGICAL MINUS
!
! Define backslash (escape) character and escape sequences.
!
  BSLASH = CHAR(92)
  TIMES  = BSLASH//'x'
  UP     = BSLASH//'u'
  DOWN   = BSLASH//'d'
!
! Zero is always printed as "0".
!
  IF (MM==0) THEN
    STRING = '0'
    NC = 1
    RETURN
  END IF
!
! If negative, make a note of that fact.
!
  MINUS = MM<0
  M = ABS(MM)
  P = PP
!
! Convert M to a left-justified digit string in WORK. As M is a
! positive integer, it cannot use more than 10 digits (2147483647).
!
  J = 10
   10 IF (M/=0) THEN
    K = MOD(M,10)
    M = M/10
    WORK(J:J) = CHAR(ICHAR('0')+K)
    J = J-1
 GOTO 10
  END IF
  TEMP = WORK(J+1:)
  WORK = TEMP
  ND = 10-J
!
! Remove right-hand zeros, and increment P for each one removed.
! ND is the final number of significant digits in WORK, and P the
! power of 10 to be applied. Number of digits before decimal point
! is NBP.
!
   20 IF (WORK(ND:ND)=='0') THEN
    ND = ND-1
    P = P+1
 GOTO 20
  END IF
  NBP = ND+MIN(P,0)
!
! Integral numbers of 4 or less digits are formatted as such.
!
  IF ((P>=0) .AND. ((FORM==0 .AND. P+ND<=4) .OR. &
                      (FORM==1 .AND. P+ND<=10))) THEN
    DO 30 I=1,P
        ND = ND+1
        WORK(ND:ND) = '0'
   30     CONTINUE
    P = 0
!
! If NBP is 4 or less, simply insert a decimal point in the right place.
!
  ELSE IF (FORM/=2.AND.NBP>=1.AND.NBP<=4.AND.NBP<ND) THEN
    TEMP = WORK(NBP+1:ND)
    WORK(NBP+2:ND+1) = TEMP
    WORK(NBP+1:NBP+1) = '.'
    ND = ND+1
    P = 0
!
! Otherwise insert a decimal point after the first digit, and adjust P.
!
  ELSE
    P = P + ND - 1
    IF (FORM/=2 .AND. P==-1) THEN
        TEMP = WORK
        WORK = '0'//TEMP
        ND = ND+1
        P = 0
    ELSE IF (FORM/=2 .AND. P==-2) THEN
        TEMP = WORK
        WORK = '00'//TEMP
        ND = ND+2
        P = 0
    END IF
    IF (ND>1) THEN
        TEMP = WORK(2:ND)
        WORK(3:ND+1) = TEMP
        WORK(2:2) = '.'
        ND = ND + 1
    END IF
  END IF
!
! Add exponent if necessary.
!
  IF (P/=0) THEN
    WORK(ND+1:ND+6) = TIMES//'10'//UP
    ND = ND+6
    IF (P<0) THEN
        P = -P
        ND = ND+1
        WORK(ND:ND) = '-'
    END IF
    J = 10
   40     IF (P/=0) THEN
        K = MOD(P,10)
        P = P/10
        WEXP(J:J) = CHAR(ICHAR('0')+K)
        J = J-1
     GOTO 40
    END IF
    WORK(ND+1:) = WEXP(J+1:10)
    ND = ND+10-J
    IF (WORK(1:3)=='1'//TIMES) THEN
        TEMP = WORK(4:)
        WORK = TEMP
        ND = ND-3
    END IF
    WORK(ND+1:ND+2) = DOWN
    ND = ND+2
  END IF
!
! Add minus sign if necessary and move result to output.
!
  IF (MINUS) THEN
   TEMP = WORK(1:ND)
   STRING = '-'//TEMP
   NC = ND+1
  ELSE
   STRING = WORK(1:ND)
   NC = ND
  END IF
!
! Check result fits.
!
  IF (NC>LEN(STRING)) THEN
    STRING = '*'
    NC = 1
  END IF
  END

!*PGOLIN -- mark a set of points using the cursor
!%void cpgolin(int maxpt, int *npt, float *x, float *y, int symbol);
!+
  SUBROUTINE PGOLIN (MAXPT, NPT, X, Y, SYMBOL)
  INTEGER MAXPT, NPT
  REAL    X(*), Y(*)
  INTEGER SYMBOL
!
! Interactive routine for user to enter data points by use of
! the cursor.  Routine allows user to Add and Delete points.  The
! points are returned in the order that they were entered (unlike
! PGNCUR).
!
! Arguments:
!  MAXPT  (input)  : maximum number of points that may be accepted.
!  NPT    (in/out) : number of points entered; should be zero on
!                    first call.
!  X      (in/out) : array of x-coordinates.
!  Y      (in/out) : array of y-coordinates.
!  SYMBOL (input)  : code number of symbol to use for marking
!                    entered points (see PGPT).
!
! Note (1): The dimension of arrays X and Y must be greater than or
! equal to MAXPT.
!
! Note (2): On return from the program, cursor points are returned in
! the order they were entered. Routine may be (re-)called with points
! already defined in X,Y (number in NPT), and they will be plotted
! first, before editing.
!
! Note (3): User commands: the user types single-character commands
! after positioning the cursor: the following are accepted:
! A (Add)    - add point at current cursor location.
! D (Delete) - delete the last point entered.
! X (eXit)   - leave subroutine.
!--
!  4-Nov-1985 - new routine (adapted from PGNCUR) - TJP.
! 13-Dec-1990 - change warnings to messages [TJP].
!  7-Sep-1994 - use PGBAND [TJP].
!  2-Aug-1995 - remove dependence on common block [TJP].
!-----------------------------------------------------------------------
  LOGICAL  PGNOTO
  CHARACTER*1 LETTER
  INTEGER  PGBAND, SAVCOL
  REAL     XP, YP, XREF, YREF
  REAL     XBLC, XTRC, YBLC, YTRC
!
! Check that PGPLOT is in the correct state.
!
  IF (PGNOTO('PGOLIN')) RETURN
!
! Save current color.
!
  CALL GRQCI(SAVCOL)
!
! Put current points on screen.  Position cursor on last point,
! or in middle viewport if there are no current points.
!
  CALL PGQWIN(XBLC, XTRC, YBLC, YTRC)
  IF (NPT/=0) THEN
    CALL PGPT(NPT,X,Y,SYMBOL)
    XP = X(NPT)
    YP = Y(NPT)
  ELSE
    XP = 0.5*(XBLC+XTRC)
    YP = 0.5*(YBLC+YTRC)
  END IF
!
! Loop over cursor inputs.
!
  100 XREF = XP
  YREF = YP
  IF (PGBAND(0,1,XREF,YREF,XP,YP,LETTER)/=1) RETURN
  IF (LETTER==CHAR(0)) RETURN
  CALL GRTOUP(LETTER,LETTER)
!
! A (ADD) command:
!
  IF (LETTER == 'A') THEN
    IF (NPT>=MAXPT) THEN
        CALL GRMSG('ADD ignored (too many points).')
    ELSE
        NPT = NPT + 1
        X(NPT) = XP
        Y(NPT) = YP
        CALL PGPT(1,X(NPT),Y(NPT),SYMBOL)
        CALL GRTERM
    END IF
!
! D (DELETE) command:
!
  ELSE IF (LETTER=='D') THEN
    IF (NPT<=0) THEN
        CALL GRMSG('DELETE ignored (there are no points left).')
    ELSE
        CALL GRSCI(0)
        CALL PGPT(1,X(NPT),Y(NPT),SYMBOL)
        XP = X(NPT)
        YP = Y(NPT)
        CALL GRSCI(SAVCOL)
        CALL GRTERM
        NPT = NPT-1
    END IF
!
! X (EXIT) command:
!
  ELSE IF (LETTER=='X') THEN
    CALL GRETXT
    RETURN
!
! Illegal command:
!
  ELSE
    CALL GRMSG('Commands are A (add), D (delete), X (exit).')
  END IF
!
  GOTO 100
  END

!*PGOPEN -- open a graphics device
!%int cpgopen(const char *device);
!+
  INTEGER FUNCTION PGOPEN (DEVICE)
  CHARACTER*(*) DEVICE
!
! Open a graphics device for PGPLOT output. If the device is
! opened successfully, it becomes the selected device to which
! graphics output is directed until another device is selected
! with PGSLCT or the device is closed with PGCLOS.
!
! The value returned by PGOPEN should be tested to ensure that
! the device was opened successfully, e.g.,
!
!       ISTAT = PGOPEN('plot.ps/PS')
!       IF (ISTAT .LE. 0 ) STOP
!
! Note that PGOPEN must be declared INTEGER in the calling program.
!
! The DEVICE argument is a character constant or variable; its value
! should be one of the following:
!
! (1) A complete device specification of the form 'device/type' or
!     'file/type', where 'type' is one of the allowed PGPLOT device
!     types (installation-dependent) and 'device' or 'file' is the
!     name of a graphics device or disk file appropriate for this type.
!     The 'device' or 'file' may contain '/' characters; the final
!     '/' delimits the 'type'. If necessary to avoid ambiguity,
!     the 'device' part of the string may be enclosed in double
!     quotation marks.
! (2) A device specification of the form '/type', where 'type' is one
!     of the allowed PGPLOT device types. PGPLOT supplies a default
!     file or device name appropriate for this device type.
! (3) A device specification with '/type' omitted; in this case
!     the type is taken from the environment variable PGPLOT_TYPE,
!     if defined (e.g., setenv PGPLOT_TYPE PS). Because of possible
!     confusion with '/' in file-names, omitting the device type
!     in this way is not recommended.
! (4) A blank string (' '); in this case, PGOPEN will use the value
!     of environment variable PGPLOT_DEV as the device specification,
!     or '/NULL' if the environment variable is undefined.
! (5) A single question mark, with optional trailing spaces ('?'); in
!     this case, PGPLOT will prompt the user to supply the device
!     specification, with a prompt string of the form
!         'Graphics device/type (? to see list, default XXX):'
!     where 'XXX' is the default (value of environment variable
!     PGPLOT_DEV).
! (6) A non-blank string in which the first character is a question
!     mark (e.g., '?Device: '); in this case, PGPLOT will prompt the
!     user to supply the device specification, using the supplied
!     string as the prompt (without the leading question mark but
!     including any trailing spaces).
!
! In cases (5) and (6), the device specification is read from the
! standard input. The user should respond to the prompt with a device
! specification of the form (1), (2), or (3). If the user types a
! question-mark in response to the prompt, a list of available device
! types is displayed and the prompt is re-issued. If the user supplies
! an invalid device specification, the prompt is re-issued. If the user
! responds with an end-of-file character, e.g., ctrl-D in UNIX, program
! execution is aborted; this  avoids the possibility of an infinite
! prompting loop.  A programmer should avoid use of PGPLOT-prompting
! if this behavior is not desirable.
!
! The device type is case-insensitive (e.g., '/ps' and '/PS' are
! equivalent). The device or file name may be case-sensitive in some
! operating systems.
!
! Examples of valid DEVICE arguments:
!
! (1)  'plot.ps/ps', 'dir/plot.ps/ps', '"dir/plot.ps"/ps',
!      'user:[tjp.plots]plot.ps/PS'
! (2)  '/ps'      (PGPLOT interprets this as 'pgplot.ps/ps')
! (3)  'plot.ps'  (if PGPLOT_TYPE is defined as 'ps', PGPLOT
!                  interprets this as 'plot.ps/ps')
! (4)  '   '      (if PGPLOT_DEV is defined)
! (5)  '?  '
! (6)  '?Device specification for PGPLOT: '
!
! [This routine was added to PGPLOT in Version 5.1.0. Older programs
! use PGBEG instead.]
!
! Returns:
!  PGOPEN          : returns either a positive value, the
!                    identifier of the graphics device for use with
!                    PGSLCT, or a 0 or negative value indicating an
!                    error. In the event of error a message is
!                    written on the standard error unit.
! Arguments:
!  DEVICE  (input) : the 'device specification' for the plot device
!                    (see above).
!--
! 22-Dec-1995 - new routine [TJP].
! 14-May-1996 - device '? ' should not give a blank prompt [TJP].
!-----------------------------------------------------------------------
  INCLUDE       'pgplot.h'
  INTEGER       DEFTYP,GRDTYP,GROPEN,L,LR,IC1, LPROMP
  INTEGER       GRGCOM, IER, LDEFDE, UNIT, ISTAT
  REAL          DUMMY,DUMMY2,XCSZ, XSZ, YSZ
  CHARACTER*128 DEFDEV, PROMPT
  CHARACTER*20  DEFSTR
  CHARACTER*256 REQ
  LOGICAL JUNK
!
! Initialize PGPLOT if necessary.
!
  CALL PGINIT
!
! Get the default device/type (environment variable PGPLOT_DEV).
!
  CALL GRGENV('DEV', DEFDEV, LDEFDE)
  IF (LDEFDE==0) THEN
   DEFDEV = '/NULL'
   LDEFDE = 5
  END IF
!
! Open the plot file; default type is given by environment variable
! PGPLOT_TYPE.
!
  CALL GRGENV('TYPE', DEFSTR, L)
  IF (L==0) THEN
    DEFTYP = 0
  ELSE
    CALL GRTOUP(DEFSTR, DEFSTR)
    DEFTYP = GRDTYP(DEFSTR(1:L))
  END IF
  IF (DEVICE==' ') THEN
!        -- Blank device string: use default device and type.
   ISTAT = GROPEN(DEFTYP,UNIT,DEFDEV(1:LDEFDE),PGID)
  ELSE IF (DEVICE(1:1)=='?') THEN
   IF (DEVICE=='?') THEN
!           -- Device string is a ingle question mark: prompt user
!           -- for device/type
      PROMPT = 'Graphics device/type (? to see list, default ' &
             //DEFDEV(1:LDEFDE)//'): '
      LPROMP = LDEFDE + 48
   ELSE
!           -- Device string starts with a question mark: use it
!           -- as a prompt
      PROMPT = DEVICE(2:)
      LPROMP = LEN(DEVICE)-1
   END IF
   10    IER = GRGCOM(REQ, PROMPT(1:LPROMP), LR)
   IF (IER/=1) THEN
      CALL GRWARN('Error reading device specification')
      PGOPEN = -1
      RETURN
   END IF
   IF (LR<1 .OR. REQ==' ') THEN
      REQ = DEFDEV(1:LDEFDE)
   ELSE IF (REQ(1:1)=='?') THEN
      CALL PGLDEV
      GOTO 10
   END IF
   ISTAT = GROPEN(DEFTYP,UNIT,REQ,PGID)
   IF (ISTAT/=1) GOTO 10
  ELSE
    ISTAT = GROPEN(DEFTYP,UNIT,DEVICE,PGID)
  END IF
!
! Failed to open plot file?
!
  IF (ISTAT/=1) THEN
   PGOPEN = - 1
   RETURN
  END IF
!
! Success: determine device characteristics.
!
  IF (PGID<0 .OR. PGID>PGMAXD) CALL &
         GRWARN('Something terribly wrong in PGOPEN')
  PGDEVS(PGID) = 1
  PGADVS(PGID) = 0
  PGPFIX(PGID) = .FALSE.
  CALL GRSIZE(PGID,XSZ,YSZ,DUMMY,DUMMY2, &
              PGXPIN(PGID),PGYPIN(PGID))
  CALL GRCHSZ(PGID,XCSZ,DUMMY,PGXSP(PGID),PGYSP(PGID))
  PGROWS(PGID)= .TRUE.
  PGNX(PGID)  = 1
  PGNY(PGID)  = 1
  PGXSZ(PGID) = XSZ
  PGYSZ(PGID) = YSZ
  PGNXC(PGID) = 1
  PGNYC(PGID) = 1
  CALL GRQTYP(DEFSTR,JUNK)
!
! Set the prompt state to ON, so that terminal devices pause between
! pages; this can be changed with PGASK.
!
  CALL PGASK(.TRUE.)
!
! If environment variable PGPLOT_BUFFER is defined (any value),
! start buffering output.
!
  PGBLEV(PGID) = 0
  CALL GRGENV('BUFFER', DEFSTR, L)
  IF (L>0) CALL PGBBUF
!
! Set background and foreground colors if requested.
!
  CALL GRGENV('BACKGROUND', DEFSTR, L)
  IF (L>0) CALL PGSCRN(0, DEFSTR(1:L), IER)
  CALL GRGENV('FOREGROUND', DEFSTR, L)
  IF (L>0) CALL PGSCRN(1, DEFSTR(1:L), IER)
!
! Set default attributes.
!
  CALL PGSCI(1)
  CALL PGSLS(1)
  CALL PGSLW(1)
  CALL PGSCH(1.0)
  CALL PGSCF(1)
  CALL PGSFS(1)
  CALL PGSAH(1, 45.0, 0.3)
  CALL PGSTBG(-1)
  CALL PGSHS(45.0, 1.0, 0.0)
  CALL PGSCLP(1)
!
! Set the default range of color indices available for images (16 to
! device maximum, if device maximum >= 16; otherwise not possible).
! Select linear transfer function.
!
  CALL GRQCOL(IC1, PGMXCI(PGID))
  PGMNCI(PGID) = 16
  IF (PGMXCI(PGID)<16) PGMXCI(PGID) = 0
  PGITF(PGID) = 0
!
! Set the default window (unit square).
!
  PGXBLC(PGID) = 0.0
  PGXTRC(PGID) = 1.0
  PGYBLC(PGID) = 0.0
  PGYTRC(PGID) = 1.0
!
! Set the default viewport.
!
  CALL PGVSTD
!
  PGOPEN = PGID
  RETURN
  END

!*PGPAGE -- advance to new page
!%void cpgpage(void);
!+
  SUBROUTINE PGPAGE
!
! Advance plotter to a new page or panel, clearing the screen if
! necessary. If the "prompt state" is ON (see PGASK), confirmation is
! requested from the user before clearing the screen. If the view
! surface has been subdivided into panels with PGBEG or PGSUBP, then
! PGPAGE advances to the next panel, and if the current panel is the
! last on the page, PGPAGE clears the screen or starts a new sheet of
! paper.  PGPAGE does not change the PGPLOT window or the viewport
! (in normalized device coordinates); but note that if the size of the
! view-surface is changed externally (e.g., by a workstation window
! manager) the size of the viewport is changed in proportion.
!
! Arguments: none
!--
!  7-Feb-1983
! 23-Sep-1984 - correct bug: call GRTERM at end (if flush mode set).
! 31-Jan-1985 - make closer to Fortran-77.
! 19-Nov-1987 - explicitly clear the screen if device is interactive;
!               this restores the behavior obtained with older versions
!               of GRPCKG.
!  9-Feb-1988 - move prompting into routine GRPROM.
! 11-Apr-1989 - change name to PGPAGE.
! 10-Sep-1990 - add identification labelling.
! 11-Feb-1992 - check if device size has changed.
!  3-Sep-1992 - allow column ordering of panels.
! 17-Nov-1994 - move identification to drivers.
! 23-Nov-1994 - fix bug: character size not getting reset.
! 23-Jan-1995 - rescale viewport if size of view surface  has changed.
!  4-Feb-1997 - bug fix; character size was not correctly indexed by
!               device ID.
!-----------------------------------------------------------------------
  INCLUDE      'pgplot.h'
  CHARACTER*16 STR
  LOGICAL      INTER, PGNOTO
  REAL DUM1, DUM2, XS, YS, XVP1, XVP2, YVP1, YVP2
!
  IF (PGNOTO('PGPAGE')) RETURN
!
  IF (PGROWS(PGID)) THEN
  PGNXC(PGID) = PGNXC(PGID) + 1
  IF (PGNXC(PGID)>PGNX(PGID)) THEN
    PGNXC(PGID) = 1
    PGNYC(PGID) = PGNYC(PGID) + 1
    IF (PGNYC(PGID)>PGNY(PGID)) PGNYC(PGID) = 1
  END IF
  ELSE
  PGNYC(PGID) = PGNYC(PGID) + 1
  IF (PGNYC(PGID)>PGNY(PGID)) THEN
    PGNYC(PGID) = 1
    PGNXC(PGID) = PGNXC(PGID) + 1
    IF (PGNXC(PGID)>PGNX(PGID)) PGNXC(PGID) = 1
  END IF
  END IF
  IF (PGNXC(PGID)==1 .AND. PGNYC(PGID)==1) THEN
    IF (PGADVS(PGID)==1 .AND. PGPRMP(PGID)) THEN
        CALL GRTERM
        CALL GRPROM
    END IF
    CALL GRPAGE
    IF (.NOT.PGPFIX(PGID)) THEN
!             -- Get current viewport in NDC.
        CALL PGQVP(0, XVP1, XVP2, YVP1, YVP2)
!             -- Reset view surface size if it has changed
        CALL GRSIZE(PGID, XS,YS, DUM1,DUM2, &
                      PGXPIN(PGID), PGYPIN(PGID))
        PGXSZ(PGID) = XS/PGNX(PGID)
        PGYSZ(PGID) = YS/PGNY(PGID)
!             -- and character size
        CALL PGSCH(PGCHSZ(PGID))
!             -- and viewport
        CALL PGSVP(XVP1, XVP2, YVP1, YVP2)
    END IF
!
! If the device is interactive, call GRBPIC to clear the page.
! (If the device is not interactive, GRBPIC will be called
! automatically before the first output; omitting the call here
! ensures that a blank page is not output.)
!
    CALL GRQTYP(STR,INTER)
    IF (INTER) CALL GRBPIC
  END IF
  PGXOFF(PGID) = PGXVP(PGID) + (PGNXC(PGID)-1)*PGXSZ(PGID)
  PGYOFF(PGID) = PGYVP(PGID) + &
                 (PGNY(PGID)-PGNYC(PGID))*PGYSZ(PGID)
!
! Window the plot in the new viewport.
!
  CALL PGVW
  PGADVS(PGID) = 1
  CALL GRTERM
  END

!*PGPANL -- switch to a different panel on the view surface
!%void cpgpanl(int nxc, int nyc);
!+
  SUBROUTINE PGPANL(IX, IY)
  INTEGER IX, IY
!
! Start plotting in a different panel. If the view surface has been
! divided into panels by PGBEG or PGSUBP, this routine can be used to
! move to a different panel. Note that PGPLOT does not remember what
! viewport and window were in use in each panel; these should be reset
! if necessary after calling PGPANL. Nor does PGPLOT clear the panel:
! call PGERAS after calling PGPANL to do this.
!
! Arguments:
!  IX     (input)  : the horizontal index of the panel (in the range
!                    1 <= IX <= number of panels in horizontal
!                    direction).
!  IY     (input)  : the vertical index of the panel (in the range
!                    1 <= IY <= number of panels in horizontal
!                    direction).
!--
!  1-Dec-1994 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE      'pgplot.h'
  LOGICAL PGNOTO
!
! Check that a device is open.
!
  IF (PGNOTO('PGPANL')) RETURN
!
! Check arguments.
!
  IF (IX<1 .OR. IX>PGNX(PGID) .OR. &
      IY<1 .OR. IY>PGNY(PGID)) THEN
   CALL GRWARN('PGPANL: the requested panel does not exist')
!
! Adjust the viewport to the new panel and window the plot
! in the new viewport.
!
  ELSE
   PGNXC(PGID)  = IX
   PGNYC(PGID)  = IY
   PGXOFF(PGID) = PGXVP(PGID) + (IX-1)*PGXSZ(PGID)
   PGYOFF(PGID) = PGYVP(PGID) + (PGNY(PGID)-IY)*PGYSZ(PGID)
   CALL PGVW
  END IF
!
  END

!*PGPAPER -- non-standard alias for PGPAP
!+
  SUBROUTINE PGPAPER (WIDTH, ASPECT)
  REAL WIDTH, ASPECT
!
! See description of PGPAP.
!--
  CALL PGPAP (WIDTH, ASPECT)
  END

!*PGPAP -- change the size of the view surface
!%void cpgpap(float width, float aspect);
!+
  SUBROUTINE PGPAP (WIDTH, ASPECT)
  REAL WIDTH, ASPECT
!
! This routine changes the size of the view surface ("paper size") to a
! specified width and aspect ratio (height/width), in so far as this is
! possible on the specific device. It is always possible to obtain a
! view surface smaller than the default size; on some devices (e.g.,
! printers that print on roll or fan-feed paper) it is possible to
! obtain a view surface larger than the default.
!
! This routine should be called either immediately after PGBEG or
! immediately before PGPAGE. The new size applies to all subsequent
! images until the next call to PGPAP.
!
! Arguments:
!  WIDTH  (input)  : the requested width of the view surface in inches;
!                    if WIDTH=0.0, PGPAP will obtain the largest view
!                    surface available consistent with argument ASPECT.
!                    (1 inch = 25.4 mm.)
!  ASPECT (input)  : the aspect ratio (height/width) of the view
!                    surface; e.g., ASPECT=1.0 gives a square view
!                    surface, ASPECT=0.618 gives a horizontal
!                    rectangle, ASPECT=1.618 gives a vertical rectangle.
!--
! (22-Apr-1983; bug fixed 7-Jun-1988)
!  6-Oct-1990 Modified to work correctly on interactive devices.
! 13-Dec-1990 Make errors non-fatal [TJP].
! 14-Sep-1994 Fix bug to do with drivers changing view surface size.
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  LOGICAL  PGNOTO
  REAL     HDEF, HMAX, HREQ, WDEF, WMAX, WREQ
  REAL     XSMAX, YSMAX, XSZ, YSZ
!
  IF (PGNOTO('PGPAP'))  RETURN
  IF (WIDTH<0.0 .OR. ASPECT<=0.0) THEN
    CALL GRWARN('PGPAP ignored: invalid arguments')
    RETURN
  END IF
!
  PGPFIX(PGID) = .TRUE.
!     -- Find default size WDEF, HDEF and maximum size WMAX, HMAX
!        of view surface (inches)
  CALL GRSIZE(PGID,XSZ,YSZ,XSMAX,YSMAX, &
              PGXPIN(PGID),PGYPIN(PGID))
  WDEF = XSZ/PGXPIN(PGID)
  HDEF = YSZ/PGYPIN(PGID)
  WMAX = XSMAX/PGXPIN(PGID)
  HMAX = YSMAX/PGYPIN(PGID)
!     -- Find desired size WREQ, HREQ of view surface (inches)
  IF (WIDTH/=0.0) THEN
    WREQ = WIDTH
    HREQ = WIDTH*ASPECT
  ELSE
    WREQ = WDEF
    HREQ = WDEF*ASPECT
    IF (HREQ>HDEF) THEN
        WREQ = HDEF/ASPECT
        HREQ = HDEF
    END IF
  END IF
!     -- Scale the requested view surface to fit the maximum
!        dimensions
  IF (WMAX>0.0 .AND. WREQ>WMAX) THEN
    WREQ = WMAX
    HREQ = WMAX*ASPECT
  END IF
  IF (HMAX>0.0 .AND. HREQ>HMAX) THEN
    WREQ = HMAX/ASPECT
    HREQ = HMAX
  END IF
!     -- Establish the new view surface dimensions
  XSZ = WREQ*PGXPIN(PGID)
  YSZ = HREQ*PGYPIN(PGID)
  CALL GRSETS(PGID,XSZ,YSZ)
  PGXSZ(PGID) = XSZ/PGNX(PGID)
  PGYSZ(PGID) = YSZ/PGNY(PGID)
  PGNXC(PGID) = PGNX(PGID)
  PGNYC(PGID) = PGNY(PGID)
  CALL PGSCH(1.0)
  CALL PGVSTD
  END

!*PGPIXL -- draw pixels
!%void cpgpixl(const int *ia, int idim, int jdim, int i1, int i2, \
!% int j1, int j2, float x1, float x2, float y1, float y2);
!+
  SUBROUTINE PGPIXL (IA, IDIM, JDIM, I1, I2, J1, J2, &
                     X1, X2, Y1, Y2)
  INTEGER IDIM, JDIM, I1, I2, J1, J2
  INTEGER IA(IDIM,JDIM)
  REAL    X1, X2, Y1, Y2
!
! Draw lots of solid-filled (tiny) rectangles aligned with the
! coordinate axes. Best performance is achieved when output is
! directed to a pixel-oriented device and the rectangles coincide
! with the pixels on the device. In other cases, pixel output is
! emulated.
!
! The subsection of the array IA defined by indices (I1:I2, J1:J2)
! is mapped onto world-coordinate rectangle defined by X1, X2, Y1
! and Y2. This rectangle is divided into (I2 - I1 + 1) * (J2 - J1 + 1)
! small rectangles. Each of these small rectangles is solid-filled
! with the color index specified by the corresponding element of
! IA.
!
! On most devices, the output region is "opaque", i.e., it obscures
! all graphical elements previously drawn in the region. But on
! devices that do not have erase capability, the background shade
! is "transparent" and allows previously-drawn graphics to show
! through.
!
! Arguments:
!  IA     (input)  : the array to be plotted.
!  IDIM   (input)  : the first dimension of array A.
!  JDIM   (input)  : the second dimension of array A.
!  I1, I2 (input)  : the inclusive range of the first index
!                    (I) to be plotted.
!  J1, J2 (input)  : the inclusive range of the second
!                    index (J) to be plotted.
!  X1, Y1 (input)  : world coordinates of one corner of the output
!                    region
!  X2, Y2 (input)  : world coordinates of the opposite corner of the
!                    output region
!--
! 16-Jan-1991 - [GvG]
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
! Check inputs.
!
  IF (PGNOTO('PGPIXL')) RETURN
  IF (I1<1 .OR. I2>IDIM .OR. I1>I2 .OR. &
      J1<1 .OR. J2>JDIM .OR. J1>J2) THEN
   CALL GRWARN('PGPIXL: invalid range I1:I2, J1:J2')
  ELSE
!
! Call lower-level routine to do the work.
!
   CALL PGBBUF
   CALL GRPIXL(IA, IDIM, JDIM, I1, I2, J1, J2, X1, X2, Y1, Y2)
   CALL PGEBUF
  END IF
!-----------------------------------------------------------------------
  END

!*PGPNTS -- draw several graph markers, not all the same
!%void cpgpnts(int n, const float *x, const float *y, \
!% const int *symbol, int ns);
!+
  SUBROUTINE PGPNTS (N, X, Y, SYMBOL, NS)
  INTEGER N, NS
  REAL X(*), Y(*)
  INTEGER SYMBOL(*)
!
! Draw Graph Markers. Unlike PGPT, this routine can draw a different
! symbol at each point. The markers are drawn using the current values
! of attributes color-index, line-width, and character-height
! (character-font applies if the symbol number is >31).  If the point
! to be marked lies outside the window, no marker is drawn.  The "pen
! position" is changed to (XPTS(N),YPTS(N)) in world coordinates
! (if N > 0).
!
! Arguments:
!  N      (input)  : number of points to mark.
!  X      (input)  : world x-coordinate of the points.
!  Y      (input)  : world y-coordinate of the points.
!  SYMBOL (input)  : code number of the symbol to be plotted at each
!                    point (see PGPT).
!  NS     (input)  : number of values in the SYMBOL array.  If NS <= N,
!                    then the first NS points are drawn using the value
!                    of SYMBOL(I) at (X(I), Y(I)) and SYMBOL(1) for all
!                    the values of (X(I), Y(I)) where I > NS.
!
! Note: the dimension of arrays X and Y must be greater than or equal
! to N and the dimension of the array SYMBOL must be greater than or
! equal to NS.  If N is 1, X and Y may be scalars (constants or
! variables).  If NS is 1, then SYMBOL may be a scalar.  If N is
! less than 1, nothing is drawn.
!--
! 11-Mar-1991 - new routine [JM].
! 26-Feb-1997 - revised to use PGPT1 [TJP].
!-----------------------------------------------------------------------
  INTEGER I, SYMB
!
  IF (N<1) RETURN
  CALL PGBBUF
  DO 10 I=1,N
    IF (I <= NS) THEN
        SYMB = SYMBOL(I)
    ELSE
        SYMB = SYMBOL(1)
    END IF
    CALL PGPT1(X(I), Y(I), SYMB)
   10 CONTINUE
  CALL PGEBUF
  END

!*PGPOINT -- non-standard alias for PGPT
!+
  SUBROUTINE PGPOINT (N, XPTS, YPTS, SYMBOL)
  INTEGER N
  REAL XPTS(*), YPTS(*)
  INTEGER SYMBOL
!
! See description of PGPT.
!--
  CALL PGPT (N, XPTS, YPTS, SYMBOL)
  END

!*PGPOLY -- draw a polygon, using fill-area attributes
!%void cpgpoly(int n, const float *xpts, const float *ypts);
!+
  SUBROUTINE PGPOLY (N, XPTS, YPTS)
  INTEGER N
  REAL XPTS(*), YPTS(*)
!
! Fill-area primitive routine: shade the interior of a closed
! polygon in the current window.  The action of this routine depends
! on the setting of the Fill-Area Style attribute (see PGSFS).
! The polygon is clipped at the edge of the
! window. The pen position is changed to (XPTS(1),YPTS(1)) in world
! coordinates (if N > 1).  If the polygon is not convex, a point is
! assumed to lie inside the polygon if a straight line drawn to
! infinity intersects and odd number of the polygon's edges.
!
! Arguments:
!  N      (input)  : number of points defining the polygon; the
!                    line consists of N straight-line segments,
!                    joining points 1 to 2, 2 to 3,... N-1 to N, N to 1.
!                    N should be greater than 2 (if it is 2 or less,
!                    nothing will be drawn).
!  XPTS   (input)  : world x-coordinates of the vertices.
!  YPTS   (input)  : world y-coordinates of the vertices.
!                    Note: the dimension of arrays XPTS and YPTS must be
!                    greater than or equal to N.
!--
! 21-Nov-1983 - [TJP].
! 16-Jul-1984 - revised to shade polygon with GRFA [TJP].
! 21-Oct-1985 - test PGFAS [TJP].
! 25-Nov-1994 - implement clipping [TJP].
! 13-Jan-1994 - fix bug in clipping [TJP].
!  6-Mar-1995 - add support for fill styles 3 and 4 [TJP].
! 12-Sep-1995 - fix another bug in clipping [TJP].
!-----------------------------------------------------------------------
  INTEGER MAXOUT
  PARAMETER (MAXOUT=1000)
  LOGICAL CLIP
  INTEGER I, N1, N2, N3, N4
  REAL    QX(MAXOUT), QY(MAXOUT), RX(MAXOUT), RY(MAXOUT)
  REAL    XL, XH, YL, YH
  LOGICAL PGNOTO
  INCLUDE 'pgplot.h'
!
  IF (PGNOTO('PGPOLY')) RETURN
  IF (N<1) RETURN
!
! Outline style, or polygon of less than 3 vertices.
!
  IF (PGFAS(PGID)==2 .OR. N<3) THEN
   CALL PGBBUF
   CALL GRMOVA(XPTS(N),YPTS(N))
   DO 10 I=1,N
      CALL GRLINA(XPTS(I),YPTS(I))
 10      CONTINUE
!
! Hatched style.
!
  ELSE IF (PGFAS(PGID)==3) THEN
   CALL PGBBUF
   CALL PGHTCH(N, XPTS, YPTS, 0.0)
  ELSE IF (PGFAS(PGID)==4) THEN
   CALL PGBBUF
   CALL PGHTCH(N, XPTS, YPTS, 0.0)
   CALL PGHTCH(N, XPTS, YPTS, 90.0)
  ELSE
!
! Test whether polygon lies completely in the window.
!
   CLIP = .FALSE.
   XL = MIN(PGXBLC(PGID),PGXTRC(PGID))
   XH = MAX(PGXBLC(PGID),PGXTRC(PGID))
   YL = MIN(PGYBLC(PGID),PGYTRC(PGID))
   YH = MAX(PGYBLC(PGID),PGYTRC(PGID))
   DO 20 I=1,N
      IF (XPTS(I)<XL .OR. XPTS(I)>XH .OR. &
             YPTS(I)<YL .OR. YPTS(I)>YH) THEN
         CLIP = .TRUE.
         GOTO 30
      END IF
 20      CONTINUE
 30      CONTINUE
!
! Filled style, no clipping required.
!
   CALL PGBBUF
   IF (.NOT.CLIP) THEN
      CALL GRFA(N,XPTS,YPTS)
!
! Filled style, clipping required: the vertices of the clipped
! polygon are put in temporary arrays QX,QY, RX, RY.
!
   ELSE
      CALL GRPOCL(N,  XPTS, YPTS, 1, XL, MAXOUT, N1, QX, QY)
      IF (N1>MAXOUT) GOTO 40
      IF (N1<3) GOTO 50
      CALL GRPOCL(N1, QX,   QY,   2, XH, MAXOUT, N2, RX, RY)
      IF (N2>MAXOUT) GOTO 40
      IF (N2<3) GOTO 50
      CALL GRPOCL(N2, RX,   RY,   3, YL, MAXOUT, N3, QX, QY)
      IF (N3>MAXOUT) GOTO 40
      IF (N3<3) GOTO 50
      CALL GRPOCL(N3, QX,   QY,   4, YH, MAXOUT, N4, RX, RY)
      IF (N4>MAXOUT) GOTO 40
      IF (N4>0) CALL GRFA(N4,RX,RY)
      GOTO 50
 40         CALL GRWARN('PGPOLY: polygon is too complex')
 50         CONTINUE
   END IF
  END IF
!
! Set the current pen position.
!
  CALL GRMOVA(XPTS(1),YPTS(1))
  CALL PGEBUF
!
  END

!*PGPT1 -- draw one graph marker
!%void cpgpt1(float xpt, float ypt, int symbol);
!+
  SUBROUTINE PGPT1 (XPT, YPT, SYMBOL)
  REAL XPT, YPT
  INTEGER SYMBOL
!
! Primitive routine to draw a single Graph Marker at a specified point.
! The marker is drawn using the current values of attributes
! color-index, line-width, and character-height (character-font applies
! if the symbol number is >31).  If the point to be marked lies outside
! the window, no marker is drawn.  The "pen position" is changed to
! (XPT,YPT) in world coordinates.
!
! To draw several markers with coordinates specified by X and Y
! arrays, use routine PGPT.
!
! Arguments:
!  XPT    (input)  : world x-coordinate of the point.
!  YPT    (input)  : world y-coordinate of the point.
!  SYMBOL (input)  : code number of the symbol to be drawn:
!                    -1, -2  : a single dot (diameter = current
!                              line width).
!                    -3..-31 : a regular polygon with ABS(SYMBOL)
!                              edges (style set by current fill style).
!                    0..31   : standard marker symbols.
!                    32..127 : ASCII characters (in current font).
!                              e.g. to use letter F as a marker, let
!                              SYMBOL = ICHAR('F').
!                    > 127  :  a Hershey symbol number.
!--
!  4-Feb-1997 - new routine [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
  REAL XPTS(1), YPTS(1)
!
  IF (PGNOTO('PGPT1')) RETURN
  XPTS(1) = XPT
  YPTS(1) = YPT
  CALL PGPT(1, XPTS, YPTS, SYMBOL)
  END

!*PGPTEXT -- non-standard alias for PGPTXT
!+
  SUBROUTINE PGPTEXT (X, Y, ANGLE, FJUST, TEXT)
  REAL X, Y, ANGLE, FJUST
  CHARACTER*(*) TEXT
!
! See description of PGPTXT.
!--
  CALL PGPTXT (X, Y, ANGLE, FJUST, TEXT)
  END

!*PGPT -- draw several graph markers
!%void cpgpt(int n, const float *xpts, const float *ypts, int symbol);
!+
  SUBROUTINE PGPT (N, XPTS, YPTS, SYMBOL)
  INTEGER N
  REAL XPTS(*), YPTS(*)
  INTEGER SYMBOL
!
! Primitive routine to draw Graph Markers (polymarker). The markers
! are drawn using the current values of attributes color-index,
! line-width, and character-height (character-font applies if the symbol
! number is >31).  If the point to be marked lies outside the window,
! no marker is drawn.  The "pen position" is changed to
! (XPTS(N),YPTS(N)) in world coordinates (if N > 0).
!
! Arguments:
!  N      (input)  : number of points to mark.
!  XPTS   (input)  : world x-coordinates of the points.
!  YPTS   (input)  : world y-coordinates of the points.
!  SYMBOL (input)  : code number of the symbol to be drawn at each
!                    point:
!                    -1, -2  : a single dot (diameter = current
!                              line width).
!                    -3..-31 : a regular polygon with ABS(SYMBOL)
!                              edges (style set by current fill style).
!                    0..31   : standard marker symbols.
!                    32..127 : ASCII characters (in current font).
!                              e.g. to use letter F as a marker, let
!                              SYMBOL = ICHAR('F').
!                    > 127  :  a Hershey symbol number.
!
! Note: the dimension of arrays X and Y must be greater than or equal
! to N. If N is 1, X and Y may be scalars (constants or variables). If
! N is less than 1, nothing is drawn.
!--
! 27-Nov-1986
! 17-Dec-1990 - add polygons [PAH].
! 14-Mar-1997 - optimization: use GRDOT1 [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (N<1) RETURN
  IF (PGNOTO('PGPT')) RETURN
!
  CALL PGBBUF
  IF (SYMBOL>=0 .OR. SYMBOL<=-3) THEN
    CALL GRMKER(SYMBOL,.FALSE.,N,XPTS,YPTS)
  ELSE
    CALL GRDOT1(N,XPTS,YPTS)
  END IF
  CALL PGEBUF
  END

!*PGPTXT -- write text at arbitrary position and angle
!%void cpgptxt(float x, float y, float angle, float fjust, \
!% const char *text);
!+
  SUBROUTINE PGPTXT (X, Y, ANGLE, FJUST, TEXT)
  REAL X, Y, ANGLE, FJUST
  CHARACTER*(*) TEXT
!
! Primitive routine for drawing text. The text may be drawn at any
! angle with the horizontal, and may be centered or left- or right-
! justified at a specified position.  Routine PGTEXT provides a
! simple interface to PGPTXT for horizontal strings. Text is drawn
! using the current values of attributes color-index, line-width,
! character-height, and character-font.  Text is NOT subject to
! clipping at the edge of the window.
!
! Arguments:
!  X      (input)  : world x-coordinate.
!  Y      (input)  : world y-coordinate. The string is drawn with the
!                    baseline of all the characters passing through
!                    point (X,Y); the positioning of the string along
!                    this line is controlled by argument FJUST.
!  ANGLE  (input)  : angle, in degrees, that the baseline is to make
!                    with the horizontal, increasing counter-clockwise
!                    (0.0 is horizontal).
!  FJUST  (input)  : controls horizontal justification of the string.
!                    If FJUST = 0.0, the string will be left-justified
!                    at the point (X,Y); if FJUST = 0.5, it will be
!                    centered, and if FJUST = 1.0, it will be right
!                    justified. [Other values of FJUST give other
!                    justifications.]
!  TEXT   (input)  : the character string to be plotted.
!--
! (2-May-1983)
! 31-Jan-1985 - convert to Fortran-77 standard...
! 13-Feb-1988 - correct a PGBBUF/PGEBUF mismatch if string is blank.
! 16-Oct-1993 - erase background of opaque text.
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  INTEGER CI, I, L, GRTRIM
  REAL D, XP, YP
  REAL XBOX(4), YBOX(4)
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGPTXT')) RETURN
  CALL PGBBUF
!
  L = GRTRIM(TEXT)
  D = 0.0
  IF (FJUST/=0.0) CALL GRLEN(TEXT(1:L),D)
  XP = PGXORG(PGID)+X*PGXSCL(PGID) - D*FJUST*COS(ANGLE/57.29578)
  YP = PGYORG(PGID)+Y*PGYSCL(PGID) - D*FJUST*SIN(ANGLE/57.29578)
  IF (PGTBCI(PGID)>=0) THEN
    CALL GRQTXT (ANGLE, XP, YP, TEXT(1:L), XBOX, YBOX)
    DO 25 I=1,4
        XBOX(I) = (XBOX(I)-PGXORG(PGID))/PGXSCL(PGID)
        YBOX(I) = (YBOX(I)-PGYORG(PGID))/PGYSCL(PGID)
   25     CONTINUE
    CALL PGQCI(CI)
    CALL PGSCI(PGTBCI(PGID))
    CALL GRFA(4, XBOX, YBOX)
    CALL PGSCI(CI)
  END IF
  CALL GRTEXT(.TRUE. ,ANGLE, .TRUE., XP, YP, TEXT(1:L))
   30 CALL PGEBUF
  END

!*PGQAH -- inquire arrow-head style
!%void cpgqah(int *fs, float *angle, float *barb);
!+
  SUBROUTINE PGQAH (FS, ANGLE, BARB)
  INTEGER  FS
  REAL ANGLE, BARB
!
! Query the style to be used for arrowheads drawn with routine PGARRO.
!
! Argument:
!  FS     (output) : FS = 1 => filled; FS = 2 => outline.
!  ANGLE  (output) : the acute angle of the arrow point, in degrees.
!  BARB   (output) : the fraction of the triangular arrow-head that
!                    is cut away from the back.
!--
! 13-Oct-1992 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
!
  FS = PGAHS(PGID)
  ANGLE = PGAHA(PGID)
  BARB = PGAHV(PGID)
!
  END

!*PGQCF -- inquire character font
!%void cpgqcf(int *font);
!+
  SUBROUTINE PGQCF (FONT)
  INTEGER  FONT
!
! Query the current Character Font (set by routine PGSCF).
!
! Argument:
!  FONT   (output)   : the current font number (in range 1-4).
!--
!  5-Nov-1985 - new routine [TJP].
! 25-OCT-1993 - changed name of argument [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGQCF')) THEN
   FONT = 1
  ELSE
   CALL GRQFNT(FONT)
  END IF
  END

!*PGQCH -- inquire character height
!%void cpgqch(float *size);
!+
  SUBROUTINE PGQCH (SIZE)
  REAL SIZE
!
! Query the Character Size attribute (set by routine PGSCH).
!
! Argument:
!  SIZE   (output) : current character size (dimensionless multiple of
!                    the default size).
!--
!  5-Nov-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  LOGICAL  PGNOTO
!
  IF (PGNOTO('PGQCH')) THEN
    SIZE = 1.0
  ELSE
    SIZE = PGCHSZ(PGID)
  END IF
  END

!*PGQCI -- inquire color index
!%void cpgqci(int *ci);
!+
  SUBROUTINE PGQCI (CI)
  INTEGER  CI
!
! Query the Color Index attribute (set by routine PGSCI).
!
! Argument:
!  CI     (output) : the current color index (in range 0-max). This is
!                    the color index actually in use, and may differ
!                    from the color index last requested by PGSCI if
!                    that index is not available on the output device.
!--
!  5-Nov-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGQCI')) THEN
   CI = 1
  ELSE
   CALL GRQCI(CI)
  END IF
  END

!*PGQCIR -- inquire color index range
!%void cpgqcir(int *icilo, int *icihi);
!+
  SUBROUTINE PGQCIR(ICILO, ICIHI)
  INTEGER   ICILO, ICIHI
!
! Query the color index range to be used for producing images with
! PGGRAY or PGIMAG, as set by routine PGSCIR or by device default.
!
! Arguments:
!  ICILO  (output) : the lowest color index to use for images
!  ICIHI  (output) : the highest color index to use for images
!--
! 1994-Mar-17 : new routine [AFT/TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
!---
  ICILO = PGMNCI(PGID)
  ICIHI = PGMXCI(PGID)
!
  END

!*PGQCLP -- inquire clipping status
!%void cpgqclp(int *state);
!+
  SUBROUTINE PGQCLP(STATE)
  INTEGER  STATE
!
! Query the current clipping status (set by routine PGSCLP).
!
! Argument:
!  STATE  (output) : receives the clipping status (0 => disabled,
!                    1 => enabled).
!--
! 25-Feb-1997 [TJP] - new routine.
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGQCLP')) THEN
   STATE = 1
  ELSE
   STATE = PGCLP(PGID)
  END IF
  END

!*PGQCOL -- inquire color capability
!%void cpgqcol(int *ci1, int *ci2);
!+
  SUBROUTINE PGQCOL (CI1, CI2)
  INTEGER  CI1, CI2
!
! Query the range of color indices available on the current device.
!
! Argument:
!  CI1    (output) : the minimum available color index. This will be
!                    either 0 if the device can write in the
!                    background color, or 1 if not.
!  CI2    (output) : the maximum available color index. This will be
!                    1 if the device has no color capability, or a
!                    larger number (e.g., 3, 7, 15, 255).
!--
! 31-May-1989 - new routine [TJP].
!-----------------------------------------------------------------------
  CALL GRQCOL(CI1, CI2)
  END

!*PGQCR  -- inquire color representation
!%void cpgqcr(int ci, float *cr, float *cg, float *cb);
!+
  SUBROUTINE PGQCR (CI, CR, CG, CB)
  INTEGER CI
  REAL    CR, CG, CB
!
! Query the RGB colors associated with a color index.
!
! Arguments:
!  CI  (input)  : color index
!  CR  (output) : red, green and blue intensities
!  CG  (output)   in the range 0.0 to 1.0
!  CB  (output)
!--
! 7-Apr-1992 - new routine [DLT]
!-----------------------------------------------------------------------
  CALL GRQCR(CI, CR, CG, CB)
  END

!*PGQCS  -- inquire character height in a variety of units
!%void cpgqcs(int units, float *xch, float *ych);
!+
  SUBROUTINE PGQCS(UNITS, XCH, YCH)
  INTEGER UNITS
  REAL XCH, YCH
!
! Return the current PGPLOT character height in a variety of units.
! This routine provides facilities that are not available via PGQCH.
! Use PGQCS if the character height is required in units other than
! those used in PGSCH.
!
! The PGPLOT "character height" is a dimension that scales with the
! size of the view surface and with the scale-factor specified with
! routine PGSCH. The default value is 1/40th of the height or width
! of the view surface (whichever is less); this value is then
! multiplied by the scale-factor supplied with PGSCH. Note that it
! is a nominal height only; the actual character size depends on the
! font and is usually somewhat smaller.
!
! Arguments:
!  UNITS  (input)  : Used to specify the units of the output value:
!                    UNITS = 0 : normalized device coordinates
!                    UNITS = 1 : inches
!                    UNITS = 2 : millimeters
!                    UNITS = 3 : pixels
!                    UNITS = 4 : world coordinates
!                    Other values give an error message, and are
!                    treated as 0.
!  XCH    (output) : The character height for text written with a
!                    vertical baseline.
!  YCH    (output) : The character height for text written with
!                    a horizontal baseline (the usual case).
!
! The character height is returned in both XCH and YCH.
!
! If UNITS=1 or UNITS=2, XCH and YCH both receive the same value.
!
! If UNITS=3, XCH receives the height in horizontal pixel units, and YCH
! receives the height in vertical pixel units; on devices for which the
! pixels are not square, XCH and YCH will be different.
!
! If UNITS=4, XCH receives the height in horizontal world coordinates
! (as used for the x-axis), and YCH receives the height in vertical
! world coordinates (as used for the y-axis). Unless special care has
! been taken to achive equal world-coordinate scales on both axes, the
! values of XCH and YCH will be different.
!
! If UNITS=0, XCH receives the character height as a fraction of the
! horizontal dimension of the view surface, and YCH receives the
! character height as a fraction of the vertical dimension of the view
! surface.
!--
! 15-Oct-1992 - new routine [MCS].
!  4-Dec-1992 - added more explanation [TJP].
!  5-Sep-1995 - add UNITS=4; correct error for non-square pixels [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
  REAL RATIO
!                                        Conversion factor inches -> mm
  REAL INTOMM
  PARAMETER (INTOMM=25.4)
!-----------------------------------------------------------------------
  IF (PGNOTO('PGQCS')) RETURN
  RATIO = PGYPIN(PGID)/PGXPIN(PGID)
!
! Return the character height in the required units.
!
!                                        Inches.
  IF (UNITS==1) THEN
  XCH = PGYSP(PGID)/PGXPIN(PGID)
  YCH = XCH
!                                        Millimeters.
  ELSE IF (UNITS==2) THEN
  XCH = PGYSP(PGID)/PGXPIN(PGID) * INTOMM
  YCH = XCH
!                                        Pixels.
  ELSE IF (UNITS==3) THEN
  XCH = PGYSP(PGID)
  YCH = PGYSP(PGID)*RATIO
!                                        World coordinates.
  ELSE IF (UNITS==4) THEN
   XCH = PGYSP(PGID)/PGXSCL(PGID)
   YCH = PGYSP(PGID)*RATIO/PGYSCL(PGID)
!                                        Normalized device coords, or
!                                        unknown.
  ELSE
  XCH = PGYSP(PGID)/PGXSZ(PGID)
  YCH = PGYSP(PGID)*RATIO/PGYSZ(PGID)
  IF (UNITS/=0) &
         CALL GRWARN('Invalid "UNITS" argument in PGQCS.')
  END IF
  END

!*PGQDT -- inquire name of nth available device type
!%void cpgqdt(int n, char *type, int *type_length, char *descr, \
!% int *descr_length, int *inter);
!+
  SUBROUTINE PGQDT(N, TYPE, TLEN, DESCR, DLEN, INTER)
  INTEGER N
  CHARACTER*(*) TYPE, DESCR
  INTEGER TLEN, DLEN, INTER
!
! Return the name of the Nth available device type as a character
! string. The number of available types can be determined by calling
! PGQNDT. If the value of N supplied is outside the range from 1 to
! the number of available types, the routine returns DLEN=TLEN=0.
!
! Arguments:
!  N      (input)  : the number of the device type (1..maximum).
!  TYPE   (output) : receives the character device-type code of the
!                    Nth device type. The argument supplied should be
!                    large enough for at least 8 characters. The first
!                    character in the string is a '/' character.
!  TLEN   (output) : receives the number of characters in TYPE,
!                    excluding trailing blanks.
!  DESCR  (output) : receives a description of the device type. The
!                    argument supplied should be large enough for at
!                    least 64 characters.
!  DLEN   (output) : receives the number of characters in DESCR,
!                    excluding trailing blanks.
!  INTER  (output) : receives 1 if the device type is an interactive
!                    one, 0 otherwise.
!--
! 17-Mar-1997 - new routine [TJP].
!-----------------------------------------------------------------------
  INTEGER NDEV, NBUF, LCHR, L1, L2
  REAL RBUF
  CHARACTER*80 CHR
!
! Initialize PGPLOT if necessary.
!
  CALL PGINIT
!
  TYPE = 'error'
  TLEN = 0
  DESCR = ' '
  DLEN = 0
  INTER = 1
  CALL PGQNDT(NDEV)
  IF (N>=1 .AND. N<=NDEV) THEN
   NBUF = 0
   CALL GREXEC(N, 1, RBUF, NBUF, CHR, LCHR)
   IF (LCHR>0) THEN
      L1 = INDEX(CHR(1:LCHR), ' ')
      IF (L1>1) THEN
         TYPE(1:1) = '/'
         IF (LEN(TYPE)>1) TYPE(2:) = CHR(1:L1-1)
         TLEN = MIN(L1,LEN(TYPE))
      END IF
      L2 = INDEX(CHR(1:LCHR), '(')
      IF (L2>0) DESCR = CHR(L2:LCHR)
      DLEN = MIN(LCHR-L2+1,LEN(DESCR))
      CALL GREXEC(N, 4, RBUF, NBUF, CHR, LCHR)
      IF (CHR(1:1)=='H') INTER = 0
   END IF
  END IF
!
  END

!*PGQFS -- inquire fill-area style
!%void cpgqfs(int *fs);
!+
  SUBROUTINE PGQFS (FS)
  INTEGER  FS
!
! Query the current Fill-Area Style attribute (set by routine
! PGSFS).
!
! Argument:
!  FS     (output) : the current fill-area style:
!                      FS = 1 => solid (default)
!                      FS = 2 => outline
!                      FS = 3 => hatched
!                      FS = 4 => cross-hatched
!--
!  5-Nov-1985 - new routine [TJP].
!  6-Mar-1995 - add styles 3 and 4 [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGQFS')) THEN
    FS = 1
  ELSE
    FS = PGFAS(PGID)
  END IF
  END

!*PGQHS -- inquire hatching style
!%void cpgqhs(float *angle, float *sepn, float* phase);
!+
  SUBROUTINE PGQHS (ANGLE, SEPN, PHASE)
  REAL ANGLE, SEPN, PHASE
!
! Query the style to be used hatching (fill area with fill-style 3).
!
! Arguments:
!  ANGLE  (output) : the angle the hatch lines make with the
!                    horizontal, in degrees, increasing
!                    counterclockwise (this is an angle on the
!                    view surface, not in world-coordinate space).
!  SEPN   (output) : the spacing of the hatch lines. The unit spacing
!                    is 1 percent of the smaller of the height or
!                    width of the view surface.
!  PHASE  (output) : a real number between 0 and 1; the hatch lines
!                    are displaced by this fraction of SEPN from a
!                    fixed reference.  Adjacent regions hatched with the
!                    same PHASE have contiguous hatch lines.
!--
! 26-Feb-1995 - new routine [TJP].
! 19-Jun-1995 - correct synopsis [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
!
  ANGLE = PGHSA(PGID)
  SEPN  = PGHSS(PGID)
  PHASE = PGHSP(PGID)
!
  END

!*PGQID -- inquire current device identifier
!%void cpgqid(int *id);
!+
  SUBROUTINE PGQID (ID)
  INTEGER  ID
!
! This subroutine returns the identifier of the currently
! selected device, or 0 if no device is selected.  The identifier is
! assigned when PGOPEN is called to open the device, and may be used
! as an argument to PGSLCT.  Each open device has a different
! identifier.
!
! [This routine was added to PGPLOT in Version 5.1.0.]
!
! Argument:
!  ID     (output) : the identifier of the current device, or 0 if
!                    no device is currently selected.
!--
! 22-Dec-1995 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
!
  ID = PGID
  END

!*PGQINF -- inquire PGPLOT general information
!%void cpgqinf(const char *item, char *value, int *value_length);
!+
  SUBROUTINE PGQINF (ITEM, VALUE, LENGTH)
  CHARACTER*(*) ITEM, VALUE
  INTEGER LENGTH
!
! This routine can be used to obtain miscellaneous information about
! the PGPLOT environment. Input is a character string defining the
! information required, and output is a character string containing the
! requested information.
!
! The following item codes are accepted (note that the strings must
! match exactly, except for case, but only the first 8 characters are
! significant). For items marked *, PGPLOT must be in the OPEN state
! for the inquiry to succeed. If the inquiry is unsuccessful, either
! because the item code is not recognized or because the information
! is not available, a question mark ('?') is returned.
!
!   'VERSION'     - version of PGPLOT software in use.
!   'STATE'       - status of PGPLOT ('OPEN' if a graphics device
!                   is open for output, 'CLOSED' otherwise).
!   'USER'        - the username associated with the calling program.
!   'NOW'         - current date and time (e.g., '17-FEB-1986 10:04').
!   'DEVICE'    * - current PGPLOT device or file.
!   'FILE'      * - current PGPLOT device or file.
!   'TYPE'      * - device-type of the current PGPLOT device.
!   'DEV/TYPE'  * - current PGPLOT device and type, in a form which
!                   is acceptable as an argument for PGBEG.
!   'HARDCOPY'  * - is the current device a hardcopy device? ('YES' or
!                   'NO').
!   'TERMINAL'  * - is the current device the user's interactive
!                   terminal? ('YES' or 'NO').
!   'CURSOR'    * - does the current device have a graphics cursor?
!                   ('YES' or 'NO').
!   'SCROLL'    * - does current device have rectangle-scroll
!                   capability ('YES' or 'NO'); see PGSCRL.
!
! Arguments:
!  ITEM  (input)  : character string defining the information to
!                   be returned; see above for a list of possible
!                   values.
!  VALUE (output) : returns a character-string containing the
!                   requested information, truncated to the length
!                   of the supplied string or padded on the right with
!                   spaces if necessary.
!  LENGTH (output): the number of characters returned in VALUE
!                   (excluding trailing blanks).
!--
! 18-Feb-1988 - [TJP].
! 30-Aug-1988 - remove pseudo logical use of IER.
! 12-Mar-1992 - change comments for clarity.
! 17-Apr-1995 - clean up some zero-length string problems [TJP].
!  7-Jul-1995 - get cursor information directly from driver [TJP].
! 24-Feb-1997 - add SCROLL request.
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  INTEGER IER, L1, GRTRIM
  LOGICAL INTER, SAME
  CHARACTER*8 TEST
  CHARACTER*64 DEV1
!
! Initialize PGPLOT if necessary.
!
  CALL PGINIT
!
  CALL GRTOUP(TEST,ITEM)
  IF (TEST=='USER') THEN
    CALL GRUSER(VALUE, LENGTH)
    IER = 1
  ELSE IF (TEST=='NOW') THEN
    CALL GRDATE(VALUE, LENGTH)
    IER = 1
  ELSE IF (TEST=='VERSION') THEN
    VALUE = 'v5.2.2'
    LENGTH = 6
    IER = 1
  ELSE IF (TEST=='STATE') THEN
    IF (PGID<1 .OR. PGID>PGMAXD) THEN
       VALUE = 'CLOSED'
       LENGTH = 6
    ELSE IF (PGDEVS(PGID)==0) THEN
       VALUE = 'CLOSED'
       LENGTH = 6
    ELSE
       VALUE = 'OPEN'
       LENGTH = 4
    END IF
    IER = 1
  ELSE IF (PGID<1 .OR. PGID>PGMAXD) THEN
    IER = 0
  ELSE IF (PGDEVS(PGID)==0) THEN
    IER = 0
  ELSE IF (TEST=='DEV/TYPE') THEN
    CALL GRQDT(VALUE)
    LENGTH = GRTRIM(VALUE)
    IER = 0
    IF (LENGTH>0) IER = 1
  ELSE IF (TEST=='DEVICE' .OR. TEST=='FILE') THEN
    CALL GRQDEV(VALUE, LENGTH)
    IER = 1
  ELSE IF (TEST=='TERMINAL') THEN
    CALL GRQDEV(DEV1, L1)
    IF (L1>=1) THEN
       CALL GRTTER(DEV1(1:L1), SAME)
    ELSE
       SAME = .FALSE.
    END IF
    IF (SAME) THEN
        VALUE = 'YES'
        LENGTH = 3
    ELSE
        VALUE = 'NO'
        LENGTH = 2
    END IF
    IER = 1
  ELSE IF (TEST=='TYPE') THEN
    CALL GRQTYP(VALUE,INTER)
    LENGTH = GRTRIM(VALUE)
    IER = 0
    IF (LENGTH>0) IER = 1
  ELSE IF (TEST=='HARDCOPY') THEN
    CALL GRQTYP(VALUE,INTER)
    IF (INTER) THEN
        VALUE = 'NO'
        LENGTH = 2
    ELSE
        VALUE = 'YES'
        LENGTH = 3
    END IF
    IER = 1
  ELSE IF (TEST=='CURSOR') THEN
    CALL GRQCAP(DEV1)
    IF (DEV1(2:2)=='N') THEN
        VALUE = 'NO'
        LENGTH = 2
    ELSE
        VALUE = 'YES'
        LENGTH = 3
    END IF
    IER = 1
  ELSE IF (TEST=='SCROLL') THEN
    CALL GRQCAP(DEV1)
    IF (DEV1(11:11)/='S') THEN
        VALUE = 'NO'
        LENGTH = 2
    ELSE
        VALUE = 'YES'
        LENGTH = 3
    END IF
    IER = 1
  ELSE
    IER = 0
  END IF
  IF (IER/=1) THEN
   VALUE = '?'
   LENGTH = 1
  ELSE IF (LENGTH<1) THEN
   LENGTH = 1
   VALUE = ' '
  END IF
  END

!*PGQITF -- inquire image transfer function
!%void cpgqitf(int *itf);
!+
  SUBROUTINE PGQITF (ITF)
  INTEGER  ITF
!
! Return the Image Transfer Function as set by default or by a previous
! call to PGSITF. The Image Transfer Function is used by routines
! PGIMAG, PGGRAY, and PGWEDG.
!
! Argument:
!  ITF    (output) : type of transfer function (see PGSITF)
!--
! 15-Sep-1994 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGQITF')) THEN
    ITF = 0
  ELSE
    ITF = PGITF(PGID)
  END IF
  END

!*PGQLS -- inquire line style
!%void cpgqls(int *ls);
!+
  SUBROUTINE PGQLS (LS)
  INTEGER  LS
!
! Query the current Line Style attribute (set by routine PGSLS).
!
! Argument:
!  LS     (output) : the current line-style attribute (in range 1-5).
!--
!  5-Nov-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGQLS')) THEN
   LS = 1
  ELSE
   CALL GRQLS(LS)
  END IF
  END

!*PGQLW -- inquire line width
!%void cpgqlw(int *lw);
!+
  SUBROUTINE PGQLW (LW)
  INTEGER  LW
!
! Query the current Line-Width attribute (set by routine PGSLW).
!
! Argument:
!  LW     (output)  : the line-width (in range 1-201).
!--
!  5-Nov-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGQLW')) THEN
   LW = 1
  ELSE
   CALL GRQLW(LW)
  END IF
  END

!*PGQNDT -- inquire number of available device types
!%void cpgqndt(int *n);
!+
  SUBROUTINE PGQNDT(N)
  INTEGER N
!
! Return the number of available device types. This routine is
! usually used in conjunction with PGQDT to get a list of the
! available device types.
!
! Arguments:
!  N      (output) : the number of available device types.
!--
! 17-Mar-1997 - new routine [TJP].
!-----------------------------------------------------------------------
  INTEGER NBUF, LCHR
  REAL RBUF(2)
  CHARACTER CHR
!
! Initialize PGPLOT if necessary.
!
  CALL PGINIT
!
! Find number of device types.
!
  CALL GREXEC(0, 0, RBUF, NBUF, CHR, LCHR)
  N = NINT(RBUF(1))
!
  END

!*PGQPOS -- inquire current pen position
!%void cpgqpos(float *x, float *y);
!+
  SUBROUTINE PGQPOS (X, Y)
  REAL X, Y
!
! Query the current "pen" position in world C coordinates (X,Y).
!
! Arguments:
!  X      (output)  : world x-coordinate of the pen position.
!  Y      (output)  : world y-coordinate of the pen position.
!--
!  1-Mar-1991 - new routine [JM].
!-----------------------------------------------------------------------
  CALL GRQPOS(X,Y)
  END

!*PGQTBG -- inquire text background color index
!%void cpgqtbg(int *tbci);
!+
  SUBROUTINE PGQTBG (TBCI)
  INTEGER  TBCI
!
! Query the current Text Background Color Index (set by routine
! PGSTBG).
!
! Argument:
!  TBCI   (output) : receives the current text background color index.
!--
! 16-Oct-1993 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGQTBG')) THEN
    TBCI = 0
  ELSE
    TBCI = PGTBCI(PGID)
  END IF
  END

!*PGQTXT -- find bounding box of text string
!%void cpgqtxt(float x, float y, float angle, float fjust, \
!% const char *text, float *xbox, float *ybox);
!+
  SUBROUTINE PGQTXT (X, Y, ANGLE, FJUST, TEXT, XBOX, YBOX)
  REAL X, Y, ANGLE, FJUST
  CHARACTER*(*) TEXT
  REAL XBOX(4), YBOX(4)
!
! This routine returns a bounding box for a text string. Instead
! of drawing the string as routine PGPTXT does, it returns in XBOX
! and YBOX the coordinates of the corners of a rectangle parallel
! to the string baseline that just encloses the string. The four
! corners are in the order: lower left, upper left, upper right,
! lower right (where left and right refer to the first and last
! characters in the string).
!
! If the string is blank or contains no drawable characters, all
! four elements of XBOX and YBOX are assigned the starting point
! of the string, (X,Y).
!
! Arguments:
!  X, Y, ANGLE, FJUST, TEXT (input) : these arguments are the same as
!                    the corrresponding arguments in PGPTXT.
!  XBOX, YBOX (output) : arrays of dimension 4; on output, they
!                    contain the world coordinates of the bounding
!                    box in (XBOX(1), YBOX(1)), ..., (XBOX(4), YBOX(4)).
!--
! 12-Sep-1993 - new routine [TJP].
!  8-Nov-1994 - return something for blank string [TJP].
! 14-Jan-1997 - additional explanation [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
  INTEGER I, L, GRTRIM
  REAL D, XP, YP, XPBOX(4), YPBOX(4), XOFFS, YOFFS
!
  IF (PGNOTO('PGQTXT')) RETURN
!
  L = GRTRIM(TEXT)
  IF (L<=0) THEN
   DO 15 I=1,4
      XBOX(I) = X
      YBOX(I) = Y
 15      CONTINUE
  ELSE
   D = 0.0
   IF (FJUST/=0.0) CALL GRLEN(TEXT(1:L),D)
   XOFFS = PGXORG(PGID) - D*FJUST*COS(ANGLE/57.29578)
   YOFFS = PGYORG(PGID) - D*FJUST*SIN(ANGLE/57.29578)
   XP = X*PGXSCL(PGID) + XOFFS
   YP = Y*PGYSCL(PGID) + YOFFS
   CALL GRQTXT(ANGLE, XP, YP, TEXT(1:L), XPBOX, YPBOX)
   DO 25 I=1,4
      XBOX(I) = (XPBOX(I) - PGXORG(PGID))/PGXSCL(PGID)
      YBOX(I) = (YPBOX(I) - PGYORG(PGID))/PGYSCL(PGID)
 25      CONTINUE
  END IF
  END

!*PGQVP -- inquire viewport size and position
!%void cpgqvp(int units, float *x1, float *x2, float *y1, float *y2);
!+
  SUBROUTINE PGQVP (UNITS, X1, X2, Y1, Y2)
  INTEGER UNITS
  REAL    X1, X2, Y1, Y2
!
! Inquiry routine to determine the current viewport setting.
! The values returned may be normalized device coordinates, inches, mm,
! or pixels, depending on the value of the input parameter CFLAG.
!
! Arguments:
!  UNITS  (input)  : used to specify the units of the output parameters:
!                    UNITS = 0 : normalized device coordinates
!                    UNITS = 1 : inches
!                    UNITS = 2 : millimeters
!                    UNITS = 3 : pixels
!                    Other values give an error message, and are
!                    treated as 0.
!  X1     (output) : the x-coordinate of the bottom left corner of the
!                    viewport.
!  X2     (output) : the x-coordinate of the top right corner of the
!                    viewport.
!  Y1     (output) : the y-coordinate of the bottom left corner of the
!                    viewport.
!  Y2     (output) : the y-coordinate of the top right corner of the
!                    viewport.
!--
! 26-Sep-1985 - new routine (TJP).
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  REAL SX, SY
!
  IF (UNITS==0) THEN
    SX = PGXSZ(PGID)
    SY = PGYSZ(PGID)
  ELSE IF (UNITS==1) THEN
    SX = PGXPIN(PGID)
    SY = PGYPIN(PGID)
  ELSE IF (UNITS==2) THEN
    SX = (PGXPIN(PGID)/25.4)
    SY = (PGYPIN(PGID)/25.4)
  ELSE IF (UNITS==3) THEN
    SX = 1.0
    SY = 1.0
  ELSE
    CALL GRWARN( &
          'Illegal value for parameter UNITS in routine PGQVP')
    SX = PGXSZ(PGID)
    SY = PGYSZ(PGID)
  END IF
  X1 = PGXVP(PGID)/SX
  X2 = (PGXVP(PGID)+PGXLEN(PGID))/SX
  Y1 = PGYVP(PGID)/SY
  Y2 = (PGYVP(PGID)+PGYLEN(PGID))/SY
  END

!*PGQVSZ -- inquire size of view surface
!%void cpgqvsz(int units, float *x1, float *x2, float *y1, float *y2);
!+
  SUBROUTINE PGQVSZ (UNITS, X1, X2, Y1, Y2)
  INTEGER UNITS
  REAL X1, X2, Y1, Y2
!
! This routine returns the dimensions of the view surface (the maximum
! plottable area) of the currently selected graphics device, in
! a variety of units. The size of the view surface is device-dependent
! and is established when the graphics device is opened. On some
! devices, it can be changed by calling PGPAP before starting a new
! page with PGPAGE. On some devices, the size can be changed (e.g.,
! by a workstation window manager) outside PGPLOT, and PGPLOT detects
! the change when PGPAGE is used. Call this routine after PGPAGE to
! find the current size.
!
! Note 1: the width and the height of the view surface in normalized
! device coordinates are both always equal to 1.0.
!
! Note 2: when the device is divided into panels (see PGSUBP), the
! view surface is a single panel.
!
! Arguments:
!  UNITS  (input)  : 0,1,2,3 for output in normalized device coords,
!                    inches, mm, or device units (pixels)
!  X1     (output) : always returns 0.0
!  X2     (output) : width of view surface
!  Y1     (output) : always returns 0.0
!  Y2     (output) : height of view surface
!--
! 28-Aug-1992 - new routine [Neil Killeen].
!  2-Dec-1992 - changed to avoid resetting the viewport [TJP].
! 26-Feb-1997 - revised description [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
  REAL SX, SY
!
  IF (PGNOTO('PGQVSZ')) THEN
   X1 = 0.0
   X2 = 0.0
   Y1 = 0.0
   Y2 = 0.0
   RETURN
  END IF
!
  IF (UNITS==0) THEN
    SX = PGXSZ(PGID)
    SY = PGYSZ(PGID)
  ELSE IF (UNITS==1) THEN
    SX = PGXPIN(PGID)
    SY = PGYPIN(PGID)
  ELSE IF (UNITS==2) THEN
    SX = (PGXPIN(PGID)/25.4)
    SY = (PGYPIN(PGID)/25.4)
  ELSE IF (UNITS==3) THEN
    SX = 1.0
    SY = 1.0
  ELSE
    CALL GRWARN( &
          'Illegal value for parameter UNITS in routine PGQVSZ')
    SX = PGXSZ(PGID)
    SY = PGYSZ(PGID)
  END IF
  X1 = 0.0
  X2 = PGXSZ(PGID)/SX
  Y1 = 0.0
  Y2 = PGYSZ(PGID)/SY
  END

!*PGQWIN -- inquire window boundary coordinates
!%void cpgqwin(float *x1, float *x2, float *y1, float *y2);
!+
  SUBROUTINE PGQWIN (X1, X2, Y1, Y2)
  REAL X1, X2, Y1, Y2
!
! Inquiry routine to determine the current window setting.
! The values returned are world coordinates.
!
! Arguments:
!  X1     (output) : the x-coordinate of the bottom left corner
!                    of the window.
!  X2     (output) : the x-coordinate of the top right corner
!                    of the window.
!  Y1     (output) : the y-coordinate of the bottom left corner
!                    of the window.
!  Y2     (output) : the y-coordinate of the top right corner
!                    of the window.
!--
! 26-Sep-1985 - new routine (TJP).
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
!
  X1 = PGXBLC(PGID)
  X2 = PGXTRC(PGID)
  Y1 = PGYBLC(PGID)
  Y2 = PGYTRC(PGID)
  END

!*PGRECT -- draw a rectangle, using fill-area attributes
!%void cpgrect(float x1, float x2, float y1, float y2);
!+
  SUBROUTINE PGRECT (X1, X2, Y1, Y2)
  REAL X1, X2, Y1, Y2
!
! This routine can be used instead of PGPOLY for the special case of
! drawing a rectangle aligned with the coordinate axes; only two
! vertices need be specified instead of four.  On most devices, it is
! faster to use PGRECT than PGPOLY for drawing rectangles.  The
! rectangle has vertices at (X1,Y1), (X1,Y2), (X2,Y2), and (X2,Y1).
!
! Arguments:
!  X1, X2 (input) : the horizontal range of the rectangle.
!  Y1, Y2 (input) : the vertical range of the rectangle.
!--
! 21-Nov-1986 - [TJP].
! 22-Mar-1988 - use GRRECT for fill [TJP].
!  6-Mar-1995 - add hatching (by calling PGHTCH) [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  REAL XP(4), YP(4)
!
  CALL PGBBUF
!
! Outline only.
!
  IF (PGFAS(PGID)==2) THEN
   CALL GRMOVA(X1,Y1)
   CALL GRLINA(X1,Y2)
   CALL GRLINA(X2,Y2)
   CALL GRLINA(X2,Y1)
   CALL GRLINA(X1,Y1)
!
! Hatching.
!
  ELSE IF (PGFAS(PGID)==3 .OR. PGFAS(PGID)==4) THEN
   XP(1) = X1
   XP(2) = X1
   XP(3) = X2
   XP(4) = X2
   YP(1) = Y1
   YP(2) = Y2
   YP(3) = Y2
   YP(4) = Y1
   CALL PGHTCH(4, XP, YP, 0.0)
   IF (PGFAS(PGID)==4) CALL PGHTCH(4, XP, YP, 90.0)
!
! Solid fill.
!
  ELSE
    CALL GRRECT(X1,Y1,X2,Y2)
    CALL GRMOVA(X1,Y1)
  END IF
  CALL PGEBUF
  END

!*PGRND -- find the smallest `round' number greater than x
!%float cpgrnd(float x, int *nsub);
!+
  REAL FUNCTION PGRND (X, NSUB)
  REAL X
  INTEGER NSUB
!
! Routine to find the smallest "round" number larger than x, a
! "round" number being 1, 2 or 5 times a power of 10. If X is negative,
! PGRND(X) = -PGRND(ABS(X)). eg PGRND(8.7) = 10.0,
! PGRND(-0.4) = -0.5.  If X is zero, the value returned is zero.
! This routine is used by PGBOX for choosing  tick intervals.
!
! Returns:
!  PGRND         : the "round" number.
! Arguments:
!  X      (input)  : the number to be rounded.
!  NSUB   (output) : a suitable number of subdivisions for
!                    subdividing the "nice" number: 2 or 5.
!--
!  6-Sep-1989 - Changes for standard Fortran-77 [TJP].
!  2-Dec-1991 - Fix for bug found on Fujitsu [TJP].
!-----------------------------------------------------------------------
  INTEGER  I,ILOG
  REAL     FRAC,NICE(3),PWR,XLOG,XX
  INTRINSIC ABS, LOG10, SIGN
  DATA     NICE/2.0,5.0,10.0/
!
  IF (X==0.0) THEN
    PGRND = 0.0
    NSUB = 2
    RETURN
  END IF
  XX   = ABS(X)
  XLOG = LOG10(XX)
  ILOG = XLOG
  IF (XLOG<0) ILOG=ILOG-1
  PWR  = 10.0**ILOG
  FRAC = XX/PWR
  I = 3
  IF (FRAC<=NICE(2)) I = 2
  IF (FRAC<=NICE(1)) I = 1
  PGRND = SIGN(PWR*NICE(I),X)
  NSUB = 5
  IF (I==1) NSUB = 2
  END

!*PGRNGE -- choose axis limits
!%void cpgrnge(float x1, float x2, float *xlo, float *xhi);
!+
  SUBROUTINE PGRNGE (X1, X2, XLO, XHI)
  REAL X1, X2, XLO, XHI
!
! Choose plotting limits XLO and XHI which encompass the data
! range X1 to X2.
!
! Arguments:
!  X1, X2 (input)  : the data range (X1<X2), ie, the min and max values
!                    to be plotted.
!  XLO, XHI (output) : suitable values to use as the extremes of a graph
!                    axis (XLO <= X1, XHI >= X2).
!--
! 10-Nov-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  XLO = X1 - 0.1*(X2-X1)
  XHI = X2 + 0.1*(X2-X1)
  IF (XLO<0.0 .AND. X1>=0.0) XLO = 0.0
  IF (XHI>0.0 .AND. X2<=0.0) XHI = 0.0
  END

!*PGSAH -- set arrow-head style
!%void cpgsah(int fs, float angle, float barb);
!+
  SUBROUTINE PGSAH (FS, ANGLE, BARB)
  INTEGER  FS
  REAL ANGLE, BARB
!
! Set the style to be used for arrowheads drawn with routine PGARRO.
!
! Argument:
!  FS     (input)  : FS = 1 => filled; FS = 2 => outline.
!                    Other values are treated as 2. Default 1.
!  ANGLE  (input)  : the acute angle of the arrow point, in degrees;
!                    angles in the range 20.0 to 90.0 give reasonable
!                    results. Default 45.0.
!  BARB   (input)  : the fraction of the triangular arrow-head that
!                    is cut away from the back. 0.0 gives a triangular
!                    wedge arrow-head; 1.0 gives an open >. Values 0.3
!                    to 0.7 give reasonable results. Default 0.3.
!--
! 13-Oct-1992 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
!
  PGAHS(PGID) = FS
  IF (PGAHS(PGID)/=1) PGAHS(PGID) = 2
  PGAHA(PGID) = ANGLE
  PGAHV(PGID) = BARB
!
  END

!*PGSAVE -- save PGPLOT attributes
!%void cpgsave(void);
!+
  SUBROUTINE PGSAVE
!
! This routine saves the current PGPLOT attributes in a private storage
! area. They can be restored by calling PGUNSA (unsave). Attributes
! saved are: character font, character height, color index, fill-area
! style, line style, line width, pen position, arrow-head style,
! hatching style, and clipping state. Color representation is not saved.
!
! Calls to PGSAVE and PGUNSA should always be paired. Up to 20 copies
! of the attributes may be saved. PGUNSA always retrieves the last-saved
! values (last-in first-out stack).
!
! Note that when multiple devices are in use, PGUNSA retrieves the
! values saved by the last PGSAVE call, even if they were for a
! different device.
!
! Arguments: none
!--
! 20-Apr-1992 - new routine [TJP].
! 27-Nov-1992 - add arrowhead style [TJP].
!  6-Oct-1993 - add text opacity [TJP].
! 28-Feb-1994 - correct bug (variable not saved) [TJP].
! 26-Feb-1995 - add hatching attributes.
! 19-Jun-1996 - correction in header comments [TJP].
! 26-Feb-1997 - add clipping state [TJP].
!-----------------------------------------------------------------------
  INTEGER MAXS
  PARAMETER (MAXS=20)
!
  INTEGER LEV
  INTEGER CF(MAXS), CI(MAXS), FS(MAXS), LS(MAXS), LW(MAXS)
  INTEGER AHFS(MAXS), TBG(MAXS), CLP(MAXS)
  REAL    CH(MAXS), POS(2,MAXS)
  REAL    AHANG(MAXS), AHBARB(MAXS), HSA(MAXS), HSS(MAXS), HSP(MAXS)
  SAVE    LEV, CF, CI, FS, LS, LW, AHFS, TBG, CH, POS
  SAVE    AHANG, AHBARB, HSA, HSS, HSP, CLP
  DATA    LEV /0/
!
  IF (LEV>=MAXS) THEN
    CALL GRWARN('Too many unmatched calls to PGSAVE')
  ELSE
    LEV = LEV+1
    CALL PGQCF(CF(LEV))
    CALL PGQCH(CH(LEV))
    CALL PGQCI(CI(LEV))
    CALL PGQFS(FS(LEV))
    CALL PGQLS(LS(LEV))
    CALL PGQLW(LW(LEV))
!          CALL PGQVP(0, VP(1,LEV), VP(2,LEV), VP(3,LEV), VP(4,LEV))
!          CALL PGQWIN(WIN(1,LEV), WIN(2,LEV), WIN(3,LEV), WIN(4,LEV))
    CALL PGQPOS(POS(1,LEV), POS(2,LEV))
    CALL PGQAH(AHFS(LEV), AHANG(LEV), AHBARB(LEV))
    CALL PGQTBG(TBG(LEV))
    CALL PGQHS(HSA(LEV), HSS(LEV), HSP(LEV))
    CALL PGQCLP(CLP(LEV))
  END IF
  RETURN
!
!*PGUNSA -- restore PGPLOT attributes
!%void cpgunsa(void);
!+
  ENTRY PGUNSA
!
! This routine restores the PGPLOT attributes saved in the last call to
! PGSAVE. Usage: CALL PGUNSA (no arguments). See PGSAVE.
!
! Arguments: none
!-----------------------------------------------------------------------
  IF (LEV<=0) THEN
    CALL GRWARN('PGUNSA: nothing has been saved')
  ELSE
    CALL PGSCF(CF(LEV))
    CALL PGSCH(CH(LEV))
    CALL PGSCI(CI(LEV))
    CALL PGSFS(FS(LEV))
    CALL PGSLS(LS(LEV))
    CALL PGSLW(LW(LEV))
!          CALL PGSVP(VP(1,LEV), VP(2,LEV), VP(3,LEV), VP(4,LEV))
!          CALL PGSWIN(WIN(1,LEV), WIN(2,LEV), WIN(3,LEV), WIN(4,LEV))
    CALL PGMOVE(POS(1,LEV), POS(2,LEV))
    CALL PGSAH(AHFS(LEV), AHANG(LEV), AHBARB(LEV))
    CALL PGSTBG(TBG(LEV))
    CALL PGSHS(HSA(LEV), HSS(LEV), HSP(LEV))
    CALL PGSCLP(CLP(LEV))
    LEV = LEV-1
  END IF
  RETURN
  END

!*PGSCF -- set character font
!%void cpgscf(int font);
!+
  SUBROUTINE PGSCF (FONT)
  INTEGER  FONT
!
! Set the Character Font for subsequent text plotting. Four different
! fonts are available:
!   1: (default) a simple single-stroke font ("normal" font)
!   2: roman font
!   3: italic font
!   4: script font
! This call determines which font is in effect at the beginning of
! each text string. The font can be changed (temporarily) within a text
! string by using the escape sequences \fn, \fr, \fi, and \fs for fonts
! 1, 2, 3, and 4, respectively.
!
! Argument:
!  FONT   (input)  : the font number to be used for subsequent text
!                    plotting (in range 1-4).
!--
! 26-Sep-1985 - new routine [TJP].
! 25-OCT-1993 - changed name of argument [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSCF')) RETURN
  CALL GRSFNT(FONT)
  END

!*PGSCH -- set character height
!%void cpgsch(float size);
!+
  SUBROUTINE PGSCH (SIZE)
  REAL SIZE
!
! Set the character size attribute. The size affects all text and graph
! markers drawn later in the program. The default character size is
! 1.0, corresponding to a character height about 1/40 the height of
! the view surface.  Changing the character size also scales the length
! of tick marks drawn by PGBOX and terminals drawn by PGERRX and PGERRY.
!
! Argument:
!  SIZE   (input)  : new character size (dimensionless multiple of
!                    the default size).
!--
! (1-Mar-1983)
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  LOGICAL  PGNOTO
  REAL     XC, XCNEW, YC, XS, YS
!
  IF (PGNOTO('PGSCH')) RETURN
!
  CALL GRCHSZ(PGID, XC, YC, XS, YS)
  IF (PGXSZ(PGID)/PGXPIN(PGID) > &
      PGYSZ(PGID)/PGYPIN(PGID)) THEN
    XCNEW = SIZE*XC*PGYSZ(PGID)/YS/40.0
  ELSE
    XCNEW = SIZE*XC*(PGXSZ(PGID)*PGYPIN(PGID)/PGXPIN(PGID)) &
              /YS/40.0
  END IF
  CALL GRSETC(PGID,XCNEW)
  PGXSP(PGID) = XS*XCNEW/XC
  PGYSP(PGID) = YS*XCNEW/XC
  PGCHSZ(PGID) = SIZE
  END

!*PGSCI -- set color index
!%void cpgsci(int ci);
!+
  SUBROUTINE PGSCI (CI)
  INTEGER  CI
!
! Set the Color Index for subsequent plotting, if the output device
! permits this. The default color index is 1, usually white on a black
! background for video displays or black on a white background for
! printer plots. The color index is an integer in the range 0 to a
! device-dependent maximum. Color index 0 corresponds to the background
! color; lines may be "erased" by overwriting them with color index 0
! (if the device permits this).
!
! If the requested color index is not available on the selected device,
! color index 1 will be substituted.
!
! The assignment of colors to color indices can be changed with
! subroutine PGSCR (set color representation).  Color indices 0-15
! have predefined color representations (see the PGPLOT manual), but
! these may be changed with PGSCR.  Color indices above 15  have no
! predefined representations: if these indices are used, PGSCR must
! be called to define the representation.
!
! Argument:
!  CI     (input)  : the color index to be used for subsequent plotting
!                    on the current device (in range 0-max). If the
!                    index exceeds the device-dependent maximum, the
!                    default color index (1) is used.
!--
! 26-Sep-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSCI')) RETURN
  CALL GRSCI(CI)
  END

!*PGSCIR -- set color index range
!%void cpgscir(int icilo, int icihi);
!+
  SUBROUTINE PGSCIR(ICILO, ICIHI)
  INTEGER   ICILO, ICIHI
!
! Set the color index range to be used for producing images with
! PGGRAY or PGIMAG. If the range is not all within the range supported
! by the device, a smaller range will be used. The number of
! different colors available for images is ICIHI-ICILO+1.
!
! Arguments:
!  ICILO  (input)  : the lowest color index to use for images
!  ICIHI  (input)  : the highest color index to use for images
!--
! 1994-Mar-17 : new routine [AFT/TJP].
!---
  INCLUDE 'pgplot.h'
  INTEGER IC1, IC2
!---
  CALL GRQCOL(IC1,IC2)
  PGMNCI(PGID) = MIN(IC2,MAX(IC1,ICILO))
  PGMXCI(PGID) = MIN(IC2,MAX(IC1,ICIHI))
!
  END

!*PGSCLP -- enable or disable clipping at edge of viewport
!%void cpgsclp(int state);
!+
  SUBROUTINE PGSCLP(STATE)
  INTEGER STATE
!
! Normally all PGPLOT primitives except text are ``clipped'' at the
! edge of the viewport: parts of the primitives that lie outside
! the viewport are not drawn. If clipping is disabled by calling this
! routine, primitives are visible wherever they lie on the view
! surface. The default (clipping enabled) is appropriate for almost
! all applications.
!
! Argument:
!  STATE  (input)  : 0 to disable clipping, or 1 to enable clipping.
!
! 25-Feb-1997 [TJP] - new routine.
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSCLP')) RETURN
!
! Disable clipping.
!
  IF (STATE==0) THEN
   CALL GRAREA(PGID,0.,0.,-1.,-1.)
   PGCLP(PGID) = 0
!
! Enable clipping.
!
  ELSE
   CALL GRAREA(PGID,PGXOFF(PGID),PGYOFF(PGID), &
                 PGXLEN(PGID),PGYLEN(PGID))
   PGCLP(PGID) = 1
  END IF
  END

!*PGSCR -- set color representation
!%void cpgscr(int ci, float cr, float cg, float cb);
!+
  SUBROUTINE PGSCR (CI, CR, CG, CB)
  INTEGER CI
  REAL    CR, CG, CB
!
! Set color representation: i.e., define the color to be
! associated with a color index.  Ignored for devices which do not
! support variable color or intensity.  Color indices 0-15
! have predefined color representations (see the PGPLOT manual), but
! these may be changed with PGSCR.  Color indices 16-maximum have no
! predefined representations: if these indices are used, PGSCR must
! be called to define the representation. On monochrome output
! devices (e.g. VT125 terminals with monochrome monitors), the
! monochrome intensity is computed from the specified Red, Green, Blue
! intensities as 0.30*R + 0.59*G + 0.11*B, as in US color television
! systems, NTSC encoding.  Note that most devices do not have an
! infinite range of colors or monochrome intensities available;
! the nearest available color is used.  Examples: for black,
! set CR=CG=CB=0.0; for white, set CR=CG=CB=1.0; for medium gray,
! set CR=CG=CB=0.5; for medium yellow, set CR=CG=0.5, CB=0.0.
!
! Argument:
!  CI     (input)  : the color index to be defined, in the range 0-max.
!                    If the color index greater than the device
!                    maximum is specified, the call is ignored. Color
!                    index 0 applies to the background color.
!  CR     (input)  : red, green, and blue intensities,
!  CG     (input)    in range 0.0 to 1.0.
!  CB     (input)
!--
! 5-Nov-1985 - new routine [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSCR')) RETURN
  CALL GRSCR(CI,CR,CG,CB)
  END

!*PGSCRL -- scroll window
!%void cpgscrl(float dx, float dy);
!+
  SUBROUTINE PGSCRL (DX, DY)
  REAL DX, DY
!
! This routine moves the window in world-coordinate space while
! leaving the viewport unchanged. On devices that have the
! capability, the pixels within the viewport are scrolled
! horizontally, vertically or both in such a way that graphics
! previously drawn in the window are shifted so that their world
! coordinates are unchanged.
!
! If the old window coordinate range was (X1, X2, Y1, Y2), the new
! coordinate range will be approximately (X1+DX, X2+DX, Y1+DY, Y2+DY).
! The size and scale of the window are unchanged.
!
! Thee window can only be shifted by a whole number of pixels
! (device coordinates). If DX and DY do not correspond to integral
! numbers of pixels, the shift will be slightly different from that
! requested. The new window-coordinate range, and hence the exact
! amount of the shift, can be determined by calling PGQWIN after this
! routine.
!
! Pixels that are moved out of the viewport by this operation are
! lost completely; they cannot be recovered by scrolling back.
! Pixels that are ``scrolled into'' the viewport are filled with
! the background color (color index 0).
!
! If the absolute value of DX is bigger than the width of the window,
! or the aboslute value of DY is bigger than the height of the window,
! the effect will be the same as zeroing all the pixels in the
! viewport.
!
! Not all devices have the capability to support this routine.
! It is only available on some interactive devices that have discrete
! pixels. To determine whether the current device has scroll capability,
! call PGQINF.
!
! Arguments:
!  DX     (input)  : distance (in world coordinates) to shift the
!                    window horizontally (positive shifts window to the
!                    right and scrolls to the left).
!  DY     (input)  : distance (in world coordinates) to shift the
!                    window vertically (positive shifts window up and
!                    scrolls down).
!--
! 25-Feb-97: new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
  REAL X1, X2, Y1, Y2, DDX, DDY
  INTEGER NDX, NDY
!
  IF (PGNOTO('PGSCRL')) RETURN
!
! Shift must be a whole number of pixels.
!
  NDX = NINT(DX*PGXSCL(PGID))
  NDY = NINT(DY*PGYSCL(PGID))
!
  IF (NDX/=0 .OR. NDY/=0) THEN
   CALL PGBBUF
   DDX = NDX/PGXSCL(PGID)
   DDY = NDY/PGYSCL(PGID)
!
!        -- Set new world-ccordinate window.
!
   X1 = PGXBLC(PGID)
   X2 = PGXTRC(PGID)
   Y1 = PGYBLC(PGID)
   Y2 = PGYTRC(PGID)
   PGXBLC(PGID) = X1+DDX
   PGXTRC(PGID) = X2+DDX
   PGYBLC(PGID) = Y1+DDY
   PGYTRC(PGID) = Y2+DDY
   CALL PGVW
!
!        -- Do hardware scroll.
!
   CALL GRSCRL(NDX, NDY)
   CALL PGEBUF
  END IF
  END

!*PGSCRN -- set color representation by name
!%void cpgscrn(int ci, const char *name, int *ier);
!+
  SUBROUTINE PGSCRN(CI, NAME, IER)
  INTEGER CI
  CHARACTER*(*) NAME
  INTEGER IER
!
! Set color representation: i.e., define the color to be
! associated with a color index.  Ignored for devices which do not
! support variable color or intensity.  This is an alternative to
! routine PGSCR. The color representation is defined by name instead
! of (R,G,B) components.
!
! Color names are defined in an external file which is read the first
! time that PGSCRN is called. The name of the external file is
! found as follows:
! 1. if environment variable (logical name) PGPLOT_RGB is defined,
!    its value is used as the file name;
! 2. otherwise, if environment variable PGPLOT_DIR is defined, a
!    file "rgb.txt" in the directory named by this environment
!    variable is used;
! 3. otherwise, file "rgb.txt" in the current directory is used.
! If all of these fail to find a file, an error is reported and
! the routine does nothing.
!
! Each line of the file
! defines one color, with four blank- or tab-separated fields per
! line. The first three fields are the R, G, B components, which
! are integers in the range 0 (zero intensity) to 255 (maximum
! intensity). The fourth field is the color name. The color name
! may include embedded blanks. Example:
!
! 255   0   0 red
! 255 105 180 hot pink
! 255 255 255 white
!   0   0   0 black
!
! Arguments:
!  CI     (input)  : the color index to be defined, in the range 0-max.
!                    If the color index greater than the device
!                    maximum is specified, the call is ignored. Color
!                    index 0 applies to the background color.
!  NAME   (input)  : the name of the color to be associated with
!                    this color index. This name must be in the
!                    external file. The names are not case-sensitive.
!                    If the color is not listed in the file, the
!                    color representation is not changed.
!  IER    (output) : returns 0 if the routine was successful, 1
!                    if an error occurred (either the external file
!                    could not be read, or the requested color was
!                    not defined in the file).
!--
! 12-Oct-1992 [TJP]
! 31-May-1993 [TJP] use GROPTX to open file.
!  7-Nov-1994 [TJP] better error messages.
!-----------------------------------------------------------------------
  INTEGER MAXCOL
  PARAMETER (MAXCOL=1000)
  INTEGER I, IR, IG, IB, J, L, NCOL, UNIT, IOS
  INTEGER GRCTOI, GROPTX, GRTRIM
  REAL RR(MAXCOL), RG(MAXCOL), RB(MAXCOL)
  CHARACTER*20 CREQ, CNAME(MAXCOL)
  CHARACTER*255 TEXT
  SAVE NCOL, CNAME, RR, RG, RB
  DATA NCOL/0/
!
! On first call, read the database.
!
  IF (NCOL==0) THEN
    CALL GRGFIL('RGB', TEXT)
    L = GRTRIM(TEXT)
    IF (L<1) L = 1
    CALL GRGLUN(UNIT)
    IOS = GROPTX(UNIT, TEXT(1:L), 'rgb.txt', 0)
    IF (IOS/=0) GOTO 40
    DO 10 I=1,MAXCOL
        READ (UNIT, '(A)', ERR=15, END=15) TEXT
        J = 1
        CALL GRSKPB(TEXT, J)
        IR = GRCTOI(TEXT, J)
        CALL GRSKPB(TEXT, J)
        IG = GRCTOI(TEXT, J)
        CALL GRSKPB(TEXT, J)
        IB = GRCTOI(TEXT, J)
        CALL GRSKPB(TEXT, J)
        NCOL = NCOL+1
        CALL GRTOUP(CNAME(NCOL), TEXT(J:))
        RR(NCOL) = IR/255.0
        RG(NCOL) = IG/255.0
        RB(NCOL) = IB/255.0
   10     CONTINUE
   15     CLOSE (UNIT)
    CALL GRFLUN(UNIT)
  END IF
!
! Look up requested color and set color representation if found.
!
  CALL GRTOUP(CREQ, NAME)
  DO 20 I=1,NCOL
    IF (CREQ==CNAME(I)) THEN
        CALL PGSCR(CI, RR(I), RG(I), RB(I))
        IER = 0
        RETURN
    END IF
   20 CONTINUE
!
! Color not found.
!
  IER = 1
  TEXT = 'Color not found: '//NAME
  CALL GRWARN(TEXT)
  RETURN
!
! Database not found.
!
   40 IER = 1
  NCOL = -1
  CALL GRFLUN(UNIT)
  CALL GRWARN('Unable to read color file: '//TEXT(1:L))
  CALL GRWARN('Use environment variable PGPLOT_RGB to specify '// &
              'the location of the PGPLOT rgb.txt file.')
  RETURN
  END

!*PGSFS -- set fill-area style
!%void cpgsfs(int fs);
!+
  SUBROUTINE PGSFS (FS)
  INTEGER  FS
!
! Set the Fill-Area Style attribute for subsequent area-fill by
! PGPOLY, PGRECT, or PGCIRC.  Four different styles are available:
! solid (fill polygon with solid color of the current color-index),
! outline (draw outline of polygon only, using current line attributes),
! hatched (shade interior of polygon with parallel lines, using
! current line attributes), or cross-hatched. The orientation and
! spacing of hatch lines can be specified with routine PGSHS (set
! hatch style).
!
! Argument:
!  FS     (input)  : the fill-area style to be used for subsequent
!                    plotting:
!                      FS = 1 => solid (default)
!                      FS = 2 => outline
!                      FS = 3 => hatched
!                      FS = 4 => cross-hatched
!                    Other values give an error message and are
!                    treated as 2.
!--
! 21-Oct-1985 - new routine [TJP].
! 17-Dec-1990 - pass to GR level [TJP].
!  6-Mar-1995 - add styles 3 and 4 [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSFS')) RETURN
  IF (FS<1 .OR. FS>4) THEN
    CALL GRWARN('illegal fill-area style requested')
    PGFAS(PGID) = 2
  ELSE
    PGFAS(PGID) = FS
  END IF
  END

!*PGSHLS -- set color representation using HLS system
!%void cpgshls(int ci, float ch, float cl, float cs);
!+
  SUBROUTINE PGSHLS (CI, CH, CL, CS)
  INTEGER CI
  REAL    CH, CL, CS
!
! Set color representation: i.e., define the color to be
! associated with a color index.  This routine is equivalent to
! PGSCR, but the color is defined in the Hue-Lightness-Saturation
! model instead of the Red-Green-Blue model. Hue is represented
! by an angle in degrees, with red at 120, green at 240,
! and blue at 0 (or 360). Lightness ranges from 0.0 to 1.0, with black
! at lightness 0.0 and white at lightness 1.0. Saturation ranges from
! 0.0 (gray) to 1.0 (pure color). Hue is irrelevant when saturation
! is 0.0.
!
! Examples:           H     L     S        R     G     B
!     black          any   0.0   0.0      0.0   0.0   0.0
!     white          any   1.0   0.0      1.0   1.0   1.0
!     medium gray    any   0.5   0.0      0.5   0.5   0.5
!     red            120   0.5   1.0      1.0   0.0   0.0
!     yellow         180   0.5   1.0      1.0   1.0   0.0
!     pink           120   0.7   0.8      0.94  0.46  0.46
!
! Reference: SIGGRAPH Status Report of the Graphic Standards Planning
! Committee, Computer Graphics, Vol.13, No.3, Association for
! Computing Machinery, New York, NY, 1979. See also: J. D. Foley et al,
! ``Computer Graphics: Principles and Practice'', second edition,
! Addison-Wesley, 1990, section 13.3.5.
!
! Argument:
!  CI     (input)  : the color index to be defined, in the range 0-max.
!                    If the color index greater than the device
!                    maximum is specified, the call is ignored. Color
!                    index 0 applies to the background color.
!  CH     (input)  : hue, in range 0.0 to 360.0.
!  CL     (input)  : lightness, in range 0.0 to 1.0.
!  CS     (input)  : saturation, in range 0.0 to 1.0.
!--
! 9-May-1988 - new routine [TJP].
!-----------------------------------------------------------------------
  REAL CR, CG, CB
  CALL GRXRGB (CH,CL,CS,CR,CG,CB)
  CALL GRSCR(CI,CR,CG,CB)
  END

!*PGSHS -- set hatching style
!%void cpgshs(float angle, float sepn, float phase);
!+
  SUBROUTINE PGSHS (ANGLE, SEPN, PHASE)
  REAL ANGLE, SEPN, PHASE
!
! Set the style to be used for hatching (fill area with fill-style 3).
! The default style is ANGLE=45.0, SEPN=1.0, PHASE=0.0.
!
! Arguments:
!  ANGLE  (input)  : the angle the hatch lines make with the
!                    horizontal, in degrees, increasing
!                    counterclockwise (this is an angle on the
!                    view surface, not in world-coordinate space).
!  SEPN   (input)  : the spacing of the hatch lines. The unit spacing
!                    is 1 percent of the smaller of the height or
!                    width of the view surface. This should not be
!                    zero.
!  PHASE  (input)  : a real number between 0 and 1; the hatch lines
!                    are displaced by this fraction of SEPN from a
!                    fixed reference.  Adjacent regions hatched with the
!                    same PHASE have contiguous hatch lines. To hatch
!                    a region with alternating lines of two colors,
!                    fill the area twice, with PHASE=0.0 for one color
!                    and PHASE=0.5 for the other color.
!--
! 26-Feb-1995 - new routine [TJP].
! 12-Feb-1996 - check for zero spacing [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSHS')) RETURN
  PGHSA(PGID) = ANGLE
  IF (SEPN==0.0) THEN
   CALL GRWARN('PGSHS: zero hatch line spacing requested')
   PGHSS(PGID) = 1.0
  ELSE
   PGHSS(PGID) = SEPN
  END IF
  IF (PHASE<0.0 .OR. PHASE>1.0) THEN
   CALL GRWARN('PGSHS: hatching phase must be in (0.0,1.0)')
  END IF
  PGHSP(PGID) = PHASE
!
  END

!*PGSITF -- set image transfer function
!%void cpgsitf(int itf);
!+
  SUBROUTINE PGSITF (ITF)
  INTEGER  ITF
!
! Set the Image Transfer Function for subsequent images drawn by
! PGIMAG, PGGRAY, or PGWEDG. The Image Transfer Function is used
! to map array values into the available range of color indices
! specified with routine PGSCIR or (for PGGRAY on some devices)
! into dot density.
!
! Argument:
!  ITF    (input)  : type of transfer function:
!                      ITF = 0 : linear
!                      ITF = 1 : logarithmic
!                      ITF = 2 : square-root
!--
! 15-Sep-1994 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSITF')) RETURN
  IF (ITF<0 .OR. ITF>2) THEN
    PGITF(PGID) = 0
    CALL GRWARN('PGSITF: argument must be 0, 1, or 2')
  ELSE
    PGITF(PGID) = ITF
  END IF
  END

!*PGSLCT -- select an open graphics device
!%void cpgslct(int id);
!+
  SUBROUTINE PGSLCT(ID)
  INTEGER ID
!
! Select one of the open graphics devices and direct subsequent
! plotting to it. The argument is the device identifier returned by
! PGOPEN when the device was opened. If the supplied argument is not a
! valid identifier of an open graphics device, a warning message is
! issued and the current selection is unchanged.
!
! [This routine was added to PGPLOT in Version 5.1.0.]
!
! Arguments:
!
! ID (input, integer): identifier of the device to be selected.
!--
! 22-Dec-1995 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
!
  IF (ID<1 .OR. ID>PGMAXD) THEN
   CALL GRWARN('PGSLCT: invalid argument')
  ELSE IF (PGDEVS(ID)/=1) THEN
   CALL GRWARN('PGSLCT: requested device is not open')
  ELSE
!        -- Select the new device
   PGID = ID
   CALL GRSLCT(PGID)
  END IF
!
  END

!*PGSLS -- set line style
!%void cpgsls(int ls);
!+
  SUBROUTINE PGSLS (LS)
  INTEGER  LS
!
! Set the line style attribute for subsequent plotting. This
! attribute affects line primitives only; it does not affect graph
! markers, text, or area fill.
! Five different line styles are available, with the following codes:
! 1 (full line), 2 (dashed), 3 (dot-dash-dot-dash), 4 (dotted),
! 5 (dash-dot-dot-dot). The default is 1 (normal full line).
!
! Argument:
!  LS     (input)  : the line-style code for subsequent plotting
!                    (in range 1-5).
!--
!  8-Aug-1985 - new routine, equivalent to GRSLS [TJP].
!  3-Jun-1984 - add GMFILE device [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSLS')) RETURN
  CALL GRSLS(LS)
  END

!*PGSLW -- set line width
!%void cpgslw(int lw);
!+
  SUBROUTINE PGSLW (LW)
  INTEGER  LW
!
! Set the line-width attribute. This attribute affects lines, graph
! markers, and text. The line width is specified in units of 1/200
! (0.005) inch (about 0.13 mm) and must be an integer in the range
! 1-201. On some devices, thick lines are generated by tracing each
! line with multiple strokes offset in the direction perpendicular to
! the line.
!
! Argument:
!  LW     (input)  : width of line, in units of 0.005 inch (0.13 mm)
!                    in range 1-201.
!--
!  8-Aug-1985 - new routine, equivalent to GRSLW [TJP].
!  1-Feb-1995 - change comment [TJP].
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSLW')) RETURN
  CALL GRSLW(LW)
  END

!*PGSTBG -- set text background color index
!%void cpgstbg(int tbci);
!+
  SUBROUTINE PGSTBG (TBCI)
  INTEGER  TBCI
!
! Set the Text Background Color Index for subsequent text. By default
! text does not obscure underlying graphics. If the text background
! color index is positive, however, text is opaque: the bounding box
! of the text is filled with the color specified by PGSTBG before
! drawing the text characters in the current color index set by PGSCI.
! Use color index 0 to erase underlying graphics before drawing text.
!
! Argument:
!  TBCI   (input)  : the color index to be used for the background
!                    for subsequent text plotting:
!                      TBCI < 0  => transparent (default)
!                      TBCI >= 0 => text will be drawn on an opaque
!                    background with color index TBCI.
!--
! 16-Oct-1993 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSTBG')) RETURN
  IF (TBCI<0) THEN
    PGTBCI(PGID) = -1
  ELSE
    PGTBCI(PGID) = TBCI
  END IF
  END

!*PGSUBP -- subdivide view surface into panels
!%void cpgsubp(int nxsub, int nysub);
!+
  SUBROUTINE PGSUBP (NXSUB, NYSUB)
  INTEGER NXSUB, NYSUB
!
! PGPLOT divides the physical surface of the plotting device (screen,
! window, or sheet of paper) into NXSUB x NYSUB `panels'. When the
! view surface is sub-divided in this way, PGPAGE moves to the next
! panel, not the next physical page. The initial subdivision of the
! view surface is set in the call to PGBEG. When PGSUBP is called,
! it forces the next call to PGPAGE to start a new physical page,
! subdivided in the manner indicated. No plotting should be done
! between a call of PGSUBP and a call of PGPAGE (or PGENV, which calls
! PGPAGE).
!
! If NXSUB > 0, PGPLOT uses the panels in row order; if <0,
! PGPLOT uses them in column order, e.g.,
!
!  NXSUB=3, NYSUB=2            NXSUB=-3, NYSUB=2
!
! +-----+-----+-----+         +-----+-----+-----+
! |  1  |  2  |  3  |         |  1  |  3  |  5  |
! +-----+-----+-----+         +-----+-----+-----+
! |  4  |  5  |  6  |         |  2  |  4  |  6  |
! +-----+-----+-----+         +-----+-----+-----+
!
! PGPLOT advances from one panels to the next when PGPAGE is called,
! clearing the screen or starting a new page when the last panel has
! been used. It is also possible to jump from one panel to another
! in random order by calling PGPANL.
!
! Arguments:
!  NXSUB  (input)  : the number of subdivisions of the view surface in
!                    X (>0 or <0).
!  NYSUB  (input)  : the number of subdivisions of the view surface in
!                    Y (>0).
!--
! 15-Nov-1993 [TJP] - new routine.
! 19-Feb-1994 [TJP] - rescale viewport when panel size changes.
! 23-Sep-1996 [TJP] - correct bug in assignment of PGROWS.
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  REAL     CH, XFSZ, YFSZ
  LOGICAL  PGNOTO
  REAL     XVP1, XVP2, YVP1, YVP2

!
  IF (PGNOTO('PGSUBP')) RETURN
!
! Find current character size and viewport (NDC).
!
  CALL PGQCH(CH)
  CALL PGQVP(0, XVP1, XVP2, YVP1, YVP2)
!
! Set the subdivisions.
!
  XFSZ = PGNX(PGID)*PGXSZ(PGID)
  YFSZ = PGNY(PGID)*PGYSZ(PGID)
  PGROWS(PGID) = (NXSUB>=0)
  PGNX(PGID) = MAX(ABS(NXSUB),1)
  PGNY(PGID) = MAX(ABS(NYSUB),1)
  PGXSZ(PGID) = XFSZ/PGNX(PGID)
  PGYSZ(PGID) = YFSZ/PGNY(PGID)
!
! The current panel is the last on the physical page, to force
! a new physical page at next PGPAGE.
!
  PGNXC(PGID) = PGNX(PGID)
  PGNYC(PGID) = PGNY(PGID)
!
! Rescale the character size and viewport to the new panel size.
!
  CALL PGSCH(CH)
  CALL PGSVP(XVP1, XVP2, YVP1, YVP2)
!
  END

!*PGSVP -- set viewport (normalized device coordinates)
!%void cpgsvp(float xleft, float xright, float ybot, float ytop);
!+
  SUBROUTINE PGSVP (XLEFT, XRIGHT, YBOT, YTOP)
  REAL XLEFT, XRIGHT, YBOT, YTOP
!
! Change the size and position of the viewport, specifying
! the viewport in normalized device coordinates.  Normalized
! device coordinates run from 0 to 1 in each dimension. The
! viewport is the rectangle on the view surface "through"
! which one views the graph.  All the PG routines which plot lines
! etc. plot them within the viewport, and lines are truncated at
! the edge of the viewport (except for axes, labels etc drawn with
! PGBOX or PGLAB).  The region of world space (the coordinate
! space of the graph) which is visible through the viewport is
! specified by a call to PGSWIN.  It is legal to request a
! viewport larger than the view surface; only the part which
! appears on the view surface will be plotted.
!
! Arguments:
!  XLEFT  (input)  : x-coordinate of left hand edge of viewport, in NDC.
!  XRIGHT (input)  : x-coordinate of right hand edge of viewport,
!                    in NDC.
!  YBOT   (input)  : y-coordinate of bottom edge of viewport, in NDC.
!  YTOP   (input)  : y-coordinate of top  edge of viewport, in NDC.
!--
! 13-Dec-1990  Make errors non-fatal [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  LOGICAL  PGNOTO
  REAL     XS, YS
!
  IF (PGNOTO('PGSVP'))  RETURN
  IF (XLEFT>=XRIGHT .OR. YBOT>=YTOP) THEN
    CALL GRWARN('PGSVP ignored: invalid arguments')
    RETURN
  END IF
!
  XS = PGXSZ(PGID)/PGXPIN(PGID)
  YS = PGYSZ(PGID)/PGYPIN(PGID)
  CALL PGVSIZ(XLEFT*XS, XRIGHT*XS, YBOT*YS, YTOP*YS)
  END

!*PGSWIN -- set window
!%void cpgswin(float x1, float x2, float y1, float y2);
!+
  SUBROUTINE PGSWIN (X1, X2, Y1, Y2)
  REAL X1, X2, Y1, Y2
!
! Change the window in world coordinate space that is to be mapped on
! to the viewport.  Usually PGSWIN is called automatically by PGENV,
! but it may be called directly by the user.
!
! Arguments:
!  X1     (input)  : the x-coordinate of the bottom left corner
!                    of the viewport.
!  X2     (input)  : the x-coordinate of the top right corner
!                    of the viewport (note X2 may be less than X1).
!  Y1     (input)  : the y-coordinate of the bottom left corner
!                    of the viewport.
!  Y2     (input)  : the y-coordinate of the top right corner
!                    of the viewport (note Y2 may be less than Y1).
!--
! 15-Nov-95: check arguments to prevent divide-by-zero [TJP].
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGSWIN')) RETURN
!
! If invalid arguments are specified, issue warning and leave window
! unchanged.
!
  IF (X1==X2) THEN
   CALL GRWARN('invalid x limits in PGSWIN: X1 = X2.')
  ELSE IF (Y1==Y2) THEN
   CALL GRWARN('invalid y limits in PGSWIN: Y1 = Y2.')
  ELSE
   PGXBLC(PGID) = X1
   PGXTRC(PGID) = X2
   PGYBLC(PGID) = Y1
   PGYTRC(PGID) = Y2
   CALL PGVW
  END IF
  END

!*PGTBOX -- draw frame and write (DD) HH MM SS.S labelling
!%void cpgtbox(const char *xopt, float xtick, int nxsub, \
!% const char *yopt, float ytick, int nysub);
!+
  SUBROUTINE PGTBOX (XOPT, XTICK, NXSUB, YOPT, YTICK, NYSUB)
!
  REAL XTICK, YTICK
  INTEGER NXSUB, NYSUB
  CHARACTER XOPT*(*), YOPT*(*)
!
! Draw a box and optionally label one or both axes with (DD) HH MM SS
! style numeric labels (useful for time or RA - DEC plots).   If this
! style of labelling is desired, then PGSWIN should have been called
! previously with the extrema in SECONDS of time.
!
! In the seconds field, you can have at most 3 places after the decimal
! point, so that 1 ms is the smallest time interval you can time label.
!
! Large numbers are coped with by fields of 6 characters long.  Thus
! you could have times with days or hours as big as 999999.  However,
! in practice, you might have trouble with labels overwriting  themselves
! with such large numbers unless you a) use a small time INTERVAL,
! b) use a small character size or c) choose your own sparse ticks in
! the call to PGTBOX.
!
! PGTBOX will attempt, when choosing its own ticks, not to overwrite
! the labels, but this algorithm is not very bright and may fail.
!
! Note that small intervals but large absolute times such as
! TMIN = 200000.0 s and TMAX=200000.1 s will cause the algorithm
! to fail.  This is inherent in PGPLOT's use of single precision
! and cannot be avoided.  In such cases, you should use relative
! times if possible.
!
! PGTBOX's labelling philosophy is that the left-most or bottom tick of
! the axis contains a full label.  Thereafter, only changing fields are
! labelled.  Negative fields are given a '-' label, positive fields
! have none.   Axes that have the DD (or HH if the day field is not
! used) field on each major tick carry the sign on each field.  If the
! axis crosses zero, the zero tick will carry a full label and sign.
!
! This labelling style can cause a little confusion with some special
! cases, but as long as you know its philosophy, the truth can be divined.
! Consider an axis with TMIN=20s, TMAX=-20s.   The labels will look like
!
!        +----------+----------+----------+----------+
!     0h0m20s      10s      -0h0m0s      10s        20s
!
! Knowing that the left field always has a full label and that
! positive fields are unsigned, informs that time is decreasing
! from left to right, not vice versa.   This can become very
! unclear if you have used the 'F' option, but that is your problem !
!
! Exceptions to this labelling philosophy are when the finest time
! increment being displayed is hours (with option 'Y') or days.
! Then all fields carry a label.  For example,
!
!        +----------+----------+----------+----------+
!      -10h        -8h        -6h        -4h        -2h
!
!
! PGTBOX can be used in place of PGBOX; it calls PGBOX and only invokes
! time labelling if requested. Other options are passed intact to PGBOX.
!
! Inputs:
!  XOPT   :  X-options for PGTBOX.  Same as for PGBOX plus
!
!             'Z' for (DD) HH MM SS.S time labelling
!             'Y' means don't include the day field so that labels
!                 are HH MM SS.S rather than DD HH MM SS.S   The hours
!                 will accumulate beyond 24 if necessary in this case.
!             'X' label the HH field as modulo 24.  Thus, a label
!                 such as 25h 10m would come out as 1h 10m
!             'H' means superscript numbers with d, h, m, & s  symbols
!             'D' means superscript numbers with    o, ', & '' symbols
!             'F' causes the first label (left- or bottom-most) to
!                 be omitted. Useful for sub-panels that abut each other.
!                 Care is needed because first label carries sign as well.
!             'O' means omit leading zeros in numbers < 10
!                 E.g.  3h 3m 1.2s rather than 03h 03m 01.2s  Useful
!                 to help save space on X-axes. The day field does not
!                 use this facility.
!
!  YOPT   :  Y-options for PGTBOX.  See above.
!  XTICK  :  X-axis major tick increment.  0.0 for default.
!  YTICK  :  Y-axis major tick increment.  0.0 for default.
!            If the 'Z' option is used then XTICK and/or YTICK must
!            be in seconds.
!  NXSUB  :  Number of intervals for minor ticks on X-axis. 0 for default
!  NYSUB  :  Number of intervals for minor ticks on Y-axis. 0 for default
!
!  The regular XOPT and YOPT axis options for PGBOX are
!
!  A : draw Axis (X axis is horizontal line Y=0, Y axis is vertical
!      line X=0).
!  B : draw bottom (X) or left (Y) edge of frame.
!  C : draw top (X) or right (Y) edge of frame.
!  G : draw Grid of vertical (X) or horizontal (Y) lines.
!  I : Invert the tick marks; ie draw them outside the viewport
!      instead of inside.
!  L : label axis Logarithmically (see below).
!  N : write Numeric labels in the conventional location below the
!      viewport (X) or to the left of the viewport (Y).
!  P : extend ("Project") major tick marks outside the box (ignored if
!      option I is specified).
!  M : write numeric labels in the unconventional location above the
!      viewport (X) or to the right of the viewport (Y).
!  T : draw major Tick marks at the major coordinate interval.
!  S : draw minor tick marks (Subticks).
!  V : orient numeric labels Vertically. This is only applicable to Y.
!      The default is to write Y-labels parallel to the axis.
!  1 : force decimal labelling, instead of automatic choice (see PGNUMB).
!  2 : force exponential labelling, instead of automatic.
!
!      The default is to write Y-labels parallel to the axis
!
!
!        ******************        EXCEPTIONS       *******************
!
!        Note that
!          1) PGBOX option 'L' (log labels) is ignored with option 'Z'
!          2) The 'O' option will be ignored for the 'V' option as it
!             makes it impossible to align the labels nicely
!          3) Option 'Y' is forced with option 'D'
!
!        ***************************************************************
!
!
!--
! 05-Sep-1988 - new routine (Neil Killeen)
! 20-Apr-1991 - add support for new DD (day) field and implement
!               labelling on any axis (bottom,top,left,right) [nebk]
! 10-Jun-1993 - add option 'O' for leading zeros, correctly deal with
!               user ticks, fully support 'V' and 'NM' options, modify
!               slightly meaning of 'F' option [nebk]
! 16-Jan-1995 - add option 'X' [nebk]
! 16-Aug-1996 - Bring axis labelling displacements more in line with
!               those of pgbox.f [nebk]
!-----------------------------------------------------------------------
  REAL XTICKD, YTICKD, XMIN, XMAX, YMIN, YMAX
  INTEGER IPT, TSCALX, TSCALY, NXSUBD, NYSUBD
  CHARACTER XXOPT*15, YYOPT*15, SUPTYP*4
  LOGICAL XTIME, YTIME, FIRST, DODAYX, DODAYY, DO2, DOPARA, MOD24
!------------------------------------------------------------------------
!
!  Copy inputs
!
  XTICKD = XTICK
  YTICKD = YTICK
  NXSUBD = NXSUB
  NYSUBD = NYSUB
!
!  Get window in world coordinates
!
  CALL PGQWIN (XMIN, XMAX, YMIN, YMAX)
!
!  X-axis first
!
  CALL GRTOUP (XXOPT, XOPT)
  XTIME = .FALSE.
  IF (INDEX(XXOPT,'Z')/=0) THEN
!
!  Work out units for labelling and find the tick increments.
!
  IF (ABS(XMAX-XMIN)<0.001) THEN
    CALL GRWARN ('PGTBOX: X-axis time interval too small '// &
                   '(< 1 ms) for time labels')
  ELSE
    XTIME = .TRUE.
    DODAYX = .TRUE.
    IF (INDEX(XXOPT,'Y')/=0 .OR. INDEX(XXOPT,'D')/=0) &
          DODAYX = .FALSE.
!
    DOPARA = .TRUE.
    CALL PGTBX1 ('X', DODAYX, DOPARA, XMIN, XMAX, XTICKD, &
                   NXSUBD, TSCALX)
  END IF
  END IF
!
!  Same again for Y-axis
!
  CALL GRTOUP (YYOPT, YOPT)
  YTIME = .FALSE.
  IF (INDEX(YYOPT,'Z')/=0) THEN
  IF (ABS(YMAX-YMIN)<0.001) THEN
    CALL GRWARN ('PGTBOX: Y-axis time interval too small '// &
                   '(< 1ms) for time labels')
  ELSE
    YTIME = .TRUE.
    DODAYY = .TRUE.
    IF (INDEX(YYOPT,'Y')/=0 .OR. INDEX(YYOPT,'D')/=0) &
          DODAYY = .FALSE.
!
    DOPARA = .TRUE.
    IF (INDEX(YYOPT,'V')/=0) DOPARA = .FALSE.
!
    CALL PGTBX1 ('Y', DODAYY, DOPARA, YMIN, YMAX, YTICKD, &
                   NYSUBD, TSCALY)
  END IF
  END IF
!
!  Parse options list.  For call to PGBOX when doing time labelling, we
!  don't want L (log), N or M (write numeric labels).
!
  IF (XTIME) THEN
  IPT = INDEX(XXOPT,'L')
  IF (IPT/=0) XXOPT(IPT:IPT) = ' '
  IPT = INDEX(XXOPT,'N')
  IF (IPT/=0) XXOPT(IPT:IPT) = ' '
  IPT = INDEX(XXOPT,'M')
  IF (IPT/=0) XXOPT(IPT:IPT) = ' '
  END IF
!
  IF (YTIME) THEN
  IPT = INDEX(YYOPT,'L')
  IF (IPT/=0) YYOPT(IPT:IPT) = ' '
  IPT = INDEX(YYOPT,'N')
  IF (IPT/=0) YYOPT(IPT:IPT) = ' '
  IPT = INDEX(YYOPT,'M')
  IF (IPT/=0) YYOPT(IPT:IPT) = ' '
  END IF
!
!  Draw box and ticks
!
  CALL PGBOX (XXOPT, XTICKD, NXSUBD, YYOPT, YTICKD, NYSUBD)
!
!  Add (DD) HH MM SS labels if desired.  Go back to the original user
!  specified options list.
!
  XXOPT = ' '
  CALL GRTOUP (XXOPT, XOPT)
  IF (XTIME .AND. (INDEX(XXOPT,'N')/=0 .OR. &
                   INDEX(XXOPT,'M')/=0)) THEN
  FIRST = .TRUE.
  IF (INDEX(XXOPT,'F')/=0) FIRST = .FALSE.
!
  SUPTYP = 'NONE'
  IF (INDEX(XXOPT,'D')/=0) SUPTYP = ' DMS'
  IF (INDEX(XXOPT,'H')/=0) SUPTYP = 'DHMS'
!
  DO2 = .TRUE.
  IF (INDEX(XXOPT,'O')/=0) DO2 = .FALSE.
!
  DOPARA = .TRUE.
!
  MOD24 = .FALSE.
  IF (INDEX(XXOPT,'X')/=0) MOD24 = .TRUE.
!
  IF (INDEX(XXOPT,'N')/=0) &
      CALL PGTBX4 (DODAYX, SUPTYP, 'X', .TRUE., FIRST, &
        XMIN, XMAX, TSCALX, XTICKD, DO2, DOPARA, MOD24)
!
  IF (INDEX(XXOPT,'M')/=0) &
      CALL PGTBX4 (DODAYX, SUPTYP, 'X', .FALSE., FIRST, &
         XMIN, XMAX, TSCALX, XTICKD, DO2, DOPARA, MOD24)
  END IF
!
  YYOPT = ' '
  CALL GRTOUP (YYOPT, YOPT)
  IF (YTIME .AND. (INDEX(YYOPT,'N')/=0 .OR. &
                   INDEX(YYOPT,'M')/=0)) THEN
  FIRST = .TRUE.
  IF (INDEX(YYOPT,'F')/=0) FIRST = .FALSE.
!
  SUPTYP = 'NONE'
  IF (INDEX(YYOPT,'D')/=0) SUPTYP = ' DMS'
  IF (INDEX(YYOPT,'H')/=0) SUPTYP = 'DHMS'
!
  DOPARA = .TRUE.
  IF (INDEX(YYOPT,'V')/=0) DOPARA = .FALSE.
!
  DO2 = .TRUE.
  IF (DOPARA .AND. INDEX(YYOPT,'O')/=0) DO2 = .FALSE.
!
  MOD24 = .FALSE.
  IF (INDEX(YYOPT,'X')/=0) MOD24 = .TRUE.
!
  IF (INDEX(YYOPT,'N')/=0) &
      CALL PGTBX4 (DODAYY, SUPTYP, 'Y', .TRUE., FIRST, &
         YMIN, YMAX, TSCALY, YTICKD, DO2, DOPARA, MOD24)
!
  IF (INDEX(YYOPT,'M')/=0) &
      CALL PGTBX4 (DODAYY, SUPTYP, 'Y', .FALSE., FIRST, &
         YMIN, YMAX, TSCALY, YTICKD, DO2, DOPARA, MOD24)
!
  END IF
!
  RETURN
  END
! PGTBX1 -- support routine for PGTBOX
!
  SUBROUTINE PGTBX1 (AXIS, DODAY, DOPARA, TMIN, TMAX, TICK, &
                     NSUB, TSCALE)
!
  REAL TMIN, TMAX, TICK
  INTEGER NSUB, TSCALE
  LOGICAL DODAY, DOPARA
  CHARACTER AXIS*1
!
! Work out what the finest units the time labels will be in and
! return the tick increments if the user does not set them.
!
! This is a support routine for PGTBOX and should not
! be called by the user.
!
! Input:
!  AXIS   :  'X' or 'Y' for use in determining if labels overwrite
!  TMIN   :  Start time in seconds
!  TMAX   :  End   time in seconds
!  DOPARA :  True if label to be parallel to axis, else perpendicular
! Input/output:
!  DODAY  :  Write labels as DD HH MM SS.S else HH MM SS.S with
!            hours ranging above 24.  Useful for declination labels
!  TICK   :  Major tick interval in seconds.  If 0.0 on input, will
!            be set here.
!  NSUB   :  Number of minor ticks between major ticks. If 0 on input
!            will be set here.
! Outputs:
!  TSCALE :  Determines finest unit of labelling
!            (1 => ss, 60 => mm, 3600 => hh, 3600*24 => dd)
!
! 05-Sep-1988 - new routine (Neil Killeen)
! 08-Apr-1991 - correctly work out HH MM SS when the time > 60 h [nebk]
! 20-Apr-1991 - revise to add support for new DD (day) field and
!               do lots of work on tick algorithm [nebk]
! 10-Jun-1993 - deal with user given ticks & rename from PGTIME [nebk/jm]
!-----------------------------------------------------------------------
  INTEGER NLIST1, NLIST2, NLIST3, NLIST4, NTICMX
  PARAMETER (NLIST1 = 19, NLIST2 = 10, NLIST3 = 6, NLIST4 = 8, &
             NTICMX = 8)
!
  REAL TICKS1(NLIST1), TICKS2(NLIST2), TICKS3(NLIST3), &
  TICKS4(NLIST4), TOCK, TOCK2, TINT, TINTS, TMINS, TMAXS
  INTEGER NSUBS1(NLIST1), NSUBS2(NLIST2), NSUBS3(NLIST3), &
  NSUBS4(NLIST4), NPL, NTICK, ITICK, STRLEN
  CHARACTER STR*15
!
  SAVE TICKS1, TICKS2, TICKS3, TICKS4
  SAVE NSUBS1, NSUBS2, NSUBS3, NSUBS4
!
  DATA TICKS1 /0.001,  0.002,                 0.005, &
               0.01,   0.02,                  0.05, &
               0.1,    0.2,                   0.5, &
               1.0,    2.0,   3.0,    4.0,    5.0, &
               6.0,   10.0,  15.0,   20.0,   30.0/
  DATA NSUBS1 / 4,      4,                     2, &
                4,      4,                     2, &
                4,      4,                     2, &
                4,      4,     3,      4,      5, &
                3,      2,     3,      2,      3/
!
  DATA TICKS2 /1.0,    2.0,   3.0,    4.0,    5.0, &
               6.0,   10.0,  15.0,   20.0,   30.0/
  DATA NSUBS2 / 4,      4,     3,      4,      5, &
                3,      2,     3,      2,      3/
!
  DATA TICKS3 /1.0,    2.0,   3.0,    4.0,    6.0,   12.0/
  DATA NSUBS3 / 4,      4,     3,      4,      3,      2/
!
  DATA TICKS4 /1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 8.0, 9.0/
  DATA NSUBS4 / 4,   4,   3,   4,   5,   3,   4,   3 /
!----------------------------------------------------------------------
!
!  Turn off DD (day) field if it has been unnecessarily asked for
!
  IF ((ABS(TMIN)<24.0*3600.0) .AND. (ABS(TMAX)<24.0*3600.0)) &
     DODAY = .FALSE.
!
!  If a tick size is provided, use it to determine TSCALE
!
  TINT = ABS(TMAX - TMIN)
  TICK = ABS(TICK)
  IF (TICK/=0.0) THEN
  IF (TICK>=TINT) THEN
    CALL GRWARN ('PGTBX1: user given tick bigger than time ' &
                   //'interval; will auto-tick')
    TICK = 0.0
  ELSE IF (TICK<0.001) THEN
    CALL GRWARN ('PGTBX1: user given tick too small (< 1 ms); ' &
                   //'will auto-tick')
    TICK = 0.0
  ELSE
    IF (MOD(TICK, 60.0) /= 0.0) THEN
      TSCALE = 1
    ELSE IF (MOD(TICK, 3600.0)/=0.0) THEN
      TSCALE = 60
    ELSE IF (.NOT.DODAY) THEN
      TSCALE = 3600
    ELSE IF (MOD(TICK,(24.0*3600.0))/=0.0) THEN
      TSCALE = 3600
    ELSE
      TSCALE = 24 * 3600
    ENDIF
!
!  Make a simple default for the number of minor ticks and bug out
!
    IF (NSUB==0) NSUB = 2
    RETURN
  END IF
  END IF
!
!  Work out label units depending on time interval if user
!  wants auto-ticking
!
  IF (TINT<=5*60) THEN
  TSCALE = 1
  ELSE IF (TINT<=5*3600) THEN
  TSCALE = 60
  ELSE
  IF (.NOT.DODAY) THEN
    TSCALE = 3600
  ELSE
    IF (TINT<=5*24*3600) THEN
      TSCALE = 3600
    ELSE
      TSCALE = 3600*24
    END IF
  END IF
  END IF
!
!CCCC
!  Divide interval into NTICK major ticks and NSUB minor intervals
!  The tick choosing algorithm is not very robust, so watch out
!  if you fiddle anything.
!CCCC
!
  TINTS = TINT / TSCALE
  IF (TSCALE==1) THEN
!
!  Time in seconds.  If the time interval is very small, may need to
!  label with up to 3 decimal places.  Have less ticks to help prevent
!  label overwrite. STR is a dummy tick label to assess label
!  overwrite potential
!
  IF (DOPARA) THEN
    IF (TINTS<=0.01) THEN
      NTICK = 4
      STR = '60.423'
      STRLEN = 6
    ELSE IF (TINTS<=0.1) THEN
      NTICK = 5
      STR = '60.42'
      STRLEN = 5
    ELSE IF (TINTS<=1.0) THEN
      NTICK = 6
      STR = '60.4'
      STRLEN = 4
    ELSE
      NTICK = 6
      STR = '60s'
      STRLEN = 3
    END IF
  ELSE
    NTICK = 6
    STR = ' '
    STRLEN = 1
  END IF
  TOCK = TINTS / NTICK
!
!  Select nearest tick to TOCK from list.
!
  CALL PGTBX2 (TOCK, NLIST1, TICKS1, NSUBS1, TICK, NSUB, ITICK)
!
!  Check label overwrite and/or too many ticks.
!
  CALL PGTBX3 (DODAY, 0, TSCALE, TINTS, NTICMX, NLIST1, TICKS1, &
                 NSUBS1, ITICK, AXIS, DOPARA, STR(1:STRLEN), &
                 TICK, NSUB)
  ELSE IF (TSCALE==60) THEN
!
!  Time in minutes
!
  NTICK = 6
  TOCK = TINTS / NTICK
!
!  Select nearest tick from list
!
  CALL PGTBX2 (TOCK, NLIST2, TICKS2, NSUBS2, TICK, NSUB, ITICK)
!
!  Check label overwrite and/or too many ticks.
!
  IF (DOPARA) THEN
    STR = '42m'
    STRLEN = 3
  ELSE
    STR = ' '
    STRLEN = 1
  END IF
  CALL PGTBX3 (DODAY, 0, TSCALE, TINTS, NTICMX, NLIST2, TICKS2, &
                 NSUBS2, ITICK, AXIS, DOPARA, STR(1:STRLEN), &
                 TICK, NSUB)
  ELSE
  IF (TSCALE==3600 .AND. DODAY) THEN
!
!  Time in hours with the day field
!
    NTICK = 6
    TOCK = TINTS / NTICK
!
!  Select nearest tick from list
!
    CALL PGTBX2 (TOCK, NLIST3, TICKS3, NSUBS3, TICK, NSUB, ITICK)
!
!   Check label overwrite and/or too many ticks.
!
    IF (DOPARA) THEN
      STR = '42h'
      STRLEN = 3
    ELSE
      STR = ' '
      STRLEN = 1
    END IF
    CALL PGTBX3 (DODAY, 0, TSCALE, TINTS, NTICMX, NLIST3, TICKS3, &
                   NSUBS3, ITICK, AXIS, DOPARA, STR(1:STRLEN), &
                   TICK, NSUB)
  ELSE
!
!  Time in hours with no day field or time in days. Have less
!  ticks for big numbers or the parallel labels will overwrite.

    IF (DOPARA) THEN
      TMINS = ABS(TMIN) / TSCALE
      TMAXS = ABS(TMAX) / TSCALE
      CALL PGNPL (-1, NINT(MAX(TINTS,TMINS,TMAXS)), NPL)
      IF (NPL<=3) THEN
        NTICK = 6
      ELSE IF (NPL==4) THEN
        NTICK = 5
      ELSE
        NTICK = 4
      END IF
      STR = '345678912'
      STR(NPL+1:) = 'd'
      STRLEN = NPL + 1
    ELSE
      STR = ' '
      STRLEN = 1
      NTICK = 6
    END IF
    TOCK = TINTS / NTICK
!
!   Select nearest tick from list; 1 choose nearest nice integer
!   scaled by the appropriate power of 10
!
    CALL PGNPL (-1, NINT(TOCK), NPL)
    TOCK2 = TOCK / 10**(NPL-1)
!
    CALL PGTBX2 (TOCK2, NLIST4, TICKS4, NSUBS4, TICK, NSUB, ITICK)
    TICK = TICK * 10**(NPL-1)
!
!  Check label overwrite and/or too many ticks.
!
    CALL PGTBX3 (DODAY, NPL, TSCALE, TINTS, NTICMX, NLIST4, &
                   TICKS4, NSUBS4, ITICK, AXIS, DOPARA, &
                   STR(1:STRLEN), TICK, NSUB)
  END IF
  END IF
!
!  Convert tick to seconds
!
  TICK = TICK * TSCALE
!
  RETURN
  END
! PGTBX2 -- support routine for PGTBOX
!
  SUBROUTINE PGTBX2 (TOCK, NTICKS, TICKS, NSUBS, TICK, NSUB, ITICK)
!
  INTEGER NTICKS, NSUBS(NTICKS), NSUB, ITICK
  REAL TOCK, TICKS(NTICKS), TICK
!
! Find the nearest tick in a list to a given value.
!
! This is a support routine for PGTBOX and should not be called
! by the user.
!
! Input:
!  TOCK   :  Try to find the nearest tick in the list to TOCK
!  NTICKS :  Number of ticks in list
!  TICKS  :  List of ticks
!  NSUBS  :  List of number of minor ticks between ticks to go with TICKS
! Output:
!  TICK   :  The selected tick
!  ITICK  :  The index of the selected tick from the list TICKS
! Input/output
!  NSUB   :  Number of minor ticks between major ticks. If 0 on input
!            will be set here.
!
! 10-Jun-1993 - new routine [nebk]
!-----------------------------------------------------------------------
  INTEGER I, NSUBD
  REAL DMIN, DIFF
!----------------------------------------------------------------------
  NSUBD = NSUB
  DMIN = 1.0E30
  DO 100 I = 1, NTICKS
  DIFF = ABS(TOCK - TICKS(I))
  IF (DIFF<DMIN) THEN
    TICK = TICKS(I)
    IF (NSUBD==0) NSUB = NSUBS(I)
    ITICK = I
!
    DMIN = DIFF
  END IF
 100  CONTINUE
!
  RETURN
  END
! PGTBX3 -- support routine for PGTBOX
!
  SUBROUTINE PGTBX3 (DODAY, NPL, TSCALE, TINTS, NTICMX, NTICKS, &
                     TICKS, NSUBS, ITICK, AXIS, DOPARA, STR, &
                     TICK, NSUB)
!
  INTEGER TSCALE, NTICMX, NTICKS, ITICK, NSUB, NSUBS(NTICKS), NPL
  REAL TINTS, TICKS(NTICKS), TICK
  CHARACTER AXIS*1, STR*(*)
  LOGICAL DODAY, DOPARA
!
! Try to see if label overwrite is going to occur with this tick
! selection, or if there are going to be more than a reasonable
! number of ticks in the displayed time range.  If so, choose,
! if available, the next tick (bigger separation) up in the list.
! If the overwrite requires that we would need to go up to the bext
! TSCALE, give up.  They will need to choose a smaller character size
!
! This is a support routine for PGTBOX and should not
! be called by the user.
!
! Input:
!  DODAY  :  True if day field being used
!  NPL    :  Number of characters needed to format TICK on input
!  TSCALE :  Dictates what the finest units of the labelling are.
!            1 = sec, 60 = min, 3600 = hr, 24*3600 = days
!  TINTS  :  Absolute time interval in units of TSCALE
!  NTICMX :  Max. reasonable number of ticks to allow in the time range
!  NTICKS :  Number of ticks in list of ticks to choose from
!  TICKS  :  List of ticks from which the current tick was chosen
!  NSUBS  :  List of number of minor ticks/major tick to choose NSUB from
!  ITICK  :  Index of chosen tick in list TICKS
!  AXIS   :  'X' or 'Y' axis
!  DOPARA :  Labels parallel or perpendicualr to axis
!  STR    :  A typical formatted string used for checking overwrite
! Input/output:
!  TICK   :  Current major tick interval in units of TSCALE. May be
!            made larger if possible if overwrite likely.
!  NSUB   :  Number of minor ticks between major ticks.
!
! 10-Jun-1993 - new routine [nebk]
!-----------------------------------------------------------------------
  INTEGER NTICK
  REAL LENS, LENX, LENY
!----------------------------------------------------------------------
  CALL PGLEN (4, STR, LENX, LENY)
  LENS = LENX
  IF ( (DOPARA .AND. AXIS=='Y') .OR. &
       (.NOT.DOPARA .AND. AXIS=='X') ) LENS = LENY
!
  IF (TSCALE==1 .OR. TSCALE==60 .OR. &
      (TSCALE==3600 .AND. DODAY)) THEN
!
!  Time in seconds or minutes, or in hours with a day field
!
  NTICK = INT(TINTS / TICK)
  IF ( (ITICK<NTICKS)  .AND. &
         ((DOPARA .AND. (LENS/TSCALE)>0.9*TICK) .OR. &
         (NTICK>NTICMX)) ) THEN
    IF (TICKS(ITICK+1)<TINTS) THEN
      NSUB = NSUBS(ITICK+1)
      TICK = TICKS(ITICK+1)
    END IF
  END IF
  ELSE
!
!  Time in hours and no day field or time in days
!
  NTICK = INT(TINTS / TICK)
  IF ( (DOPARA .AND. (LENS/TSCALE)>0.9*TICK) .OR. &
         (NTICK>NTICMX) ) THEN
    IF (ITICK<NTICKS) THEN
      IF (TICKS(ITICK+1)*10**(NPL-1)<TINTS) THEN
        NSUB = NSUBS(ITICK+1)
        TICK = TICKS(ITICK+1) * 10**(NPL-1)
      END IF
    ELSE
      IF (TICKS(1)*10**NPL<TINTS) THEN
        NSUB = NSUBS(1)
        TICK = TICKS(1) * 10**NPL
      END IF
    END IF
  END IF
  END IF
!
  RETURN
  END
! PGTBX4 -- support routine for PGTBOX
!
  SUBROUTINE PGTBX4 (DODAY, SUPTYP, AXIS, CONVTL, FIRST, TMIN, &
                     TMAX, TSCALE, TICK, DO2, DOPARA, MOD24)
!
  REAL TMIN, TMAX, TICK
  INTEGER TSCALE
  CHARACTER AXIS*(*), SUPTYP*(*)
  LOGICAL FIRST, DODAY, CONVTL, DO2, DOPARA, MOD24
!
! Label an axis in (DD) HH MM SS.S style.    This is the main
! workhorse of the PGTBOX routines.
!
! This is a support subroutine for PGTBOX and should not be
! called by the user.
!
! Inputs:
!  DODAY  :  Write labels as DD HH MM SS.S else HH MM SS.S with
!            hours ranging above 24.  Useful for declination labels
!  SUPTYP :  If 'DHMS' then superscript the fields with d, h, m, & s
!            If ' DMS' then superscript the fields with    o, '  & ''
!              Good for declination plots.  You should obviously not
!              ask for the day field for this to do anything sensible.
!            If '    ' then no superscripting is done.
!  AXIS   :  'X' for x-axis, 'Y' for y-axis
!  CONVTL :  If .true., write the labels in the conventional axis
!            locations (bottom and left for 'X' and 'Y').  Otherwise
!            write them on the top and right axes ('X' and 'Y')
!  FIRST  :  If .false. then omit the first label.
!  TMIN   :  Start time (seconds)
!  TMAX   :  End time (seconds)
!  TSCALE :  Determines finest units of axis
!              1 => ss, 60 => mm, 3600 => hh, 3600*24 => dd
!  TICK   :  Major tick interval in seconds
!  DO2    :  If .true., write labels less than 10 with a leading zero.
!  DOPARA :  Y axis label parallel to axis, else perpendicular
!  MOD24  :  HH field labelled as modulo 24
!
! 05-Sep-1988 - new routine (Neil Killeen)
! 20-Apr-1991 - add support for new DD (day) field [nebk]
! 10-Jun-1993 - complete rewrite & rename from PGTLAB. Fixes user given
!               ticks bug too [nebk]
! 15-Jan-1995 - Add argument MOD24
!-----------------------------------------------------------------------
  INTEGER MAXTIK
  LOGICAL T, F
  PARAMETER (MAXTIK = 1000, T = .TRUE., F = .FALSE.)
!
  REAL SS(MAXTIK), TFRAC(MAXTIK)
  INTEGER DD(MAXTIK), HH(MAXTIK), MM(MAXTIK)
  CHARACTER*1 ASIGN(MAXTIK), ASIGNL
!
  REAL TIME, XLEN, YLEN, COORD, FJUST, RVAL, SSL, DISP, &
  XLEN2, YLEN2
  INTEGER IS, SD, NT, IZERO, IPOS, INEG, IT, I, J, K, SPREC, &
  JST(2), JEND(2), TLEN, LAST, IVAL(3), IVALO(3), IVALZ(3), &
  IVALF(3), IVALL(3), NPASS, INC, DDL, HHL, MML
  CHARACTER SIGNF*1, TEXT*80, AXLOC*2
  LOGICAL WRIT(4)
!-----------------------------------------------------------------------
  CALL PGBBUF
!
!  Direction signs
!
  SD = 1
  IF (TMAX<TMIN) SD = -1
  IS = 1
  IF (TMIN<0.0) IS = -1
!
!  Find first tick.  Return if none.
!
  NT = TMIN / TICK
  IF (IS*SD==1 .AND. ABS(TMIN)>ABS(NT)*TICK) NT = NT + SD
  TIME = NT * TICK
  IF ( (SD== 1.AND.(TIME<TMIN.OR.TIME>TMAX)) .OR. &
       (SD==-1.AND.(TIME>TMIN.OR.TIME<TMAX)) ) RETURN
!
!  Now step through time range in TICK increments and convert
!  times in seconds at each tick to  +/- (DD) HH MM SS.S
!
  IZERO = 0
  IT = 1
 100  IF ( (SD==1  .AND. TIME>(TMAX+1.0E-5)) .OR. &
       (SD==-1 .AND. TIME<(TMAX-1.0E-5)) ) GOTO 200
  IF (IT>MAXTIK) THEN
    CALL GRWARN ('PGTBX4: storage exhausted -- you have' &
                   //'asked for far too many ticks')
    GOTO 200
  END IF
!
!  Convert to (DD) HH MM SS.S and find fraction of window that this
!  tick falls at
!
  CALL PGTBX5 (DODAY, TIME, ASIGN(IT), DD(IT), HH(IT), &
                 MM(IT), SS(IT))
  TFRAC(IT) = (TIME - TMIN) / (TMAX - TMIN)
!
!  Note zero tick
!
  IF (NT==0) IZERO = IT
!
!  Increment time
!
  NT = NT + SD
  TIME = NT * TICK
  IT = IT + 1
!
  GOTO 100
 200  CONTINUE
  IT = IT - 1
!
!   Work out the precision with which to write fractional seconds
!   labels into the SS.S field.   All other fields have integer labels.
!
  SPREC = 0
  IF (TSCALE==1) THEN
  IF (TICK<0.01) THEN
    SPREC = 3
  ELSE IF (TICK<0.1) THEN
    SPREC = 2
  ELSE IF (TICK<1.0) THEN
    SPREC = 1
  END IF
  END IF
!
!  Label special case of first tick.  Prepare fields and label
!
  CALL PGTBX6 (DODAY, MOD24, TSCALE, DD(1), HH(1), MM(1), &
               SS(1), IVALF, RVAL, WRIT)
  SIGNF = 'H'
  IF (DODAY) SIGNF = 'D'
  CALL PGTBX7 (SUPTYP, SIGNF, ASIGN(1), IVALF, RVAL, WRIT, &
               SPREC, DO2, TEXT, TLEN, LAST)
!
!   Set label displacements from axes.  This is messy for labels oriented
!   perpendicularly on the right hand axis as we need to know how long
!   the longest string we are going to write is before we write any
!   labels as they are right justified.
!
  IF (AXIS=='X') THEN
  IF (CONVTL) THEN
    AXLOC = 'B'
    IF (SUPTYP/='NONE') THEN
      DISP = 1.4
    ELSE
      DISP = 1.2
    END IF
  ELSE
    AXLOC = 'T'
    DISP = 0.7
  END IF
  ELSE IF (AXIS=='Y') THEN
  IF (CONVTL) THEN
    AXLOC = 'LV'
    IF (DOPARA) AXLOC = 'L'
    DISP = 0.7
  ELSE
    IF (DOPARA) THEN
      AXLOC = 'R'
      IF (SUPTYP/='NONE') THEN
        DISP = 1.7
      ELSE
        DISP = 1.9
      END IF
    ELSE
!
!  Work out number of characters in first label
!
      AXLOC = 'RV'
      IF (ASIGN(1)/='-' .AND. TMIN*TMAX<0.0) THEN
        CALL PGLEN (2, ' -'//TEXT(1:TLEN), XLEN, YLEN)
      ELSE
        CALL PGLEN (2, ' '//TEXT(1:TLEN), XLEN, YLEN)
      END IF
      CALL PGQCS (2, XLEN2, YLEN2)
      DISP = (XLEN/XLEN2)
    END IF
  END IF
  END IF
!
!  Now write the label to the plot.  The X-axis label for the first tick is
!  centred such that the last field of the label is centred on the tick
!
  IF (FIRST) THEN
  CALL PGLEN (5, TEXT(LAST:TLEN), XLEN, YLEN)
!
  IF (AXIS=='X') THEN
    COORD = TFRAC(1) + XLEN / 2.0
    FJUST = 1.0
  ELSE IF (AXIS=='Y') THEN
    IF (DOPARA) THEN
      COORD = TFRAC(1) + YLEN / 2.0
      FJUST = 1.0
    ELSE
      FJUST = 1.0
      COORD = TFRAC(1)
    END IF
  END IF
  CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN))
  END IF
  IF (IT==1) RETURN
!
!   Designate which field out of DD or HH will carry the sign, depending
!   on whether you want the day field or not for the rest of the ticks
!
  SIGNF = 'H'
  IF (DODAY) SIGNF = 'D'
!
!  Set up labelling justifications for the rest of the labels
!
  IF (AXIS=='X') THEN
  FJUST = 0.5
  ELSE IF (AXIS=='Y') THEN
  IF (DOPARA) THEN
    FJUST = 0.5
  ELSE
    FJUST = 1.0
  END IF
  END IF
!
!  Note zero crossings; IPOS is the first positive tick and
!  INEG is the first negative tick on either side of 0
!
  IPOS = 0
  INEG = 0
!
  IF (IZERO/=0) THEN
  J = IZERO - 1
  IF (J>=1) THEN
    IF (ASIGN(J)=='-') THEN
      INEG = J
    ELSE IF (ASIGN(J)==' ') THEN
      IPOS = J
    END IF
  END IF
  J = IZERO + 1
  IF (J<=IT) THEN
    IF (ASIGN(J)=='-') THEN
      INEG = J
    ELSE IF (ASIGN(J)==' ') THEN
      IPOS = J
    END IF
  END IF
  END IF
!
!  Now label special case of zero tick. It carries the sign change
!  when going from positive to negative time, left to right.
!
  IF (IZERO/=0 .AND. IZERO/=1) THEN
  CALL PGTBX6 (DODAY, MOD24, TSCALE, DD(IZERO), HH(IZERO), &
                 MM(IZERO), SS(IZERO), IVALZ, RVAL, WRIT)
!
  IF (ASIGN(IZERO-1)==' ') ASIGN(IZERO) = '-'
  CALL PGTBX7 (SUPTYP, SIGNF, ASIGN(IZERO), IVALZ, RVAL, WRIT, &
                 SPREC, DO2, TEXT, TLEN, LAST)
!
  COORD = TFRAC(IZERO)
  CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN))
  END IF
!
!   We may need an extra "virtual" tick if there is no zero crossing
!   and SD=-1 & IS=1 or SD=1 & IS=-1.  It is used to work out which
!   fields to label on the right most tick which is labelled first.
!
  IF (IZERO==0) THEN
  IF (SD*IS==-1) THEN
    IF ( (SD==-1 .AND. TIME<=0.0) .OR. &
           (SD== 1 .AND. TIME>=0.0) ) TIME = 0.0
    CALL PGTBX5 (DODAY, TIME, ASIGNL, DDL, HHL, MML, SSL)
    CALL PGTBX6 (DODAY, MOD24, TSCALE, DDL, HHL, MML, SSL, &
                   IVALL, RVAL, WRIT)
  END IF
  END IF
!
!  We want to label in the direction(s) away from zero, so we may  need
!  two passes. Determine the start and end ticks for each required pass.
!
  JST(2) = 0
  JEND(2) = 0
  NPASS = 1
  IF (IZERO==0) THEN
  IF (IS*SD==1) THEN
    JST(1) = 1
    JEND(1) = IT
  ELSE
    JST(1) = IT
    JEND(1) = 1
  END IF
  ELSE
  IF (INEG==0 .OR. IPOS==0) THEN
    JST(1) = IZERO
    JEND(1) = IT
    IF (IZERO==IT) JEND(1) = 1
  ELSE
    NPASS = 2
    JST(1) = IZERO
    JEND(1) = 1
    JST(2) = IZERO
    JEND(2) = IT
  END IF
  END IF
!
!  Now label the rest of the ticks.  Always label away from 0
!
  DO 400 I = 1, NPASS
!
!  Initialize previous tick values.  Use virtual tick if labelling
!  left to right without a zero (one pass)
!
  DO 250 K = 1, 3
    IVALO(K) = IVALZ(K)
    IF (IZERO==0) THEN
      IVALO(K) = IVALL(K)
      IF (JST(I)==1) IVALO(K) = IVALF(K)
    END IF
  250   CONTINUE
!
  INC = 1
  IF (JEND(I)<JST(I)) INC = -1
  DO 300 J = JST(I), JEND(I), INC
!
!  First and zero tick already labelled
!
    IF (J/=1 .AND. J/=IZERO) THEN
!
!  Prepare fields
!
      CALL PGTBX6 (DODAY, MOD24, TSCALE, DD(J), HH(J), MM(J), &
                     SS(J), IVAL, RVAL, WRIT)
!
!  Don't write unchanging fields
!
      DO 275 K = 1, 3
        IF (IVAL(K)==IVALO(K)) WRIT(K) = F
 275        CONTINUE
!
!  Prepare label
!
      CALL PGTBX7 (SUPTYP, SIGNF, ASIGN(J), IVAL, RVAL, WRIT, &
                     SPREC, DO2, TEXT, TLEN, LAST)
!
!  Write label
!
      COORD = TFRAC(J)
      CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN))
!
!  Update old values
!
      DO 280 K = 1, 3
        IVALO(K) = IVAL(K)
  280       CONTINUE
    END IF
 300    CONTINUE
 400  CONTINUE
  CALL PGEBUF
!
  RETURN
  END
! PGTBX5 -- support routine for PGTBOX
!
  SUBROUTINE PGTBX5 (DODAY, TSEC, ASIGN, D, H, M, S)
!
  REAL S, TSEC
  INTEGER  D, H, M
  LOGICAL DODAY
  CHARACTER*1 ASIGN
!
!  Convert time in seconds to (DD) HH MM SS.S
!
! Input
!  DODAY  :  Use day field if true, else hours accumulates beyond 24
!  TSEC   :  Time in seconds (signed)
! Output
!  ASIGN  :  Sign, ' ' or '-'
!  D,H,M  :  DD, HH, MM (unsigned)
!  S      :  SS.S       (unsigned)
!
! 10-Jun-1993 - new routine [nebk]
!-----------------------------------------------------------------------
  INTEGER IT
!----------------------------------------------------------------------
  ASIGN = ' '
  IF (TSEC<0.0) ASIGN = '-'
!
  S = MOD(ABS(TSEC),60.0)
!
  IT = NINT(ABS(TSEC)-S) / 60
  M = MOD(IT,60)
!
  IT = (IT - M) / 60
  IF (DODAY) THEN
  H = MOD(IT,24)
  D = (IT-H) / 24
  ELSE
  H = IT
  D = 0
  END IF
!
  RETURN
  END
! PGTBX6 -- support routine for PGTBOX
!
  SUBROUTINE PGTBX6 (DODAY, MOD24, TSCALE, DD, HH, MM, SS, IVAL, &
                     RVAL, WRIT)
!
  INTEGER TSCALE, IVAL(3), DD, HH, MM
  REAL SS, RVAL
  LOGICAL WRIT(4), DODAY, MOD24
!
!   Find out which of the DD HH MM SS.S fields we want to write
!   into the label according to TSCALE and make a round off
!   error check.
!
!  Input:
!    DODAY  :  Use day field if true else hours accrue beyond 24
!    MOD24  :  HH field labelled as modulo 24
!    TSCALE :  Dictates which fields appear in labels
!    DD     :  Day of time  (will be 0 if DODAY=F and HH will compensate)
!    HH     :  Hour of time
!    MM     :  Minute of time
!    SS     :  Second of time
!  Output:
!    IVAL(3):  DD HH MM to write into label
!    RVAL   :  SS.S to write into label
!    WRIT(4):  T or F if DD,HH,MM,SS are to be written into the label
!              or not.  IVAL and RVAL fields are set explicitly to
!              zero if the corresponding WRIT field is false.
!              This really is overkill.
!
!  10-Jun-1993 - New routine [nebk]
!  16-Jan-1995 - Add argument MOD24
!-----------------------------------------------------------------------
  LOGICAL T, F
  PARAMETER (T = .TRUE., F = .FALSE.)
  INTEGER WM
!-----------------------------------------------------------------------
  IVAL(1) = DD
  IVAL(2) = HH
  IVAL(3) = MM
  RVAL    = SS
!
!  SS should be 0.0; round off may get us 59.999 or the like but
!  not 60.001 (see PGTBX5)
!
  IF (TSCALE>1) THEN
  WM = NINT(SS/60.0)
  IVAL(3) = IVAL(3) + WM
  IF (IVAL(3)==60) THEN
    IVAL(3) = 0
    IVAL(2) = IVAL(2) + 1
    IF (DODAY .AND. IVAL(2)==24) THEN
      IVAL(2) = 0
      IVAL(1) = IVAL(1) + 1
    END IF
  END IF
  END IF
!
! Make HH field modulo 24 if desired
!
  IF (MOD24) IVAL(2) = MOD(IVAL(2),24)
!
  IF (TSCALE==1) THEN
!
!  Label contains (DD) HH MM SS.S
!
  WRIT(1) = DODAY
  WRIT(2) = T
  WRIT(3) = T
  WRIT(4) = T
  ELSE IF (TSCALE==60) THEN
!
!  Label contains (DD) HH MM
!
  WRIT(1) = DODAY
  WRIT(2) = T
  WRIT(3) = T
!
  RVAL    = 0.0
  WRIT(4) = F
  ELSE IF (TSCALE==3600) THEN
!
!  Label contains (DD) HH
!
  WRIT(1) = DODAY
  WRIT(2) = T
!
  IVAL(3) = 0
  WRIT(3) = F
!
  RVAL    = 0.0
  WRIT(4) = F
  ELSE IF (TSCALE==3600*24) THEN
!
!  Label contains DD
!
  WRIT(1) = T
!
  IVAL(2) = 0
  WRIT(2) = F
!
  IVAL(3) = 0
  WRIT(3) = F
!
  RVAL    = 0.0
  WRIT(4) = F
  END IF
!
  RETURN
  END
  SUBROUTINE PGTBX7 (SUPTYP, SIGNF, ASIGN, IVAL, RVAL, WRIT, &
                     SPREC, DO2, TEXT, TLEN, LAST)
!
  REAL RVAL
  INTEGER IVAL(3), TLEN, SPREC, LAST
  CHARACTER ASIGN*1, TEXT*(*), SIGNF*1, SUPTYP*4
  LOGICAL WRIT(4), DO2
!
! Write (DD) HH MM SS.S time labels into a string
!
! This is a support routine for PGTBOX and should not be
! called by the user
!
! Inputs
!  SUPTYP :  '    ', 'DHMS', or ' DMS' for no superscript labelling,
!            d,h,m,s   or   o,','' superscripting
!  SIGNF  :  Tells which field the sign is associated with.
!            One of 'D', 'H', 'M', or 'S'
!  ASIGN  :  ' ' or '-' for positive or negative times
!  IVAL(3):  Day, hour, minutes of time
!  RVAL   :  Seconds of time
!  WRIT(4):  If .true. then write DD, HH, MM, SS  into label
!  SPREC  :  Number of places after the decimal to write seconds
!            string to.  Must be in the range 0-3
!  DO2    :  If true, add a leading zero to numbers < 10
! Outputs
!  TEXT   :  Label
!  TLEN   :  Length of label
!  LAST   :  Is the location of the start character of the last
!            field written into TEXT
!
!  05-Sep-1989 -- New routine (Neil Killeen)
!  20-Apr-1991 -- Complete rewrite; support for new DD (day) field and
!                 superscripted labels [nebk]
!  14-May-1991 -- Removed BSL as a parameter (Char(92)) and made it
!                 a variable to appease Cray compiler [mjs/nebk]
!  10-Jun-1993 -- Rename from PGTLB1, add code to label superscript
!                 seconds above the '.' and add DO2 option [nebk/jm]
!-----------------------------------------------------------------------
  INTEGER FLEN, FST, FMAX, TRLEN(3), SUPPNT, TMPNT, TLEN2, &
  IR1, IR2, IP
  CHARACTER FIELD*30, FRMAT2(3)*2, SUPER(4,3)*11, TMP*100, &
  BSL*1, FRMAT*30
!
  SAVE FRMAT2
  SAVE TRLEN
!
  DATA FRMAT2 /'I1', 'I2', 'I3'/
  DATA TRLEN /5, 11, 5/
!-----------------------------------------------------------------------
!
!   Initialize
!
  BSL = CHAR(92)
  TLEN = 0
  TEXT = ' '
!
!   Assign superscripting strings.  Use CHAR(92) for backslash as the
!   latter must be escaped on SUNs thus requiring preprocessing.  The
!   concatenator operator precludes the use of a data statement
!
  SUPER(1,1) = BSL//'ud'//BSL//'d'
  SUPER(2,1) = BSL//'uh'//BSL//'d'
  SUPER(3,1) = BSL//'um'//BSL//'d'
  SUPER(4,1) = BSL//'us'//BSL//'d'
!
  SUPER(1,2) = BSL//'u'//BSL//'(2199)'//BSL//'d'
  SUPER(2,2) = BSL//'u'//BSL//'(2729)'//BSL//'d'
  SUPER(3,2) = BSL//'u'//BSL//'(2727)'//BSL//'d'
  SUPER(4,2) = BSL//'u'//BSL//'(2728)'//BSL//'d'
!
  SUPER(1,3) = BSL//'u'//' '//BSL//'d'
  SUPER(2,3) = BSL//'u'//' '//BSL//'d'
  SUPER(3,3) = BSL//'u'//' '//BSL//'d'
  SUPER(4,3) = BSL//'u'//' '//BSL//'d'
!
!   Point at correct superscript strings
!
  IF (SUPTYP=='DHMS') THEN
  SUPPNT = 1
  ELSE IF (SUPTYP==' DMS') THEN
  SUPPNT = 2
  ELSE
  SUPPNT = 3
  END IF
!
!CCC
!   Days field
!CCC
!
  IF (WRIT(1)) THEN
  LAST = TLEN + 1
!
!   Write into temporary field
!
  FIELD = ' '
  CALL PGNPL (0, IVAL(1), FLEN)
  WRITE (FIELD, '(I6)') IVAL(1)
  FMAX = 6
  FST = FMAX - FLEN + 1
!
!   Write output text string with desired superscripting
!
  TMPNT = 2
  IF (SIGNF=='D' .AND. ASIGN/=' ') TMPNT = 1
!
  TMP = ASIGN//FIELD(FST:FMAX)//SUPER(1,SUPPNT)
  TLEN2 = (2 - TMPNT) + FLEN + TRLEN(SUPPNT)
!
  TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1)
  TLEN = TLEN + TLEN2
  END IF
!
!CCC
!   Hours field
!CCC
!
  IF (WRIT(2)) THEN
  LAST = TLEN + 1
!
!   Write into temporary field
!
  FIELD = ' '
  CALL PGNPL (0, IVAL(2), FLEN)
  WRITE (FIELD, '(I6)') IVAL(2)
  FMAX = 6
  FST = FMAX - FLEN + 1
!
  IF (DO2 .AND. FLEN==1) THEN
    FLEN = FLEN + 1
    FST = FST - 1
    FIELD(FST:FST) = '0'
  END IF
!
!   Write output text string with desired superscripting
!
  TMPNT = 2
  IF (SIGNF=='H' .AND. ASIGN/=' ') TMPNT = 1
!
  TMP = ASIGN//FIELD(FST:FMAX)//SUPER(2,SUPPNT)
  TLEN2 = (2 - TMPNT) + FLEN + TRLEN(SUPPNT)
!
  TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1)
  TLEN = TLEN + TLEN2
  END IF
!
!CCC
!   Minutes field
!CCC
!
  IF (WRIT(3)) THEN
  LAST = TLEN + 1
!
!   Write into temporary field with desired superscripting
!
  FIELD = ' '
  WRITE (FIELD, '(I2, A)') IVAL(3), &
                             SUPER(3,SUPPNT)(1:TRLEN(SUPPNT))
  FMAX = 2 + TRLEN(SUPPNT)
!
  FST = 1
  IF (FIELD(FST:FST)==' ') THEN
    IF (DO2) THEN
      FIELD(FST:FST) = '0'
    ELSE
      FST = FST + 1
    END IF
  END IF
  FLEN = FMAX - FST + 1
!
!   Write output text string
!
  TMPNT = 2
  IF (SIGNF=='M' .AND. ASIGN/=' ') TMPNT = 1
!
  TMP = ASIGN//FIELD(FST:FMAX)
  TLEN2 = (2 - TMPNT) + FLEN
!
  TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1)
  TLEN = TLEN + TLEN2
  END IF
!
!CCC
!   Seconds field
!CCC
!
  IF (WRIT(4)) THEN
  LAST = TLEN + 1
!
!   Write into temporary field
!
  FIELD = ' '
  FST = 1
  IF (SPREC>=1) THEN
!
!   Fractional label.  Upto 3 places after the decimal point allowed
!   Muck around to get the superscript on top of the decimal point
!
    IR1 = INT(RVAL)
    IR2 = NINT((RVAL - IR1) * 10**SPREC)
    FRMAT = '(I2, A1, A, '//FRMAT2(SPREC)//')'
    WRITE (FIELD, FRMAT(1:15)) &
                         IR1, '.', &
                         BSL//'b'//SUPER(4,SUPPNT)(1:TRLEN(SUPPNT)), &
                         IR2
    IP = 5 + TRLEN(SUPPNT) + 1
    IF (FIELD(IP:IP)==' ') FIELD(IP:IP) = '0'
    IF (FIELD(IP+1:IP+1)==' ') FIELD(IP+1:IP+1) = '0'
    FMAX = 1 + 2 + SPREC
  ELSE
!
!   Integer label.
!
    WRITE (FIELD, '(I2,A)') NINT(RVAL), &
                              SUPER(4,SUPPNT)(1:TRLEN(SUPPNT))
    FMAX = 0
  END IF
  FMAX = FMAX + 2 + TRLEN(SUPPNT)
!
  IF (FIELD(FST:FST)==' ') THEN
    IF (DO2) THEN
      FIELD(FST:FST) = '0'
    ELSE
      FST = FST + 1
    END IF
  END IF
  FLEN = FMAX - FST + 1
!
!   Write output text string
!
  TMPNT = 2
  IF (SIGNF=='S' .AND. ASIGN/=' ') TMPNT = 1
  TMP = ASIGN//FIELD(FST:FMAX)
  TLEN2 = (3 - TMPNT) + FLEN
!
  TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1)
  TLEN = TLEN + TLEN2
  END IF
!
!   A trailing blank will occur if no superscripting wanted
!
  IF (TLEN>=5 .AND. TEXT(TLEN-4:TLEN)==BSL//'u'//' '//BSL//'d') &
     TLEN = TLEN - 5
!
  RETURN
  END

!*PGTEXT -- write text (horizontal, left-justified)
!%void cpgtext(float x, float y, const char *text);
!+
  SUBROUTINE PGTEXT (X, Y, TEXT)
  REAL X, Y
  CHARACTER*(*) TEXT
!
! Write text. The bottom left corner of the first character is placed
! at the specified position, and the text is written horizontally.
! This is a simplified interface to the primitive routine PGPTXT.
! For non-horizontal text, use PGPTXT.
!
! Arguments:
!  X      (input)  : world x-coordinate of start of string.
!  Y      (input)  : world y-coordinate of start of string.
!  TEXT   (input)  : the character string to be plotted.
!--
! (2-May-1983)
!-----------------------------------------------------------------------
  CALL PGPTXT(X, Y, 0.0, 0.0, TEXT)
  END

!*PGTICK -- draw a single tick mark on an axis
!%void cpgtick(float x1, float y1, float x2, float y2, float v, \
!% float tikl, float tikr, float disp, float orient, const char *str);
!+
  SUBROUTINE PGTICK (X1, Y1, X2, Y2, V, TIKL, TIKR, DISP, &
                     ORIENT, STR)
  REAL X1, Y1, X2, Y2, V, TIKL, TIKR, DISP, ORIENT
  CHARACTER*(*) STR
!
! Draw and label single tick mark on a graph axis. The tick mark is
! a short line perpendicular to the direction of the axis (which is not
! drawn by this routine). The optional text label is drawn with its
! baseline parallel to the axis and reading in the same direction as
! the axis (from point 1 to point 2). Current line and text attributes
! are used.
!
! Arguments:
!  X1, Y1 (input)  : world coordinates of one endpoint of the axis.
!  X2, Y2 (input)  : world coordinates of the other endpoint of the axis.
!  V      (input)  : draw the tick mark at fraction V (0<=V<=1) along
!                    the line from (X1,Y1) to (X2,Y2).
!  TIKL   (input)  : length of tick mark drawn to left of axis
!                    (as seen looking from first endpoint to second), in
!                    units of the character height.
!  TIKR   (input)  : length of major tick marks drawn to right of axis,
!                    in units of the character height.
!  DISP   (input)  : displacement of label text to
!                    right of axis, in units of the character height.
!  ORIENT (input)  : orientation of label text, in degrees; angle between
!                    baseline of text and direction of axis (0-360).
!  STR    (input)  : text of label (may be blank).
!--
! 25-Mar-1997 - new routine [TJP].
!-----------------------------------------------------------------------
  REAL X, Y, XV1, XV2, YV1, YV2, XW1, XW2, YW1, YW2
  REAL XPMM, YPMM, LENMM, ANGLE, XCH, YCH
  REAL TIKX, TIKY, FJUST, D, OR
!
! Check arguments.
!
  IF (X1==X2 .AND. Y1==Y2) RETURN
!
! Get current character height (mm) [note: XCH = YCH].
!
  CALL PGQCS(2, XCH, YCH)
!
! Get x and y scales (units per mm).
!
  CALL PGQVP(2, XV1, XV2, YV1, YV2)
  CALL PGQWIN(XW1, XW2, YW1, YW2)
  XPMM  = (XW2-XW1)/(XV2-XV1)
  YPMM  = (YW2-YW1)/(YV2-YV1)
!
! Length of axis in mm.
!
  LENMM = SQRT(((X2-X1)/XPMM)**2 + ((Y2-Y1)/YPMM)**2)
!
! Angle of axis to horizontal (device coordinates).
!
  ANGLE = ATAN2((Y2-Y1)/YPMM, (X2-X1)/XPMM)*57.29577951
!
! (x,y) displacement for 1 character height perpendicular to axis.
!
  TIKX = (Y1-Y2)*XCH*XPMM/(LENMM*YPMM)
  TIKY = (X2-X1)*XCH*YPMM/(LENMM*XPMM)
!
! Draw the tick mark at point (X,Y) on the axis.
!
  X = X1 + V*(X2-X1)
  Y = Y1 + V*(Y2-Y1)
  CALL PGMOVE(X - TIKR*TIKX, Y - TIKR*TIKY)
  CALL PGDRAW(X + TIKL*TIKX, Y + TIKL*TIKY)
!
! Label the tick mark.
!
  D = DISP
  IF (STR==' ') RETURN
  OR = MOD(ORIENT, 360.0)
  IF (OR<0.0) OR=OR+360.0
  IF (OR>45.0 .AND. OR<=135.0) THEN
   FJUST = 0.0
   IF (D<0.0) FJUST = 1.0
  ELSE IF (OR>135.0 .AND. OR<=225.0) THEN
   FJUST = 0.5
   IF (D<0.0) D = D-1.0
  ELSE IF (OR>225.0 .AND. OR<=315.0) THEN
   ANGLE = ANGLE+90.0
   FJUST = 1.0
   IF (D<0.0) FJUST = 0.0
  ELSE
   FJUST = 0.5
   IF (D>0.0) D = D+1.0
  END IF
  CALL PGPTXT(X-D*TIKX, Y-D*TIKY, ANGLE-OR, FJUST, STR)
  END

!.PGTIKL -- length of error bar terminal
!
  SUBROUTINE PGTIKL (T, XL, YL)
  REAL T, XL, YL
!
! Return the length of the terminal of an error bar, in world
! coordinates.
!
! Arguments:
!  T      (input)  : terminal multiplier
!  XL     (output) : terminal lnegth in world x-coordinates
!  YL     (output) : terminal lnegth in world y-coordinates
!--
! 31-Mar-1997 - new routine [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
!
  XL = T*PGXSP(PGID)*0.15/PGXSCL(PGID)
  YL = T*PGXSP(PGID)*0.15/PGYSCL(PGID)
!
  END

!*PGUPDT -- update display
!%void cpgupdt(void);
!+
  SUBROUTINE PGUPDT
!
! Update the graphics display: flush any pending commands to the
! output device. This routine empties the buffer created by PGBBUF,
! but it does not alter the PGBBUF/PGEBUF counter. The routine should
! be called when it is essential that the display be completely up to
! date (before interaction with the user, for example) but it is not
! known if output is being buffered.
!
! Arguments: none
!--
! 27-Nov-1986
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!
  IF (PGNOTO('PGUPDT')) RETURN
  CALL GRTERM
  END

!*PGVECT -- vector map of a 2D data array, with blanking
!%void cpgvect(const float *a, const float *b, int idim, int jdim, \
!% int i1, int i2, int j1, int j2, float c, int nc, \
!% const float *tr, float blank);
!+
  SUBROUTINE PGVECT (A, B, IDIM, JDIM, I1, I2, J1, J2, C, NC, TR, &
                     BLANK)
  INTEGER IDIM, JDIM, I1, I2, J1, J2, NC
  REAL    A(IDIM,JDIM), B(IDIM, JDIM), TR(6), BLANK, C
!
! Draw a vector map of two arrays.  This routine is similar to
! PGCONB in that array elements that have the "magic value" defined by
! the argument BLANK are ignored, making gaps in the vector map.  The
! routine may be useful for data measured on most but not all of the
! points of a grid. Vectors are displayed as arrows; the style of the
! arrowhead can be set with routine PGSAH, and the the size of the
! arrowhead is determined by the current character size, set by PGSCH.
!
! Arguments:
!  A      (input)  : horizontal component data array.
!  B      (input)  : vertical component data array.
!  IDIM   (input)  : first dimension of A and B.
!  JDIM   (input)  : second dimension of A and B.
!  I1,I2  (input)  : range of first index to be mapped (inclusive).
!  J1,J2  (input)  : range of second index to be mapped (inclusive).
!  C      (input)  : scale factor for vector lengths, if 0.0, C will be
!                    set so that the longest vector is equal to the
!                    smaller of TR(2)+TR(3) and TR(5)+TR(6).
!  NC     (input)  : vector positioning code.
!                    <0 vector head positioned on coordinates
!                    >0 vector base positioned on coordinates
!                    =0 vector centered on the coordinates
!  TR     (input)  : array defining a transformation between the I,J
!                    grid of the array and the world coordinates. The
!                    world coordinates of the array point A(I,J) are
!                    given by:
!                      X = TR(1) + TR(2)*I + TR(3)*J
!                      Y = TR(4) + TR(5)*I + TR(6)*J
!                    Usually TR(3) and TR(5) are zero - unless the
!                    coordinate transformation involves a rotation
!                    or shear.
!  BLANK   (input) : elements of arrays A or B that are exactly equal to
!                    this value are ignored (blanked).
!--
!  4-Sep-1992: derived from PGCONB [J. Crane].
! 26-Nov-1992: revised to use PGARRO [TJP].
! 25-Mar-1994: correct error for NC not =0 [G. Gonczi].
!  5-Oct-1996: correct error in computing max vector length [TJP;
!              thanks to David Singleton].
!-----------------------------------------------------------------------
  INTEGER  I, J
  REAL X, Y, X1, Y1, X2, Y2
  REAL CC
  INTRINSIC SQRT, MAX, MIN
!
! Define grid to world transformation
!
  X(I,J) = TR(1) + TR(2)*I + TR(3)*J
  Y(I,J) = TR(4) + TR(5)*I + TR(6)*J
!
! Check arguments.
!
  IF (I1<1 .OR. I2>IDIM .OR. I1>=I2 .OR. &
      J1<1 .OR. J2>JDIM .OR. J1>=J2) THEN
!        CALL GRWARN('PGVECT: invalid range I1:I2, J1:J2')
   RETURN
  END IF
!
! Check for scale factor C.
!
  CC = C
  IF (CC==0.0) THEN
   DO 20 J=J1,J2
      DO 10 I=I1,I2
         IF (A(I,J)/=BLANK .AND. B(I,J)/=BLANK) &
                CC = MAX(CC,SQRT(A(I,J)**2+B(I,J)**2))
 10         CONTINUE
 20      CONTINUE
   IF (CC==0.0) RETURN
   CC = SQRT(MIN(TR(2)**2+TR(3)**2,TR(5)**2+TR(6)**2))/CC
  END IF
!
  CALL PGBBUF
!
  DO 40 J=J1,J2
   DO 30 I=I1,I2
!
! Ignore vector if element of A and B are both equal to BLANK
!
      IF (.NOT.(A(I,J)==BLANK .AND. B(I,J)==BLANK)) THEN

!
! Define the vector starting and end points according to NC.
!
         IF (NC<0) THEN
            X2 = X(I,J)
            Y2 = Y(I,J)
            X1 = X2 - A(I,J)*CC
            Y1 = Y2 - B(I,J)*CC
         ELSE IF (NC==0) THEN
            X2 = X(I,J) + 0.5*A(I,J)*CC
            Y2 = Y(I,J) + 0.5*B(I,J)*CC
            X1 = X2 - A(I,J)*CC
            Y1 = Y2 - B(I,J)*CC
         ELSE
            X1 = X(I,J)
            Y1 = Y(I,J)
            X2 = X1 + A(I,J)*CC
            Y2 = Y1 + B(I,J)*CC
         END IF
!
! Draw vector.
!
         CALL PGARRO(X1, Y1, X2, Y2)
      END IF
 30      CONTINUE
 40   CONTINUE
!
  CALL PGEBUF
  END

!*PGVPORT -- non-standard alias for PGSVP
!+
  SUBROUTINE PGVPORT (XLEFT, XRIGHT, YBOT, YTOP)
  REAL XLEFT, XRIGHT, YBOT, YTOP
!
! See description of PGSVP.
!--
  CALL PGSVP (XLEFT, XRIGHT, YBOT, YTOP)
  END

!*PGVSIZE -- non-standard alias for PGVSIZ
!+
  SUBROUTINE PGVSIZE (XLEFT, XRIGHT, YBOT, YTOP)
  REAL XLEFT, XRIGHT, YBOT, YTOP
!
! See description of PGVSIZ.
!--
  CALL PGVSIZ (XLEFT, XRIGHT, YBOT, YTOP)
  END

!*PGVSIZ -- set viewport (inches)
!%void cpgvsiz(float xleft, float xright, float ybot, float ytop);
!+
  SUBROUTINE PGVSIZ (XLEFT, XRIGHT, YBOT, YTOP)
  REAL XLEFT, XRIGHT, YBOT, YTOP
!
! Change the size and position of the viewport, specifying
! the viewport in physical device coordinates (inches).  The
! viewport is the rectangle on the view surface "through"
! which one views the graph.  All the PG routines which plot lines
! etc. plot them within the viewport, and lines are truncated at
! the edge of the viewport (except for axes, labels etc drawn with
! PGBOX or PGLAB).  The region of world space (the coordinate
! space of the graph) which is visible through the viewport is
! specified by a call to PGSWIN.  It is legal to request a
! viewport larger than the view surface; only the part which
! appears on the view surface will be plotted.
!
! Arguments:
!  XLEFT  (input)  : x-coordinate of left hand edge of viewport, in
!                    inches from left edge of view surface.
!  XRIGHT (input)  : x-coordinate of right hand edge of viewport, in
!                    inches from left edge of view surface.
!  YBOT   (input)  : y-coordinate of bottom edge of viewport, in
!                    inches from bottom of view surface.
!  YTOP   (input)  : y-coordinate of top  edge of viewport, in inches
!                    from bottom of view surface.
!--
! 13-Dec-1990  Make errors non-fatal [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  LOGICAL  PGNOTO
!
  IF (PGNOTO('PGVSIZ'))  RETURN
  IF (XLEFT>=XRIGHT .OR. YBOT>=YTOP) THEN
    CALL GRWARN('PGVSIZ ignored: invalid arguments')
    RETURN
  END IF
!
  PGXLEN(PGID) = (XRIGHT-XLEFT)*PGXPIN(PGID)
  PGYLEN(PGID) = (YTOP-YBOT)*PGYPIN(PGID)
  PGXVP(PGID)  = XLEFT*PGXPIN(PGID)
  PGYVP(PGID)  = YBOT*PGYPIN(PGID)
  PGXOFF(PGID) = PGXVP(PGID) + (PGNXC(PGID)-1)*PGXSZ(PGID)
  PGYOFF(PGID) = PGYVP(PGID) + &
                  (PGNY(PGID)-PGNYC(PGID))*PGYSZ(PGID)
  CALL PGVW
  END

!*PGVSTAND -- non-standard alias for PGVSTD
!+
  SUBROUTINE PGVSTAND
!
! See description of PGVSTD.
!--
  CALL PGVSTD
  END

!*PGVSTD -- set standard (default) viewport
!%void cpgvstd(void);
!+
  SUBROUTINE PGVSTD
!
! Define the viewport to be the standard viewport.  The standard
! viewport is the full area of the view surface (or panel),
! less a margin of 4 character heights all round for labelling.
! It thus depends on the current character size, set by PGSCH.
!
! Arguments: none.
!--
! 22-Apr-1983: [TJP].
!  2-Aug-1995: [TJP].
!-----------------------------------------------------------------------
  INCLUDE  'pgplot.h'
  LOGICAL  PGNOTO
  REAL     XLEFT, XRIGHT, YBOT, YTOP, R
!
  IF (PGNOTO('PGVSIZ')) RETURN
!
  R = 4.0*PGYSP(PGID)
  XLEFT  = R/PGXPIN(PGID)
  XRIGHT = XLEFT + (PGXSZ(PGID)-2.0*R)/PGXPIN(PGID)
  YBOT   = R/PGYPIN(PGID)
  YTOP   = YBOT + (PGYSZ(PGID)-2.0*R)/PGYPIN(PGID)
  CALL PGVSIZ(XLEFT, XRIGHT, YBOT, YTOP)
  END

!
  SUBROUTINE PGVW
!
! PGPLOT (internal routine): set the GRPCKG scaling transformation
! and window appropriate for the current window and viewport. This
! routine is called whenever the viewport or window is changed.
!
! Arguments: none
!
! (11-Feb-1983)
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
!
! Scale plotter in world coordinates.
!
  PGXSCL(PGID) = PGXLEN(PGID)/ABS(PGXTRC(PGID)-PGXBLC(PGID))
  PGYSCL(PGID) = PGYLEN(PGID)/ABS(PGYTRC(PGID)-PGYBLC(PGID))
  IF (PGXBLC(PGID)>PGXTRC(PGID)) THEN
    PGXSCL(PGID) = -PGXSCL(PGID)
  END IF
  IF (PGYBLC(PGID)>PGYTRC(PGID)) THEN
    PGYSCL(PGID) = -PGYSCL(PGID)
  END IF
  PGXORG(PGID) = PGXOFF(PGID)-PGXBLC(PGID)*PGXSCL(PGID)
  PGYORG(PGID) = PGYOFF(PGID)-PGYBLC(PGID)*PGYSCL(PGID)
  CALL GRTRN0(PGXORG(PGID),PGYORG(PGID), &
              PGXSCL(PGID),PGYSCL(PGID))
!
! Window plotter in viewport.
!
  CALL GRAREA(PGID,PGXOFF(PGID),PGYOFF(PGID), &
              PGXLEN(PGID),PGYLEN(PGID))
  END

!*PGWEDG -- annotate an image plot with a wedge
!%void cpgwedg(const char *side, float disp, float width, \
!% float fg, float bg, const char *label);
!+
  SUBROUTINE PGWEDG(SIDE, DISP, WIDTH, FG, BG, LABEL)
  CHARACTER *(*) SIDE,LABEL
  REAL DISP, WIDTH, FG, BG
!
! Plot an annotated grey-scale or color wedge parallel to a given axis
! of the the current viewport. This routine is designed to provide a
! brightness/color scale for an image drawn with PGIMAG or PGGRAY.
! The wedge will be drawn with the transfer function set by PGSITF
! and using the color index range set by PGSCIR.
!
! Arguments:
!  SIDE   (input)  : The first character must be one of the characters
!                    'B', 'L', 'T', or 'R' signifying the Bottom, Left,
!                    Top, or Right edge of the viewport.
!                    The second character should be 'I' to use PGIMAG
!                    to draw the wedge, or 'G' to use PGGRAY.
!  DISP   (input)  : the displacement of the wedge from the specified
!                    edge of the viewport, measured outwards from the
!                    viewport in units of the character height. Use a
!                    negative value to write inside the viewport, a
!                    positive value to write outside.
!  WIDTH  (input)  : The total width of the wedge including annotation,
!                    in units of the character height.
!  FG     (input)  : The value which is to appear with shade
!                    1 ("foreground"). Use the values of FG and BG
!                    that were supplied to PGGRAY or PGIMAG.
!  BG     (input)  : the value which is to appear with shade
!                    0 ("background").
!  LABEL  (input)  : Optional units label. If no label is required
!                    use ' '.
!--
!  15-Oct-1992: New routine (MCS)
!   2-Aug-1995: no longer needs common (TJP).
!-----------------------------------------------------------------------
  LOGICAL PGNOTO
!                                        Temporary window coord storage.
  REAL WXA,WXB,WYA,WYB, XA,XB,YA,YB
!                                        Viewport coords of wedge.
  REAL VXA,VXB,VYA,VYB
!                          Original and anotation character heights.
  REAL OLDCH, NEWCH
!                          Size of unit character height (NDC units).
  REAL NDCSIZ
!                          True if wedge plotted horizontally.
  LOGICAL HORIZ
!                          Use PGIMAG (T) or PGGRAY (F).
  LOGICAL IMAGE
!                          Symbolic version of SIDE.
  INTEGER NSIDE,BOT,TOP,LFT,RGT
  PARAMETER (BOT=1,TOP=2,LFT=3,RGT=4)
  INTEGER I
  REAL WEDWID, WDGINC, VWIDTH, VDISP, XCH, YCH, LABWID, FG1, BG1
!                          Set the fraction of WIDTH used for anotation.
  REAL TXTFRC
  PARAMETER (TXTFRC=0.6)
!                          Char separation between numbers and LABEL.
  REAL TXTSEP
  PARAMETER (TXTSEP=2.2)
!                          Array to draw wedge in.
  INTEGER WDGPIX
  PARAMETER (WDGPIX=100)
  REAL WDGARR(WDGPIX)
!                          Define the coordinate-mapping function.
  REAL TR(6)
  SAVE TR
  DATA TR /0.0,1.0,0.0,0.0,0.0,1.0/
!-----------------------------------------------------------------------
  IF(PGNOTO('PGWEDG')) RETURN
!
! Get a numeric version of SIDE.
!
  IF(SIDE(1:1)=='B' .OR. SIDE(1:1)=='b') THEN
  NSIDE = BOT
  HORIZ = .TRUE.
  ELSE IF(SIDE(1:1)=='T' .OR. SIDE(1:1)=='t') THEN
  NSIDE = TOP
  HORIZ = .TRUE.
  ELSE IF(SIDE(1:1)=='L' .OR. SIDE(1:1)=='l') THEN
  NSIDE = LFT
  HORIZ = .FALSE.
  ELSE IF(SIDE(1:1)=='R' .OR. SIDE(1:1)=='r') THEN
  NSIDE = RGT
  HORIZ = .FALSE.
  ELSE
  CALL GRWARN('Invalid "SIDE" argument in PGWEDG.')
  RETURN
  END IF
!
! Determine which routine to use.
!
  IF (LEN(SIDE)<2) THEN
   IMAGE = .FALSE.
  ELSE IF(SIDE(2:2)=='I' .OR. SIDE(2:2)=='i') THEN
   IMAGE = .TRUE.
  ELSE IF(SIDE(2:2)=='G' .OR. SIDE(2:2)=='g') THEN
   IMAGE = .FALSE.
  ELSE
   CALL GRWARN('Invalid "SIDE" argument in PGWEDG.')
  END IF
!
  CALL PGBBUF
!
! Store the current world and viewport coords and the character height.
!
  CALL PGQWIN(WXA, WXB, WYA, WYB)
  CALL PGQVP(0, XA, XB, YA, YB)
  CALL PGQCH(OLDCH)
!
! Determine the unit character height in NDC coords.
!
  CALL PGSCH(1.0)
  CALL PGQCS(0, XCH, YCH)
  IF(HORIZ) THEN
  NDCSIZ = YCH
  ELSE
  NDCSIZ = XCH
  END IF
!
! Convert 'WIDTH' and 'DISP' into viewport units.
!
  VWIDTH = WIDTH * NDCSIZ * OLDCH
  VDISP  = DISP * NDCSIZ * OLDCH
!
! Determine the number of character heights required under the wedge.
!
  LABWID = TXTSEP
  IF(LABEL/=' ') LABWID = LABWID + 1.0
!
! Determine and set the character height required to fit the wedge
! anotation text within the area allowed for it.
!
  NEWCH = TXTFRC*VWIDTH / (LABWID*NDCSIZ)
  CALL PGSCH(NEWCH)
!
! Determine the width of the wedge part of the plot minus the anotation.
! (NDC units).
!
  WEDWID = VWIDTH * (1.0-TXTFRC)
!
! Use these to determine viewport coordinates for the wedge + annotation.
!
  VXA = XA
  VXB = XB
  VYA = YA
  VYB = YB
  IF(NSIDE==BOT) THEN
  VYB = YA - VDISP
  VYA = VYB - WEDWID
  ELSE IF(NSIDE==TOP) THEN
  VYA = YB + VDISP
  VYB = VYA + WEDWID
  ELSE IF(NSIDE==LFT) THEN
  VXB = XA - VDISP
  VXA = VXB - WEDWID
  ELSE IF(NSIDE==RGT) THEN
  VXA = XB + VDISP
  VXB = VXA + WEDWID
  END IF
!
! Set the viewport for the wedge.
!
  CALL PGSVP(VXA, VXB, VYA, VYB)
!
! Swap FG/BG if necessary to get axis direction right.
!
  FG1 = MAX(FG,BG)
  BG1 = MIN(FG,BG)
!
! Create a dummy wedge array to be plotted.
!
  WDGINC = (FG1-BG1)/(WDGPIX-1)
  DO 1 I=1,WDGPIX
  WDGARR(I) = BG1 + (I-1) * WDGINC
 1    CONTINUE
!
! Draw the wedge then change the world coordinates for labelling.
!
  IF (HORIZ) THEN
  CALL PGSWIN(1.0, REAL(WDGPIX), 0.9, 1.1)
  IF (IMAGE) THEN
     CALL PGIMAG(WDGARR, WDGPIX,1, 1,WDGPIX, 1,1, FG,BG, TR)
  ELSE
     CALL PGGRAY(WDGARR, WDGPIX,1, 1,WDGPIX, 1,1, FG,BG, TR)
  END IF
  CALL PGSWIN(BG1,FG1,0.0,1.0)
  ELSE
  CALL PGSWIN(0.9, 1.1, 1.0, REAL(WDGPIX))
  IF (IMAGE) THEN
     CALL PGIMAG(WDGARR, 1,WDGPIX, 1,1, 1,WDGPIX, FG,BG, TR)
  ELSE
     CALL PGGRAY(WDGARR, 1,WDGPIX, 1,1, 1,WDGPIX, FG,BG, TR)
  END IF
  CALL PGSWIN(0.0, 1.0, BG1, FG1)
  ENDIF
!
! Draw a labelled frame around the wedge.
!
  IF(NSIDE==BOT) THEN
  CALL PGBOX('BCNST',0.0,0,'BC',0.0,0)
  ELSE IF(NSIDE==TOP) THEN
  CALL PGBOX('BCMST',0.0,0,'BC',0.0,0)
  ELSE IF(NSIDE==LFT) THEN
  CALL PGBOX('BC',0.0,0,'BCNST',0.0,0)
  ELSE IF(NSIDE==RGT) THEN
  CALL PGBOX('BC',0.0,0,'BCMST',0.0,0)
  ENDIF
!
! Write the units label.
!
  IF(LABEL/=' ') THEN
  CALL PGMTXT(SIDE,TXTSEP,1.0,1.0,LABEL)
  END IF
!
! Reset the original viewport and world coordinates.
!
  CALL PGSVP(XA,XB,YA,YB)
  CALL PGSWIN(WXA,WXB,WYA,WYB)
  CALL PGSCH(OLDCH)
  CALL PGEBUF
  RETURN
  END

!*PGWINDOW -- non-standard alias for PGSWIN
!+
  SUBROUTINE PGWINDOW (X1, X2, Y1, Y2)
  REAL X1, X2, Y1, Y2
!
! See description of PGSWIN.
!--
  CALL PGSWIN (X1, X2, Y1, Y2)
  END

!*PGWNAD -- set window and adjust viewport to same aspect ratio
!%void cpgwnad(float x1, float x2, float y1, float y2);
!+
  SUBROUTINE PGWNAD (X1, X2, Y1, Y2)
  REAL X1, X2, Y1, Y2
!
! Change the window in world coordinate space that is to be mapped on
! to the viewport, and simultaneously adjust the viewport so that the
! world-coordinate scales are equal in x and y. The new viewport is
! the largest one that can fit within the previously set viewport
! while retaining the required aspect ratio.
!
! Arguments:
!  X1     (input)  : the x-coordinate of the bottom left corner
!                    of the viewport.
!  X2     (input)  : the x-coordinate of the top right corner
!                    of the viewport (note X2 may be less than X1).
!  Y1     (input)  : the y-coordinate of the bottom left corner
!                    of the viewport.
!  Y2     (input)  : the y-coordinate of the top right corner of the
!                    viewport (note Y2 may be less than Y1).
!--
! 25-Sep-1985 - new routine (TJP).
! 31-May-1989 - correct error: XVP and YVP not set (TJP).
!-----------------------------------------------------------------------
  INCLUDE 'pgplot.h'
  LOGICAL PGNOTO
  REAL SCALE,OXLEN,OYLEN
!
  IF (PGNOTO('PGWNAD')) RETURN
!
! If invalid arguments are specified, issue warning and leave window
! unchanged.
!
  IF (X1==X2) THEN
   CALL GRWARN('invalid x limits in PGWNAD: X1 = X2.')
  ELSE IF (Y1==Y2) THEN
   CALL GRWARN('invalid y limits in PGWNAD: Y1 = Y2.')
  ELSE
   SCALE = MIN(PGXLEN(PGID)/ABS(X2-X1)/PGXPIN(PGID), &
                 PGYLEN(PGID)/ABS(Y2-Y1)/PGYPIN(PGID))
   PGXSCL(PGID) = SCALE*PGXPIN(PGID)
   PGYSCL(PGID) = SCALE*PGYPIN(PGID)
   OXLEN = PGXLEN(PGID)
   OYLEN = PGYLEN(PGID)
   PGXLEN(PGID) = PGXSCL(PGID)*ABS(X2-X1)
   PGYLEN(PGID) = PGYSCL(PGID)*ABS(Y2-Y1)
   PGXVP(PGID)  = PGXVP(PGID) + 0.5*(OXLEN-PGXLEN(PGID))
   PGYVP(PGID)  = PGYVP(PGID) + 0.5*(OYLEN-PGYLEN(PGID))
   PGXOFF(PGID) = PGXVP(PGID) + (PGNXC(PGID)-1)*PGXSZ(PGID)
   PGYOFF(PGID) = PGYVP(PGID) + &
                     (PGNY(PGID)-PGNYC(PGID))*PGYSZ(PGID)
   CALL PGSWIN(X1, X2, Y1, Y2)
  END IF
  END

!*PSDRIV -- PGPLOT PostScript drivers
!+
  SUBROUTINE PSDRIV (IFUNC, RBUF, NBUF, CHR, LCHR, MODE)
  INTEGER IFUNC, NBUF, LCHR, MODE
  REAL    RBUF(*)
  CHARACTER*(*) CHR
!
! PGPLOT driver for PostScript devices.
!
! Version 1.2  - 1987 Aug  5 - T. J. Pearson.
! Version 1.3  - 1987 Nov 16 - add "bind" commands to prolog - TJP.
! Version 1.4  - 1988 Jan 28 - change dimensions so whole field can be
!                              plotted - TJP.
! Version 1.5  - 1988 Oct 27 - make EOF characters optional - TJP.
! Version 1.6  - 1988 Dec 15 - standard Fortran - TJP.
! Version 1.7  - 1989 Jul  5 - change color indices so most colors
!                              are black - TJP.
! Version 2.0  - 1990 Sep 10 - parameterize dimensions; correct
!                              bounding box; add color support (from
!                              D. Meier's CPdriver) - TJP.
! Version 2.1  - 1991 Nov 29 - update Document Structuring Conventions
!                              to version 3.0.
! Version 3.0  - 1992 Sep 22 - add marker support; add CPS and VCPS
!                              modes - TJP.
! Version 3.1  - 1992 Nov 12 - up to 256 colors.
! Version 3.2  - 1993 May 26 - correct error in marker support.
! Version 4.0  - 1993 Sep 20 - trap Fortran I/O errors.
! Version 4.1  - 1994 Aug  4 - make marker support optional.
! Version 5.0  - 1994 Aug 30 - support for images.
! Version 5.1  - 1994 Sep  7 - support for PGQCR.
! Version 5.2  - 1994 Oct 12 - add IDENT option.
! Version 5.3  - 1995 May  8 - recognise '-' as standard output; keep
!                              track of bounding box; use upper case
!                              for all defined commands; move
!                              showpage outside save/restore.
! Version 5.4  - 1995 Aug 19 - correct usage of PS_BBOX.
! Version 6.0  - 1995 Dec 28 - reject concurrent access.
! Version 6.1  - 1996 Apr 29 - decode environment variables using GRCTOI.
! Version 6.2  - 1996 Oct  7 - correct bounding-box error (K-G Adams);
!                              correct error in use of GCTOI (G Gonczi);
!                              suppress <0 0 C> commands (R Scharroo);
!                              allow arbitrary page size.
! Version 6.3  - 1997 Nov 14 - shorter commands for setrgbcolor and setgray.
! Version 6.4  - 1997 Nov 19 - workaround a Ghostscript bug: split long
!                              polylines into shorter segments.
! Version 6.5  - 1998 Feb 23 - support for real linewidth.
! Version 6.6  - 1998 Nov 10 - provide easy way to convert color to grey.
! Version 6.7  - 1998 Dec 12 - added #copies to header.
!
! Supported device:
!   Any printer that accepts the PostScript page description language,
!   eg, the LaserWriter (Apple Computer, Inc.).
!   PostScript is a trademark of Adobe Systems Incorporated.
!
! Device type code:
!   /PS (monochrome landscape mode, long edge of paper horizontal).
!   /CPS (color landscape mode, long edge of paper horizontal).
!   /VPS (monochrome portrait mode, short edge of paper horizontal).
!   /VCPS (color portrait mode, short edge of paper horizontal).
!
! Default file name:
!   pgplot.ps
!
! Default view surface dimensions:
!   10.5 inches horizontal x  7.8 inches vertical (landscape mode),
!    7.8 inches horizontal x 10.5 inches vertical (portrait mode).
!   These dimensions can be changed with environment variables.
!
! Resolution:
!   The driver uses coordinate increments of 0.001 inch, giving an
!   ``apparent'' resolution of 1000 pixels/inch. The true resolution is
!   device-dependent; eg, on an Apple LaserWriter it is 300 pixels/inch
!   (in both dimensions).
!
! Color capability (monochrome mode):
!   Color indices 0-255 are supported. Color index 0 is white (erase
!   or background color), indices 1-13 are black, 14 is light grey,
!   and 15 is dark grey.
!
! Color capability (color mode):
!   Color indices 0-255 are supported. Color index 0 is white (erase
!   or background color), index 1 is black, and indices 2-15 have the
!   standard PGPLOT color assignments.
!
! Input capability: none.
!
! File format: the file contains variable length records (maximum 132
! characters) containing PostScript commands. The commands use only
! printable ASCII characters, and the file can be examined or modified
! with a text editor.
!
! Obtaining hardcopy: use the operating system print or copy command to
! send the file to a suitable device.
!
! Environment variables:
!
!  PGPLOT_PS_WIDTH      default  7800
!  PGPLOT_PS_HEIGHT     default 10500
!  PGPLOT_PS_HOFFSET    default   350
!  PGPLOT_PS_VOFFSET    default   250
! These variables tell PGPLOT how big an image to produce. The defaults
! are appropriate for 8.5 x 11-inch paper. The maximum dimensions of
! a PGPLOT image are WIDTH by HEIGHT, with the lower left corner offset
! by HOFFSET horizontally and VOFFSET vertically from the lower left
! corner of the paper. The units are milli-inches. The "top" of the
! paper is the edge that comes out of the printer first.
!
!  PGPLOT_IDENT
! If this variable is set, the user name, date and time are written
! in the bottom right corner of each page.
!
!  PGPLOT_PS_BBOX
! If this variable has value MAX, PGPLOT puts standard (full-page)
! bounding-box information in the header of the PostScript file. If
! the variable is unset or has some other value, PGPLOT puts the
! correct (smallest) bounding box information in the trailer of the
! PostScript file.
!
!  PGPLOT_PS_EOF
! Normally the output file does not contain special end-of-file
! characters. But if environment variable PGPLOT_PS_EOF is defined
! (with any value) PGPLOT writes a control-D job-separator character at
! the beginning and at the end of the file. This is appropriate for
! Apple LaserWriters using the serial interface, but it may not be
! appropriate for other PostScript devices.
!
!  PGPLOT_PS_MARKERS
! Specify "NO" to suppress use of a PostScript font for the graph
! markers; markers are then emulated by line-drawing.
!
! Document Structuring Conventions:
!
!  The PostScript files conform to Version 3.0 of the Adobe Document
!  Structuring Conventions (see ref.3) and to version 3.0 of the
!  encapsulated PostScript file (EPSF) format. This should allow
!  the files to be read by other programs that accept the EPSF format.
!  Note, though, that multi-page plots are not valid EPSF files. The
!  files do not contain a screen preview section.
!
! References:
!
! (1) Adobe Systems, Inc.: PostScript Language Reference Manual.
! Addison-Wesley, Reading, Massachusetts, 1985.
! (2) Adobe Systems, Inc.: PostScript Language Tutorial and Cookbook.
! Addison-Wesley, Reading, Massachusetts, 1985.
! (3) Adobe Systems, Inc.: PostScript Language Reference Manual, Second
! Edition. Addison-Wesley, Reading, Massachusetts, 1990.
!-----------------------------------------------------------------------
  INTEGER DWD, DHT, DOFFW, DOFFH
  CHARACTER*(*) PTYPE, LTYPE, CPTYPE, CLTYPE, DEFNAM
  PARAMETER ( &
   PTYPE= 'VPS   (PostScript file, portrait orientation)', &
   LTYPE= 'PS    (PostScript file, landscape orientation)', &
   CPTYPE='VCPS  (Colour PostScript file, portrait orientation)', &
   CLTYPE='CPS   (Colour PostScript file, landscape orientation)')
!     PARAMETER (PTYPE='VPS', LTYPE='PS', CPTYPE='VCPS', CLTYPE='CPS')
  PARAMETER (DEFNAM='pgplot.ps')
! -- printable paper area: in milli-inches; (WIDTH, HEIGHT) are
!    the dimensions of the printable area; OFFW, OFFH the offset from
!    the lower left corner of the paper
  PARAMETER (DWD=7800, DHT=10500, DOFFW=350, DOFFH=250)
!
  INTEGER WIDTH, HEIGHT, OFFW, OFFH
  SAVE    WIDTH, HEIGHT, OFFW, OFFH
  INTEGER  IER, I0, J0, I1, J1, L, LL, LASTI, LASTJ, UNIT, LOBUF
  SAVE                                 LASTI, LASTJ, UNIT, LOBUF
  INTEGER  CI, NPTS, NPAGE, IOERR, LFNAME
  SAVE         NPTS, NPAGE, IOERR, LFNAME
  INTEGER  STATE, NSEG
  SAVE     STATE, NSEG
  INTEGER  NXP, NYP, XORG, YORG, XLEN, YLEN, N, RGB(3)
  INTEGER  HIGH, LOW, I, K, KMAX, POSN, LD, LU
  INTEGER  BBOX(4), BB1, BB2, BB3, BB4
  SAVE     BBOX
  INTEGER  GROPTX, GRCTOI
  LOGICAL  START, LANDSC, COLOR, STDOUT
  SAVE     START,         COLOR, STDOUT
  REAL     LW
  SAVE     LW
  REAL     BBXMIN, BBXMAX, BBYMIN, BBYMAX
  SAVE     BBXMIN, BBXMAX, BBYMIN, BBYMAX
  REAL     RVALUE(0:255), GVALUE(0:255), BVALUE(0:255)
  SAVE     RVALUE,        GVALUE,        BVALUE
  CHARACTER*20  SUSER, SDATE
  CHARACTER*120 INSTR, MSG
  CHARACTER*132 OBUF
  SAVE          OBUF
  CHARACTER*255 FNAME
  SAVE          FNAME
  INTEGER       MARKER(0:31), NSYM, RAD(0:31)
  SAVE          MARKER, RAD
  REAL          MFAC
  SAVE          MFAC
  REAL          SHADE(0:15), RINIT(0:15), GINIT(0:15), BINIT(0:15)
  SAVE          SHADE,       RINIT,       GINIT,       BINIT
  CHARACTER*1   HEXDIG(0:15)
  DATA HEXDIG/'0','1','2','3','4','5','6','7', &
              '8','9','A','B','C','D','E','F'/
  DATA SHADE /1.00, 13*0.00, 0.33, 0.67/
  DATA RINIT &
       / 1.00, 0.00, 1.00, 0.00, 0.00, 0.00, 1.00, 1.00, &
         1.00, 0.50, 0.00, 0.00, 0.50, 1.00, 0.33, 0.67/
  DATA GINIT &
       / 1.00, 0.00, 0.00, 1.00, 0.00, 1.00, 0.00, 1.00, &
         0.50, 1.00, 1.00, 0.50, 0.00, 0.00, 0.33, 0.67/
  DATA BINIT &
       / 1.00, 0.00, 0.00, 0.00, 1.00, 1.00, 1.00, 0.00, &
         0.00, 0.00, 0.50, 1.00, 1.00, 0.50, 0.33, 0.67/
  DATA RAD/ 6,  1,  7,  6, 7, 5, 6, 8, &
            7,  7,  9, 10, 9, 8, 6, 8, &
            4,  5,  9, 12, 2, 4, 5, 7, &
           11, 17, 22, 41, 9, 9, 9, 9/
  DATA STATE/0/
!-----------------------------------------------------------------------
!
  GOTO( 10, 20, 30, 40, 50, 60, 70, 80, 90,100, &
       110,120,130,140,150,160,170,180,190,200, &
       210,220,230,900,900,260,900,280,290), IFUNC
  GOTO 900
!
!--- IFUNC = 1, Return device name.-------------------------------------
!
   10 IF (MODE==1) THEN
!         -- landscape, monochrome
    CHR = LTYPE
    LCHR = LEN(LTYPE)
  ELSE IF (MODE==2) THEN
!         -- portrait, monochrome
    CHR = PTYPE
    LCHR = LEN(PTYPE)
  ELSE IF (MODE==3) THEN
!         -- landscape, color
    CHR = CLTYPE
    LCHR = LEN(CLTYPE)
  ELSE
!         -- portrait, color
    CHR = CPTYPE
    LCHR = LEN(CPTYPE)
  END IF
  RETURN
!
!--- IFUNC = 2, Return physical min and max for plot device, and range
!               of color indices.---------------------------------------
!
   20 RBUF(1) = 0
  RBUF(2) = -1
  RBUF(3) = 0
  RBUF(4) = -1
  RBUF(5) = 0
  RBUF(6) = 255
  NBUF = 6
  RETURN
!
!--- IFUNC = 3, Return device resolution. ------------------------------
!
   30 RBUF(1) = 1000.0
  RBUF(2) = 1000.0
  RBUF(3) = 5
  NBUF = 3
  RETURN
!
!--- IFUNC = 4, Return misc device info. -------------------------------
!    (This device is Hardcopy, No cursor, No dashed lines, Area fill,
!    Thick lines, QCR, Markers [optional])
!
   40 CONTINUE
  CHR = 'HNNATNQNYM'
!     -- Marker support suppressed?
  CALL GRGENV('PS_MARKERS', INSTR, L)
  IF (L>=2) THEN
   IF (INSTR(1:L)=='NO' .OR. INSTR(1:L)=='no') THEN
      CHR(10:10) = 'N'
   END IF
  END IF
  LCHR = 10
  RETURN
!
!--- IFUNC = 5, Return default file name. ------------------------------
!
   50 CHR = DEFNAM
  LCHR = LEN(DEFNAM)
  RETURN
!
!--- IFUNC = 6, Return default physical size of plot. ------------------
!
   60 RBUF(1) = 0
  RBUF(3) = 0
  LANDSC = MODE==1 .OR. MODE==3
  IF (LANDSC) THEN
    RBUF(2) = HEIGHT-1
    RBUF(4) = WIDTH-1
  ELSE
    RBUF(2) = WIDTH-1
    RBUF(4) = HEIGHT-1
  END IF
  NBUF = 4
  RETURN
!
!--- IFUNC = 7, Return misc defaults. ----------------------------------
!
   70 RBUF(1) = 8
  NBUF = 1
  RETURN
!
!--- IFUNC = 8, Select plot. -------------------------------------------
!
   80 CONTINUE
  RETURN
!
!--- IFUNC = 9, Open workstation. --------------------------------------
!
   90 CONTINUE
!     -- check for concurrent access
  IF (STATE==1) THEN
   CALL GRWARN('a PGPLOT PostScript file is already open')
   RBUF(1) = 0
   RBUF(2) = 0
   RETURN
  END IF
!     -- Color mode?
  CALL GRGENV('PS_COLOR', INSTR, L)
  COLOR = L>0 .OR. MODE==3 .OR. MODE==4
  IF (COLOR) THEN
   DO 91 CI=0,15
      RVALUE(CI) = RINIT(CI)
      GVALUE(CI) = GINIT(CI)
      BVALUE(CI) = BINIT(CI)
 91      CONTINUE
  ELSE
   DO 92 CI=0,15
      RVALUE(CI) = SHADE(CI)
      GVALUE(CI) = SHADE(CI)
      BVALUE(CI) = SHADE(CI)
 92      CONTINUE
  END IF
  DO 93 CI=16,255
   RVALUE(CI) = 0.0
   GVALUE(CI) = 0.0
   BVALUE(CI) = 0.0
 93   CONTINUE
!     -- Device dimensions
  WIDTH = DWD
  HEIGHT = DHT
  OFFW = DOFFW
  OFFH = DOFFH
  CALL GRGENV('PS_WIDTH', INSTR, L)
  LL = 1
  IF (L>0) WIDTH = GRCTOI(INSTR(:L),LL)
  CALL GRGENV('PS_HEIGHT', INSTR, L)
  LL = 1
  IF (L>0) HEIGHT = GRCTOI(INSTR(:L),LL)
  CALL GRGENV('PS_HOFFSET', INSTR, L)
  LL = 1
  IF (L>0) OFFW = GRCTOI(INSTR(:L),LL)
  CALL GRGENV('PS_VOFFSET', INSTR, L)
  LL = 1
  IF (L>0) OFFH = GRCTOI(INSTR(:L),LL)
  STDOUT =CHR(1:LCHR)=='-'
  IF (STDOUT) THEN
   UNIT = 6
!        -- machine-dependent!
  ELSE
   CALL GRGLUN(UNIT)
  END IF
  NBUF = 2
  RBUF(1) = UNIT
  IF (.NOT.STDOUT) THEN
   IER = GROPTX(UNIT, CHR(1:LCHR), DEFNAM, 1)
   IF (IER/=0) THEN
      MSG = 'Cannot open output file for PostScript plot: '// &
             CHR(:LCHR)
      CALL GRWARN(MSG)
      RBUF(2) = 0
      CALL GRFLUN(UNIT)
      RETURN
   ELSE
      INQUIRE (UNIT=UNIT, NAME=CHR)
      LCHR = LEN(CHR)
 94         IF (CHR(LCHR:LCHR)==' ') THEN
         LCHR = LCHR-1
         GOTO 94
      END IF
      RBUF(2) = 1
      FNAME = CHR(:LCHR)
      LFNAME = LCHR
   END IF
  ELSE
   RBUF(2) = 1
   FNAME = '-'
   LFNAME= 1
  END IF
  STATE = 1
  IOERR = 0
  LOBUF = 0
  LASTI = -1
  LASTJ = -1
  LW = 1
  NPTS = 0
  CALL GRGENV('PS_EOF', INSTR, L)
  IF (L>0) CALL GRPS02(IOERR, UNIT, CHAR(4))
  CALL GRPS02(IOERR, UNIT, '%!PS-Adobe-3.0 EPSF-3.0')
  CALL GRUSER(INSTR, L)
  IF (L>0) CALL GRPS02(IOERR, UNIT, '%%For: '//INSTR(1:L))
  CALL GRPS02(IOERR, UNIT, '%%Title: PGPLOT PostScript plot')
  CALL GRPS02(IOERR, UNIT, '%%Creator: PGPLOT [PSDRIV 6.6]')
  CALL GRDATE(INSTR, L)
  IF (L>0) CALL GRPS02(IOERR, UNIT, &
      '%%CreationDate: '//INSTR(1:L))
  CALL GRGENV('PS_BBOX', INSTR, L)
  CALL GRTOUP(INSTR(1:3), INSTR(1:3))
  IF (INSTR(1:3)=='MAX') THEN
!        -- bounding box is based on maximum plot dimensions, not
!           actual dimensions
   CALL GRFAO('%%BoundingBox: # # # #', L, INSTR, &
          NINT(OFFW*0.072), NINT(OFFH*0.072), &
          NINT((WIDTH+OFFW)*0.072), NINT((HEIGHT+OFFH)*0.072))
   CALL GRPS02(IOERR, UNIT, INSTR(:L))
  ELSE
   CALL GRPS02(IOERR, UNIT, '%%BoundingBox: (atend)')
  END IF
  CALL GRPS02(IOERR, UNIT, '%%DocumentFonts: (atend)')
  CALL GRPS02(IOERR, UNIT, '%%LanguageLevel: 1')
  LANDSC = MODE==1 .OR. MODE==3
  IF (LANDSC) THEN
    CALL GRPS02(IOERR, UNIT, '%%Orientation: Landscape')
  ELSE
    CALL GRPS02(IOERR, UNIT, '%%Orientation: Portrait')
  END IF
  CALL GRPS02(IOERR, UNIT, '%%Pages: (atend)')
  CALL GRPS02(IOERR, UNIT, '%%EndComments')
  CALL GRPS02(IOERR, UNIT, '%%BeginProlog')
  CALL GRPS02(IOERR, UNIT, &
    '/L {moveto rlineto currentpoint stroke moveto} bind def')
  CALL GRPS02(IOERR, UNIT, &
    '/C {rlineto currentpoint stroke moveto} bind def')
  CALL GRPS02(IOERR, UNIT, &
    '/D {moveto 0 0 rlineto currentpoint stroke moveto} bind def')
  CALL GRPS02(IOERR, UNIT, '/LW {5 mul setlinewidth} bind def')
  CALL GRPS02(IOERR, UNIT, '/BP {newpath moveto} bind def')
  CALL GRPS02(IOERR, UNIT, '/LP /rlineto load def')
  CALL GRPS02(IOERR, UNIT, &
    '/EP {rlineto closepath eofill} bind def')
  CALL GRPS02(IOERR, UNIT, '/MB {gsave translate MFAC dup scale '// &
   '1 setlinewidth 2 setlinecap 0 setlinejoin newpath} bind def')
  CALL GRPS02(IOERR, UNIT, '/ME /grestore load def')
  CALL GRPS02(IOERR, UNIT, '/CC {0 360 arc stroke} bind def')
  CALL GRPS02(IOERR, UNIT, '/FC {0 360 arc fill} bind def')
  CALL GRPS02(IOERR, UNIT, '/G {1024 div setgray} bind def')
  CALL GRPS02(IOERR, UNIT, '/K {3 -1 roll 1024 div 3 -1 roll 1024'// &
       ' div 3 -1 roll 1024 div setrgbcolor} bind def')
  CALL GRPS02(IOERR, UNIT, '% Uncomment next line to convert color' &
       //' to grey shades')
  CALL GRPS02(IOERR, UNIT, '%/K {3 -1 roll 3413 div 3 -1 roll 1739' &
       //' div 3 -1 roll 9309 div add add setgray} bind def')
  CALL GRGENV('IDENT', INSTR, L)
  IF (L>0) THEN
   CALL GRPS02(IOERR, UNIT, &
          '/RS{findfont exch scalefont setfont moveto dup'// &
          ' stringwidth neg exch neg exch rmoveto show} bind def')
  END IF
  CALL GRPS02(IOERR, UNIT, '%%EndProlog')
  CALL GRPS02(IOERR, UNIT, '%%BeginSetup')
  CALL GRPS02(IOERR, UNIT, '/#copies 1 def')
  CALL GRPS02(IOERR, UNIT, '%%EndSetup')
  NPAGE = 0
  RETURN
!
!--- IFUNC=10, Close workstation. --------------------------------------
!
  100 CONTINUE
  CALL GRPS02(IOERR, UNIT, ' ')
  CALL GRPS02(IOERR, UNIT, '%%Trailer')
  CALL GRGENV('PS_BBOX', INSTR, L)
  CALL GRTOUP(INSTR(1:3), INSTR(1:3))
  IF (INSTR(1:3)/='MAX') THEN
   CALL GRFAO('%%BoundingBox: # # # #', L, INSTR, &
          BBOX(1), BBOX(2), BBOX(3), BBOX(4))
   CALL GRPS02(IOERR, UNIT, INSTR(:L))
  END IF
  CALL GRPS02(IOERR, UNIT, '%%DocumentFonts: ')
  CALL GRFAO('%%Pages: #', L, INSTR, NPAGE, 0, 0, 0)
  CALL GRPS02(IOERR, UNIT, INSTR(:L))
  CALL GRPS02(IOERR, UNIT, '%%EOF')
  CALL GRGENV('PS_EOF', INSTR, L)
  IF (L>0) CALL GRPS02(IOERR, UNIT, CHAR(4))
  IF (IOERR/=0) THEN
    CALL GRWARN('++WARNING++ Error '// &
         'writing PostScript file: file is incomplete')
    CALL GRWARN('Check for device full or quota exceeded')
    CALL GRWARN('Filename: '//FNAME(:LFNAME))
  END IF
  IF (.NOT.STDOUT) THEN
   CLOSE (UNIT, IOSTAT=IOERR)
   IF (IOERR/=0) THEN
     CALL GRWARN('Error closing PostScript file '//FNAME(:LFNAME))
   END IF
   CALL GRFLUN(UNIT)
  END IF
  STATE = 0
  RETURN
!
!--- IFUNC=11, Begin picture. ------------------------------------------
!
  110 CONTINUE
  LANDSC = MODE==1 .OR. MODE==3
  IF (LANDSC) THEN
   HEIGHT = RBUF(1)
   WIDTH = RBUF(2)
  ELSE
   WIDTH = RBUF(1)
   HEIGHT = RBUF(2)
  END IF
  NPAGE = NPAGE+1
  CALL GRPS02(IOERR, UNIT, ' ')
  CALL GRFAO('%%Page: # #', L, INSTR, NPAGE, NPAGE, 0, 0)
  CALL GRPS02(IOERR, UNIT, INSTR(:L))
  CALL GRPS02(IOERR, UNIT, '%%BeginPageSetup')
  CALL GRPS02(IOERR, UNIT, '/PGPLOT save def')
  CALL GRPS02(IOERR, UNIT, '0.072 0.072 scale')
  LANDSC = MODE==1 .OR. MODE==3
  IF (LANDSC) THEN
    CALL GRFAO('# # translate 90 rotate', L, INSTR, WIDTH+OFFW, &
                 OFFH, 0, 0)
  ELSE
    CALL GRFAO('# # translate', L, INSTR, OFFW, OFFH, 0, 0)
  END IF
  CALL GRPS02(IOERR, UNIT, INSTR(:L))
  CALL GRPS02(IOERR, UNIT, '1 setlinejoin 1 setlinecap 1 LW 1')
  CALL GRPS02(IOERR, UNIT, '%%EndPageSetup')
  CALL GRPS02(IOERR, UNIT, '%%PageBoundingBox: (atend)')
  DO 111 NSYM=0,31
    MARKER(NSYM) = 0
  111 CONTINUE
  MFAC = 0.0
  BBXMIN = WIDTH
  BBYMIN = HEIGHT
  BBXMAX = 0.0
  BBYMAX = 0.0
  RETURN
!
!--- IFUNC=12, Draw line. ----------------------------------------------
!
  120 CONTINUE
  I0 = NINT(RBUF(1))
  J0 = NINT(RBUF(2))
  I1 = NINT(RBUF(3))
  J1 = NINT(RBUF(4))
  IF (I0==LASTI .AND. J0==LASTJ) THEN
!        -- suppress zero-length continuation segment
   IF (I0==I1 .AND. J0==J1) RETURN
   CALL GRFAO('# # C', L, INSTR, (I1-I0), (J1-J0), 0, 0)
   NSEG = NSEG+1
  ELSE
   NSEG = 1
   CALL GRFAO('# # # # L', L, INSTR, (I1-I0), (J1-J0), I0, J0)
  END IF
  LASTI = I1
  IF (NSEG>200) LASTI = -1
  LASTJ = J1
  BBXMIN = MIN(BBXMIN, I0-LW*5.0, I1-LW*5.0)
  BBXMAX = MAX(BBXMAX, I0+LW*5.0, I1+LW*5.0)
  BBYMIN = MIN(BBYMIN, J0-LW*5.0, J1-LW*5.0)
  BBYMAX = MAX(BBYMAX, J0+LW*5.0, J1+LW*5.0)
  GOTO 800
!
!--- IFUNC=13, Draw dot. -----------------------------------------------
!
  130 CONTINUE
  I1 = NINT(RBUF(1))
  J1 = NINT(RBUF(2))
  CALL GRFAO('# # D', L, INSTR, I1, J1, 0, 0)
  LASTI = I1
  LASTJ = J1
  BBXMIN = MIN(BBXMIN, I1-LW*5.0)
  BBXMAX = MAX(BBXMAX, I1+LW*5.0)
  BBYMIN = MIN(BBYMIN, J1-LW*5.0)
  BBYMAX = MAX(BBYMAX, J1+LW*5.0)
  GOTO 800
!
!--- IFUNC=14, End picture. --------------------------------------------
!
  140 CONTINUE
  IF (LOBUF/=0) THEN
    CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF))
    LOBUF = 0
  END IF
  LANDSC = MODE==1 .OR. MODE==3
!     -- optionally write identification
  CALL GRGENV('IDENT', INSTR, L)
  IF (L>0) THEN
   CALL GRUSER(SUSER, LU)
   CALL GRDATE(SDATE, LD)
   POSN = WIDTH - 1
   IF (LANDSC) POSN = HEIGHT - 1
   CALL GRFAO('('//SUSER(:LU)//' '//SDATE(:LD)// &
          ' [#]) # # 100 /Helvetica RS', &
          L, INSTR, NPAGE, POSN, 50, 0)
   CALL GRPS02(IOERR, UNIT, '0 G')
   CALL GRPS02(IOERR, UNIT, INSTR(1:L))
  END IF
!     -- optionally draw bounding box
  CALL GRGENV('PS_DRAW_BBOX', INSTR, L)
  IF (L>0) THEN
   CALL GRFAO('0 G 0 LW newpath # # moveto', L, INSTR, &
                NINT(BBXMIN), NINT(BBYMIN), 0, 0)
   CALL GRPS02(IOERR, UNIT, INSTR(1:L))
   CALL GRFAO('# # lineto # # lineto', L, INSTR, &
          NINT(BBXMIN), NINT(BBYMAX), NINT(BBXMAX), NINT(BBYMAX))
   CALL GRPS02(IOERR, UNIT, INSTR(1:L))
   CALL GRFAO('# # lineto closepath stroke', L,INSTR, &
                NINT(BBXMAX), NINT(BBYMIN), 0, 0)
   CALL GRPS02(IOERR, UNIT, INSTR(1:L))
  END IF
  CALL GRPS02(IOERR, UNIT, 'PGPLOT restore showpage')
  CALL GRPS02(IOERR, UNIT, '%%PageTrailer')
  IF (LANDSC) THEN
   BB1 = INT((WIDTH-BBYMAX+OFFW)*0.072)
   BB2 = INT((BBXMIN+OFFH)*0.072)
   BB3 = 1+INT((WIDTH-BBYMIN+OFFW)*0.072)
   BB4 = 1+INT((BBXMAX+OFFH)*0.072)
  ELSE
   BB1 = INT((BBXMIN+OFFW)*0.072)
   BB2 = INT((BBYMIN+OFFH)*0.072)
   BB3 = 1+INT((BBXMAX+OFFW)*0.072)
   BB4 = 1+INT((BBYMAX+OFFH)*0.072)
  END IF
  CALL GRFAO('%%PageBoundingBox: # # # #', L, INSTR, &
             BB1, BB2, BB3, BB4)
  CALL GRPS02(IOERR, UNIT, INSTR(1:L))
  IF (NPAGE==1) THEN
   BBOX(1) = BB1
   BBOX(2) = BB2
   BBOX(3) = BB3
   BBOX(4) = BB4
  ELSE
   BBOX(1) = MIN(BBOX(1),BB1)
   BBOX(2) = MIN(BBOX(2),BB2)
   BBOX(3) = MAX(BBOX(3),BB3)
   BBOX(4) = MAX(BBOX(4),BB4)
  END IF
  RETURN
!
!--- IFUNC=15, Select color index. -------------------------------------
!
  150 CONTINUE
  CI = NINT(RBUF(1))
  IF (COLOR) THEN
   CALL GRFAO('# # # K', L, INSTR, NINT(1024.*RVALUE(CI)), &
          NINT(1024.*GVALUE(CI)), NINT(1024.*BVALUE(CI)), 0)
  ELSE
   CALL GRFAO('# G', L, INSTR, NINT(1024.*RVALUE(CI)), 0, 0, 0)
  END IF
  LASTI = -1
  GOTO 800
!
!--- IFUNC=16, Flush buffer. -------------------------------------------
!
  160 CONTINUE
  IF (LOBUF/=0) THEN
    CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF))
    LOBUF = 0
  END IF
  RETURN
!
!--- IFUNC=17, Read cursor. --------------------------------------------
!    (Not implemented: should not be called.)
!
  170 GOTO 900
!
!--- IFUNC=18, Erase alpha screen. -------------------------------------
!    (Null operation: there is no alpha screen.)
!
  180 CONTINUE
  RETURN
!
!--- IFUNC=19, Set line style. -----------------------------------------
!    (Not implemented: should not be called.)
!
  190 GOTO 900
!
!--- IFUNC=20, Polygon fill. -------------------------------------------
!
  200 CONTINUE
  IF (NPTS==0) THEN
    NPTS = RBUF(1)
    START = .TRUE.
    RETURN
  ELSE
    NPTS = NPTS-1
    I0 = NINT(RBUF(1))
    J0 = NINT(RBUF(2))
    IF (START) THEN
        CALL GRFAO('# # BP', L, INSTR, I0, J0, 0, 0)
        START = .FALSE.
        LASTI = I0
        LASTJ = J0
    ELSE IF (NPTS==0) THEN
        CALL GRFAO('# # EP', L, INSTR, (I0-LASTI), &
                       (J0-LASTJ), 0, 0)
        LASTI = -1
        LASTJ = -1
    ELSE
        CALL GRFAO('# # LP', L, INSTR, (I0-LASTI), &
                       (J0-LASTJ), 0, 0)
        LASTI = I0
        LASTJ = J0
    END IF
    BBXMIN = MIN(BBXMIN, I0-LW*5.0)
    BBXMAX = MAX(BBXMAX, I0+LW*5.0)
    BBYMIN = MIN(BBYMIN, J0-LW*5.0)
    BBYMAX = MAX(BBYMAX, J0+LW*5.0)
    GOTO 800
  END IF
!
!--- IFUNC=21, Set color representation. -------------------------------
!
  210 CONTINUE
  IF (COLOR) THEN
    CI = RBUF(1)
    RVALUE(CI) = RBUF(2)
    GVALUE(CI) = RBUF(3)
    BVALUE(CI) = RBUF(4)
  ELSE
    CI = RBUF(1)
    RVALUE(CI) = 0.30*RBUF(2) + 0.59*RBUF(3) + 0.11*RBUF(4)
    GVALUE(CI) = RVALUE(CI)
    BVALUE(CI) = RVALUE(CI)
  END IF
  RETURN
!
!--- IFUNC=22, Set line width. -----------------------------------------
!
  220 CONTINUE
  LW = RBUF(1)
  IF (INT(LW)==LW) THEN
   CALL GRFAO('# LW', L, INSTR, INT(LW), 0, 0, 0)
  ELSE
   WRITE (INSTR,'(F6.2,'' LW'')') LW
   L = 9
  END IF
  LASTI = -1
  GOTO 800
!
!--- IFUNC=23, Escape. -------------------------------------------------
!
  230 CONTINUE
  IF (LOBUF/=0) THEN
!         -- flush buffer first
    CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF))
    LOBUF = 0
  END IF
  CALL GRPS02(IOERR, UNIT, CHR(:LCHR))
  LASTI = -1
  RETURN
!
!--- IFUNC=26, Image.---------------------------------------------------
!
  260 CONTINUE
  N = RBUF(1)
  IF (N==0) THEN
!         -- First: setup for image
!         -- Set clipping region (RBUF(2...5))
    NXP = RBUF(2)
    NYP = RBUF(3)
    XORG = RBUF(4)
    XLEN = RBUF(5) - RBUF(4)
    YORG = RBUF(6)
    YLEN = RBUF(7) - RBUF(6)
    BBXMIN = MIN(BBXMIN, RBUF(4), RBUF(5))
    BBXMAX = MAX(BBXMAX, RBUF(4), RBUF(5))
    BBYMIN = MIN(BBYMIN, RBUF(6), RBUF(7))
    BBYMAX = MAX(BBYMAX, RBUF(6), RBUF(7))
!
    CALL GRPS02(IOERR, UNIT, 'gsave newpath')
    CALL GRFAO('# # moveto # 0 rlineto 0 # rlineto', L, INSTR, &
                 XORG, YORG, XLEN, YLEN)
    CALL GRPS02(IOERR, UNIT, INSTR(:L))
    CALL GRFAO('# 0 rlineto closepath clip', L, INSTR, -XLEN, &
                  0, 0, 0)
    CALL GRPS02(IOERR, UNIT, INSTR(:L))
!         --
    CALL GRFAO('/picstr # string def', L, INSTR, NXP, 0, 0, 0)
    CALL GRPS02(IOERR, UNIT, INSTR(:L))
    CALL GRFAO('# # 8 [', L, INSTR, NXP, NYP, 0, 0)
    CALL GRPS02(IOERR, UNIT, INSTR(:L))
    WRITE (INSTR, '(6(1PE10.3, 1X), '']'')') (RBUF(I),I=8,13)
    CALL GRPS02(IOERR, UNIT, INSTR(:67))
    IF (COLOR) THEN
        CALL GRPS02(IOERR, UNIT, &
        '{currentfile picstr readhexstring pop} false 3 colorimage')
    ELSE
        CALL GRPS02(IOERR, UNIT, &
        '{currentfile picstr readhexstring pop} image')
    END IF
  ELSE IF (N==-1) THEN
!         -- Last: terminate image
    CALL GRPS02(IOERR, UNIT, 'grestore')
  ELSE
!         -- Middle: write N image pixels; each pixel uses 6 chars
!            in INSTR, so N must be <= 20.
    L = 0
    KMAX = 1
    IF (COLOR) KMAX = 3
    DO 262 I=1,N
        CI = RBUF(I+1)
        RGB(1) = NINT(255.0*RVALUE(CI))
        RGB(2) = NINT(255.0*GVALUE(CI))
        RGB(3) = NINT(255.0*BVALUE(CI))
        DO 261 K=1,KMAX
            HIGH = RGB(K)/16
            LOW  = RGB(K)-16*HIGH
            L = L+1
            INSTR(L:L) = HEXDIG(HIGH)
            L = L+1
            INSTR(L:L) = HEXDIG(LOW)
 261          CONTINUE
 262      CONTINUE
    CALL GRPS02(IOERR, UNIT, INSTR(1:L))
  END IF
  RETURN
!
!--- IFUNC=28, Marker.--------------------------------------------------
!
  280 CONTINUE
  NSYM = NINT(RBUF(1))
!     -- Output code for this marker if necessary
  IF (MARKER(NSYM)==0) THEN
    IF (LOBUF>0) CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF))
    LOBUF = 0
    CALL GRPS03(IOERR, NSYM, UNIT)
    MARKER(NSYM) = 1
  END IF
!     -- Output scale factor
  IF (RBUF(4)/=MFAC) THEN
    IF (LOBUF>0) CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF))
    LOBUF = 0
    MFAC = RBUF(4)
    WRITE (INSTR, '(''/MFAC '',F10.3,'' def'')') MFAC
    CALL GRPS02(IOERR, UNIT, INSTR(1:24))
  END IF
!     -- Output an instruction to draw one marker
  I1 = NINT(RBUF(2))
  J1 = NINT(RBUF(3))
  CALL GRFAO('# # M#', L, INSTR, I1, J1, NSYM, 0)
  LASTI = -1
  BBXMIN = MIN(BBXMIN, I1-MFAC*RAD(NSYM))
  BBXMAX = MAX(BBXMAX, I1+MFAC*RAD(NSYM))
  BBYMIN = MIN(BBYMIN, J1-MFAC*RAD(NSYM))
  BBYMAX = MAX(BBYMAX, J1+MFAC*RAD(NSYM))
  GOTO 800
!
!--- IFUNC=29, Query color representation.------------------------------
!
 290  CONTINUE
  CI = NINT(RBUF(1))
  NBUF = 4
  RBUF(2) = RVALUE(CI)
  RBUF(3) = GVALUE(CI)
  RBUF(4) = BVALUE(CI)
  RETURN
!
!-----------------------------------------------------------------------
! Buffer output if possible.
!
  800 IF ( (LOBUF+L+1) .GT. 132) THEN
    CALL GRPS02(IOERR, UNIT, OBUF(1:LOBUF))
    OBUF(1:L) = INSTR(1:L)
    LOBUF = L
  ELSE
    IF (LOBUF>1) THEN
        LOBUF = LOBUF+1
        OBUF(LOBUF:LOBUF) = ' '
    END IF
    OBUF(LOBUF+1:LOBUF+L) = INSTR(1:L)
    LOBUF = LOBUF+L
  END IF
  RETURN
!-----------------------------------------------------------------------
! Error: unimplemented function.
!
  900 WRITE (MSG, &
    '(''Unimplemented function in PS device driver: '',I10)') IFUNC
  CALL GRWARN(MSG)
  NBUF = -1
  RETURN
!-----------------------------------------------------------------------
  END

!*GRPS03 -- PGPLOT PostScript driver, marker support
!+
  SUBROUTINE GRPS03(IOERR, NSYM, UNIT)
  INTEGER IOERR, NSYM, UNIT
!
! Write PostScript instructions for drawing graph marker number NSYM
! on Fortran unit UNIT.
!-----------------------------------------------------------------------
  CHARACTER*80 T(6)
  INTEGER I, N
!
  IF (NSYM<0 .OR. NSYM>31) RETURN
  GOTO (100, 101, 102, 103, 104, 105, 106, 107, 108, &
        109, 110, 111, 112, 113, 114, 115, 116, 117, &
        118, 119, 120, 121, 122, 123, 124, 125, 126, &
        127, 128, 129, 130, 131) NSYM+1
!
  100 T(1)='/M0 {MB -6 -6 moveto 0 12 rlineto 12 0 rlineto'
  T(2)='0 -12 rlineto closepath stroke ME} bind def'
  N=2
  GOTO 200
  101 T(1)='/M1 {MB 0 0 1 FC ME} bind def'
  N=1
  GOTO 200
  102 T(1)='/M2 {MB 0 7 moveto 0 -14 rlineto -7 0 moveto'
  T(2)='14 0 rlineto stroke ME} bind def'
  N=2
  GOTO 200
  103 T(1)='/M3 {MB 0 6 moveto 0 -6 lineto -5 3 moveto 5 -3 lineto'
  T(2)='5 3 moveto -5 -3 lineto stroke ME} bind def'
  N=2
  GOTO 200
  104 T(1)='/M4 {MB 0 0 7 CC ME} bind def'
  N=1
  GOTO 200
  105 T(1)='/M5 {MB -5 -5 moveto 10 10 rlineto -5 5 moveto'
  T(2)='10 -10 rlineto stroke ME} bind def'
  N=2
  GOTO 200
  106 T(1)='/M6 {MB -6 -6 moveto 0 12 rlineto 12 0 rlineto'
  T(2)='0 -12 rlineto closepath stroke ME} bind def'
  N=2
  GOTO 200
  107 T(1)='/M7 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath'
  T(2)='stroke ME} bind def'
  N=2
  GOTO 200
  108 T(1)='/M8 {MB 0 7 moveto 0 -14 rlineto -7 0 moveto 14 0 rlineto'
  T(2)='stroke 0 0 7 CC ME} bind def'
  N=2
  GOTO 200
  109 T(1)='/M9 {MB 0 0 1 FC 0 0 7 CC ME} bind def'
  N=1
  GOTO 200
  110 T(1)='/M10 {MB -9 9 moveto -8 7 lineto -7 3 lineto -7 -3 lineto'
  T(2)='-8 -7 lineto -9 -9 lineto -7 -8 lineto -3 -7 lineto'
  T(3)='3 -7 lineto 7 -8 lineto 9 -9 lineto 8 -7 lineto'
  T(4)='7 -3 lineto 7 3 lineto 8 7 lineto 9 9 lineto 7 8 lineto'
  T(5)='3 7 lineto -3 7 lineto  -7 8 lineto closepath stroke'
  T(6)='ME} bind def'
  N=6
  GOTO 200
  111 T(1)='/M11 {MB 0 10 moveto -6 0 lineto 0 -10 lineto 6 0 lineto'
  T(2)='closepath stroke ME} bind def'
  N=2
  GOTO 200
  112 T(1)='/M12 {MB 0 9 moveto -2 3 lineto -8 3 lineto -3 -1 lineto'
  T(2)='-5 -7 lineto 0 -3 lineto 5 -7 lineto 3 -1 lineto 8 3'
  T(3)='lineto 2 3 lineto closepath stroke ME} bind def'
  N=3
  GOTO 200
  113 T(1)='/M13 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath'
  T(2)='fill ME} bind def'
  N=2
  GOTO 200
  114 T(1)='/M14 {MB -2 6 moveto -2 2 lineto -6 2 lineto -6 -2 lineto'
  T(2)='-2 -2 lineto -2 -6 lineto 2 -6 lineto 2 -2 lineto'
  T(3)='6 -2 lineto 6 2 lineto 2 2 lineto 2 6 lineto closepath'
  T(4)='stroke ME} bind def'
  N=4
  GOTO 200
  115 T(1)='/M15 {MB 0 8 moveto -7 -4 lineto 7 -4 lineto closepath'
  T(2)='0 -8 moveto 7 4 lineto -7 4 lineto closepath stroke ME}'
  T(3)='bind def'
  N=3
  GOTO 200
  116 T(1)='/M16 {MB -4 -4 moveto 0 8 rlineto 8 0 rlineto 0 -8'
  T(2)='rlineto closepath fill ME} bind def'
  N=2
  GOTO 200
  117 T(1)='/M17 {MB 0 0 4.5 FC ME} bind def'
  N=1
  GOTO 200
  118 T(1)='/M18 {MB 0 9 moveto -2 3 lineto -8 3 lineto -3 -1 lineto'
  T(2)=' -5 -7 lineto 0 -3 lineto 5 -7 lineto 3 -1 lineto 8 3'
  T(3)='lineto 2 3 lineto closepath fill ME} bind def'
  N=3
  GOTO 200
  119 T(1)='/M19 {MB -12 -12 moveto 0 24 rlineto 24 0 rlineto 0 -24'
  T(2)='rlineto closepath stroke ME} bind def'
  N=2
  GOTO 200
  120 T(1)='/M20 {MB 0 0 2 CC ME} bind def'
  N=1
  GOTO 200
  121 T(1)='/M21 {MB 0 0 4 CC ME} bind def'
  N=1
  GOTO 200
  122 T(1)='/M22 {MB 0 0 5 CC ME} bind def'
  N=1
  GOTO 200
  123 T(1)='/M23 {MB 0 0 7 CC ME} bind def'
  N=1
  GOTO 200
  124 T(1)='/M24 {MB 0 0 11 CC ME} bind def'
  N=1
  GOTO 200
  125 T(1)='/M25 {MB 0 0 17 CC ME} bind def'
  N=1
  GOTO 200
  126 T(1)='/M26 {MB 0 0 22 CC ME} bind def'
  N=1
  GOTO 200
  127 T(1)='/M27 {MB 0 0 41 CC ME} bind def'
  N=1
  GOTO 200
  128 T(1)='/M28 {MB -6 2 moveto -9 0 lineto -6 -2 lineto -3 5'
  T(2)='moveto -8 0 lineto -3 -5 lineto -8 0 moveto 9 0 lineto'
  T(3)='stroke ME} bind def'
  N=3
  GOTO 200
  129 T(1)='/M29 {MB 6 2 moveto 9 0 lineto 6 -2 lineto 3 5 moveto'
  T(2)='8 0 lineto 3 -5 lineto 8 0 moveto -9 0 lineto stroke ME}'
  T(3)='bind def'
  N=3
  GOTO 200
  130 T(1)='/M30 {MB 2 6 moveto 0 9 lineto -2 6 lineto 5 3 moveto'
  T(2)='0 8 lineto -5 3 lineto 0 8 moveto 0 -9 lineto stroke ME}'
  T(3)='bind def'
  N=3
  GOTO 200
  131 T(1)='/M31 {MB 2 -6 moveto 0 -9 lineto -2 -6 lineto 5 -3'
  T(2)='moveto 0 -8 lineto -5 -3 lineto 0 -8 moveto 0 9 lineto'
  T(3)='stroke ME} bind def'
  N=3
  GOTO 200
!
  200 DO 210 I=1,N
    CALL GRPS02(IOERR, UNIT, T(I))
  210 CONTINUE
!
  END

!*GRPS02 -- PGPLOT PostScript driver, copy buffer to file
!+
  SUBROUTINE GRPS02 (IER, UNIT, S)
!
! Support routine for PSdriver: write character string S on
! specified Fortran unit.
!
! Error handling: if IER is not 0 on input, the routine returns
! immediately. Otherwise IER receives the I/O status from the Fortran
! write (0 => success).
!-----------------------------------------------------------------------
  INTEGER IER, UNIT
  CHARACTER*(*) S
!
  IF (IER==0) THEN
    WRITE (UNIT, '(A)', IOSTAT=IER) S
    IF (IER/=0) CALL &
          GRWARN('++WARNING++ Error writing PostScript file')
  END IF
!-----------------------------------------------------------------------
  END
